/*
   :       . 
*/

#include <stdio.h>
#include <mem.h>

unsigned int n, m;         // n - vert   m - edges
unsigned char g[40][40];   // graph
unsigned char comp[40];    // one component
unsigned char used[40];    // for dfs
unsigned char taken[40];   // for components;
unsigned int best, curr;


void init() {
  memset(g, 0, sizeof(g));
}

void readIt() {
  unsigned int p,q,i;
  FILE *F;

  F = fopen("BAS.INP", "rt");

  fscanf(F, "%d%d", &n, &m);

  for (i=0; i<m; i++) {
    fscanf(F, "%d%d", &p, &q);

    g[p][q] = g[q][p] = 1;
  }

  for (i=1; i<=n; i++)
    g[i][i] = 1;

  fclose(F);
}

void dfs(unsigned int v) {
  unsigned int i;
  comp[v] = 1;
  used[v] = 1;

  for (i=1; i<=n; i++)
    if (!used[i] && g[v][i]) {
      dfs(i);
    }
}

void take(unsigned int k) {
  unsigned int i;
  for (i=1; i<=n; i++)
    taken[i] += g[k][i];
}

void untake(unsigned int k) {
  unsigned int i;
  for (i=1; i<=n; i++)
    taken[i] -= g[k][i];
}

void rec() {
  unsigned int takeMe=0, i;

  for (i=1; i<=n; i++)
    if (taken[i]==0 && comp[i]==1) {
      takeMe = i;
      break;
    }

  if (takeMe == 0) {
    if (curr < best) best = curr;
    return;
  }

  for (i=1; i<=n; i++)
    if (g[i][takeMe]) {
      curr++;
      take(i);
      if (curr < best) rec();
      untake(i);
      curr--;
    }
}

void solveComponent() {
  memset(taken, 0, sizeof(taken));
  curr=0; best=n+1;
  rec();
}

void solve() {
  unsigned int bestSol=0, i;
  FILE *f;

  memset(used, 0, sizeof(used));
  for (i=1; i<=n; i++)
    if (!used[i]) {
      memset(comp, 0, sizeof(comp));
      dfs(i);
      solveComponent();
      bestSol += best;
    }

  f = fopen("BAS.OUT", "wt");
  fprintf(f, "%d\n", bestSol);
  fclose(f);
}

void main() {
  init();
  readIt();
  solve();
}
