/*
  :  

  O(n^3)

*/

#include <stdio.h>

int a[60][60], hor[61][61], ver[61][61];
int n;

void input() {
  FILE *f = fopen("sqr.inp", "rt");
  int i,j;
  fscanf(f, "%d", &n);

  for (i=0; i<n; i++)
    for (j=0; j<n; j++) {
      fscanf(f, "%d",&a[i][j]);
    }
  fclose(f);
}

void precompute() {
  int i, j;

  for (i=0; i<n; i++) {
    hor[0][i] = ver[i][0] = 0;
  }

  for (i=1; i<=n; i++)
    for (j=0; j<n; j++) {
      hor[i][j] = hor[i-1][j] + a[i-1][j];
      ver[j][i] = ver[j][i-1] + a[j][i-1];
    }
}

void solve() {
  int i,j,k, maxij, sum, best;
  FILE *f;

  best = -9;
  for (i=0; i<n; i++)
    for (j=0; j<n; j++) {
      maxij = i;
      if (maxij < j) maxij = j;

      sum = 0;
      for (k=0; k<n-maxij; k++) {
	sum += (ver[i+k][j+k+1] - ver[i+k][j]) +
	       (hor[i+k+1][j+k] - hor[i][j+k]) -
	       a[i+k][j+k];

	if (sum > best) best = sum;
      }

    }


  f = fopen("sqr.out","wt");
  fprintf(f, "%d\n", best);
  fclose(f);
}

int main() {
  input();
  precompute();
  solve();
}