/*
     

  C++
*/


#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>

struct MTree {
  int count;
  int mulV[10], v[10];
  MTree *child[10];
};

FILE *F;
MTree *mobile, *mobs[17];
int used[18];
int n=0, mcount=0;

MTree *makeTree() {
  MTree *tmp;
  int v;
  char c;

  tmp = new MTree;
  tmp->count=0;

  while (1) {
    fscanf(F, "%d%c", &v, &c);
    n++;

    tmp->mulV[tmp->count] = v;

    if (c == '(') {
      n--;
      tmp->child[tmp->count] = makeTree();
      fscanf(F, "%c", &c);
    } else
      tmp->child[tmp->count] = NULL;

    tmp->count++;

    if (c == ')') break;
  }

  mobs[mcount++] = tmp;
  return tmp;
}

int nodeSum(MTree *t) {
  int sum=0;

  for (int i=0; i<t->count; i++) {
    if (t->child[i] == NULL) sum += t->v[i];
    else sum += nodeSum(t->child[i]);
  }
  return sum;
}

void printTree(MTree *t) {
  fprintf(F,"(");

  for (int i=0; i<t->count; i++) {
    if (t->child[i] == NULL)
      fprintf(F,"%d", t->v[i]);
    else
      printTree(t->child[i]);
    if (i<t->count-1) fprintf(F,",");
  }

  fprintf(F,")");
}


void printSol() {
  F = fopen("MOBILE.OUT", "wt");
  printTree(mobile);
  fclose(F);
  exit(0);
}

int check(MTree *t) {
  int sum=0;

  for (int i=0; i<t->count; i++)
    if (t-> child[i] == NULL) sum += t->mulV[i] * t->v[i];
    else sum += nodeSum(t->child[i]) * t->mulV[i];

  return (sum==0);
}

void makePerfect(int treeNum, int k) {
  if (k == mobs[treeNum]->count) {
    if (check(mobs[treeNum])) {
      if (treeNum < mcount-1)
	makePerfect(treeNum+1, 0);
      else
	printSol();
    }
    return;
  }

  if (mobs[treeNum]->child[k] != NULL) {
    makePerfect(treeNum, k+1);
  } else
  for (int i=1; i<=n; i++)
    if (!used[i]) {
      used[i] = 1;
      mobs[treeNum]->v[k] = i;
      makePerfect(treeNum, k+1);
      used[i] = 0;
    }
}


void solve() {
  makePerfect(0, 0);
}


void main() {
  F = fopen("mobile.in", "rt");
  fgetc(F);
  mobile = makeTree();
  solve();
  fclose(F);
}
