{  , 12 .,   }
{$MODE objfpc}

Type
  TSum = Array[0..20] Of Byte;

Var
  Done : Boolean;
  N : Integer;
  SrcSum, DestSum : TSum;
  Src, Dest : Integer;
  V : Array[0..1000] Of Boolean;
  Q : Array[0..1000] Of Integer;
  P : Array[0..1000] Of Integer;
  QStart, QEnd : Integer;
  SumListNum : Integer;
  SumList : Array[1..700] Of TSum;
  StartLUT : Array[1..20, 0..10, 0..6] Of Integer;
  tmpSum : TSum;
  Qt : Integer;

Operator = (Const a, b : TSum) res : Boolean;

Var
  I : Integer;

Begin
  If a[0] <> b[0] Then
    res := False
  Else
  Begin
    res := True;
    For I := 1 To a[0] Do
      If a[I] <> b[I] Then
      Begin
        res := False;
        Exit;
      End;
  End;
End;

Procedure WriteSum(Sm : TSum);

Var
  I : Integer;

Begin
  Write(Sm[1]);
  For I := 2 To Sm[0] Do
    Write('+', Sm[I]);
  Writeln;
End;

Procedure WriteSum(Var F : Text; Sm : TSum);

Var
  I : Integer;

Begin
  Write(F, Sm[1]);
  For I := 2 To Sm[0] Do
    Write(F, '+', Sm[I]);
  Writeln(F);
End;

Procedure Norm(Var Sm : TSum);

Var
  I, J, K : Integer;
  Q : Array[1..20] Of Integer;

Begin
  FillChar(Q, N * SizeOf(Integer), 0);
  For I := 1 To Sm[0] Do
    Inc(Q[Sm[I]]);
  K := 0;
  For I := N DownTo 1 Do
    For J := 1 To Q[I] Do
    Begin
      Inc(K);
      Sm[K] := I;
    End;
End;

Function Sum2Num(Sm : TSum) : Integer;

Var
  I : Integer;
  Start : Integer;

Begin
  Norm(Sm);
  Case Sm[0] Of
    1 : Begin
      Sm[2] := 0;
      Sm[3] := 0;
    End;
    2 : Sm[3] := 0;
  End;
  Start := StartLUT[Sm[1], Sm[2], Sm[3]];
  For I := Start To SumListNum Do
    If Sm = SumList[I] Then
      Exit(I);
End;

Procedure BuildLUT;

Var
  I : Integer;
  A, B, C : Integer;

Begin
  For I := SumListNum DownTo 1 Do
  Begin
    A := SumList[I, 1];
    B := SumList[I, 2];
    C := SumList[I, 3];
    Case SumList[I, 0] Of
      1 : Begin
        B := 0;
        C := 0;
      End;
      2 : C := 0;
    End;
    StartLUT[A, B, C] := I;
  End;
End;

Procedure ParseSum(St : AnsiString; Var Sm : TSum);

Var
  I : Integer;
  tmpS : AnsiString;
  tmpI, tmpI2 : Integer;

Begin
  Sm[0] := 0;
  St := St + '+';
  tmpS := '';
  For I := 1 To Length(St) Do
  Begin
    If St[I] = '+' Then
    Begin
      Val(tmpS, tmpI, tmpI2);
      Inc(Sm[0]);
      Sm[Sm[0]] := tmpI;

      tmpS := '';
    End
    Else
      tmpS := tmpS + St[I];
  End;
  Norm(Sm);
End;

Procedure ReadIn;

Var
  F : Text;
  S : AnsiString;

Begin
  ASSign(F, 'SUMS.INP');
  Reset(F);
  Readln(F, N);
  Readln(F, S);
  ParseSum(S, SrcSum);
  Readln(F, S);
  ParseSum(S, DestSum);
  Close(F);
End;

Procedure Dig(P : Integer);

Var
  I : Integer;

Begin
  If Qt > N Then
    Exit;
  If Qt = N Then
  Begin
    tmpSum[0] := P - 1;
    Inc(SumListNum);
    SumList[SumListNum] := tmpSum;
    Exit;
  End;
  For I := 1 To tmpSum[P - 1] Do
  Begin
    tmpSum[P] := I;
    Inc(Qt, I);
    Dig(P + 1);
    Dec(Qt, I);
  End;
End;

Procedure Gen;

Var
  I : Integer;

Begin
  SumListNum := 0;
  For I := 1 To N Do
  Begin
    tmpSum[1] := I;
    Qt := I;
    Dig(2);
  End;
  BuildLUT;
End;

Procedure NQ(S, Prev : Integer);

Begin
  If S = Dest Then
    Done := True;
  If V[S] Then
    Exit;
  P[S] := Prev;
  V[S] := True;
  Inc(QEnd);
  Q[QEnd] := S;
End;

Function DeQ : Integer;

Begin
  DeQ := Q[QStart];
  Inc(QStart);
End;

Procedure Bahur;

Var
  S : Integer;
  I, J, K : Integer;
  Sm, NewSm : TSum;

Begin
  Done := False;
  Src := Sum2Num(SrcSum);
  Dest := Sum2Num(DestSum);
  QStart := 1;
  QEnd := 0;
  NQ(Src, -1);
  While (QStart <= QEnd) And Not Done Do
  Begin
    S := DeQ;
    Sm := SumList[S];
    For I := 1 To Sm[0] Do
      If Sm[I] > 1 Then
      Begin
        NewSm := Sm;
        Inc(NewSm[0]);
        For J := 1 To Sm[I] Shr 1 Do
        Begin
          NewSm[I] := J;
          NewSm[NewSm[0]] := Sm[I] - J;
          NQ(Sum2Num(NewSm), S);
        End;
      End;
    For I := 1 To Sm[0] Do
      For J := I + 1 To Sm[0] Do
      Begin
        NewSm := Sm;
        Inc(NewSm[I], NewSm[J]);
        NewSm[J] := NewSm[NewSm[0]];
        Dec(NewSm[0]);
        NQ(Sum2Num(NewSm), S);
      End;
  End;
End;

Procedure WriteOut;

Var
  Path : Array[1..1000] Of Integer;
  PathLen : Integer;
  Q : Integer;
  F : Text;

Begin
  PathLen := 0;
  Q := Dest;
  While Q <> -1 Do
  Begin
    Inc(PathLen);
    Path[PathLen] := Q;
    Q := P[Q];
  End;
  ASSign(F, 'SUMS.OUT');
  Rewrite(F);
  Writeln(F, PathLen - 1);
  If Src <> Dest Then
    For Q := PathLen DownTo 1 Do
      WriteSum(F, SumList[Path[Q]]);
  Close(F);
End;

Begin
  ReadIn;
  Gen;
  Bahur;
  WriteOut;
End.
