(* NACIONALNA OLIMPIADA PO INFORMATIKA - 17 MART 2002 *)
(* VTORI KRUG - TEMA ZA 9 - 10 KLAS *)
(* grad Haskovo - PMG-Haskovo *)
(* Nikolay Georgiev Semov  - 10b *)

Program Dist;

Uses Crt, Dos;

Type TPoint = Record X, Y : Longint; End;
     TRect = Array[1..2] Of TPoint;

Var  R : Array[1..19] Of TRect;
     N : Integer;
     O : Text;

Procedure InvertRect(Var T : TRect); Forward;

Procedure ReadData;
Var F : Text;
    I : Integer;
Begin
   Assign(F, 'DIST.INP');
   Reset(F);
   ReadLn(F, N);
   For I := 1 To N Do Begin
      Read(F, R[I][1].X); Read(F, R[I][1].Y);
      Read(F, R[I][2].X); ReadLn(F, R[I][2].Y);
      InvertRect(R[I]);
   End;
   Close(F);
End;

Procedure WriteDataEx;
Begin
   Assign(O, 'DIST.OUT');
   Rewrite(O);
End;

Procedure WriteEx(P : String);
Begin
   WriteLn(O, P);
End;

Function GetPDist(P1, P2 : TPoint) : Real;
Var K1, K2 : Longint;
Begin
   K1 := Abs(P1.X - P2.X);
   K2 := Abs(P1.Y - P2.Y);
   GetPDist := Sqrt(Sqr(K1) + Sqr(K2));
End;

Function IsPIn(P : TPoint; T : TRect) : Boolean;
Begin
   If  (P.X >= T[1].X) And (P.X <= T[2].X)
   And (P.Y >= T[1].Y) And (P.Y <= T[2].Y) Then
      IsPIn := True
   Else IsPIn := False;
End;

Function Shared(T1, T2 : TRect) : Boolean;
Begin
   If (IsPIn(T1[1], T2)) Or (IsPIn(T1[2], T2)) Then
      Shared := True
   Else Shared := False;
End;

Procedure SwapEx(Var V1, V2 : Longint);
Var K : Longint;
Begin
   K := V1; V1 := V2; V2 := K;
End;

Procedure InvertRect(Var T : TRect);
Begin
   If T[1].X > T[2].X Then SwapEx(T[1].X, T[2].X);
   If T[1].Y > T[2].Y Then SwapEx(T[1].Y, T[2].Y);
End;

Function CStr(P : Integer) : String;
Var Ret : String;
Begin
   Str(P, Ret);
   CStr := Ret;
End;

Procedure ProceedData;
Type pTRes = Array[1..19] Of Real;
     pTResEx = Array[1..19] Of Integer;
Var  Res : pTRes; RC : Integer;
     ResEx : pTResEx;
     CRect : Integer;
     i : Integer;

   Function pConvert : String;
   Var i, j : Integer; K : Real; Ret : String;
   Begin
      For i := 1 To RC Do ResEx[I] := I;
      For i :=1 To RC - 1 Do
         For j := i + 1 To RC Do
            If (Res[j] < Res[i]) And (i <> CRect) And (j <> CRect) Then Begin
               K := Res[i];
               Res[i] := Res[j];
               Res[j] := K;
               ResEx[i] := j; ResEx[j] := i;
            End;
      Ret := '';
      For i := 1 To RC Do If i <> CRect Then Ret := Ret + CStr(ResEx[i]) + ' ';
      pConvert := Ret;
   End;

   Function GetMinDist(T1, T2 : TRect) : Real;
   Var P1, P2 : TPoint;
   Begin
      If Shared(T1, T2) Then Begin GetMinDist := 0; Exit; End;
      If T1[1].Y <= T2[2].Y Then Begin
         P1.Y := T2[2].Y; P2.Y := T1[1].Y;
      End Else Begin
         If T1[2].Y >= T2[1].Y Then Begin
            P1.Y := T2[1].Y; P2.Y := T1[2].Y;
         End Else Begin
            P1.Y := 1; P2.Y := 1;
         End;
      End;
      If T1[1].X <= T2[2].X Then Begin
         P1.X := T2[2].X; P2.Y := T1[1].Y;
      End Else Begin
         If T1[2].X >= T2[1].X Then Begin
            P1.X := T2[1].X; P2.X := T1[2].X;
         End Else Begin
            P1.X := 1; P2.X := 1;
         End;
      End;
      GetMinDist := GetPDist(P1, P2);
   End;

Begin
   RC := N;
   For CRect := 1 To N Do Begin
      For i := 1 To N Do Res[i] := GetMinDist(R[CRect], R[i]);
      WriteEx(pConvert);
   End;
End;

Procedure WriteData;
Begin
   Close(O);
End;

BEGIN
   ReadData;
   WriteDataEx;
   ProceedData;
   WriteData;
END.
