/*
   Ivaylo Penkov Riskov
   OMG, Plovdiv
   11 now klas
*/

#include <stdio.h>

typedef char        sum[21];

sum  index[500];
int  dist[500], visited[500], parent[500];
char adj[500][500];
int start, end;
int n;
int ind = 0;
int path[21];

int cmp(sum a, sum b) {
    int i;
    
    if (a[0]!=b[0])
       return 0;
       
    for (i = 1; i <= a[0]; i++)
        if (a[i]!=b[i])
           return 0;
    return 1;
}

int getindex(sum t) {
    int i;
    
    for (i = 0; i < ind; i++)
        if (cmp(t, index[i]))
              return i;
    return -1;
}

#define MAXI	2000000000

void Dijkstra(int node) {
	int i, mindist;

        for (i = 0; i < ind; i++)
		dist[i] = MAXI, visited[i] = 0;

        dist[node] = 0;

        while (1) {
          	mindist = MAXI;
                for (i = 0; i < ind; i++)
                   if (!visited[i] && dist[i] < mindist)
                     	node = i, mindist = dist[i];

                if (mindist == MAXI)
                   break;

                visited[node] = 1;
                for (i = 0; i < ind; i++)
                   if (adj[node][i] && dist[i] > dist[node] + adj[node][i]) {
                     dist[i] = dist[node] + adj[node][i];
                     parent[i] = node;
                   }
        }
}

void razbij(int n, int depth, int last) {
     int i;
     
     if (n < 0)
        return;
        
     if (!n) {
        index[ind++][0] = depth-1;
        for (i = 1; i <= depth; i++)
            index[ind][i] = index[ind-1][i];
     }
     else
	for (i = 1; i <= last; i++) {
           index[ind][depth] = i;
           razbij(n-i, depth+1, i);
        }
}

void swap(sum a, int x, int y) {
     int temp;

     temp = a[x];
     a[x] = a[y];
     a[y] = temp;
}

void sort(sum a, int start, int end) {
    int i, temp = start;
    
    if (start >= end)
       return;
    for (i = start+1; i<=end; i++)
        if (a[i] > a[start])
           swap(a, i, ++temp);
           
    swap(a, temp, start);
    sort(a, start, temp-1);
    sort(a, temp+1, end);
}

int readsum(char *str) {
     sum a;
     int num, i = 1;
     
     while (1) {
           num = 0;
           while (*str<='9' && *str>='0') {
                 num = num*10+*str-'0';
                 str++;
           }
           a[i++] = num;
           if (*str!='+')
              break;
           str++;
     }
     a[0] = i-1;
     sort(a, 1, i-1);
     return getindex(a);
}

void printsum(FILE *f, sum a) {
     int i;
     
     for (i = 1; i < a[0]; i++)
         fprintf(f, "%i+", a[i]);
     fprintf(f, "%i\n", a[a[0]]);
}

void split(int parent) {
	sum temp;
        static int k;
        int i, j;

       if (visited[parent])
          return;
        visited[parent] = 1;
        temp[0] = index[parent][0]+1;
        for (i = 1; i <= index[parent][0]; i++)
           if (index[parent][i] > 1)
             	for (j = 1; j <= index[parent][i]/2; j++) {
                   	for (k = 1; k <= index[parent][0]; k++)
                           temp[k] = index[parent][k];
                        temp[k] = index[parent][i]-j;
                        temp[i] = j;
                   	sort(temp, 1, temp[0]);
             		k = getindex(temp);
	            	adj[parent][k] = adj[k][parent] = 1;
                    	split(k);
                }
}

void getpath(int i) {
	if (i == start) {
          path[ind++] = i;
          return;
        }
       	getpath(parent[i]);
        path[ind++] = i;
}

int main() {
    FILE *f;
    char str[50];
    int i,j;

    for (i = 0; i < 500; i++)
       	for (j = 0; j < 500; j++)
           adj[i][j] = 0;

    f = fopen("sums.inp", "rt");
    fscanf(f, "%i\n", &n);
    razbij(n, 1, n);
    fgets(str, 50, f);
    start = readsum(str);
    fgets(str, 50, f);
    end = readsum(str);
    fclose(f);

    if (end == start) {
       f = fopen("sums.out", "wt");
       fprintf(f, "0\n");
       fclose(f);
       return 0;
    }
    for (i = 0; i < ind; i++)
       visited[i] = 0;
    split(ind-1);

    Dijkstra(start);
    
    f = fopen("sums.out", "wt");
    fprintf(f, "%i\n", dist[end]);
    ind = 0;
    getpath(end);
    for (i = 0; i < ind; i++)
        printsum(f, index[path[i]]);
    fclose(f);

    return 0;
}
