/*
   Peter Radoslavov Dimov - OMG "Akad. Kiril Popov" Plovdiv - 11z klas
*/
#include <fstream>
#include <list>

using namespace std;

#define MAXN 100001

long long calcprice(int v);

int n, k;
int parent[MAXN];
int comps[MAXN];
int length[MAXN];
list<int> childs[MAXN];

int main(){

  for(int i = 0; i < MAXN; i++){
    parent[i] = 0;
    comps[i] = 0;
    length[i] = 0;
  }

  ifstream in("comp.inp");
  ofstream out("comp.out");

  in >> n >> k;

  for(int i = 1; i < n; i++){
    int child, par, len, count;
    in >> child >> par >> count >> len;
    parent[child] = par;
    length[child] = len;
    comps[child] = count;
    childs[par].push_back(child);
  }


  out << calcprice(1) << endl;
  
  return 0;
}

long long calcprice(int v){
  long long price = 0;
  int totcomps = 0;
  list<int>::iterator it;
  for(it = childs[v].begin(); it != childs[v].end(); it++){
    int u = *it;
    long long subtreepr = calcprice(u);
    price += subtreepr;
    price += 2 * (comps[u] / k * length[u]);
    if(comps[u] % k != 0) price += 2 * length[u];
    totcomps += comps[u];
  }
  comps[v] += totcomps;
  return price;
}
