/*
 * Rangel Petkov Dokov
 * gr. Plovdiv
 */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <conio.h>

struct rect{
	int x1;
	int x2;
	int y1;
	int y2;
	int number;
};

FILE *input, *output;
rect data[20];
int n;
int distances[20][20];

void getdata();
void solve();
int sortcmp();
int intcmp();
int calcdist();
int calcdist2();

void getdata()
{
	int i;
	
	fscanf( input, "%d\n", &n );
	for( i=1; i<=n; i++ ) {
		fscanf( input, "%d %d %d %d\n", &(data[i].x1),
			&(data[i].y1), &(data[i].x2), &(data[i].y2) );
		data[i].number=i;
	}
}

int sortcmp( const void *a, const void *b )
{
	if( ((rect*) a)->x1 > ((rect*) b)->x1 )
		return -1;
	else if( ((rect*) a)->y1 > ((rect*) b)->y1 )
		return -1;
	else 1;
}

void sort()
{
	int i;

	for( i=1; i<=n; i++ ) {
		if ( data[i].x2 > data[i].x1 ) {
			data[i].x1=data[i].x1^data[i].x2;
			data[i].x2=data[i].x1^data[i].x2;
			data[i].x1=data[i].x1^data[i].x2;
		}
		if ( data[i].y2 > data[i].y1 ) {
			data[i].y1=data[i].y1^data[i].y2;
			data[i].y2=data[i].y1^data[i].y2;
			data[i].y1=data[i].y1^data[i].y2;
		}
	}
	qsort( data, n, sizeof(rect), sortcmp );
}

int calcdist( int a, int b )
{
	double dist;
	
	if( data[b].x2 < data[a].x1 ) {
		if( data[b].y1 < data[a].y2 )
			dist=data[a].y2 - data[b].y1;
		else if( data[b].y2 > data[a].y1 )
			dist=data[b].y2 - data[a].y1;
		else dist=0;
	} else {
		if( data[b].y1 < data[a].y2 )
			dist=sqrt( (data[b].x2-data[a].x1)*(data[b].x2-data[a].x1)
			+ (data[a].y2-data[b].y1)*(data[a].y2-data[b].y1) );
			
		else if( data[a].y1 < data[b].y2 )
			dist=sqrt( (data[b].x2-data[a].x1)*(data[b].x2-data[a].x1)
			+ (data[b].y2-data[a].y1)*(data[b].y2-data[a].y1) );
			
		else dist=data[b].x2-data[a].x1;
	}

	return (int) floor(dist);
}

int calcdist2( int a, int b )
{
	double dist;
	
	if( data[b].x1 > data[a].x2 ) {
		if( data[b].y1 < data[a].y2 )
			dist=data[a].y2 - data[b].y1;
		else if( data[b].y2 > data[a].y1 )
			dist=data[b].y2 - data[a].y1;
		else dist=0;
	} else {
		if( data[b].y1 < data[a].y2 )
			dist=sqrt( (data[a].x2-data[b].x1)*(data[a].x2-data[b].x1)
			+ (data[a].y2-data[b].y1)*(data[a].y2-data[b].y1) );
			
		else if( data[a].y1 < data[b].y2 )
			dist=sqrt( (data[a].x2-data[b].x1)*(data[a].x2-data[b].x1)
			+ (data[b].y2-data[a].y1)*(data[b].y2-data[a].y1) );
			
		else dist=data[a].x2-data[b].x1;
	}

	return (int) floor(dist);
}

int intcmp( const void *a, const void *b )
{
	struct dist{
		int rec;
		int dis;
	};
	
	if( ((dist*) a)->dis > ((dist*) b)->dis )
		return 1;
	else if( ((dist*) a)->rec < ((dist*) b)->dis )
		return -1;
	else return -1;
}

void solve()
{
	struct {
		int rec;
		int dis;
	} dist[20];
	int i, m;

	for( i=1; i<=n; i++ ) {

		m=i;
		while( m>=1 ) {
			dist[m].dis = calcdist( i, m );
			dist[m].rec = data[m].number;
			m--;
		}
		m=i+1;
		while( m<=n ) {
			dist[m].dis = calcdist2( i, m );
			dist[m].rec = data[m].number;
			m++;
		}

		qsort( dist, n, 2*sizeof(int), intcmp );
		
		for( m=1; m<=n; m++ ) {
			distances[(data[i].number)][m] = dist[m].rec;
		}
	}
	for( i=1; i<=n; i++ ) {
		for( m=1; m<=n; m++ )
			if( distances[i][m] != i )
			fprintf( output, "%d ", distances[i][m] );
		fprintf( output, "\n");
	}
}

int main()
{
	input = fopen( "dist.inp", "r" );
	output = fopen( "dist.out", "w" );

//	clrscr();
	getdata();
	sort();
	solve();

//	for( int i=1; i<=n; i++ )
//	printf("\n %d %d %d %d", data[i].x1, data[i].y1, data[i].x2, data[i].y2 );

	fclose(input);
	fclose(output);
}
