//
// Zadacha 1 (Razburkvane) - STIR
//
// Ivan Zahariev
// grad Razgrad
//

#include <stdio.h>
#include <fcntl.h>
#include <sys\stat.h>

#define TRUE	1==1
#define FALSE	0==1

#define MAXLEN 100

int n;		/* N */
int bi[MAXLEN];	/* Bi */
int ai[MAXLEN];	/* Ai - redicata */
int pi[MAXLEN];	/* predpolagaemata redica */

void readdata() {
  int fd, i, j;
  char tmps[3], ch;

  if ((fd=open("STIR.INP", O_RDONLY|O_TEXT)) == -1) {
    perror("open()");
    exit(1);
  }

  memset(tmps, 0, 3);
  i=0;
  do {
    read(fd, &ch, 1);
    if (ch != '\n') {
      tmps[i++]=ch;
    }
  } while (ch != '\n');
  n=atoi(tmps);

  i=0;
  j=1;
  memset(tmps, 0, 3);
  do {
    read(fd, &ch, 1);
    if (ch != ' ' && ch != '\n' && !eof(fd)) {
      tmps[i++]=ch;
    } else
      if (strlen(tmps) > 0) {
	bi[j++]=atoi(tmps);
	i=0;
	memset(tmps, 0, 3);
      }
  } while (!eof(fd));

  close(fd);
}

int checknow() {
  int allare=TRUE, povt;
  int i, j, count;

  for (i=1; i <= n; ++i) {
    povt=FALSE;
    for (j=1; j <= n; ++j) {
      if (i == pi[j] && povt) return FALSE;	/* ima dublirane na cifrite */
      if (i == pi[j] && !povt) povt=TRUE;
    }
  }

  for (i=1; i <= n-1; ++i) {
    count=0;
    for (j=i+1; j <= n; ++j) {
      if (pi[j] < pi[i]) ++count;
    }
    if (count != bi[i]) allare=FALSE;
  }

  return allare;
}

void mydec(int idx) {
  if (pi[idx] - 1 == 0) {
    pi[idx]=n;
    mydec(idx-1);	/* recursia */
  } else {
    pi[idx]--;
  }
}

int allones() {
  int allare=TRUE;
  int i;

  for (i=1; i <= n; ++i) {
    if (pi[i] != 1) allare=FALSE;
  }

  return allare;
}

void think() {
  int i, lastidx;

  for (i=1; i <= n; ++i) pi[i]=n;

  do {
    mydec(n);	/* bruteforce method za namirane na vsichki vuzmojni redici */
    if (checknow()) break;	/* i proverka dali otgovariat na uslovieto */
  } while (!allones());	/* nikoga ne bi triabvalo vsichki da sa == 1 !! */
	/* pravim proverka za allones() samo, za da izbegnem nevuzojni redici, t.e. */
	/* uslovieto da ne moje da otgovaria na nikoia redica */
}

void writeresult() {
  int fd, i;
  char tmps[3];

  if ((fd=creat("STIR.OUT", S_IREAD|S_IWRITE)) == -1) {
    perror("creat()");
    exit(1);
  }

  for (i=1; i <= n-1; ++i) {
    sprintf(tmps, "%d ", pi[i]);
    write(fd, tmps, strlen(tmps));
  }
  sprintf(tmps, "%d\n", pi[n]);
  write(fd, tmps, strlen(tmps));

  close(fd);
}

int main() {

  readdata();
  think();
  writeresult();

  return 0;
}