/* Alexander Georgiev Kynchev     11 klas MG Rousse */

#include <iostream>
#include <fstream>
#include <list>
#include <stack>
#include <queue>

#define	INPUT		"comp.inp"
#define	OUTPUT		"comp.out"

typedef unsigned long long uint;

struct edge {
	uint num, len;
        edge *next;
};

struct vertex {
	uint pcs, count;
	edge *link;
};

vertex *a;
uint trace, kn, n, start;

void topol();
void prep();
//void dfs(uint, uint, uint);

enum { nil=-1, absent=-2 };

int main(void)
{
 ifstream fin(INPUT, ios::in | ios::nocreate);
 	if(!fin) { cout << "I/O error !\n"; return 1; }
 uint k1, len;
 	fin >> n >> kn;
	a = new vertex[n+=1];
 uint i, j;
 	for(i=1 ; i < n ; i++) {
        	a[i].link = NULL;
                a[i].count = absent;
        }
	while(fin >> i >> j >> k1 >> len && !fin.fail()) {
    	 edge *p = new edge;
         	if(a[i].count == absent) a[i].count = 0;
                if(a[j].count == absent) a[j].count = 0;
         	p->num = j;
                p->len = len;
		p->next = a[i].link;
                a[i].link = p;
                a[j].count++;
                a[i].pcs = k1;
        }
	fin.close();

        cout << endl << endl;
        a[1].pcs = 0;
        prep();
        topol();

ofstream fout(OUTPUT, ios::out | ios::trunc);
	cout << trace << endl;
        fout << trace << endl;
        fout.close();
	return 0;
}

void prep() {
	for(uint i=1 ; i < n ; i++)
		if(!a[i].count) { a[i].count = start; start = i; }
}
	

void topol() {
 uint j, k, ln, pc;
 edge *p;
	for(uint i=1 ; i < n-1 ; i++) {
		while(a[i].count == absent) i++;
		if(start == nil) { cout << "There is a cycle !\n"; exit(-1); }
		j = start; start = a[j].count;
         	if(a[j].pcs) {
                 uint f = a[j].pcs/kn;
                 uint ff = a[j].pcs%kn;
                 	if(f)
                        	trace += (2*a[j].link->len)*(a[j].pcs/kn)-(ff ? 0 : a[j].link->len);
                        if(ff)
                                	trace += (f ? 2 : 1)*a[j].link->len;
                        a[a[j].link->num].pcs += a[j].pcs;
                        a[j].pcs = 0;
                }

		while(1) {
			p = a[j].link;
			if(!p) break;
                        ln = p->len;
			k = p->num;
			if(!(--a[k].count)) { a[k].count = start; start = k; }
			a[j].link = p->next;
			delete p;
		}
	}
	trace += 2*ln;
}

