/*
NAME: Ivan Anev
SCHOOL: SMG
CLASS: 11a
PROBLEM: comp
*/

#include <stdio.h>

#define MAXN 100000

typedef struct Vex TVex;

struct Vex {
       int p, ch, comp, edge;
};

TVex vs[MAXN];
int n, k;

int queue[MAXN+1];
int head, tail;

void reset(void) {
     head = tail = 0;
}

void enqueue(int a) {
     queue[tail++] = a;
     if (tail > MAXN)
        tail = 0;
}

int dequeue(void) {
    int r;

    r = queue[head++];
    if (head > MAXN)
       head = 0;

    return r;
}

int empty(void) {
    return head == tail;
}

int main(void) {
    FILE *fin, *fout;
    int i, x, p, c, e;
    long long total;

    fin = fopen("comp.inp", "r");
    fout = fopen("comp.out", "w");

    fscanf(fin, "%d %d\n", &n, &k);
    for (i = 0; i < n; ++i) {
        vs[i].p = -1;
        vs[i].ch = 0;
        vs[i].comp = 0;
        vs[i].edge = 0;
    }
    for (i = 1; i < n; ++i) {
        fscanf(fin, "%d %d %d %d\n", &x, &p, &c, &e);
        --x;
        --p;
        vs[x].p = p;
        vs[x].comp = c;
        vs[x].edge = e;
        ++vs[p].ch;
    }
    for (i = 0; i < n; ++i)
        if (vs[i].ch == 0)
           enqueue(i);

    total = 0;
    while (!empty()) {
          x = dequeue();
          if (x == 0)
             break;
          p = vs[x].comp / k + (vs[x].comp % k != 0);
          total += p * vs[x].edge;
          p = vs[x].p;
          --vs[p].ch;
          vs[p].comp += vs[x].comp;
          if (vs[p].ch == 0)
             enqueue(p);
    }

    total *= 2;
    fprintf(fout, "%lld\n", total);

    fclose(fin);
    fclose(fout);
    
    return 0;
}
