// Rumen Ivanov Zarev - 11a SMG, Sofia

#include <fstream>
#include <string>

using namespace std;

struct pred{
       char num;
       char c[ 20 ];
};

const int QSIZE = 150000;

int n;
pred A, B, tmp, S[ QSIZE ];
short prev[ QSIZE ];
int history[ QSIZE ];
int hists;
bool proc[ 1024 * 512 + 5 ];
short sb, se;

bool comp( const pred&, const pred& );
void read( const string&, pred& );
void write( ostream&, pred );
int encode( const pred& );
void add( pred&, short );

int main( ) {
    string line;
    ifstream fin( "SUMS.INP" );
    fin >> n;
    fin >> line;
    read( line, A );
    fin >> line;
    read( line, B );
    fin.close( );

    if ( comp( A, B ) ) {
       ofstream fout( "SUMS.OUT" );
       fout << 0 << endl;
       fout.close( );
       return 0;
    }

    sb = 0;
    se = 1;
    S[ 0 ] = A;
    prev[ 0 ] = -1;
    proc[ encode( A ) ] = true;
    
    while ( !comp( S[ sb ], B ) ) {
          tmp = S[ sb ];
          for ( int i = 1; i <= n; i++ )
              if ( tmp.c[ i ] != 0 ) {
                  for ( int j = 1; j + j <= i; j++ ) {
                      if ( j + j < i ) {
                         if ( tmp.c[ j ] == 0 )
                            tmp.num++;
                         if ( tmp.c[ i - j ] == 0 )
                            tmp.num++;
                      } else if ( tmp.c[ j ] == 0 )
                        tmp.num++;
                      if ( tmp.c[ i ] == 1 )
                         tmp.num--;
                      tmp.c[ i ]--;
                      tmp.c[ j ]++;
                      tmp.c[ i - j ]++;

                      add( tmp, sb );

                      tmp.c[ i ]++;
                      tmp.c[ j ]--;
                      tmp.c[ i - j ]--;
                      tmp.num = S[ sb ].num;
                  }
              }
          for ( int i = 1; i <= n; i++ )
              if ( tmp.c[ i ] != 0 ) {
                 if ( tmp.c[ i ] > 1 ) {
                    if ( tmp.c[ i ] == 2 )
                       tmp.num --;
                    if ( tmp.c[ i + i ] == 0 )
                       tmp.num++;
                    tmp.c[ i ] -= 2;
                    tmp.c[ i + i ]++;

                    add( tmp, sb );

                    tmp.c[ i ] += 2;
                    tmp.c[ i + i ]--;
                    tmp.num = S[ sb ].num;
                 }
                 for ( int j = i + 1; j <= n; j++ )
                     if( tmp.c[ j ] != 0 ) {
                         if ( tmp.c[ j ] == 1 )
                            tmp.num--;
                         if ( tmp.c[ i ] == 1 )
                            tmp.num--;
                         if ( tmp.c[ i + j ] == 0 )
                            tmp.num++;
                         tmp.c[ i ]--;
                         tmp.c[ j ]--;
                         tmp.c[ i + j ]++;

                         add( tmp, sb );

                         tmp.c[ i ]++;
                         tmp.c[ j ]++;
                         tmp.c[ i + j ]--;
                         tmp.num = S[ sb ].num;
                     }
              }
          sb++;
    }

    hists = 0;
    do {
       history[ hists ] = sb;
       hists++;
       sb = prev[ sb ];
    } while ( sb != -1 );

    ofstream fout( "SUMS.OUT" );
    fout << hists - 1 << endl;
    for ( int i = hists - 1; i >= 0; i-- )
        write( fout, S[ history[ i ] ] );
    fout.close( );

    return 0;
}

void read( const string& x, pred& a ) {
     int j = 0;
     int lim = x.length( );
     for ( int i = 0; i <= n; i++ )
         a.c[ i ] = 0;
     while ( j < lim )
           if ( j == lim - 1 || x[ j + 1 ] == '+' ) {
              a.c[ x[ j ] - '0' ]++;
              j += 2;
           } else {
             a.c[ ( x[ j ] - '0' ) * 10 + x[ j + 1 ] - '0' ]++;
             j += 3;
           }
     int num = 0;
     for ( int i = 0; i <= n; i++ )
         if ( a.c[ i ] > 0 )
            num++;
     a.num = num;
}

void write( ostream& sout, pred a ) {
     int j = 19;
     for ( int i = 0; i < a.num - 1; i++ ) {
         while ( a.c[ j ] == 0 )
               j--;
         while ( a.c[ j ] != 0 ) {
               sout << j << '+';
               a.c[ j ]--;
         }
     }
     while ( a.c[ j ] == 0 )
           j--;
     while ( a.c[ j ] != 1 ) {
           sout << j << '+';
           a.c[ j ]--;
     }
     sout << j << endl;
}

int encode( const pred& a ) {
    int hash = 0;
    for ( int i = 1; i <= n; i++ )
        for ( int j = 0; j < a.c[ i ]; j++ ) {
            hash = hash << i;
            hash += 1;
        }
    return hash;
}

bool comp( const pred& a, const pred& b ) {
     if ( a.num != b.num )
        return false;
     for ( int i = 1; i <= n; i++ )
         if ( a.c[ i ] != b.c[ i ] )
            return false;
     return true;
}

void add( pred& a, short pr ) {
     if ( proc[ encode( a ) ] )
        return;
     proc[ encode( a ) ] = true;
     S[ se ] = a;
     prev[ se ] = pr;
     se++;
//     if ( se == QSIZE )
//        se = 0;
}
