#include <stdio.h>
#include <stdlib.h>
 
int used[270000];
int par[270000];
int que[270000];
int dist[270000];
int ir, iw;
int arr[2][22];
int S, T;
int N, P;


void read_all(void);
void do_all(void);
int encode(int *arr);
int decode(int c, int *arr);
void printc(FILE *f, int c);
void BFS(void);
void write_all(void);



int main(void)
{
  read_all();
  do_all();
  write_all();
  return 0;
}



void read_all(void)
{
  char s[100];
  int i, nl, k;

  FILE *f = fopen("sums.inp", "rt");
  fscanf(f, "%d\n", &N);
  for (nl = 0; nl < 2;) {
    k = fscanf(f, "%d%[^0-9]", &i, s);
    arr[nl][i]++;
    if (strchr(s, '\n') || k != 2)  nl++;
  }
  fclose(f);
}



void do_all(void)
{
  int i;

  S = encode(arr[0]);
  T = encode(arr[1]);
  BFS();
}



void BFS(void)
{
  int i, j, u, v;
  int a[22];
  int AA, AB;

  que[iw++] = S;
  used[S] = 1;
  memset(par, -1, 270000*sizeof(par[0]));
  AA = AB = 0;
  while (ir < iw) {
    u = que[ir++];
    AA++;
    if (u == T)  break;
    decode(u, a);
    for (i = 1; i <= N; i++) {
      if (a[i]) {
        for (j = 1; j < i; j++) {
          a[i]--;  a[j]++;  a[i-j]++;
          v = encode(a);
          if (used[v] == 0)  used[v] = 1, que[iw++] = v, par[v] = u, dist[v] = dist[u]+1;
          a[i]++;  a[j]--;  a[i-j]--;
        }
      }
    }
    for (i = 0; i <= N; i++) {
      for (j = i; j <= N; j++) {
        if (a[i] == 0 || a[j] == 0 || (i == j && a[i] < 2))  continue;
        a[i]--;  a[j]--;  a[i+j]++;
        v = encode(a);
        if (used[v] == 0)  used[v] = 1, que[iw++] = v, par[v] = u, dist[v] = dist[u]+1;
        a[i]++;  a[j]++;  a[i+j]--;
      }
    }
  }
  P = dist[u];
}



int encode(int *arr)
{
  int i, j, k, n;
  int res = 0;

  n = N;
  for (i = 1; i <= N; i++) {
    for (j = 0; j < arr[i]; j++) {
      for (k = 1; k < i; k++) {
        res += (1<<(n-k-1));
      }
      n -= i;
    }
  }
  return res;
}



int decode(int c, int *arr)
{
  int i, j, k, n;
  int res = 0;

  memset(arr, 0, 22*sizeof(arr[0]));
  for (n = N; n >= 1; ) {
    k = (1<<(n-1))-1;
    for (j = 1, i = n; ; j<<=1, i--) {
      if (c >= k) {
        arr[i]++;
        c -= k;
        n -= i;
        break;
      }
      k -= j;
    }
  }
  return 0;
}



void printc(FILE *f, int c)
{
  int a[22];
  int i, j, ft;

  ft = 1;
  decode(c, a);
  for (i = 1; i <= N; i++) {
    for (j = 0; j < a[i]; j++) {
      fprintf(f, "%s%d", (ft)?"":"+", i);  ft = 0;
    }
  }
  fprintf(f, "\n");
}


void write_all(void)
{
  int i;
  int path[700];

  FILE *f = fopen("sums.out", "wt");
  fprintf(f, "%d\n", P);
  if (P > 0) {
    i = 0;
    while (T != -1) {
      path[i++] = T;
      T = par[T];
    }
    for (i = i-1; i >= 0; i--) {
      printc(f, path[i]);
    }
  }
  fclose(f);
}


