program Comp__;
{Hristo Atanasov Ivanov 11 klas Dobrich}
const
  MaxItems   = 88;
  MaxElements=100000;
  MaxQItems       = MaxLongInt;

  InputFStr='comp.inp';
  OutputFStr='comp.out';
type
  Ogr=0..MaxElements;
  TEdge= record

           Computers,
           Length_,
           Length_Here,
           ChildCount,
           Parent      : LongInt;
           used        : boolean;

         end;
  TGraph= array[Ogr] of TEdge;

  TMultee = Comp;

  PNode      = ^TNode;

  TWeigth    = LongInt; {modify here!!}

  TEdgeInfo     = record

                 Child  : PNode;
                 Weigth : TWeigth;

               end;

  PEdge     = ^TEdge;

  MEdge     = record

                 EInfo : TEdgeInfo;
                 Next  : PEdge;

               end;

  {declarations for the base Node type}

  TKey       = integer; {modify here as needed!!}

  TInfo      = record   {modify as needed!! == Node data goes here ==}

                 Key  : TKey;
                 {other fields, if need go here}

               end;

  TNode      = record

                 Data      : TInfo;
                 InDegreeZero,        {used in Topological Sort}
                 Visited   : Boolean; { used in finding a way and other
                                       recursive procedures}
                 Head      : PEdge;   { The HEAD node. Is always empty}
                 Parent,              { Used for path finding}
                 Child     : PNode;   { Used in TopologicalSort}
                 HeapIndex : Integer; { Used in FindMCPath, BuildMCTree}
                 MinCost   : TWeigth; { Used in FindMCPath, BuildMCTree}
                 Next      : PNode;   { the next element in the table}

               end;

  QInfoType = PNode;

  HTKey     = TWeigth;
  HTInfo    = record
                Key : HTKey;
                Node : PNode;
              end;
  TItems    = array[ 1..MAxItems ] of HTInfo;

  THeap     = record
                Items : TItems;
                Count : Integer;
              end;



    QPtr       = ^QNode;
    QNode      = record
                   Data : QInfoType;
                   Next : QPtr;
                 end;
    TQueue     = object
                   Back  : QPtr;
                   Count : Integer;
                   constructor Init;
                   destructor Done;

                   function IsEmpty : Boolean;
                   function IsFull  : Boolean;
                   procedure Add(var Data : QInfoType);
                   procedure Serve(var Data : QInfoType);
                   procedure ReturnFirst( var Data : QInfoType);
                 end;


  {**********************************************}
  {* Basic declarations for the graph structure *}
  {**********************************************}



var

  Graph:TGraph;
  n:Ogr;
  k:Ogr;

procedure Input;
var
  InpF:Text;
  Iterator, j:Ogr;
begin
  assign(InpF, InputFStr);
  ReSet(InpF);

  ReadLn(InpF, N, K);
  with Graph[1] do
  begin
    Length_:=0;
    Computers:=0;
    Parent:=0;
    Used:=false;
  end;

  for Iterator:=1 to N-1 do
  begin

    read(InpF, j);

    with Graph[j] do
    begin

      ReadLn(InpF, Parent, Computers, Length_);
      Used:=false;

    end;

  end;

  Close(InpF);
end;

procedure CountEdges;
var
  Iterator, j:Ogr;

  begin
    for Iterator:=2 to n do
      Graph[ Graph[Iterator].Parent ].ChildCount:=
         Graph[ Graph[Iterator].Parent ].ChildCount + 1;
  end;

   function FindNode:Ogr;
     var
       Iterator:Ogr;
     begin
       for Iterator:=1 to n do
         with Graph[Iterator] do
          if (not Used) and (ChildCount=0) then
           begin
             FindNode:=Iterator;
             EXIT;
           end;
     End;

   function TrialsForComputers(num:LongInt):LongInt;
     Begin
       if num mod k =0 then
         TrialsForComputers:=num div k
       else TrialsForComputers:=num div k+1;
     End;

   procedure Solve;
     var
       Done:boolean;
       Iterator:Ogr;
     begin
       CountEdges;
       Done:=false;

       while not Done do
        begin

          Iterator:=FindNode;

          if Iterator=1 then
            Done:=true

          else
          begin
            with Graph[Iterator] do
            begin
              Graph[Parent].Computers:=Graph[Parent].Computers+Computers;
              Graph[Parent].ChildCount:=Graph[Parent].ChildCount-1;
              Graph[Parent].Length_Here:=Graph[Parent].Length_Here+TrialsForComputers(Computers)*2*Length_+Length_Here;
              Used:=true;
            end;
          end;
        end;
     end;

   procedure Print;
     var
       Fout:Text;
     Begin
       Assign(Fout, OutputFStr);
       ReWrite(Fout);

       Write(Fout,  Graph [1].Length_Here);

       Close(Fout);
     End;

  constructor TQueue.Init;
  begin
    Back := nil;
    Count := 0;
  end;

  function TQueue.IsEmpty: Boolean;
  begin
    IsEmpty := Count = 0;
  end;

  function TQueue.IsFull: Boolean;
  begin
    IsFull := Count = MaxQItems;
  end;

  procedure TQueue.Add( var Data : QInfoType );
  var
    P : QPtr;
  begin
    New(P);
    P^.Data := Data;
    if IsEmpty then
      P^.Next := P
    else
    begin
      P^.Next := Back^.Next;
      Back^.Next := P;
    end;

    Back := P;
    Count := Count + 1;

  end;

  procedure TQueue.Serve( var Data : QInfoType );
  var
    Front : QPtr;
  begin

    Front := Back^.Next;
    Data  := Front^.Data;

    if Front = Back then
      Back := nil
    else
      Back^.Next := Front^.Next;

    Dispose(Front);
    Dec(Count);

  end;

  procedure TQueue.ReturnFirst( var Data : QInfoType );
  begin
    Data := Back^.Next^.Data;
  end;

  destructor TQueue.Done;
  var
    Data : QInfoType;
  begin
    while back <> nil do
      Serve(Data);
  end;

var
  Q : TQueue;
Begin
  Input;
  Q.Init;
  Solve;
  Print;
End.