const inf=10000;

var graph: array[1..1000, 1..1000] of Integer; {1000, 1000}
    N, M: Integer;
    works: array[1..5000] of record i, j, c: Integer end; {5000}
    solution: array[1..1000] of Integer; {1000}

procedure Floyd;
var i, j, m: Integer;
begin
  for m:=1 to N do
    for i:=1 to N do
      if graph[i, m]>-inf then
        for j:=1 to N do
          if graph[m, j]>-inf then
            if graph[i, j]<(graph[i, m]+graph[m, j]) then
              graph[i, j]:=graph[i, m]+graph[m, j];
end;

procedure Init;
var i, j: Integer;
begin
  for i:=1 to N do
    for j:=1 to N do
      graph[i, j]:=-inf;
  for i:=1 to M do
    {if works[i].c<0 then}
      graph[works[i].i, works[i].j]:=-works[i].c;
end;

procedure ReadData(fname: String);
var F: Text; u: Integer;
begin
  Assign(F, fname);
  Reset(F);
  readln(F, N, M);
  for u:=1 to M do
    readln(F, works[u].i, works[u].j, works[u].c);
  Close(F);
end;

procedure Solve;
var i, j, min: Integer;
begin
  for i:=1 to N do
    for j:=1 to N do
      if graph[i, j]>0 then
        begin
        if (solution[i]<>0)and(solution[j]<>0) then continue;
        if (solution[i]=0)and(i<>1) then solution[i]:=solution[j]-graph[i, j];
        if (solution[j]=0)and(j<>1) then solution[j]:=solution[i]+graph[i, j];
        end;
  min:=0;
  for i:=2 to N do
    if solution[i]<min then
      min:=solution[i];
  if min<0 then
    for i:=1 to N do
      solution[i]:=solution[i]+min;
end;

procedure WriteData(fname: String);
var F: Text; i: Integer; ok: Boolean;
begin
  Assign(F, fname);
  Rewrite(F);
  ok:=true;
  for i:=1 to M do
    if solution[works[i].i]-solution[works[i].j]>works[i].c then
      begin
      ok:=false; break;
      end;
  if ok then
    for i:=1 to N do
      writeln(F, solution[i])
  else
    writeln(F, 'NO SOLUTION');
  Close(F);
end;

begin
  ReadData('work.inp');
  Init;
  Floyd;
  Solve;
  WriteData('work.out');
end.
