{$MODE objfpc}

Uses
  SysUtils;

Const
  Infinity = $1FFFFFFF;

Var
  N, M : Integer;
  res : Array[1..1000] Of Integer;
  range : Array[1..1000] Of Record
    min, max : Integer;
  End;
  eq : Array[1..5000] Of Record
    i, j, B : Integer;
  End;
  nosol : Boolean;

Procedure WriteOut;

Var
  F : Text;
  I : Integer;
  minres : Integer;

Begin
  ASSign(F, 'WORK.OUT');
  Rewrite(F);
  If nosol Then
  Begin
    Writeln(F, 'NO SOLUTION');
    {$IFNDEF RELEASE}
    Writeln('NO SOLUTION');
    {$ENDIF}
  End
  Else
  Begin
    minres := Infinity;
    For I := 1 To N Do
    Begin
      res[I] := (range[I].min + range[I].max) Div 2;
      If minres > res[I] Then
        minres := res[I];
    End;
    For I := 1 To N Do
    Begin
      Writeln(F, res[I] - minres);
      {$IFNDEF RELEASE}
      Writeln(res[I] - minres);
      {$ENDIF}
    End;
  End;
  Close(F);
  Halt;
End;

Procedure NoSolution;

Begin
  nosol := True;
  WriteOut;
End;

Procedure ReadIn;

Var
  F : Text;
  I : Integer;

Begin
  ASSign(F, 'WORK.INP');
  Reset(F);
  Readln(F, N, M);
  For I := 1 To M Do
    Readln(F, eq[I].i, eq[I].j, eq[I].B);
  Close(F);
  For I := 1 To N Do
  Begin
    range[I].max := Infinity;
    range[I].min := -Infinity;
  End;
  nosol := False;
End;

Function CR : Boolean;

Var
  I : Integer;
  A, B, K : Integer;

Begin
  CR := False;
  For I := 1 To M Do
  Begin
    A := eq[I].i;
    B := eq[I].j;
    K := eq[I].B;
    If (range[B].max < Infinity) And ((range[B].max + K) < range[A].max) Then
    Begin
      range[A].max := range[B].max + K;
      CR := True;
    End;
    If range[A].max < range[A].min Then
      NoSolution;

    If (range[A].min > (-Infinity)) And ((range[A].min - K) > range[B].min) Then
    Begin
      range[B].min := range[A].min - K;
      CR := True;
    End;
    If range[B].max < range[B].min Then
      NoSolution;
  End;
End;

Var
  CRRes : Boolean;
  I : Integer;

Begin
  ReadIn;
{  range[1].min := 0;
  range[1].max := 0;}
  Repeat
    CRRes := CR;
    For I := 1 To N Do
      If (range[I].min = (-Infinity)) And (range[I].max = Infinity) Then
      Begin
        range[I].min := 0;
        range[I].max := 0;
        CRRes := True;
        Break;
      End;
    If CRRes = False Then
    Begin
      WriteOut;
    End;
  Until False;
End.
