#include <stdio.h>

#define MAXRE 1024

int m,n;

int pole[32][32];
int vc,num;

int r1[MAXRE],r2[MAXRE],r3[MAXRE],r4[MAXRE];

int vis[256][256];

int dfs(int x1,int y1)
{
  int rsl,x,y;
  num++;

  x=x1; y=y1;
  
  while (pole[x][y])
  {
    x++;
    if (x>m) { x=1; y++; }
    if (y>n) { return 1; }
  }

  pole[x][y] = num;

  if (pole[x+1][y]==0)
  { // Chance
     pole[x+1][y] = num;
     if (pole[x][y+1]==0) {
       pole[x][y+1] = num;
       rsl = dfs(x+2,y);
       if (rsl) { return 1; }
       pole[x][y+1] = 0;
     }
     if (pole[x+1][y+1]==0) {
       pole[x+1][y+1] = num;
       rsl = dfs(x+2,y);
       if (rsl) { return 1; }
       pole[x+1][y+1] = 0;
     }
     pole[x+1][y] = 0;
  }

  if (pole[x][y+1]==0)
  {
    pole[x][y+1]=num;

    if (pole[x-1][y+1]==0) {
      pole[x-1][y+1]=num;
      rsl = dfs(x+1,y);
      if (rsl) { return 1; }
      pole[x-1][y+1]=0;
    }
    if (pole[x+1][y+1]==0) {
      pole[x+1][y+1]=num;
      rsl = dfs(x+1,y);
      if (rsl) { return 1; }
      pole[x+1][y+1]=0;
    }

    pole[x][y+1]=0;
  }
  pole[x][y] = 0;

  num--;
  return 0;
}

int clearpole(void)
{
  int i,j;
  for (i=0;i<32;i++)
  {
    for (j=0;j<32;j++)
    {
      pole[i][j] = -1;
    }
  }

  for (i=1;i<=n;i++)
  {
    for (j=1;j<=m;j++)
    {
      pole[j][i] = 0;
    }    
  }
  return 0;
}

int printpole(void)
{
  int i,j,md;
  char* f1;
  char* f2;

  md = 1;
  for (i=1;i<=n;i++)
  {
    for (j=1;j<=m;j++)
    {
      if (pole[j][i]>=10) { md=2; }
      if (pole[j][i]>=100) { md=3; }
    }
  }

  if (md==1) { f1="%d"; f2=" %d"; }
  if (md==2) { f1="%2d"; f2=" %2d"; }
  if (md==3) { f1="%3d"; f2=" %.3d"; }
  
  for (i=1;i<=n;i++)
  {
    printf(f1,pole[1][i]);
    for (j=2;j<=m;j++)
    {
      printf(f2,pole[j][i]);
    }
    printf("\n");
  }
  return 0;  
}

int wasmet(int i1,int j1,int i2,int j2)
{
  if (m==n)
  {
    if
      ( (vis[i1*16+j1][i2*16+j2]==0) &&
        (vis[i2*16+j2][i1*16+j1]==0) &&
       
        (vis[j1*16+i1][j2*16+i2]==0) &&
        (vis[j2*16+i2][j1*16+i1]==0)  )

       { return 0; }

    return 1;
  }
  return 0;
}

int main(void)
{
  FILE* f;
  int i,j,mm,mn;
  f = fopen("board.inp","rt");
  fscanf(f,"%d %d",&n,&m);
  fclose(f);

  freopen("board.out","wt",stdout);

  if ((m*n)%3==0)
  {
    clearpole();
    vc = dfs(1,1);
    if (vc==0) { printf("0\n"); } else { printpole(); }
    vc=-1;
  } else
  if ((m*n)%3==1) {
    mm = (m+1)/2;
    mn = (n+1)/2;
    
    if (m==n)
    {
      for (i=1;i<=mn;i++)
      {
        for (j=1;j<=i;j++)
        {
          clearpole();
          pole[j][i] = -1;
          if (dfs(1,1)) { r1[vc]=j; r2[vc]=i; vc++; }
        }
      }
    } else {    
      for (i=1;i<=mn;i++)
      {
        for (j=1;j<=mm;j++)
        {
          clearpole();
          pole[j][i] = -1;
          if (dfs(1,1)) { r1[vc]=i; r2[vc]=j; vc++; }
        }
      }
    }
    printf("%d\n",vc);
    for (i=0;i<vc;i++)
    {
      printf("%d %d\n",r1[i],r2[i]);
    }
  } else
  {
    for (i=1;i<=n/2;i++)
    {
      for (j=1;j<=m/2;j++)
      {      
//        if ((vis[i*16+j+1][i*16+j]==0) &&
//            (vis[i*16+j][i*16+j+1]==0) &&
//            (vis[j*16+i+1][j*16+i]==0) &&
//            (vis[j*16+i][j*16+i+1]==0))
        if (wasmet(i,j,i,j+1)==0)
        {
          clearpole();
          pole[j][i] = -1;
          pole[j+1][i] = -1;
          if (dfs(1,1)) { r1[vc]=i; r2[vc]=j; r3[vc]=i; r4[vc]=j+1; vc++; }
          vis[i*16+j][i*16+j+1] = 1;
        }
//        if ((vis[i*16+j][(i+1)*16+j]==0) &&
//            (vis[(i+1)*16+j][i*16+j]==0) &&
//            (vis[j*16+i][(j+1)*16+i]==0) &&
//            (vis[(j+1)*16+i][j*16+i]==0))
        if (wasmet(i,j,i+1,j)==0)
        {
          clearpole();
          pole[j][i] = -1;
          pole[j][i+1] = -1;
          if (dfs(1,1)) { r1[vc]=i; r2[vc]=j; r3[vc]=i+1; r4[vc]=j; vc++; }
          vis[i*16+j][(i+1)*16+j] = 1;
        }
      }
    }

    for (i=0;i<vc;i++)
    {
      for (j=i+1;j<vc;j++)
      {
        if ((r1[i]==r1[j]) && (r2[i]==r2[j]))
        {
          if (r3[i]>r3[j])
          {
            mm = r3[i];
            r3[i] = r3[j];
            r3[j] = mm;

            mm = r4[i];
            r4[i] = r4[j];
            r4[j] = mm;
          }
        }
      }
    }
    
    printf("%d\n",vc);
    for (i=0;i<vc;i++)
    {
      printf("%d %d  %d %d\n",r1[i],r2[i],r3[i],r4[i]);
    }

  }

  fclose(stdout);
  return 0;
}
