const inp = 'work.inp';
      out = 'work.out';
      MaxV = 6000;

type TVert = record
             k, ind: integer;
             end;
     TVerts = array[1..MaxV] of TVert;

     TConn = array[1..MaxV, 1..MaxV] of boolean;

     TUsed = array[-100..100] of integer;
     TUsedArr = array[1..MaxV] of TUsed;

     TTaken = array[1..MaxV] of boolean;

     TStack = array[1..MaxV] of integer;

     TTime = array[1..MaxV] of longint;

var Fin, Fout: Text;
    used: TUsedArr;
    m, n, brV, ind: integer;
    conn: TConn;
    v: TVerts;
    time: TTime;

{############################################################################}
Procedure Done;
begin
close(Fin); close(Fout);
halt;
end;

{############################################################################}
Procedure Init;
var i: integer;

begin
assign(Fin, inp); reset(Fin);
assign(Fout, out); rewrite(Fout);

fillchar(used, sizeof(used), 0);
brv:= 0;
readln(Fin, n, m);
for i:=1 to n do
  begin
  inc(brV);
  used[brV][0]:= brv;
  v[brv].ind:= i; v[brv].k:= 0;
  end;

fillchar(conn, sizeof(conn), false);
end;

{############################################################################}
procedure ReadFile;
var i, j, a, b, k: integer;

begin
for i:=1 to m do
  begin
  readln(Fin, a, b, k);
  k:= -k;
  if k = 0 then
    begin conn[b, a]:= true; continue; end;
  if used[a][k]<>0 then
    begin conn[b, used[a][k]]:= true; continue; end;

  inc(brv);
  used[a][k]:= brV;
  conn[b, brv]:= true;
  if k > 0 then conn[brv, a]:= true else conn[a, brv]:= true;
  v[brv].ind:= a;
  v[brv].k:= k;

  for j:= -100 to k-1 do
    if used[a][j]<>0 then conn[brv, used[a][j]]:= true;
  for j:= k+1 to 100 do
    if used[a][j]<>0 then conn[used[a][j], brv]:= true;
  end;
end;

{############################################################################}
function Cycle: boolean;
var taken, inC: TTaken;
    b: boolean;

 procedure DFS(i: integer);
 var j, p: integer;
 begin
 for j:=1 to brv do
   begin
   if (conn[i,j]) and (j = ind) then
     begin
     fillchar(inC, sizeof(inC), false);
     for p:=1 to brv do
       if taken[p] then
         if not inC[v[p].ind] then inC[v[p].ind]:= true
         else begin b:= true; exit; end;
     continue;
     end;
   if (not taken[j]) and (conn[i, j]) then
     begin
     taken[j]:= true;
     DFS(j);
     if b then exit;
     end;
   end;
 end;

begin
fillchar(taken, sizeof(taken), false);
taken[ind]:= true;
b:= false;
DFS(ind);
if b then Cycle:= true else Cycle:= false;
end;

{############################################################################}
Procedure Solve;
var stack: TStack;
    taken: TTaken;
    size: integer;
    min: longint;

  procedure DFS(i: integer);
  var j: integer;
  begin
  taken[i]:= true;
  for j:= 1 to brv do
    if (not taken[j]) and (conn[i,j]) then
      DFS(j);
  inc(size); stack[size]:= i;
  end;

begin
fillchar(taken, sizeof(taken), false);
size:= 0;
for ind:= 1 to brv do
  if not taken[ind] then
    DFS(ind);

for ind:=1 to n do time[ind]:= -1;
time[v[stack[1]].ind]:= -v[stack[1]].k;
min:= 0;
for ind:=2 to brv do
  begin
  if time[v[stack[ind]].ind] <> -1 then
    begin
    min:= time[v[stack[ind]].ind] + v[stack[ind]].k;
    continue;
    end;
  time[v[stack[ind]].ind]:= min - v[stack[ind]].k;
  end;
end;

{############################################################################}
procedure WriteTimes;
var i: integer;
    min: longint;

begin
min:= maxLongInt;
for i:=1 to n do
  if time[i] < min then min:= time[i];
if min <> 0 then
  for i:=1 to n do
    time[i]:= time[i] - min;

for i:=1 to n do writeln(Fout, time[i]);
end;

{############################################################################}
{############################################################################}
{############################################################################}
BEGIN
Init;
ReadFile;
for ind:=1 to brv do
  if Cycle then
    begin writeln(Fout, 'NO SOLUTION'); Done; end;
Solve;
WriteTimes;
Done;
END.
