#include <stdio.h>
#include <string.h>
#define INPF "drain.inp"
#define OUTF "drain.out"
#define MAXN 350
#define MAXD 1050
#define INF 1000000500
#define MIN(a,b) ((a)>(b)?(b):(a))

struct Hole
	{
	  int pos;
	  long cap;
	}hs[MAXN];

int n,pos,cap;
long T[MAXN][MAXN][2];
long sum[MAXN];
long os[MAXD];

void Init()
  {
    FILE *f=fopen(INPF,"rt");
    fscanf(f,"%d",&n);
    for(int i=0;i<n;i++)
      {
	fscanf(f,"%d%d",&pos,&cap);
	hs[i].pos=pos;
	hs[i].cap=cap;
	os[pos]=cap;
      }
    fclose(f);
  }

void Preprocess()
  {
    sum[0]=hs[0].cap;
    for(int i=0;i<n;i++)
	sum[i]=sum[i-1]+hs[i].cap;
  }

void Output(int cap,int pos)
  {
    FILE *f=fopen(OUTF,"wt");
    fprintf(f,"%d\n%d\n",cap,pos+1);
    fclose(f);
  }

long Find(int l,int r,int pos)
  {
    if(l==0 && r==n-1) return 0;
    if(l<0) return INF;
    if(r>=n) return INF;
    if(T[l][r][pos]) return T[l][r][pos];
    long total=sum[l-1]+sum[n-1]-sum[r];
    long p1,p2;
    if(pos==1)
      {
	p1=total*(hs[l].pos-hs[l-1].pos);
	p2=total*(hs[r+1].pos-hs[l].pos);
	if(l-1<0) p1=INF;
	if(r+1>=n) p2=INF;
	T[l][r][pos]=MIN(p1+Find(l-1,r,1),p2+Find(l,r+1,2));
      }
    if(pos==2)
      {
	p1=total*(hs[r+1].pos-hs[r].pos);
	p2=total*(hs[r].pos-hs[l-1].pos);
	if(l-1<0) p2=INF;
	if(r+1>=n) p1=INF;
	T[l][r][pos]=MIN(p1+Find(l,r+1,2),p2+Find(l-1,r,1));
      }
    return T[l][r][pos];
  }

void Solve()
  {
    int i;
    long res,min,w;
    min=INF;
    for(i=0;i<n;i++)
      {
	memset(T,0,sizeof(T));
	Find(i,i,1);
	res=T[i][i][1];
	if(res<min) {min=res;w=i;}
      }
    Output(min,w);
  }

int main()
  {
    Init();
    Preprocess();
    Solve();
    return 0;
  }