/* INCLUDE ******************************************************************/
   #include <fstream>
   #include <cstdlib>
   #include <cmath>
   
   #include <string>
   #include <vector>
   #include <list>
   #include <algorithm>

   using namespace std;

/* CONSTANTS ****************************************************************/
   const string NOSOL = "NO SOLUTION";
   const int DONE = -1000;

/* CLASSES ******************************************************************/
/* GLOBALS ******************************************************************/
   ifstream fin("work.inp");
   ofstream fout("work.out");

   int gtime = 0;

   vector<int> w;

   int c_ans;
   vector<int> ans;

   int n;
   int m;
   vector<vector<int> > m0;

   list<list<int> > l;
   typedef list<list<int> >::iterator iterl;
   typedef list<int>::iterator iterll;

   vector<vector<short int> > nn;

/* FUNCTIONS ****************************************************************/
/****************************************************************************/
   void done()
   {
      fin.close();
      fout.close();
      exit(0);
   }
/****************************************************************************/
   void init()
   {
      fin >> n >> m;
      ++n;
      ++m;

      w.resize(n);
      for (int i = 1; i < n; ++i)
         w[i] = 0;

      c_ans = 0;
      ans.resize(n);

      m0.resize(n);

      nn.resize(n);
      for (int i = 1; i < n; ++i)
         nn[i].resize(n);

      for (int y = 1; y < n; ++y)
         for (int x = 1; x < n; ++x)
            nn[y][x] = 0;

      for (int i = 1; i < m; ++i)
      {
         int w1;
         int w2;
         int b;

         fin >> w1 >> w2 >> b;

         if (b == 0) continue;

         if (b < 0)
         {
            swap(w1, w2);
            b = -b;
         }

         if (nn[w1][w2] >= b) continue;

         nn[w1][w2] = b;
         m0[w2].push_back(w1);
         w[w1] += b;
         
      }
   }
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
   void add_ans(int ind)
   {
      //fout << "Out ans ind: " << ind << endl;
      ++c_ans;
      ans[ind] = gtime;
   }
/****************************************************************************/
   void remove_l(int ind)
   {
      //fout << "Remove ind: " << ind << endl;
      w[ind] = -1000;
      for (iterl i = l.begin(); i != l.end(); ++i)
      {
         iterll j((*i).begin());
         ++j;
         for (; j != (*i).end(); ++j)
         {
            if (*j == ind)
            {
               iterll j0(j);
               --j0;
               (*i).erase(j);
               j = j0;
            }
         }

         if ((*i).size() == 1)
         {
            iterl i0(i);
            --i0;
            l.erase(i);
            i = i0;
         }
      }
   }
/****************************************************************************/
   void add_l(int ind)
   {
      //fout << "add ind: " << ind << endl;
      if (m0[ind].empty()) return;

      list<int> lr;
      lr.push_back(ind);
      lr.insert(lr.end(), m0[ind].begin(), m0[ind].end());

      l.push_back(lr);
   }
/****************************************************************************/
   void run()
   {
      /*
      for (int i = 1; i < n; ++i)
      {
         fout << w[i] << endl;
      }
      fout << endl;
      */

      while (c_ans < n - 1)
      {
         for (int i = 1; i < n; ++i)
            if (w[i] == 0)
            {
               add_ans(i);
               remove_l(i);
               add_l(i);
            }

         if (l.empty() && c_ans < n - 1)
         {
            fout << NOSOL << endl;
            done();
         }

         ++gtime;
         for (iterl i = l.begin(); i != l.end(); ++i)
         {
            iterll j((*i).begin());
            ++j;
            for (; j != (*i).end(); ++j)
            {
               if (nn[*j][*((*i).begin())] == 0)
               {
                  //fout << "erase [ind] from [ind]: " << *j << " , "<< *((*i).begin()) << endl;
                  iterll j0(j);
                  --j0;
                  (*i).erase(j);
                  j = j0;

                  if ((*i).size() == 1)
                  {
                     iterl i0(i);
                     --i0;
                     l.erase(i);
                     i = i0;

                     /*if (l.empty())
                        break;*/
                     break;
                  }

                  
               } else
               //if (nn[*j][*((*i).begin())] > 0)
               {
                  //fout << "sub w[ind]: " << *j << " w[ind]: "<< w[*j] << endl;
                  --w[*j];
                  --nn[*j][*((*i).begin())];
               }
            }
         }
      }

      for (int i = 1; i < n; ++i)
      {
         fout << ans[i] << endl;
      }
   }
/****************************************************************************/
   int main()
   {
      init();
      run();
      done();

      return 0;
   }
/****************************************************************************/

