#include <stdio.h>
#include <string.h>

#define M 8192
#define N 1024
#define MAX 16384

int n,m;
int neigh[N][N];
int prev[N];
int pneigh[N][N];

int input[N][N];
int time[N];

int min(int a, int b)
{
  return (a<b)?a:b;
}

int max(int a, int b)
{
  return (a>b)?a:b;
}

void scan(void)
{
  memset(input, 63, sizeof(input));
  scanf("%d %d", &n, &m);

  for(int i=0; i<m; i++)
  {
    int x,y,z;
    scanf("%d %d %d",&x, &y, &z);
    x--;
    y--;
    int p = input[x][y];
    input[x][y] = min(p, z);
    
    if(p>0 && z<=0)
    {
      neigh[x][++neigh[x][0]] = y;
      prev[y]++;
    }
    if(p>0 && z>0)
      pneigh[x][++pneigh[x][0]] = y;
  }
}

int stack[N], sp;
int t[N];
void push(int v, int te)
{
  stack[sp] = v;
  t[sp++]= te;
}

int isused[N];

int topsort(void)
{
  int curtime = 0;
  for(int x=0; x<n; x++)
  {
    int cur = -1;

    for(int i=0; i<n; i++)
    {
      if(prev[i] == 0 && !isused[i])
      {
        if(cur==-1)
          cur = i;
        else
          cur = (time[i]<time[cur])?i:cur;
      }
    }
    
    if(cur==-1)
      return 0;
    isused[cur] = 1;
    curtime = time[cur];
    push(cur, curtime);

    //2-ra stypka
    for(int i=1; i<=neigh[cur][0]; i++)
    {
      int k=neigh[cur][i];
      prev[k]--;
      time[k] = max(time[k], curtime-input[cur][k]);
    }
  }
  return 1;
}

int doit(void)
{
  scan();
  if(!topsort())
    return 0;

  for(int i=0; i<n; i++)
  {
    for(int j=1; j<=neigh[i][0]; j++)
    {
      if(time[i]-time[j]>input[i][j])
        return 0;
    }
  }

  return 1;
}

int main(void)
{
  freopen("work.inp", "r", stdin);
  freopen("work.out", "w", stdout);

  if(!doit())
    printf("NO SOLUTION\n");
  else
    for(int i=0; i<n; i++)
      printf("%d\n", time[i]);
  
  fclose(stdin);
  fclose(stdout);
  return 0;
}
