#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#include <string.h>

#define inp "drain.inp"
#define out "drain.out"
#define INF 2000000000
#define MAXH 350

struct hole { int d,p; };
hole m[MAXH];
int n;
int s[MAXH][MAXH][2];
int v[MAXH][MAXH][2];
int ls[MAXH],rs[MAXH];
int min = INF;
int mind = -1;

int MIN(int a,int b) { if (a<b) return a; else return b; }

void init () {
int i;
     FILE *f = fopen ( inp , "r");
     fscanf(f,"%d",&n);
     for (i=1;i<=n;i++)
         fscanf(f,"%d%d",&m[i].d,&m[i].p);
     fclose(f);
     ls[0] = 0;rs[n+1] = 0;
     for (i=1;i<=n;i++) ls[i] = ls[i-1]+m[i].p;
     for (i=n;i>=1;i--) rs[i] = rs[i+1]+m[i].p;
}

void print () {
     FILE *f = fopen ( out , "w");
     if (min==INF) printf("TEST WRONG\n");
     else fprintf(f,"%d\n%d\n",min,mind);
     fclose(f);
     exit(0);
}

int rec(int l,int r,int d) {
int tmp,x,y;
     if (((float)clock()/CLOCKS_PER_SEC)>1.9) print();
     if (v[l][r][d]==1) return s[l][r][d];
     if ((l<0)||(r>(n+1))) return -1;
     if (d==0) tmp = m[l+1].d;
     if (d==1) tmp = m[r-1].d;
     x = rec(l-1,r,0);
     if (x!=-1) x += abs(tmp-m[l].d)*(ls[l]+rs[r]);
     y = rec(l,r+1,1);
     if (y!=-1) y += abs(tmp-m[r].d)*(ls[l]+rs[r]);
     if ((x==-1)||((y<x)&&(y!=-1))) x = y;
     s[l][r][d] = x;
     v[l][r][d] = 1;
     return s[l][r][d];
}

void greedy () {
int l,r,i,tmp,x,y;
int suma = 0;
     for (i=1;i<=n;i++) {
         l = i-1; r = i+1; tmp = m[i].d; suma = 0;
         while ((l>0)||(r<(n+1))) {
               x = INF;
               y = INF;
               if (l>0) x = abs(tmp - m[1].d)*(ls[l]+rs[r]);
               if (l>1) x = abs(tmp - m[l].d)*(ls[l]+rs[r])+
                            MIN (
                                 abs(m[l].d-m[l-1].d)*(ls[l-1]+rs[r]),
                                 abs(m[r].d-m[l].d)*(ls[l-1]+rs[r])
                                 );
               if (r==n) y = abs(m[n].d-tmp)*(ls[l]+rs[r]);
               if (r<n) {
                  y = abs(m[r].d-tmp)*(ls[l]+rs[r]);
                  y += MIN (
                             abs(m[r+1].d-m[r].d)*(ls[l]+rs[r+1]),
                             abs(m[r].d-m[l].d)*(ls[l]+rs[r+1])
                            );

               }
               suma += MIN(x,y);
               if (x<y) {
                  l = l--;
                  tmp = m[l].d;
               } else {
                       r++;
                       tmp = m[r].d;
                      }
         }
         if (suma<min) {
            min = suma;
            mind = i;
         }
     }
}

void solve() {
int i,sum;
     if (n>=110) greedy();
     for (i=1;i<=n;i++) {
         memset(&v,0,sizeof(v));
         s[0][n+1][0] = 0; s[0][n+1][1] = 0;
         v[0][n+1][0] = 1; v[0][n+1][1] = 1;
         sum = rec(i-1,i+1,0);
         if (sum<min) { min = sum; mind = i; }
     }
     FILE *f = fopen ( out , "w");
     if (min==INF) printf("TEST WRONG\n");
     else fprintf(f,"%d\n%d\n",min,mind);
     fclose(f);
}

int main () {
    clock();
    init ();
    solve ();
//    printf("%.3f\n",(float)clock()/CLOCKS_PER_SEC);
    return 0;
}
