Const
  nMax=300;
  FinStr='drain.inp';
  FoutStr='drain.out';

Type
  nType=0..nMax;
  {MnojNaUsed=1..nMax*(nMax-1);}
  TUsed=Array[nType]Of Boolean;
  {TTable1=
         Record
           Found:Boolean;
           Used:TUsed;
           Dist:LongInt;
         End;}
  {TTable=Array[nType, MnojNaUsed]Of TTable1;}
  THole=
        Record
          Dist, Debit:LongInt;
        End;
  TPipe=Array[nType]Of THole;
  TDist=Array[nType, nType]Of LongInt;
Var
  n:nType;
  MinHole, MinRate:LongInt;
  {Table:TTable;}
  Pipe:TPipe;
  Dist:TDist;
  Used:TUsed;

   Procedure ReadIn;
     Var
       Fin:Text;
       i:nType;
     Begin
       Assign(Fin, FinStr);
       ReSet(Fin);

       Read(Fin, n);
       For i:=1 To n-1 Do
         With Pipe[i] Do
           ReadLn(Fin, Dist, Debit);
       With Pipe[n] Do
         Read(Fin, Dist, Debit);

       Close(Fin);
     End;

   Procedure Init;
     Begin
     End;

   Procedure CalcDistances;
     Var
       i, j:nType;
     Begin
       For i:=1 To n Do
         For j:=1 To n Do
           Dist[i, j]:=Abs(Pipe[i].Dist-Pipe[j].Dist);
     End;

   {Function Equal(M1, M2:TUsed):Boolean;
     Var
       i:nType;
     Begin
       For i:=1 to n Do
         If M1[i]<>M2[i] Then
           Begin
             Equal:=False;
             EXIT;
           End;
     End;}

   {Function CheckForFound(Hole:nType;VAR Dist:LongInt):Boolean;
     Var
       j:LongInt;
       i:nType;
     Begin
       For j:=1 To n*(n-1) Do
         If Table[i, j].Found And Equal(Table[i, j].Used, Used)  Then
          Begin
            Dist:=Table[i, j].Dist;
            CheckForFound:=True;
            Exit;
          End;
     End;}

   Function OnlyOneHole(VAR Num:nType):Boolean;
     Var
       Br, i:nType;
     Begin
       Br:=0;
       For i:=1 To n Do
         If Not Used[i] Then
           Begin
             Num:=i;
             Inc(Br);
             If Br>=2 Then
              Begin
                OnlyOneHole:=False;
                EXIT;
              End;
           End;
       If Br=1 Then
           OnlyOneHole:=True;
     End;

   Function CurTech:LongInt;
     Var
       i:nType;
       Sum:LongInt;
     Begin
       Sum:=0;
       For i:=1 To n Do
         If Not Used[i] Then
           Inc(Sum, Pipe[i].Debit);

       CurTech:=Sum;
     End;

   {Procedure UpdateTable(i:nType; Min:LongInt);
     Var
       j, Bound:LongInt;
       k:nType;
     Begin
       j:=1;
       Bound:=n*(n-1);
       While j<=Bound Do
        If not Table[i, j].Found Then
          Break
        Else
          Inc(j);

       Table[i, j].Found:=True;
       For k:=1 To n Do
         Table[i, j].Used[k]:=Used[k];
     End;}

   Function C(i:nType):LongInt;
     Var
       Neib, Num:nType;
       Min, Temp:LongInt;
       Tech:Integer;
     Begin
       {If CheckForFound(i, Min) Then
        Begin
          C:=Min;
          Exit;
        End
       Else}
        If OnlyOneHole(Num) Then
         Begin
           Tech:=CurTech;
           c:=Dist[i, Num]*Tech;
           Exit;
         End;
       Min:=MaxLongInt;
       For Neib:=1 To n Do
        If NOT Used[Neib] Then
          Begin
            Tech:=CurTech;
            Used[Neib]:=True;
            Temp:=Dist[i, Neib]*Tech+C(Neib);
            Used[Neib]:=False;
            If Temp<Min Then
               Min:=Temp;
          End;
       {UpdateTable(i, Min);}
       C:=Min;
     End;

   Procedure NullUsed;
     Var
       i:nType;
     Begin
       For i:=1 To n Do
         Used[i]:=False;
     End;

   Procedure Solve;
     Var
       TempRate:LongInt;
       i:nType;
     Begin
       MinHole:=1;
       NullUsed;
       Used[1]:=True;
       MinRate:=C(1);
       For i:=2 To n Do
        Begin
          NullUsed;
          Used[i]:=True;
          TempRate:=C(I);
          If TempRate<MinRate Then
           Begin
             MinRate:=TempRate;
             MinHole:=i;
           End;
        End;
     End;

   Procedure Print;
     Var
       Fout:Text;
     Begin
       Assign(Fout, FoutStr);
       ReWrite(Fout);

       WriteLn(Fout, MinRate);
       Write(Fout, MinHole);

       Close(Fout);
     End;

Begin
  ReadIn;
  Init;
  CalcDistances;
  Solve;
  Print;
End.