#include <stdio.h>
#include <stdlib.h>

#define MAXV 1024

typedef struct Vex TVex;
typedef struct Edge TEdge;

struct Vex {
       int v, p, t;
       TEdge *edges;
};

struct Edge {
       int v, w;
       TEdge *next;
};

TVex vs[MAXV];
int n;
int queue[MAXV], head, tail;
int a[MAXV][2], ap;

void enq(int v) {
     queue[head++] = v;
     if (head == MAXV)
        head = 0;
}

int deq(void) {
    int r;

    r = queue[tail++];
    if (tail == MAXV)
       tail = 0;

    return r;
}

void add_edge(int a, int b, int w) {
     TEdge *e;

     e = (TEdge*)malloc(sizeof(TEdge));
     e->v = b;
     e->w = w;
     e->next = vs[a].edges;
     vs[a].edges = e;
     vs[b].p++;
}

int top(void) {
    TEdge *e;
    int i, v, t;

    for (i = 0; i < n; ++i)
        if (vs[i].p == 0) {
           vs[i].v = 1;
           vs[i].t = 0;
           enq(i);
        }

    while (tail != head) {
          v = deq();
          for (e = vs[v].edges; e; e = e->next) {
              vs[e->v].p--;
              if (vs[e->v].t < (t = vs[v].t + e->w))
                 vs[e->v].t = t;
              if (vs[e->v].p == 0) {
                 vs[e->v].v = 1;
                 enq(e->v);
              }
          }
    }

    for (i = 0; i < n; ++i)
        if (vs[i].v == 0)
           return 0;

    return 1;
}

int check(void) {
    int i;
    
    for (i = 0; i < ap; ++i)
        if (vs[a[i][0]].t > vs[a[i][1]].t)
           return 0;

    return 1;
}

int main(void) {
    FILE *fin, *fout;
    int m, k, i, j, b;

    fin = fopen("work.inp", "r");
    fout = fopen("work.out", "w");

    fscanf(fin, "%d %d\n", &n, &m);
    for (k = 0; k < m; ++k) {
        fscanf(fin, "%d %d %d\n", &i, &j, &b);
        --i;
        --j;
        if (b > 0)
           add_edge(j, i, b);
        else if (b < 0)
            add_edge(i, j, -b);
        else {
             a[ap][0] = i;
             a[ap++][1] = j;
        }
    }

    if (top() && check())
       for (i = 0; i < n; ++i)
           fprintf(fout, "%d\n", vs[i].t);
    else
        fprintf(fout, "NO SOLUTION\n");

    fclose(fin);
    fclose(fout);
    
    return 0;
}
