#include <stdio.h>
#include <math.h>
#include <time.h>
#define INP "ots.inp"
#define OUT "ots.out"

#define MAX 10010
#define EPS 1e-3

int mx1[MAX],mx2[MAX],my2[MAX],my1[MAX];

double dist (int ax,int ay,int bx,int by) {
       return sqrt((ax-bx)*(ax-bx)+(ay-by)*(ay-by));
}

int nass(int ax,int ay,int bx,int by,int cx,int cy) {
    return (ay-by)*cx+(bx-ax)*cy+ax*by-ay*bx;
}

int cross( int ax,int ay,int bx,int by,int cx,int cy,int dx,int dy) {
int a = nass(ax,ay,bx,by,cx,cy);
int b = nass(ax,ay,bx,by,dx,dy);
int c = nass(cx,cy,dx,dy,ax,ay);
int d = nass(cx,cy,dx,dy,bx,by);
    if ((a!=0)&&(b!=0)&&(c!=0)&&(d!=0)) {
       if (((a*b)<0)&&((c*d)<0)) return 1;
       return 0;
    } else {
      double d1 = dist(ax,ay,cx,cy) + dist(cx,cy,bx,by);
      double d2 = dist(ax,ay,dx,dy) + dist(dx,dy,bx,by);
      double d3 = dist(cx,cy,ax,ay) + dist(ax,ay,dx,dy);
      double d4 = dist(cx,cy,bx,by) + dist(bx,by,dx,dy);
      double dab = dist (ax,ay,bx,by);
      double dcd = dist (cx,cy,dx,dy);
      if (
          (fabs(dab-d1)<EPS)||
          (fabs(dab-d2)<EPS)||
          (fabs(dcd-d3)<EPS)||
          (fabs(dcd-d4)<EPS)
         ) return 1;
         return 0;
      
    }

}

void init () {
int i = 0;
int j;
int c = 0;
     FILE *f = fopen ( INP , "r");
     while (!feof(f)) {
           i++;
           fscanf(f,"%d\n%d\n%d\n%d\n",&mx1[i],&my1[i],&mx2[i],&my2[i]);
           for (j=1;j<i;j++)
               if (cross(mx1[i],my1[i],mx2[i],my2[i],mx1[j],my1[j],mx2[j],my2[j]))
                  c++;
     }
     fclose(f);
     f = fopen ( OUT , "w");
     fprintf(f,"%d\n",c);
     fclose(f);
}

int main () {
//    clock();
    init ();
//    printf("%0.3f\n",(float)clock()/CLOCKS_PER_SEC);
}
