Const
  nMax=10000;
  FinStr='ots.inp';
  FoutStr='ots.out';
  Eps=1E-7;

Type
  nType=0..nMax;
  TPoint=
         Record
           x, y:LongInt;
         End;
  TOts=
       Record
         StartO, EndO:TPoint;
       End;
  TRav=Array[nType]Of TOts;
Var
  n{, i}:nType;
  Rav:TRav;
  Ans:LongInt;

   Procedure ReadIn;
     Var
       Fin:Text;
     Begin
       Assign(Fin, FinStr);
       ReSet(Fin);

       n:=0;
       While Not Eof(Fin) Do
        Begin
          Inc(n);
          With Rav[n] Do
            ReadLn(Fin, StartO.x, StartO.y, EndO.x, EndO.y);
        End;

       Close(Fin);
     End;

   Function Zero(a:Real):Boolean;
     Begin
       If Abs(a)<Eps Then
         Zero:=True
       Else
         Zero:=False;
     End;

   Function OneSide(P1, P2, P:TPoint):ShortInt;
     Var
       A, B, C:LongInt;
       Res:Real;
     Begin
       A:=P1.y-P2.y;
       B:=P2.x-P1.x;
       C:=P1.x*P2.y-P2.x*P1.y;
       Res:=A*P.x+B*P.y+C;
       If Zero(Res) Then
        OneSide:=0
       Else
         If Res>0 Then
           OneSide:=1
         Else
           OneSide:=-1;
     End;

   Function Mejdu(P1, P2, P:TPoint):Boolean;
     Begin
       IF (P1.x<=P.x)And(P2.x>=P.x)And(P1.y<=P.y)And(P2.y>=P.y) Then
         Mejdu:=True
       Else
         If (P2.x<=P.x)And(P1.x>=P.x)And(P2.y<=P.y)And(P1.y>=P.y) Then
           Mejdu:=True
         Else
           Mejdu:=False;
     End;

   Function HaveOnePoint(Ots1, Ots2:TOts):Boolean;
     Var
       z1, z2, z3, z4:ShortInt;
     Begin
       z1:=OneSide(Ots1.StartO, Ots1.EndO, Ots2.StartO);
       z2:=OneSide(Ots1.StartO, Ots1.EndO, Ots2.EndO);
       z3:=OneSide(Ots2.StartO, Ots2.EndO, Ots1.StartO);
       z4:=OneSide(Ots2.StartO, Ots2.EndO, Ots1.EndO);
       If ((z1=0) And Mejdu(Ots1.StartO, Ots1.EndO, Ots2.StartO))
          Or((z2=0) And Mejdu(Ots1.StartO, Ots1.EndO, Ots2.EndO))
          Or((z3=0) And Mejdu(Ots2.StartO, Ots2.EndO, Ots1.StartO))
          Or((z4=0) And Mejdu(Ots2.StartO, Ots2.EndO, Ots1.EndO)) Then
         HaveOnePoint:=True
       Else
         If (z1<>z2)And(z3<>z4) Then
           HaveOnePoint:=True
         Else
           HaveOnePoint:=False;
     End;

   Procedure Solve;
     Var
       i, j:nType;
     Begin
       Ans:=0;
       For i:=1 To n-1 Do
         For j:= i+1 To n Do
           Begin
             If HaveOnePoint(Rav[i], Rav[j]) Then
              Begin
                Inc(Ans);
              End;
           End;
     End;

   Procedure Print;
     Var
       Fout:Text;
     Begin
       Assign(Fout, FoutStr);
       ReWrite(Fout);

       Write(Fout, Ans);

       Close(Fout);
     End;

Begin
  ReadIn;
  {For i:=1 To n Do
    WriteLn(i, '->', Rav[i].StartO.x, ' ', Rav[i].StartO.y, ' ', Rav[i].EndO.x, ' ', Rav[i].EndO.y);}
  Solve;
  Print;
End.
