#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define MAXN 10100
#define MAXX 40100

typedef struct {
  int ip;
  int b01; /* 0-open, 1-close */
} EVENT;

int N;
int p[MAXN][4];
int p1[MAXN][4];
int nplike[MAXN];
int M;
EVENT *xs[MAXX];
int xsi[MAXX];
int nxsi;
int nev[MAXX];
int sz[MAXX];
int cron[MAXN];
int P;


void read_all(void);
void do_all(void);
int cross(int i1, int i2);
int cmp_p(const void *a, const void *b);
int ORNi(int *p1, int *p2, int *p3);
void write_all(void);



int main(void)
{
  freopen("ots.inp", "rt", stdin);
  freopen("ots.out", "wt", stdout);
  read_all();
  do_all();
  write_all();
  return 0;
}



void read_all(void)
{
  int t;
  
  while (scanf("%d %d %d %d", &p[N][0], &p[N][1], &p[N][2], &p[N][3]) == 4) {
    if (p[N][0] > p[N][2]) {
      t=p[N][2];p[N][2]=p[N][0];p[N][0]=t;
      t=p[N][3];p[N][3]=p[N][1];p[N][1]=t;
    }
    N++;
  }
}



void do_all(void)
{
  int i, j, k, ind, i1, iind;
  int acting[MAXN];
  int open[MAXN];
  int n, nclosed;
  int imaxnpl, im;

  /*
  qsort(p, N, sizeof(p[0]), cmp_p);
  memmove(p1[M], p[0], sizeof(p[0]));  nplike[M]++;  M++;
  imaxnpl = 0;
  for (i = 1; i < N; i++) {
    if (cmp_p(p[i], p[i-1]) != 0) {
      memmove(p1[M], p[i], sizeof(p[0])); nplike[M]++;  M++;
    }
    else {
      nplike[M-1]++;
      if (nplike[M-1] > nplike[imaxnpl]) {
        imaxnpl = M-1;
        im = i;
      }
    }
  }

  while (im-1 >= 0 && cmp_p(p[im], p[im-1]) == 0) {
    im--;
  }
  memmove(p1, p, (im+1)*sizeof(p[0]));
  memmove(p1+im, p+(im+nplike[imaxnpl]), (N-im-nplike[imaxnpl])*sizeof(p[0]));

  M = N-nplike[imaxnpl]+1;
  memmove(p, p1, sizeof(p1));
  N = M;
*/
  for (i = 0; i < N; i++) {
    ind = p[i][0];
    nev[ind]++;
    if (nev[ind] > sz[ind]) {
      sz[ind] *= 2;  sz[ind]++;}
    xs[ind] = (int *)realloc((void *)(xs[ind]), sz[ind]*sizeof(EVENT));
    xs[ind][nev[ind]-1].ip = i;
    xs[ind][nev[ind]-1].b01 = 0;
  }
  for (i = 0; i < N; i++) {
    ind = p[i][2];
    nev[ind]++;
    if (nev[ind] > sz[ind]) {
      sz[ind] *= 2;  sz[ind]++;}
    xs[ind] = (int *)realloc((void *)(xs[ind]), sz[ind]*sizeof(EVENT));
    xs[ind][nev[ind]-1].ip = i;
    xs[ind][nev[ind]-1].b01 = 1;
  }
  for (i = MAXX-1; i >= 0; i--) {
    if (nev[i] > 0)  xsi[nxsi++] = i;
  }
  memset(open, 0, sizeof(open));
  n = 0;
  nclosed = 0;
  while (nxsi--) {
    i = xsi[nxsi];
    for (j = 0; j < nev[i]; j++) {
      if (xs[i][j].b01 == 1)  break;
      open[n++] = xs[i][j].ip;
    }
    for (j = j; j < nev[i]; j++) {
      ind = xs[i][j].ip;
      for (k = 0; k < n; k++) {
        i1 = open[k];
        if (i1 == ind) {
          open[k] = open[--n];
          k--;
          continue;
        }
        if (cross(i1, ind)) {
          P++;
          if (i1 < ind)  cron[i1]++;
          else  cron[ind]++;
        }
      }

/*      nclosed++;
      if (nclosed % 1000 == 0)  printf(" ,%d, ", nclosed);*/
    }
  }
/*
  P += nplike[imaxnpl]*(nplike[imaxnpl]-1)/2;
  P += cron[im]*(nplike[imaxnpl]-1);
*/
  
/*  for (i = 0; i < N; i++)  if (nplike[i] == 0)  nplike[i]++;
  for (i = 0; i < N; i++) {
    P += nplike[i]*(nplike[i]-1)/2;
    P += cron[i]*(nplike[i]-1);
  }*/
}



int cross(int i1, int i2)
{
  int o1, o2, o3, o4;

  if (p[i1][0] == p[i2][0] && p[i1][1] == p[i2][1])  return 1;
  if (p[i1][0] == p[i2][2] && p[i1][1] == p[i2][3])  return 1;
  if (p[i1][2] == p[i2][0] && p[i1][3] == p[i2][1])  return 1;
  if (p[i1][2] == p[i2][2] && p[i1][3] == p[i2][3])  return 1;
  
  if (p[i1][0] == p[i1][2] && p[i1][1] == p[i1][3] &&
      p[i2][0] == p[i2][2] && p[i2][1] == p[i2][3])  return (p[i1][0] == p[i2][0]) && (p[i1][1] == p[i2][1]);
  if (p[i1][0] == p[i1][2] && p[i1][1] == p[i1][3]) {
    int t=i1;i1=i2;i2=t;}
  if (p[i2][0] == p[i2][2] && p[i2][1] == p[i2][3]) {
    int x1, x2, y1, y2, t;
    
    o1 = ORNi(&p[i1][0], &p[i1][2], &p[i2][0]);
    if (o1 != 0)  return 0;
    x1 = p[i1][0];
    x2 = p[i1][2];
    y1 = p[i1][1];
    y2 = p[i1][3];
    if (x1 > x2)  t=x1,x1=x2,x2=t;
    if (y1 > y2)  t=y1,y1=y2,y2=t;
    if (x1 <= p[i2][0] && p[i2][0] <= x2 && y1 <= p[i2][1] && p[i2][1] <= y2)  return 1;
    return 0;
  }
  o1 = ORNi(&p[i1][0], &p[i1][2], &p[i2][0]);
  o2 = ORNi(&p[i1][0], &p[i1][2], &p[i2][2]);
  o3 = ORNi(&p[i2][0], &p[i2][2], &p[i1][0]);
  o4 = ORNi(&p[i2][0], &p[i2][2], &p[i1][2]);
  if (o1*o2 == 0 && o3*o4 == 0) {
    int i1max, i1min, i2max, i2min;
    if (p[i1][2] < p[i2][0])  return 0;
    if (p[i1][0] > p[i2][2])  return 0;
    if (p[i1][1] < p[i1][3])  i1max=p[i1][3],i1min=p[i1][1];
    else  i1max=p[i1][1],i1min=p[i1][3];
    if (p[i2][1] < p[i2][3])  i2max=p[i2][3],i2min=p[i2][1];
    else  i2max=p[i2][1],i2min=p[i2][3];
    if (i1min > i2max)  return 0;
    if (i2min > i1max)  return 0;
  }
  if (o1*o2 == 1 || o3*o4 == 1)  return 0;
  return 1;
}



int ORNi(int *p1, int *p2, int *p3)
{
  long long res;

  res = 1ll*p1[0]*p2[1] + 1ll*p2[0]*p3[1] + 1ll*p3[0]*p1[1];
  res += -1ll*p1[0]*p3[1] -1ll*p2[0]*p1[1] -1ll*p3[0]*p2[1];
  if (res < 0)  return -1;
  if (res > 0)  return 1;
  return 0;
}



int cmp_p(const void *a, const void *b)
{
  int res = ((int *)a)[0]-((int *)b)[0];
  if (res == 0)  res = ((int *)a)[1]-((int *)b)[1];
  if (res == 0)  res = ((int *)a)[2]-((int *)b)[2];
  if (res == 0)  res = ((int *)a)[3]-((int *)b)[3];
  return res;
}



void write_all(void)
{
  printf("%d\n", P);
}

