#include <fstream>
#include <cstring>
#include <fcntl.h>
#include <sys/stat.h>
#include <unistd.h>
#include <stdlib.h>

#define TMP "TEMP"

struct tmove {
  int x1,y1,x2,y2;
};

struct point {
  int x,y;
};

int n;
int cx1,cy1,cx2,cy2;
tmove cm[100000];
tmove mm[100000];


int pcmp(const void *pa,const void *pb)
{
  point *a=(point *)pa;
  point *b=(point *)pb;
  int d=a->x-b->x;
  if (d==0)
    return a->y-b->y;
  else
    return d;
}


void loadgame()
{
  int fd=open(TMP,O_RDONLY|O_BINARY);
  if (fd<0) {n=0;return;}
  ifstream fin(TMP);
  fin >> n;
  for (int i=0;i<n;i++)
  {
    fin >> cm[i].x1 >> cm[i].y1 >> cm[i].x2 >> cm[i].y2;
    fin >> mm[i].x1 >> mm[i].y1 >> mm[i].x2 >> mm[i].y2;
  }
}


void savegame()
{
  ofstream fout(TMP);
  fout << n << endl;
  for (int i=0;i<n;i++)
  {
    fout<<cm[i].x1<<" "<<cm[i].y1<<" "<<cm[i].x2<<" "<<cm[i].y2<<endl;
    fout<<mm[i].x1<<" "<<mm[i].y1<<" "<<mm[i].x2<<" "<<mm[i].y2<<endl;
  }
}


void mymove();

void swap(int &x,int &y) {int t=x;x=y;y=t;}

int main()
{
//  cout << "----------------\n";
  loadgame();
  cin >> cm[n].x1 >> cm[n].y1 >> cm[n].x2 >> cm[n].y2;
  cx1=cm[n].x1;cy1=cm[n].y1;cx2=cm[n].x2;cy2=cm[n].y2;
  if (cm[n].x1>cm[n].x2) swap(cm[n].x1,cm[n].x2);
  if (cm[n].y1>cm[n].y2) swap(cm[n].y1,cm[n].y2);
  mymove();
  cout<<mm[n].x1<<" "<<mm[n].y1<<" "<<mm[n].x2<<" "<<mm[n].y2<<endl;
  n++;
  savegame();
  return 0;
}


int checkline(int x1,int y1,int x2,int y2)
{
  if (x1>x2) swap(x1,x2);
  if (y1>y2) swap(y1,y2);
  for (int i=0;i<=n;i++)
    if ((cm[i].x1==x1)&&(cm[i].y1==y1)&&(cm[i].x2==x2)&&(cm[i].y2==y2))
      return 1;
  for (int i=0;i<n;i++)
    if ((mm[i].x1==x1)&&(mm[i].y1==y1)&&(mm[i].x2==x2)&&(mm[i].y2==y2))
      return 2;
  return 0;
}


int checkpoint(int x,int y)
{
  for (int i=0;i<=n;i++)
  {
    if ((cm[i].x1==x)&&(cm[i].y1==y)) return 1;
    if ((cm[i].x2==x)&&(cm[i].y2==y)) return 1;
  }
  return 0;
}

#define MD 10


int checkdist(int x,int y,int dx,int dy)
{
  int d=1;
  x+=dx;y+=dy;
  while ((checkpoint(x,y)!=1)&&(d<MD)) {x+=dx;y+=dy;d++;}
  return d;
}


void mymove()
{
  int t,d=1000;
  int dx[4]={ 0, 0,+1,-1};
  int dy[4]={+1,-1, 0, 0};
  int p[8];
  memset(p,0,sizeof(p));
  for (int i=0;i<4;i++)
  {
    if (checkline(cx1,cy1,cx1+dx[i],cy1+dy[i])==0)
    {
      p[i]=1;
      if ((t=checkdist(cx1,cy1,dx[i],dy[i]))<d)
        {mm[n].x1=cx1;mm[n].y1=cy1;mm[n].x2=cx1+dx[i];mm[n].y2=cy1+dy[i];d=t;}
    }
    if (checkline(cx2,cy2,cx2+dx[i],cy2+dy[i])==0)
    {
      p[i+4]=1;
      if ((t=checkdist(cx2,cy2,dx[i],dy[i]))<d)
        {mm[n].x1=cx2;mm[n].y1=cy2;mm[n].x2=cx2+dx[i];mm[n].y2=cy2+dy[i];d=t;}
    }
  }

  if (mm[n].x1>mm[n].x2) swap(mm[n].x1,mm[n].x2);
  if (mm[n].y1>mm[n].y2) swap(mm[n].y1,mm[n].y2);
}
