/* INCLUDES *****************************************************************/
   #include <fstream>
   #include <cstdlib>
   
   #include <vector>
   #include <algorithm>

   using namespace std;

/* CONSTANTS ****************************************************************/
   const int MAX = 10001;

/* CLASSES ******************************************************************/
   class line
   {
   public:
      line() {}
      line(int _x1, int _y1, int _x2, int _y2):
         a(_y1 - _y2),
         b(_x2 - _x1),
         c(_x1*_y2 - _x2*_y1) {}
      line(const line& _l): a(_l.a), b(_l.b), c(_l.c) {}
      ~line() {}
      
      line& operator=(const line& _l)
      {
         a = _l.a;
         b = _l.b;
         c = _l.c;
         return *this;
      }

      inline int sgn(int x, int y) const
      {
         return (a*x + b*y + c);
      }

      int a;
      int b;
      int c;
   };


   class ots: public line
   {
   public:
      ots() {}
      ots(int _x1, int _y1, int _x2, int _y2):
         line(_x1, _y1, _x2, _y2),
         x1(_x1),
         y1(_y1),
         x2(_x2),
         y2(_y2)
         /*
         minx(min(_x1, _x2)),
         maxx(max(_x1, _x2))
         */
      {}
      ots(const ots& _o):
         line(_o),
         x1(_o.x1),
         y1(_o.y1),
         x2(_o.x2),
         y2(_o.y2)
         /*
         minx(_o.minx),
         maxx(_o.maxx)
         */
      {}
      ~ots() {}
      
      ots& operator=(const ots _o)
      {
         line::operator=(_o);
         x1 = _o.x1;
         y1 = _o.y1;
         x2 = _o.x2;
         y2 = _o.y2;
         /*
         minx = _o.minx;
         maxx = _o.maxx;
         */
         return *this;
      }

      inline bool inter(const ots& _o) const
      {
         return
         (
            ( (sgn(_o.x1, _o.y1))*(sgn(_o.x2, _o.y2)) <= 0 ) &&
            ( (_o.sgn(x1, y1))*(_o.sgn(x2, y2)) <= 0 )
         );
      }

      int x1;
      int y1;
      int x2;
      int y2;

      /*
      int minx;
      int maxx;
      */
   };

   /*
   class comp
   {
   public:
      bool operator()(const ots& _o1, const ots _o2)
      {
         return (_o1.minx < _o2.minx);
      }
   };
   */


/* GLOBALS ******************************************************************/
   ifstream fin("ots.inp");
   ofstream fout("ots.out");

   unsigned long long res = 0;

   vector<ots> o;
   typedef vector<ots>::iterator iter;

/* FUNCTIONS ****************************************************************/
/****************************************************************************/
   void done()
   {
      fin.close();
      fout.close();
      exit(0);
   }
/****************************************************************************/
   void init()
   {
      //int c;
      //fin >> c;
      o.reserve(MAX);
      //for (iter i = o.begin(); i < o.end(); ++i)
      while (true)
      {
         int x1;
         int y1;
         int x2;
         int y2;

         fin >> x1 >> y1 >> x2 >> y2;

         if (fin.fail()) break;

         o.push_back( ots(x1, y1, x2, y2) );
      }

      //sort(o.begin(), o.end(), comp());

      /*
      for (iter i = o.begin(); i < o.end(); ++i)
      {
         fout.width(5);
         fout << (*i).x1 << " ";
         fout.width(5);
         fout << (*i).y1 << " ";
         fout.width(5);
         fout << (*i).x2 << " ";
         fout.width(5);
         fout << (*i).y2 << " ";
         fout.width(5);
         fout << (*i).minx << " ";
         fout.width(5);
         fout << (*i).maxx << endl;
      }
      */
   }
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
   void run()
   {
      for (iter i = o.begin(); i < o.end(); ++i)
         for (iter j = i + 1; j < o.end(); ++j)
         {
            //if ((*i).maxx < (*j).minx) break;

            if ((*i).inter(*j))
               ++res;
         }

      fout << res << endl;
   }
/****************************************************************************/
   int main()
   {
      init();
      run();
      done();

      return 0;
   }
/****************************************************************************/

