#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#include <string.h>

#define N 16384

typedef struct {int x1, y1, x2, y2;}ots;

ots horr[N];
ots verr[N];
int n;

int dir(int x1, int y1,int x2, int y2,int x3, int y3)
{
  return (x1*y2+x2*y3+x3*y1-x1*y3-x2*y1-x3*y2);
}

int arepres(ots o1, ots o2)
{
  int d1 = dir(o1.x1, o1.y1, o1.x2, o1.y2, o2.x1, o2.y1);
  int d2 = dir(o1.x1, o1.y1, o1.x2, o1.y2, o2.x2, o2.y2);
  
  int d3 = dir(o2.x1, o2.y1, o2.x2, o2.y2, o1.x1, o1.y1);
  int d4 = dir(o2.x1, o2.y1, o2.x2, o2.y2, o1.x2, o1.y2);

  if(d1*d2*d3*d4!=0)
    return (d1*d2<0)&&(d3*d4<0);
  if(d1*d2==0)
    return d3*d4<=0;
  if(d3*d4==0)
    return d1*d2<=0;
}

int max(int a, int b)
{
  return (a<b)?b:a;
}

int min(int a, int b)
{
  return (a>b)?b:a;
}

int maxx(ots a)
{
  return max(a.x1, a.x2);
}

int maxy(ots a)
{
  return max(a.y1, a.y2);
}

int minx(ots a)
{
  return min(a.x1, a.x2);
}

int miny(ots a)
{
  return min(a.y1, a.y2);
}

int cmphl(const void* a, const void * b)
{
  ots o1 = *(ots*)a;
  ots o2 = *(ots*)b;
  
  return minx(o1)-minx(o2);
}

void scan(void)
{
  memset(horr, 63, sizeof(horr));
  memset(verr, 63, sizeof(verr));
  
  for(n=0; !feof(stdin); n++)
  {
    scanf("%d %d %d %d ",&horr[n].x1, &horr[n].y1, &horr[n].x2, &horr[n].y2);
    verr[n] = horr[n];
  }

  qsort(horr, n, sizeof(horr[0]), cmphl);
}

int cur;

int main(void)
{
  clock();
  freopen("ots.inp", "r", stdin);
  freopen("ots.out", "w", stdout);

  scan();

  for(int i=0; i<n-1; i++)
  {
    for(int j=i+1; j<n; j++)
    {
      if(minx(horr[j]) >maxx(horr[i]) )
        break;
        
      cur+=arepres(horr[i], horr[j]);
    }
    double a = (double)clock();
    if( a/1.9>CLOCKS_PER_SEC)
      break;
  }
  
  printf("%d\n", cur);
  
  fclose(stdin);
  fclose(stdout);
  return 0;
}
