#include <stdio.h>
#include <math.h>

#define MAXN 262144

typedef struct Seg TSeg;
struct Seg {
        int x1, y1, x2, y2, c;
};

TSeg seg[MAXN];
int n;

int check(int x1, int y1, int x2, int y2) {
    int i;

    for (i = 0; i < n; ++i)
        if (seg[i].x1 == x1 && seg[i].y1 == y1 && seg[i].x2 == x2 && seg[i].y2 == y2 ||
           seg[i].x1 == x2 && seg[i].y1 == y2 && seg[i].x2 == x1 && seg[i].y2 == y1)
           return 1;

    return 0;
        
}

int search(int *x1, int *y1, int *x2, int *y2) {
     int i, j;

     for (i = 0; i < n; ++i)
         for (j = i + 1; j < n; ++j)
             if (seg[i].c == 1 && seg[i].c == 1)
                if (abs(seg[i].x1 - seg[j].x1) == 1 || abs(seg[i].y1 - seg[j].y1) == 1) {
                   *x1 = seg[i].x1;
                   *y1 = seg[i].y1;
                   *x2 = seg[j].x1;
                   *y2 = seg[j].y1;
                   return 1;
                }
                else if (abs(seg[i].x1 - seg[j].x2) == 1 || abs(seg[i].y1 - seg[j].y2) == 1) {
                   *x1 = seg[i].x1;
                   *y1 = seg[i].y1;
                   *x2 = seg[j].x2;
                   *y2 = seg[j].y2;
                   return 1;
                }
                else if (abs(seg[i].x2 - seg[j].x1) == 1 || abs(seg[i].y2 - seg[j].y1) == 1) {
                   *x1 = seg[i].x2;
                   *y1 = seg[i].y2;
                   *x2 = seg[j].x1;
                   *y2 = seg[j].y1;
                   return 1;
                }
                else if (abs(seg[i].x2 - seg[j].x2) == 1 || abs(seg[i].y2 - seg[j].y2) == 1) {
                   *x1 = seg[i].x2;
                   *y1 = seg[i].y2;
                   *x2 = seg[j].x2;
                   *y2 = seg[j].y2;
                   return 1;
                }

     return 0;
}

int main(void) {
    FILE *fin;
    int x1, y1, x2, y2, c, i;

    fin = fopen("temp", "r");
    if (fin != NULL) {
       while (fscanf(fin, "%d %d %d %d %d\n", &x1, &y1, &x2, &y2, &c) == 4) {
             seg[n].c = c;
             seg[n].x1 = x1;
             seg[n].y1 = y1;
             seg[n].x2 = x2;
             seg[n++].y2 = y2;
       }
       fclose(fin);
    }

    scanf("%d%d%d%d", &x1, &y1, &x2, &y2);
    seg[n].c = 1;
    seg[n].x1 = x1;
    seg[n].y1 = y1;
    seg[n].x2 = x2;
    seg[n++].y2 = y2;

    if (search(&x1, &y1, &x2, &y2)) {
       printf("%d %d %d %d\n", x1, y1, x2, y2);
       seg[n].c = 0;
       seg[n].x1 = x1;
       seg[n].y1 = y1;
       seg[n].x2 = x1-1;
       seg[n++].y2 = y1;
    }
    else {
         if (abs(x1 - x2) == 1) {
         if (check(x1, y1, x1, y1-1) == 0) {
            printf("%d %d %d %d\n", x1, y1, x1, y1-1);
            seg[n].c = 0;
            seg[n].x1 = x1;
            seg[n].y1 = y1;
            seg[n].x2 = x1;
            seg[n++].y2 = y1-1;
         }
         else if (check(x1, y1, x1, y1+1) == 0) {
            printf("%d %d %d %d\n", x1, y1, x1, y1+1);
            seg[n].c = 0;
            seg[n].x1 = x1;
            seg[n].y1 = y1;
            seg[n].x2 = x1;
            seg[n++].y2 = y1+1;
         }
         else if (check(x2, y2, x2, y2-1) == 0) {
            printf("%d %d %d %d\n", x2, y2, x2, y2-1);
            seg[n].c = 0;
            seg[n].x1 = x2;
            seg[n].y1 = y2;
            seg[n].x2 = x2;
            seg[n++].y2 = y2-1;
         }
         else if (check(x2, y2, x2, y2+1) == 0) {
            printf("%d %d %d %d\n", x2, y2, x2, y2+1);
            seg[n].c = 0;
            seg[n].x1 = x2;
            seg[n].y1 = y2;
            seg[n].x2 = x2;
            seg[n++].y2 = y2+1;
         }
         else if (check(x1, y1, x1-1, y1) == 0) {
            printf("%d %d %d %d\n", x1, y1, x1-1, y1);
            seg[n].c = 0;
            seg[n].x1 = x1;
            seg[n].y1 = y1;
            seg[n].x2 = x1-1;
            seg[n++].y2 = y1;
         }
         else if (check(x1, y1, x1+1, y1) == 0) {
            printf("%d %d %d %d\n", x1, y1, x1+1, y1);
            seg[n].c = 0;
            seg[n].x1 = x1;
            seg[n].y1 = y1;
            seg[n].x2 = x1+1;
            seg[n++].y2 = y1;
         }
         else if (check(x2, y2, x2-1, y2) == 0) {
            printf("%d %d %d %d\n", x2, y2, x2-1, y2);
            seg[n].c = 0;
            seg[n].x1 = x2;
            seg[n].y1 = y2;
            seg[n].x2 = x2-1;
            seg[n++].y2 = y2;
         }
         else if (check(x2, y2, x2+1, y2) == 0) {
            printf("%d %d %d %d\n", x2, y2, x2+1, y2);
            seg[n].c = 0;
            seg[n].x1 = x2;
            seg[n].y1 = y2;
            seg[n].x2 = x2+1;
            seg[n++].y2 = y2;
         }
         else
             printf("%d %d %d %d\n", x1+29, y1+29, x2+29, y2+29);
         }
         else {
         if (check(x1, y1, x1-1, y1) == 0) {
            printf("%d %d %d %d\n", x1, y1, x1-1, y1);
            seg[n].c = 0;
            seg[n].x1 = x1;
            seg[n].y1 = y1;
            seg[n].x2 = x1-1;
            seg[n++].y2 = y1;
         }
         else if (check(x1, y1, x1+1, y1) == 0) {
            printf("%d %d %d %d\n", x1, y1, x1+1, y1);
            seg[n].c = 0;
            seg[n].x1 = x1;
            seg[n].y1 = y1;
            seg[n].x2 = x1+1;
            seg[n++].y2 = y1;
         }
         else if (check(x2, y2, x2-1, y2) == 0) {
            printf("%d %d %d %d\n", x2, y2, x2-1, y2);
            seg[n].c = 0;
            seg[n].x1 = x2;
            seg[n].y1 = y2;
            seg[n].x2 = x2-1;
            seg[n++].y2 = y2;
         }
         else if (check(x2, y2, x2+1, y2) == 0) {
            printf("%d %d %d %d\n", x2, y2, x2+1, y2);
            seg[n].c = 0;
            seg[n].x1 = x2;
            seg[n].y1 = y2;
            seg[n].x2 = x2+1;
            seg[n++].y2 = y2;
         }
         else if (check(x1, y1, x1, y1-1) == 0) {
            printf("%d %d %d %d\n", x1, y1, x1, y1-1);
            seg[n].c = 0;
            seg[n].x1 = x1;
            seg[n].y1 = y1;
            seg[n].x2 = x1;
            seg[n++].y2 = y1-1;
         }
         else if (check(x1, y1, x1, y1+1) == 0) {
            printf("%d %d %d %d\n", x1, y1, x1, y1+1);
            seg[n].c = 0;
            seg[n].x1 = x1;
            seg[n].y1 = y1;
            seg[n].x2 = x1;
            seg[n++].y2 = y1+1;
         }
         else if (check(x2, y2, x2, y2-1) == 0) {
            printf("%d %d %d %d\n", x2, y2, x2, y2-1);
            seg[n].c = 0;
            seg[n].x1 = x2;
            seg[n].y1 = y2;
            seg[n].x2 = x2;
            seg[n++].y2 = y2-1;
         }
         else if (check(x2, y2, x2, y2+1) == 0) {
            printf("%d %d %d %d\n", x2, y2, x2, y2+1);
            seg[n].c = 0;
            seg[n].x1 = x2;
            seg[n].y1 = y2;
            seg[n].x2 = x2;
            seg[n++].y2 = y2+1;
         }
         else
             printf("%d %d %d %d\n", x1+29, y1+29, x2+29, y2+29);
         }
    }

    fin = fopen("temp", "w");
    for (i = 0; i < n; ++i)
        fprintf(fin, "%d %d %d %d %d\n", seg[i].x1, seg[i].y1, seg[i].x2, seg[i].y2, seg[i].c);
    fclose(fin);

    return 0;
}
