#include <stdio.h>

#define MAXN 16384
#define MAXD 40000
#define MIND 0

typedef struct Seg TSeg;
struct Seg {
       int x1, y1, x2, y2, p;
};

typedef struct Point TPoint;
struct Point {
       int x, y, s;
};

int n, pn, c;
TSeg seg[MAXN];
TPoint ps[2*MAXN];
int arr[MAXN], ap;

int min(int a, int b) {
    return ((a < b) ? a : b);
}

int max(int a, int b) {
    return ((a > b) ? a : b);
}

void epoint(int p) {
     int i;

     if (seg[ps[p].s].p != -1) {
        --ap;
        seg[arr[ap]].p = seg[ps[p].s].p;
        arr[seg[ps[p].s].p] = arr[ap];
        seg[ps[p].s].p = -1;
     }
     else {
          for (i = 0; i < ap; ++i)
              if (intersect(arr[i], ps[p].s))
                 ++c;
          seg[ps[p].s].p = ap;
          arr[ap++] = ps[p].s;
     }
}

int cross(int x0, int y0, int x1, int y1, int x2, int y2) {
    return (x1 - x0) * (y2 - y0) - (x2 - x0) * (y1 - y0);
}

int intersect(int i, int j) {
    int m1, m2, m3, m4;

    if (seg[i].x1 < seg[i].x2) {
       m1 = seg[i].x1;
       m2 = seg[i].x2;
    }
    else {
         m1 = seg[i].x2;
         m2 = seg[i].x1;
    }

    if (seg[j].x1 < seg[j].x2) {
       m3 = seg[j].x1;
       m4 = seg[j].x2;
    }
    else {
         m3 = seg[j].x2;
         m4 = seg[j].x1;
    }

    if (m1 > m4 || m3 > m2)
       return 0;

    if (seg[i].y1 < seg[i].y2) {
       m1 = seg[i].y1;
       m2 = seg[i].y2;
    }
    else {
         m1 = seg[i].y2;
         m2 = seg[i].y1;
    }

    if (seg[j].y1 < seg[j].y2) {
       m3 = seg[j].y1;
       m4 = seg[j].y2;
    }
    else {
         m3 = seg[j].y2;
         m4 = seg[j].y1;
    }

    if (m1 > m4 || m3 > m2)
       return 0;

    return (cross(seg[i].x1, seg[i].y1, seg[i].x2, seg[i].y2, seg[j].x1, seg[j].y1) *
           cross(seg[i].x1, seg[i].y1, seg[i].x2, seg[i].y2, seg[j].x2, seg[j].y2) <= 0 &&
           cross(seg[j].x1, seg[j].y1, seg[j].x2, seg[j].y2, seg[i].x1, seg[i].y1) *
           cross(seg[j].x1, seg[j].y1, seg[j].x2, seg[j].y2, seg[i].x2, seg[i].y2) <= 0);
}

void swap(int i, int j) {
     TPoint t;

     t = ps[i];
     ps[i] = ps[j];
     ps[j] = t;
}

void sort(int a, int b) {
     int i, j, g, s;

     g = b - a + 1;
     do {
        s = 0;
        g = (int)(g / 1.3);
        if (g < 1)
           g = 1;
        else if (g == 9 || g == 10)
             g = 11;
        for (i = a + g; i <= b ; ++i) {
            j = i - g;
            if (ps[j].x > ps[i].x || ps[j].x == ps[i].x && ps[j].y > ps[i].y) {
               s = 1;
               swap(i, j);
            }
        }
     }
     while (s != 0 || g > 1);
}

int sv[MAXN];

void ssort(int a, int b) {
     int i, j, m;

     for (i = a; i < b; ++i) {
         m = i;
         for (j = i + 1; j <= b; ++j)
             if (ps[m].x > ps[j].x || ps[m].x == ps[j].x && ps[m].y > ps[j].y ||
                ps[m].x == ps[j].x && ps[m].y == ps[j].y && sv[ps[m].s])
                m = j;
         if (m != i)
            swap(i, m);
         sv[ps[i].s] = 1;
     }
     sv[ps[b].s] = 1;
}

int main(void) {
    FILE *fin, *fout;
    int i, j, k, x1, y1, x2, y2, minx, maxx, miny, maxy;

    fin = fopen("ots.inp", "r");
    fout = fopen("ots.out", "w");

    minx = miny = MAXD;
    maxx = maxy = MIND;

    while (fscanf(fin, "%d %d %d %d\n", &x1, &y1, &x2, &y2) == 4) {
          seg[n].p = -1;
          seg[n].x1 = x1;
          seg[n].y1 = y1;
          seg[n].x2 = x2;
          seg[n++].y2 = y2;
          if (x1 < minx)
             minx = x1;
          if (x2 < minx)
             minx = x2;
          if (x1 > maxx)
             maxx = x1;
          if (x2 > maxx)
             maxx = x2;
          if (y1 < miny)
             miny = y1;
          if (y2 < miny)
             miny = y2;
          if (y1 > maxy)
             maxy = y1;
          if (y2 > maxy)
             maxy = y2;
    }

    if (maxx - minx > maxy - miny) {
        for (i = 0; i < n; ++i) {
            ps[pn].x = seg[i].x1;
            ps[pn+1].x = seg[i].x2;
            ps[pn].y = seg[i].y1;
            ps[pn+1].y = seg[i].y2;
            ps[pn].s = ps[pn+1].s = i;
            pn += 2;
        }
    }
    else {
         for (i = 0; i < n; ++i) {
            ps[pn].x = seg[i].y1;
            ps[pn+1].x = seg[i].y2;
            ps[pn].y = seg[i].x1;
            ps[pn+1].y = seg[i].x2;
            ps[pn].s = ps[pn+1].s = i;
            pn += 2;
        }
    }

    sort(0, pn-1);

    i = 0;
    while (i < pn) {
          for (j = i + 1; j < pn && ps[j].x == ps[i].x; ++j)
              ;
          ssort(i, j-1);
          for (k = i; k < j; ++k) {
              epoint(k);
          }
          i = j;
    }

    fprintf(fout, "%d\n", c);

    fclose(fin);
    fclose(fout);
    
    return 0;
}
