{$MODE objfpc}

Uses
  SysUtils;

Type
  TMove = Record
    X, Y, dir : Integer; {0 -right; 1 -down}
  End;

Var
  QStart, QEnd : Integer;
  Q : Array[1..1000] Of Record
    X, Y : Integer;
  End;
  gs : Record
    plAmovesNum : Integer;
    plAmoves : Array[1..1000] Of TMove;
    plBmovesNum : Integer;
    plBmoves : Array[1..1000] Of TMove;
  End;

Operator > (a, b : TMove) res : Boolean;

Begin
  If a.X > b.X Then
    res := True
  Else
    If a.X = b.X Then
      If a.Y > b.Y Then
        res := True
      Else
        res := a.dir > b.dir;
End;

Procedure sortplAmoves;

Var
  a : Integer;
  tmp : TMove;

Begin
  For a := gs.plAmovesNum - 1 DownTo 1 Do
  Begin
    If gs.plAmoves[a] > gs.plAmoves[a + 1] Then
    Begin
      tmp := gs.plAmoves[a];
      gs.plAmoves[a] := gs.plAmoves[a + 1];
      gs.plAmoves[a + 1] := tmp;
    End
    Else
      Exit;
  End;
End;

Procedure sortplBmoves;

Var
  a : Integer;
  tmp : TMove;

Begin
  For a := gs.plBmovesNum - 1 DownTo 1 Do
  Begin
    If gs.plBmoves[a] > gs.plBmoves[a + 1] Then
    Begin
      tmp := gs.plBmoves[a];
      gs.plBmoves[a] := gs.plBmoves[a + 1];
      gs.plBmoves[a + 1] := tmp;
    End
    Else
      Exit;
  End;
End;

Procedure Swap(Var A, B : Integer);

Var
  tmp : Integer;

Begin
  tmp := A;
  A := B;
  B := tmp;
End;

Procedure Save;

Var
  F : File;

Begin
  ASSign(F, 'TEMP');
  Rewrite(F, 1);
  BlockWrite(F, gs, SizeOf(gs));
  Close(F);
End;

Procedure Init;

Begin
  gs.plAmovesNum := 0;
  gs.plBmovesNum := 0;
End;

Procedure Load;

Var
  F : File;

Begin
  ASSign(F, 'TEMP');
  Try
    Reset(F, 1);
    BlockRead(F, gs, SizeOf(gs));
    Close(F);
  Except
    Init;
  End;
{  Writeln(gs.plAmovesnum);}
End;

Function Edge(X1, Y1, X2, Y2 : Integer) : Integer; {0 - free; 1-plA; 2-plB}

Var
{  I : Integer;}
  L, R, M : Integer;
  X, Y, d : Integer;
  sk : TMove;

Begin
  If X1 > X2 Then
    Swap(X1, X2);
  If Y1 > Y2 Then
    Swap(Y1, Y2);
  X := X1;
  Y := Y1;
  If X1 <> X2 Then
    d := 0
  Else
    d := 1;
  Edge := 0;
  L := 1;
  R := gs.plAmovesNum;
  sk.X := X;
  sk.Y := Y;
  sk.dir := d;
  While L <= R Do
  Begin
    M := (L + R) Shr 1;
    If (X = gs.plAmoves[M].X) And (Y = gs.plAmoves[M].Y) And
       (d = gs.plAmoves[M].dir) Then
      Exit(1);
    If sk > gs.plAmoves[M] Then
      L := M + 1
    Else
      R := M - 1;
  End;
  L := 1;
  R := gs.plBmovesNum;
  While L <= R Do
  Begin
    M := (L + R) Shr 1;
    If (X = gs.plBmoves[M].X) And (Y = gs.plBmoves[M].Y) And
       (d = gs.plBmoves[M].dir) Then
      Exit(2);
    If sk > gs.plBmoves[M] Then
      L := M + 1
    Else
      R := M - 1;
  End;
{  For I := 1 To gs.plAmovesNum Do
    If (X = gs.plAmoves[I].X) And (Y = gs.plAmoves[I].Y) And
       (d = gs.plAmoves[I].dir) Then
      Exit(1);}
{  For I := 1 To gs.plBmovesNum Do
    If (X = gs.plBmoves[I].X) And (Y = gs.plBmoves[I].Y) And
       (d = gs.plBmoves[I].dir) Then
      Exit(2);}
End;

Procedure ReadIn;

Var
  X1, Y1, X2, Y2 : Integer;

Begin
  Readln(X1, Y1, X2, Y2);
  If X1 > X2 Then
    Swap(X1, X2);
  If Y1 > Y2 Then
    Swap(Y1, Y2);
  Inc(gs.plAmovesNum);
  gs.plAmoves[gs.plAmovesNum].X := X1;
  gs.plAmoves[gs.plAmovesNum].Y := Y1;
  If X1 <> X2 Then
    gs.plAmoves[gs.plAmovesNum].dir := 0
  Else
    gs.plAmoves[gs.plAmovesNum].dir := 1;
  sortplAmoves;
End;

Procedure OurMove(X1, Y1, X2, Y2 : Integer);

Begin
  Writeln(X1, ' ', Y1, ' ', X2, ' ', Y2);
  If X1 > X2 Then
    Swap(X1, X2);
  If Y1 > Y2 Then
    Swap(Y1, Y2);
  Inc(gs.plBmovesNum);
  gs.plBmoves[gs.plBmovesNum].X := X1;
  gs.plBmoves[gs.plBmovesNum].Y := Y1;
  If X1 <> X2 Then
    gs.plBmoves[gs.plBmovesNum].dir := 0
  Else
    gs.plBmoves[gs.plBmovesNum].dir := 1;
  sortplBmoves;
  Save;
  Halt;
End;

Function NQ(X, Y : Integer) : Boolean;

Var
  I : Integer;

Begin
  For I := 1 To QEnd Do
    If (Q[I].X = X) And (Q[I].Y = Y) Then
      Exit(False);
  Inc(QEnd);
  Q[QEnd].X := X;
  Q[QEnd].Y := Y;
  NQ := True;
End;

Procedure DeQ(Var X, Y : Integer);

Begin
  X := Q[QStart].X;
  Y := Q[QStart].Y;
  Inc(QStart);
End;

Function Path(X1, Y1, X2, Y2 : Integer) : Boolean;

Var
  X, Y : Integer;

Begin
  QStart := 1;
  QEnd := 1;
  Q[1].X := X1;
  Q[1].Y := Y1;
  While QStart <= QEnd Do
  Begin
    DeQ(X, Y);
    If Edge(X, Y, X + 1, Y) = 1 Then
    Begin
      If NQ(X + 1, Y) And (((X + 1) = X2) And ((Y) = Y2)) Then
        Exit(True);
    End;
    If Edge(X, Y, X, Y + 1) = 1 Then
    Begin
      If NQ(X, Y + 1) And (((X) = X2) And ((Y + 1) = Y2)) Then
        Exit(True);
    End;
    If Edge(X, Y, X - 1, Y) = 1 Then
    Begin
      If NQ(X - 1, Y) And (((X - 1) = X2) And ((Y) = Y2)) Then
        Exit(True);
    End;
    If Edge(X, Y, X, Y - 1) = 1 Then
    Begin
      If NQ(X, Y - 1) And (((X) = X2) And ((Y - 1) = Y2)) Then
        Exit(True);
    End;
  End;
  Path := False;
End;

Procedure FCheck(X1, Y1, X2, Y2 : Integer);

Begin
  If Edge(X1, Y1, X2, Y2) = 0 Then
  Begin
    If Path(X1, Y1, X2, Y2) Then
    Begin
      OurMove(X1, Y1, X2, Y2);
    End;
  End;
End;

Procedure FCheck(X, Y : Integer);

Begin
  FCheck(X, Y, X + 1, Y);
  FCheck(X, Y, X, Y + 1);
  FCheck(X, Y, X - 1, Y);
  FCheck(X, Y, X, Y - 1);
End;

Procedure NCheck(X1, Y1, X2, Y2 : Integer);

Begin
  If Edge(X1, Y1, X2, Y2) = 0 Then
  Begin
    OurMove(X1, Y1, X2, Y2);
  End;
End;

Procedure NCheck(X, Y : Integer);

Begin
  NCheck(X, Y, X + 1, Y);
  NCheck(X, Y, X, Y + 1);
  NCheck(X, Y, X - 1, Y);
  NCheck(X, Y, X, Y - 1);
End;

Procedure Bahur;

Var
  I : Integer;
  cX1, cY1, cX2, cY2 : Integer;

Begin
  For I := 1 To gs.plAmovesNum Do
  Begin
    cX1 := gs.plAmoves[I].X;
    cY1 := gs.plAmoves[I].Y;
    If gs.plAmoves[I].dir = 0 Then
    Begin
      cX2 := cX1 + 1;
      cY2 := cY1;
    End
    Else
    Begin
      cX2 := cX1;
      cY2 := cY1 + 1;
    End;
    FCheck(cX1, cY1);
    FCheck(cX2, cY2);
  End;
  For I := 1 To gs.plAmovesNum Do
  Begin
    cX1 := gs.plAmoves[I].X;
    cY1 := gs.plAmoves[I].Y;
    If gs.plAmoves[I].dir = 0 Then
    Begin
      cX2 := cX1 + 1;
      cY2 := cY1;
    End
    Else
    Begin
      cX2 := cX1;
      cY2 := cY1 + 1;
    End;
    NCheck(cX1, cY1);
    NCheck(cX2, cY2);
  End;
  For I := 1 To gs.plAmovesNum Do
  Begin
    cX1 := gs.plBmoves[I].X;
    cY1 := gs.plBmoves[I].Y;
    If gs.plBmoves[I].dir = 0 Then
    Begin
      cX2 := cX1 + 1;
      cY2 := cY1;
    End
    Else
    Begin
      cX2 := cX1;
      cY2 := cY1 + 1;
    End;
    NCheck(cX1, cY1);
    NCheck(cX2, cY2);
  End;
End;

Begin
  Load;
  ReadIn;
  Bahur;
End.
