{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 16384,0,655360}
{$IFDEF vesko}
uses graph;
{$ENDIF}
const  infile = 'ots.inp';
      outfile = 'ots.out';
          max = 1000;
          eps = 1e-7;


type  TPoint = record
               x,y : longint;
               end;
      TLine  = array [1..2] of TPoint;
      TLines = array [1..MAX] of TLine;
      isparr = array [1..max] of boolean;

var  a : tlines;
     n : integer;
     count : longint;
     pi2 : extended;
     ispoint : isparr;

Procedure InX;
 var t  : text;
 begin
 assign(t, infile);
 reset(t);
 n:=0;
 while not seekeof(t) do
  begin
  inc(n);
  readln(t, a[n][1].x,a[n][1].y,a[n][2].x,a[n][2].y);
  end;
 close(t);
 end;

function fpAtanAsm(a,b : extended) : extended ;
 var f : extended;
 begin
 asm
 fld b
 fld a
 fpatan
 fstp f
 end;
 fpAtanAsm:=f;
 end;

procedure sw(var a,b: longint);
 var c : longint;
 begin
 c:=a;
 a:=b;
 b:=c;
 end;

function eq(a,b : real): boolean;
 begin
 eq:= abs(a-b)<eps;
 end;

function inrange(r1,r2,c : real) : boolean;
 begin
 inrange:= ((c>r1) and (c<r2)) or eq(r1,c) or eq(r2,c);
 end;


function isinrangee(a,b,c : longint):boolean;
 begin
 if a >b then sw(a,b);
 isinrangee:=inrange(a,b,c);
 end;

function probe(a,b : Tline): boolean;
 var a1,a2,a3 : real;
     t1,t2 : integer;
 begin
 probe := FALSE;
 a1:=fpAtanAsm(a[2].x-a[1].x,a[2].y-a[1].y);
 a2:=fpAtanAsm(b[2].x-a[1].x,b[2].y-a[1].y);
 a3:=fpAtanAsm(b[1].x-a[1].x,b[1].y-a[1].y);
 if inrange(a1-pi,a1,a2) or
    inrange(a1-pi,a1,a2-2*pi){ or
    inrange(a1-pi,a1,a2+2*pi)} then t1:=1 else t1:=2;
 if inrange(a1,a1+pi,a3) or
 {   inrange(a1,a1+pi,a3-2*pi) or}
    inrange(a1,a1+pi,a3+2*pi) then t2:=2 else t2:=1;

 probe:=(t1 * t2 = 2);
 end;

function ispoint1(a : TLine) : boolean;
 begin
 ispoint1:=(a[2].x = a[1].x) and (a[2].y = a[1].y);
 end;

function trypoint(a: tpoint; b : tline) : boolean;

 begin
 if b[2].x=b[1].x then trypoint:=isinrangee(b[1].y,b[2].y,a.y) else
  if b[2].y=b[1].y then trypoint:=isinrangee(b[1].x,b[2].x,a.x) else
 trypoint := eq((a.x-b[1].x) / (b[2].x-b[1].x),(a.y-b[1].y) / (b[2].y-b[1].y));
 end;

function p2p(a,b : TPOINT) : boolean;
 begin
 p2p:= (a.x=b.x) and (a.y=b.y);
 end;


Function checks(a,b : TLine; i,j : integer) : boolean;

 begin
 if ((a[1].x = b[1].x) and (a[2].x = b[2].x) and (a[1].y = b[1].y) and (a[2].y = b[2].y)) or
    ((a[1].x = b[2].x) and (a[2].x = b[1].x) and (a[1].y = b[2].y) and (a[2].y = b[1].y)) then
     begin
     checks:=TRUE;
     exit;
     end;
 if ispoint[i] then
  begin
  if ispoint[j] then checks:=p2p(a[1],b[1]) else
  checks:=trypoint(a[1],b);
  exit;
  end;
 if ispoint[j] then
  begin
  checks:=trypoint(b[1],a);
  exit;
  end;
 checks:= probe(a,b)
 and
 probe (b,a);
 end;

Procedure DoWork;
 var  K,L : TLine;
      i,j : longint;
 begin
 for i:=1 to n do ispoint[i]:=ispoint1(a[i]);
 pi2:=pi/2;{90}
 count := 0;
 for j:=1 to n-1 do
  begin
  K:=a[j];
  for i:=j+1 to n do
   begin
   L:=a[i];
   if checks(l,k,i,j) then inc(count);
   end;
  end;

 end;

Procedure OutX;
 var t : text;
 begin
 assign(t, outfile);
 rewrite(t);
 writeln(t,count);
 close(t);
 end;

{$IFDEF vesko}

Procedure vis;
 var gd,gm,i : integer;

 begin
 gd:=0;
 gm:=0;
 initgraph(gd,gm,'d:\noi\bp\bgi');
 for i:=1 to n do line(a[i][1].x,a[i][1].y,a[i][2].x,a[i][2].y);
 readln;
 closegraph;
 end;
{$ENDIF}
{var clk0 : longint absolute $0:$046C;
    clk  : longint;}

BEGIN
InX;
{$IFDEF vesko}
vis;
{$ENDIF}
{clk:=clk0;}
DoWork;
{clk:=clk0-clk;
writeln('Processing time : ',clk / 18.2 : 5 : 2 ,' seconds.');}
OutX;
{writeln(count);}
END.