#include <stdio.h>

#define MAXNUMS 20
#define MAXX 9
#define MAXLEN 200
#define SIGN 1
#define VAR 2

#define LOA 0
#define STO 1
#define ADD 2
#define MUL 3

char *msg[] = {
     "LOA",
     "STO",
     "ADD",
     "MUL"
};

typedef struct Num TNum;
struct Num {
        char n[MAXNUMS];
};

typedef struct Node TNode;
struct Node {
       int t, v;
       TNode *left, *right;
};

TNum n[MAXX], ac;
TNode *top;
TNum stack[200];
int sp;
int op[10000][2];
int opp;

void read(FILE *fin, TNum *a) {
     int c, i;

     i = 0;
     while ((c = fgetc(fin)) >= '0' && c <= '9')
           a->n[i++] = c - '0';
}

void add(TNum *a, TNum *b) {
     int c, i;

     c = 0;
     for (i = 0; i < MAXNUMS; ++i) {
         a->n[i] += b->n[i] + c;
         if (a->n[i] > 9) {
            a->n[i] -= 10;
            c = 1;
         }
         else
             c = 0;
     }
}

int cmp(TNum *a, TNum *b) {
    int i;

    for (i = 0; i < MAXNUMS && a->n[i] == b->n[i]; ++i)
        ;

    if (i == MAXNUMS)
       return 0;
    else if (a->n[i] < b->n[i])
         return -1;
    else
        return 1;
}

unsigned long long nton(TNum *a) {
         int i;
         unsigned long long p, r;

         p = 1;
         r = 0;
         for (i = 0; i < MAXNUMS; ++i) {
             r += a->n[i] * p;
             p *= 10;
         }

         return r;
}

void init(TNum *a) {
     int i;

     for (i = 0; i < MAXNUMS; ++i)
         a->n[i] = 0;
}

void copy(TNum *a, TNum *b);

void mul(TNum *a, TNum *b) {
     TNum r;
     unsigned long long i, c;

     init(&r);
     if (cmp(a, b) < 0) {
        c = nton(a);
        for (i = 0; i < c; ++i)
            add(&r, b);
     }
     else {
          c = nton(b);
          for (i = 0; i < c; ++i)
              add(&r, a);
     }

     copy(a, &r);
}

TNode *var(char *str, int *pos) {
      TNode *nn;
      
      if (str[*pos] == 'X') {
         nn = (TNode*)malloc(sizeof(TNode));
         nn->t = VAR;
         (*pos)++;
         nn->v = str[*pos] - '0';
         (*pos)++;
         return nn;
      }
      else
          return NULL;
}

TNode *expr(char *str, int *pos);

TNode *term(char *str, int *pos) {
      TNode *hn, *nn;
      
      if (str[*pos] == '\0')
         return NULL;
      else {

      if (str[*pos] == '(')
           hn = expr(str, pos);
      else
           hn = var(str, pos);

      if (str[*pos] == '*') {
         (*pos)++;
         nn = (TNode*)malloc(sizeof(TNode));
         nn->t = SIGN;
         nn->v = '*';
         nn->left = hn;
         nn->right = expr(str, pos);
      }
      else
          nn = hn;

      return nn;

      }
}

TNode *expr(char *str, int *pos) {
      TNode *nn, *hn;
      
      if (str[*pos] == '\0')
         return NULL;
      else {

      if (str[*pos] == '(') {
           (*pos)++;
           hn = expr(str, pos);
           (*pos)++;
      }
      else
           hn = term(str, pos);
           
           if (str[*pos] == '+') {
              (*pos)++;
              nn = (TNode*)malloc(sizeof(TNode));
              nn->t = SIGN;
              nn->v = '+';
              nn->left = hn;
              nn->right = term(str, pos);
           }
           else
               nn = hn;
               
           return nn;
      }
}

void copy(TNum *a, TNum *b) {
     int i;

     for (i = 0; i < MAXNUMS; ++i)
         a->n[i] = b->n[i];
}

void calc(TNode *t) {
     int c;
     TNum op1, op2;
     
     if (t) {
        if (t->t == SIGN) {
           calc(t->left);
           calc(t->right);
           c = t->v;
           copy (&op1, &stack[--sp]);
           if (opp > 0 && op[opp-1][0] == STO && op[opp-1][1] == 10 + sp)
              --opp;
           else {
                op[opp][0] = LOA;
                op[opp++][1] = 10 + sp;
           }
           copy (&op2, &stack[--sp]);
           if (c == '+') {
              op[opp][0] = ADD;
              add(&op1, &op2);
           }
           else {
                op[opp][0] = MUL;
                mul(&op1, &op2);
           }
           op[opp++][1] = 10 + sp;
           op[opp][0] = STO;
           op[opp++][1] = 10 + sp;
           copy (&stack[sp++], &op1);
        }
        else {
             op[opp][0] = LOA;
             op[opp++][1] = t->v;
             op[opp][0] = STO;
             op[opp++][1] = 10 + sp;
             copy (&stack[sp++], &n[t->v-1]);
        }
     }
}

void print(FILE *fout, TNum *a) {
     int i;

     for (i = MAXNUMS - 1; i > 0 && a->n[i] == 0; --i)
         ;
     while (i >= 0)
           fprintf(fout, "%d", a->n[i--]);
     fprintf(fout, "\n");
}

int main(void) {
    FILE *fin, *fout;
    int i;
    char str[MAXLEN+1];
    TNum r;
    TNode *hn;

    fin = fopen("assem.inp", "r");
    for (i = 0; i < MAXX; ++i)
        read(fin, &n[i]);
    fscanf(fin, "%s\n", str);
    fclose(fin);

    i = strlen(str);
    i = 0;
    top = expr(str, &i);
    while (str[i] != '\0') {
          hn = (TNode*)malloc(sizeof(TNode));
          hn->t = SIGN;
          hn->v = str[i++];
          hn->left = top;
          hn->right = expr(str, &i);
          top = hn;
    }

    calc(top);

    fout = fopen("assem.out", "w");
    print(fout, &stack[0]);
    --opp;
    fprintf(fout, "%d\n", opp);
    for (i = 0; i < opp; ++i)
        fprintf(fout, "%s %d\n", msg[op[i][0]], op[i][1]);
    fclose(fout);
    
    return 0;
}
