{$MODE objfpc}

Type
  TInstr = Record
    typ : Integer; {0-loa;1-sto;2-add;3-mul}
    Q : Integer;
  End;
  TLNum = Array[1..22] Of Byte;

Var
  X : Array[1..9] Of Integer;
  Instr : Array[1..30000] Of TInstr;
  Reg : Array[1..10000] Of TLNum;
  Acc : TLNum;
  InstrNum : Integer;
  XP : AnsiString;
  FFreeReg : Integer;

Procedure LOA(i : Integer);

Begin
  Inc(InstrNum);
  Instr[InstrNum].typ := 0;
  Instr[InstrNum].Q := i;
End;

Procedure STO(i : Integer);

Begin
  Inc(InstrNum);
  Instr[InstrNum].typ := 1;
  Instr[InstrNum].Q := i;
End;

Procedure ADD(i : Integer);

Begin
  Inc(InstrNum);
  Instr[InstrNum].typ := 2;
  Instr[InstrNum].Q := i;
End;

Procedure MUL(i : Integer);

Begin
  Inc(InstrNum);
  Instr[InstrNum].typ := 3;
  Instr[InstrNum].Q := i;
End;

Function RegAlloc : Integer;

Begin
  RegAlloc := FFreeReg;
  Inc(FFreeReg);
End;

Function GrpEnd(S : Integer) : Integer;

Var
  BL : Integer;

Begin
  BL := 0;
  Repeat
    Case XP[S] Of
      '(' : Begin
        Inc(BL);
        Inc(S);
      End;
      ')' : Begin
        Dec(BL);
        If BL = 0 Then
          Exit(S);
        Inc(S);
      End;
      'X' : Begin
        If BL = 0 Then
          Exit(S + 1);
        Inc(S, 2);
      End;
    Else
      Inc(S);
    End;
  Until False;
End;

Procedure Parse(S, E : Integer);

Var
  I : Integer;
  tmp : Integer;
{  tmp1 : QWord;
  tmp2 : QWord;}

Begin
  While GrpEnd(S) = E Do
  Begin
    If XP[S] = 'X' Then
    Begin
      I := Ord(XP[S + 1]) - Ord('0');
      LOA(I);
      Exit;
    End;
    Inc(S);
    Dec(E);
  End;
  I := S;
  While I <= E Do
  Begin
    I := GrpEnd(I);
    Inc(I);
    If I > E Then
      Break;
    Case XP[I] Of
      '+' : Begin
        {yes!}
        {tmp1 := }Parse(S, I - 1);
        tmp := RegAlloc;
        STO(tmp);
        {Inc(tmp1,} Parse(I + 1, E){)};
        ADD(tmp);
        Exit{(tmp1)};
      End;
      '*' : Begin
        Inc(I);
      End;
    End;
    If I > E Then
      Break;
  End;
{---------------------------------------------}
  I := S;
  While I <= E Do
  Begin
    I := GrpEnd(I);
    Inc(I);
    If I > E Then
      Break;
    Case XP[I] Of
      '*' : Begin
        {yes!}
        {tmp1 := }Parse(S, I - 1);
        tmp := RegAlloc;
        STO(tmp);
        {tmp2 := }Parse(I + 1, E);
{        tmp1 := tmp1 * tmp2;}
        MUL(tmp);
        Exit{(tmp1)};
      End;
      '+' : Begin
        Inc(I);
      End;
    End;
    If I > E Then
      Break;
  End;

End;

Procedure ReadIn;

Var
  F : Text;
  I : Integer;
  Q : Integer;

Begin
  ASSign(F, 'ASSEM.INP');
  Reset(F);
  For I := 1 To 9 Do
  Begin
    Read(F, Q);
    X[I] := Q;
{    Writeln(X[I]);}
  End;
  Readln(F);
  Readln(F, XP);
  Close(F);
  For I := 1 To Length(XP) Do
    XP[I] := UpCase(XP[I]);
End;

Procedure Ladd(Var dst : TLNum; src : TLNum);

Var
  c, I : Integer;

Begin
  c := 0;
  For I := 1 To 22 Do
  Begin
    c := src[I] + dst[I] + c;
    dst[I] := c Mod 10;
    c := c Div 10;
  End;
End;

Procedure Lmul(Var dst : TLNum; src : Integer);

Var
  c, I : Integer;

Begin
  c := 0;
  For I := 1 To 22 Do
  Begin
    c := dst[I]*src + c;
    dst[I] := c Mod 10;
    c := c Div 10;
  End;
End;

Procedure Lmul(Var dst : TLNum; src : TLNum);

Var
  I : Integer;
  J : Integer;
  Q : TLNum;
  Qtot : TLNum;

Begin
  FillChar(Qtot, SizeOf(Q), 0);
  For I := 1 To 22 Do
  Begin
    For J := 1 To 22 Do
    Begin
      If (J - I + 1) < 1 Then
        Q[J] := 0
      Else
        Q[J] := dst[J - I + 1];
    End;
    Lmul(Q, src[I]);
    Ladd(Qtot, Q);
  End;
  Move(Qtot, dst, SizeOf(dst));
End;

Procedure Bahur2;

Var
  I : Integer;
  Q : Integer;

Begin
  FillChar(Acc, SizeOf(Acc), 0);
  FillChar(Reg, SizeOf(Reg), 0);
  For I := 1 To 9 Do
  Begin
    Q := X[I];
    Reg[I, 1] := Q Mod 10;
    Q := Q Div 10;
    Reg[I, 2] := Q Mod 10;
    Q := Q Div 10;
    Reg[I, 3] := Q Mod 10;
    Q := Q Div 10;
    Reg[I, 4] := Q Mod 10;
    Q := Q Div 10;
  End;
  For I := 1 To InstrNum Do
  Begin
    Case Instr[I].typ Of
      0 : Move(Reg[Instr[I].Q], Acc, SizeOf(Acc));
      1 : Move(Acc, Reg[Instr[I].Q], SizeOf(Acc));
      2 : Ladd(Acc, Reg[Instr[I].Q]);
      3 : Lmul(Acc, Reg[Instr[I].Q]);
    End;
  End;
End;

Procedure Bahur;

Begin
  FFreeReg := 10;
  InstrNum := 0;
  Parse(1, Length(XP));
  Bahur2;
End;

Procedure WriteOut;

Var
  I : Integer;
  F : Text;
  lz : Boolean;

Begin
  ASSign(F, 'ASSEM.OUT');
  Rewrite(F);
  lz := True;
  For I := 22 DownTo 1 Do
  Begin
    If Acc[I] <> 0 Then
      lz := False;
    If (I = 1) Or (Not lz) Then
      Write(F, Acc[I]);
  End;
  Writeln(F);
  Writeln(F, InstrNum);
  For I := 1 To InstrNum Do
  Begin
    Case Instr[I].typ Of
      0 : Write(F, 'LOA');
      1 : Write(F, 'STO');
      2 : Write(F, 'ADD');
      3 : Write(F, 'MUL');
    End;
    Writeln(F, ' ', Instr[I].Q);
  End;
  Close(F);
End;

Begin
  ReadIn;
  Bahur;
  WriteOut;
End.
