#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>


#define MAXL 310100
#define MAXN 512
#define MAXS 512
#define HASHSIZE 65535


typedef struct {
  int l;
  char s[MAXS];
} WORD;



int L, N;
WORD w[MAXN];
int wl[MAXN];
char s[MAXL];
int minrem[MAXL];
int gotoind[MAXS];
int inds[MAXS][2];  /* 0-len, 1-ind */
int ninds;
int *hs[HASHSIZE];
int nhs[HASHSIZE];
int exl[MAXS];
char stwith[128][128][MAXS];
int stwith1[128];
int maxlen;
int P;
int AA, AB;



void read_all(void);
void do_all(void);
int hash(char *str, int l);
void write_all(void);



int main(void)
{
  read_all();
  do_all();
  write_all();
  return 0;
}



void read_all(void)
{
  int i;
  
  FILE *f = fopen("pass.inp", "rt");
  fscanf(f, "%d %d\n", &L, &N);
  fgets(s, sizeof(s), f);
  s[L] = '\0';
  for (i = 0; i < N; i++) {
    fgets(w[i].s, sizeof(w[i].s), f);
    w[i].l = strlen(w[i].s);
    while (w[i].s[w[i].l-1] <= ' ') {
      w[i].s[--w[i].l] = '\0';
    }
  }
  fclose(f);
}



void do_all(void)
{
  int i, d, e, hval;

  d = e = 0;
  for (i = 0; i < N; i++) {
    hval = hash(w[i].s, w[i].l);
    exl[w[i].l]++;
    stwith[w[i].s[0]][w[i].s[1]][w[i].l] = 1;//++;
    stwith1[w[i].s[0]] = 1;//++;
    if (w[i].l > maxlen)  maxlen = w[i].l;
    nhs[hval]++;
    hs[hval] = realloc(hs[hval], (nhs[hval])*sizeof(hs[0][0]));
    hs[hval][nhs[hval]-1] = i;
    if (nhs[hval] > 1)  d++;
    if (nhs[hval] > e)  e = nhs[hval];
  }

  memset(minrem, -1, sizeof(minrem));
  minrem[L] = 0;

  for (i = L-1; i >= 0; i--) {
    getminrem(i);
  }

  P = minrem[0];
}



int getminrem(int ind)
{
  int i, j, k;
  int res, res1, LL;
  int hval;
  
  res = L-ind;

  hval = 0;
  LL = L-ind;
  if (LL >= maxlen)  LL = maxlen;
  
  if (stwith1[s[ind]] > 0) {
    for (i = 1, k = 0; i <= LL; i++, k++) {

      if (s[ind+i-1] >= 'a') {
        hval += (1+s[ind+k])*(k+3)+1;
        hval %= HASHSIZE;
      }
      if (i > 1 && stwith[s[ind]][s[ind+1]][i] == 0)  continue;
      if (exl[i] == 0)  continue;
      if (minrem[ind+i] >= res) {
        AA++;
        continue;
      }
      /* 6650 */
      if (nhs[hval] > 0) {
        /* 128 */
        for (j = 0; j < nhs[hval]; j++) {
          if (w[hs[hval][j]].l != i)  continue;
          /* 106 */
          if (strncmp(w[hs[hval][j]].s, s+ind, i) == 0) {
            res1 = minrem[ind+i];
            if (res1 < res)  res = res1;
            break;
          }
        }
      }
    }
  }
  for (i = ind+1; i < L; i++) {
    res1 = i-ind+minrem[i];
    if (res1 < res)  res = res1;
  }
  return minrem[ind] = res;
}



int hash(char *str, int l)
{
  int i, res;

  res = 0;
  for (i = 0; i < l; i++) {
    res += (1+str[i])*(i+3)+1;
    res %= HASHSIZE;
  }
  return res;
}



void write_all(void)
{
  FILE *f = fopen("pass.out", "wt");
  fprintf(f, "%d\n", P);
  fclose(f);
}


