const inp = 'pass.inp';
      out = 'pass.out';
      MaxL = 300000;
      MaxS = 300;


type TBest = array[0..MaxL] of longint;

     TWords = array[1..MaxS] of string;

     TPass = array[1..MaxL] of char;


var Fin, Fout: text;
    word: TWords;
    best: TBest;
    n: longint;
    w, HSize, ind: integer;
    pass: TPass;

{############################################################################}
procedure Done;
begin
close(Fin); close(Fout);
halt;
end;

{############################################################################}
procedure HeapAdjustUp(i: integer);
var son, parent: integer;
    saveW: string;

begin
son:= i;
parent:= i div 2;
saveW:= word[i];
while (parent >= 1) and (word[parent][length(word[parent])] < saveW[length(saveW)]) do
  begin
  word[son]:= word[parent];
  son:= parent; parent:= parent div 2;
  end;
word[son]:= saveW;
end;

{############################################################################}
procedure Heapify(i: integer);
var l, r, one: integer;
    ww: string;

begin
l:= i*2; r:= i*2+1;
if (l <= HSize) and (word[l][length(word[l])] > word[i][length(word[i])]) then one:= l
  else one:= i;
if (r <= HSize) and (word[r][length(word[r])] > word[i][length(word[i])]) then one:= r;
if one = i then exit;
ww:= word[i]; word[i]:= word[one]; word[one]:= ww;
Heapify(one);
end;

{############################################################################}
procedure HeapSort;
var i: integer;
    ww: string;

begin
for i:= HSize downto 2 do
  begin
  ww:= word[1]; word[1]:= word[i]; word[i]:= ww;
  dec(HSize);
  Heapify(1);
  end;
end;

{############################################################################}
{############################################################################}
procedure Init;
var i: integer;

begin
assign(Fin, inp); reset(Fin);
assign(Fout, out); rewrite(Fout);

readln(Fin, N, w);

readln(Fin);
HSize:= 0;
for i:=1 to w do
  begin
  readln(Fin, word[i]);
  inc(HSize);
  HeapAdjustUp(i);
  end;
HeapSort;

reset(Fin);
readln(Fin);
end;

{############################################################################}
function FindStart(s: string; var count, pos: integer):boolean;
var b: boolean;
    i: integer;

begin
b:= true;
count:= 0;
pos:= ind;
for i:= length(s) downto 1 do
  begin
  while (pos >= 1) and (pass[pos] <> s[i]) do
    begin dec(pos); inc(count); end;
  if pos = 0 then
    begin FindStart:= false; exit; end;
  dec(pos);
  end;
FindStart:= true;
end;

{############################################################################}
procedure Solve;
var i, min: longint;
    found: boolean;
    j, k, m, count, pos: integer;

begin
best[0]:= 0;
for ind:=1 to n do
  begin
  read(Fin, pass[ind]);
  best[ind]:= best[ind-1] + 1;
  k:=1; j:= w;
  repeat
    if j - k < 10 then break;
    m:= (j+k) div 2;
    if word[m][length(word[m])] < pass[ind] then
      begin k:= m+1; continue; end;
    if word[m][length(word[m])] = pass[ind] then
      begin
      k:= m;
      while (k > 1) and (word[k-1][length(word[k-1])] = pass[ind]) do dec(k);
      break;
      end;
    j:= m;
  until false;
  for m:= k to j do
    begin
    if word[m][length(word[m])] > pass[ind] then break;
    if word[m][length(word[m])] = pass[ind] then
      begin
      if not FindStart(word[m], count, pos) then continue;
      if best[ind] > count + best[pos] then
        best[ind]:= count + best[pos];
      end;
    end;
  end;
writeln(Fout, best[n]);
end;

{############################################################################}
{############################################################################}
{############################################################################}
BEGIN
Init;
Solve;
Done;
END.
