/*
NAME: Ivan Anev
SCHOOL: SMG
PROGRAM: lines
*/

#include <stdio.h>

#define MAXN 1024
#define MAXV 1048576
#define MAXE 4194304

typedef struct Vex TVex;
typedef struct Edge TEdge;
typedef struct Lines TLines;

struct Vex {
       int v, edges, p;
};

struct Edge {
       int v, next;
};

struct Lines {
       int ts;
       int sp[MAXN];
};

TLines ls[MAXN];
TVex vs[MAXV];
TEdge *es;
int nv, ne, n, cc;

void init(int v) {
     int i;

     n = v;
     nv = ne = 0;
     v = v * MAXN;
     for (i = 0; i < v; ++i) {
         vs[i].v = 0;
         vs[i].edges = -1;
         vs[i].p = 0;
     }
}

void add_edge(int i, int j) {
     es[ne].v = j;
     es[ne].next = vs[i].edges;
     vs[i].edges = ne;
     vs[i].p++;
     ne++;
}

void dfs(int v) {
     int e;

     vs[v].v = 1;
     if (vs[v].p == 1)
        ++cc;
     for (e = vs[v].edges; e != -1; e = es[e].next)
         if (vs[es[e].v].v == 0)
            dfs(es[e].v);
}

int main(void) {
    FILE *fin, *fout;
    int cl, i, j, p, k, m, tv, pv, ttcc, v;

    fin = fopen("lines.inp", "r");
    fout = fopen("lines.out", "w");

    es = (TEdge*)malloc(sizeof(TEdge) * MAXE);

    while (1) {
          fscanf(fin, "%d", &n);
          if (n == 0)
             break;
          init(n);
          for (i = 0; i < n; ++i)
              fscanf(fin, "%d", &ls[i].ts);
          for (v = 0; v < n; ++v) {
              fscanf(fin, "%d", &cl);
              --cl;
              pv = -1;
              for (j = 0; j < ls[cl].ts; ++j) {
                  fscanf(fin, "%d", &p);
                  tv = -1;
                  for (i = 0; i < p; ++i) {
                      fscanf(fin, "%d %d", &k, &m);
                      --k;
                      --m;
                      if (k < v) {
                         tv = ls[k].sp[m];
                         ++i;
                         break;
                      }
                  }
                  while (i < p) {
                        fscanf(fin, "%d %d", &k, &m);
                        ++i;
                  }
                  if (tv == -1)
                     tv = nv++;
                  ls[cl].sp[j] = tv;
                  if (pv != -1) {
                     add_edge(tv, pv);
                     add_edge(pv, tv);
                  }
                  pv = tv;
              }
          }
          ttcc = 0;
          for (i = 0; i < nv; ++i)
              if (vs[i].v == 0) {
                 cc = 0;
                 dfs(i);
                 ttcc += (cc + 1) / 2;
              }
          if (ttcc == 0)
             ttcc = 1;
          fprintf(fout, "%d\n", ttcc);
    }

    fclose(fin);
    fclose(fout);

    free(es);

    return 0;
}
