{$MODE objfpc}

Type
  PElem = ^TElem;
  TElem = Record
    E : Integer;
    next : PElem;
  End;

Var
  InF, OutF : Text;
  LNum : Integer;
  LLen : Array[0..1000] Of Integer;
  Line : Array[0..1000, 0..1000] Of Integer;
  St : Array[0..1004004] Of Integer;
  Nb : Array[0..1004004] Of PElem;
  VNum : Integer;

Procedure Flush;

Var
  I : Integer;
  p, tmp : PElem;

Begin
  For I := 1 To VNum Do
  Begin
{$IFNDEF RELEASE}
    If St[I] <> 0 Then
      Writeln('err');
{$ENDIF}
    p := Nb[I];
    While p <> Nil Do
    Begin
      tmp := p^.next;
      Dispose(p);
      p := tmp;
    End;
    Nb[I] := Nil;
  End;
End;

Function Dig(Q : Integer) : Integer;

Var
  p : PElem;

Begin
  Dig := 0;
  If St[Q] = 0 Then
    Exit;
  If (St[Q] And 1) <> 0 Then
    Dig := 1
  Else
    Dig := 0;
  St[Q] := 0;

  p := Nb[Q];
  While p <> Nil Do
  Begin
    Inc(Dig, Dig(p^.E));
    p := p^.next;
  End;
End;

Procedure Edge(A, B : Integer);

Var
  p : PElem;

Begin
  New(p);
  p^.E := B;
  p^.next := Nb[A];
  Nb[A] := p;
  Inc(St[A]);
{  Writeln(A, '->', B);}
End;

Procedure Bahur;

Var
  I : Integer;
  tmp : Integer;
  sum : Integer;

Begin
  sum := 0;
  For I := 1 To VNum Do
  Begin
    If St[I] <> 0 Then
    Begin
      tmp := Dig(I);
      If tmp = 0 Then
        Inc(sum)
      Else
        Inc(sum, tmp Shr 1);

{      Write(I, '#', tmp, ' ');}
    End;
  End;
{  Writeln;}
  Writeln(OutF, sum);
End;

Var
  I, J : Integer;
  tmp : Integer;
  tmp2 : Integer;
  newV : Boolean;
  C1, C2 : Integer;

Begin
{  FillChar(St, SizeOf(St), 0);
  FillChar(Nb, SizeOf(Nb), 0);}
  ASSign(OutF, 'LINES.OUT');
  Rewrite(OutF);
  ASSign(InF, 'LINES.INP');
  Reset(InF);
  Repeat
    Readln(InF, LNum);
    If LNum <> 0 Then
    Begin
//      FillChar(St, SizeOf(St), 0); {$NOTE slow!!!}
//      FillChar(Nb, SizeOf(Nb), 0); {$NOTE memory leak!!!}
      VNum := 0;
      For I := 1 To LNum Do
        Read(InF, LLen[I]);
      Readln(InF);
      For I := 1 To LNum Do
      Begin
        Readln(InF, tmp);
        For J := 1 To LLen[I] Do
        Begin
          Read(InF, tmp);
          newV := True;
          For tmp2 := 1 To tmp Do
          Begin
            Read(InF, C1, C2);
            If C1 < I Then
            Begin
              newV := False;
              Break;
            End;
          End;
          Readln(InF);
          If newV Then
          Begin
            Inc(VNum);
            St[VNum] := 0;
            Nb[VNum] := Nil;
            Line[I, J] := VNum;
          End
          Else
          Begin
            Line[I, J] := Line[C1, C2];
          End;
          If J > 1 Then
          Begin
            Edge(Line[I, J], Line[I, J - 1]);
            Edge(Line[I, J - 1], Line[I, J]);
          End;
        End;
      End;
      Bahur;
      Flush;
    End;
{    Writeln('--------------');}
  Until LNum = 0;
  Close(InF);
  Close(OutF);
End.
