Const
        InFile =  'points.inp';
        OutFile = 'points.out';

        MAXN = 1500;

Type
        PNode = ^TNode;
        TNode = record
                id   : integer;
                next : PNode;
        end;

        TPoint = record
                x,y : real;
        end;

Var
        FIn,FOut : text;
        g        : array [1..MAXN] of PNode;
        ps       : array [1..MAXN] of TPoint;
        used     : array [1..MAXN] of boolean;
        n,i      : integer;
        d        : real;

procedure connect(a,b : integer);
var
        p : PNode;
begin
        new(p);
        p^.id := b;
        p^.next := g[a];
        g[a] := p;
end;

procedure clearMem;
var
        i : integer;
        p : PNode;

begin
        for i := 1 to MAXN do
                while g[i] <> nil do begin
                        p := g[i];
                        g[i] := g[i]^.next;
                        dispose(p);
                end;
end;

procedure dfs(id : integer);
var
        w : Pnode;
begin
        if used[id] then
                exit;

        used[id] := true;

        w := g[id];
        while w <> nil do begin
                dfs(w^.id);
                w := w^.next;
        end;
end;

procedure solve;
var
        i,j : integer;
begin
        for i := 1 to n-1 do
                for j := i+1 to n do
                        if sqr(ps[i].x - ps[j].x) + sqr(ps[i].y - ps[j].y) <= D then begin
                                connect(i,j);
                                connect(j,i);
                        end;

        fillchar(used,sizeof(used),false);

        j := 0;
        for i := 1 to n do
                if not used[i] then begin
                        inc(j);
                        dfs(i);
                end;

        writeln(FOut,j);
end;

Begin
        assign(FIn,InFile);     reset(FIn);
        assign(FOut,OutFIle);   rewrite(FOut);

        while true do begin
                clearMem;
                read(FIn,n);
                if n = 0 then
                        break;
                readln(Fin,d);

                d := d * d;

                for i := 1 to N do
                        read(FIn,ps[i].x,ps[i].y);
                solve;
        end;
        close(Fin);
        close(FOut);
End.
