#include <stdio.h>
#include <stdlib.h>
#include <string.h>



#define MAXN 1024
#define MAXM 100100
#define MAXI 1024
#define INF (1<<29)



typedef struct {
  short u;
  short iner;
  float fu;
} NODE;
typedef struct {
  short to;
  short dist;
} EDGE;



EDGE *g[MAXN];
short edg[MAXM][3];
int deg[MAXN];
char used[MAXN*MAXI];
float shortest[MAXN*MAXI];
NODE heap[MAXN*MAXI];
int lheap;
int N, M;
int A, B;
double P;
int AA, AB, AC;



int read_all(void);
int do_all(void);
void dijkstra(int u);
void heap_get(NODE *nod);
void heap_add(NODE *nod);
void heap_move_down(int ind);
void heap_move_up(int ind);
int write_all(void);



int main(void)
{
  read_all();
  do_all();
  write_all();
  return 0;
}



int read_all(void)
{
  int a, b, c, m, i;

  FILE *f = fopen("hill.inp", "rt");
  fscanf(f, "%d %d", &N, &M);
  m = M;
  while (M--) {
    fscanf(f, "%d %d %d", &a, &b, &c);  a--;  b--;
    edg[M][0] = a;
    edg[M][1] = b;
    edg[M][2] = c;
    deg[a]++;
    deg[b]++;
  }
  for (i = 0; i < N; i++) {
    g[i] = (EDGE *)malloc(deg[i]*sizeof(*g[i]));
  }
  memset(deg, 0, sizeof(deg));
  while (m--) {
    a = edg[m][0];
    b = edg[m][1];
    c = edg[m][2];
    g[a][deg[a]].to = b;
    g[a][deg[a]].dist = c;
    deg[a]++;
    g[b][deg[b]].to = a;
    g[b][deg[b]].dist = c;
    deg[b]++;
  }
  fscanf(f, "%d %d", &A, &B);  A--;  B--;
  fclose(f);
}



int do_all(void)
{
  int i;

  for (i = 0; i < MAXN*MAXI; i++)  shortest[i] = INF;
  dijkstra(A);
}



void dijkstra(int u)
{
  int i, v, d;
  NODE nod, nod1;
  double funew;

  P = -1;
  nod.u = u;
  nod.iner = 0;
  nod.fu = 0;
  heap_add(&nod);
  for (;;) {
    if (lheap == 0)  break;
    if (lheap > AA)  AA = lheap;
    AB++;
    heap_get(&nod);
    if (nod.u == B) {
      P = nod.fu;
      break;
    }
    used[nod.u*MAXI+nod.iner] = 1;
    u = nod.u;
    for (i = 0; i < deg[u]; i++) {
      v = g[u][i].to;
      funew = g[u][i].dist/2.;
      funew -= nod.iner/4.;
      if (funew < 0)  funew = 0;
      funew += nod.fu;
      nod1.u = v;
      nod1.iner = g[u][i].dist;
      nod1.fu = funew;
      AC++;
      if (used[nod1.u*MAXI+nod1.iner])  continue;
      if (nod1.fu < shortest[nod1.u*MAXI+nod1.iner]) {
        shortest[nod1.u*MAXI+nod1.iner] = nod1.fu;
        heap_add(&nod1);
      }
    }
  }
}



void heap_get(NODE *nod)
{
  *nod = heap[0];
  heap[0] = heap[lheap-1];
  lheap--;
  heap_move_down(0);
}



void heap_add(NODE *nod)
{
  heap[lheap] = *nod;
  lheap++;
  heap_move_up(lheap-1);
}



void heap_move_down(int ind)
{
  int dw;

  for (;;) {
    if (2*ind+1 >= lheap)  break;
    dw = 2*ind+1;
    if (dw+1 < lheap && heap[dw+1].fu < heap[dw].fu)  dw++;
    if (heap[ind].fu > heap[dw].fu) {
      NODE t;
      t = heap[ind];
      heap[ind] = heap[dw];
      heap[dw] = t;
    }
    ind = dw;
  }
}



void heap_move_up(int ind)
{
  int pr;

  for (;;) {
    if (ind <= 0)  break;
    pr = (ind-1)/2;
    if (heap[ind].fu < heap[pr].fu) {
      NODE t;
      t = heap[ind];
      heap[ind] = heap[pr];
      heap[pr] = t;
    }
    ind = pr;
  }
}



int write_all(void)
{
  FILE *f = fopen("hill.out", "wt");
  if (P < 0)  fprintf(f, "0\n");
  else {
    fprintf(f, "%.2lf\n", P);
  }
  fclose(f);
}

