{$MODE objfpc}

Unit HillBugU;

Interface

Procedure BuggyBahur;

Implementation

Type
  Float = Double;

Var
  M, N : Integer;
  G : Array[0..1023, 0..1023] Of Integer;
  V : Array[0..1023] Of Boolean;
  P : Array[0..1023] Of Float;
  Prev : Array[0..1023] Of Integer;
  Source, Dest : Integer;

Procedure WriteOut;

Var
  F : Text;

Begin
  ASSign(F, 'HILL.OUT');
  Rewrite(F);
  Writeln(F, 0);
  Close(F);
  Halt;
End;

Procedure WriteOut(q : Float);

Var
  F : Text;

Begin
  ASSign(F, 'HILL.OUT');
  Rewrite(F);
  Writeln(F, q:0:2);
  Close(F);
  Halt;
End;

Procedure ReadIn;

Var
  F : Text;
  I : Integer;
  A, B, C : Integer;

Begin
  FillChar(G, SizeOf(G), $3F);
  ASSign(F, 'HILL.INP');
  Reset(F);
  Readln(F, N, M);
  For I := 1 To M Do
  Begin
    Readln(F, A, B, C);
    G[A, B] := C;
    G[B, A] := C;
  End;
  Readln(F, Source, Dest);
  Close(F);
End;

Function Clip(q : Float) : Float;

Begin
  If q > 0 Then
    Clip := q
  Else
    Clip := 0;
End;

Procedure Bahur;

Var
  I : Integer;
  QQ : Integer;
  min : Float;
  minI : Integer;
  newp : Float;
  oldp : Float;

Begin
  FillChar(V, SizeOf(V), 0);
  For I := 1 To N Do
    P[I] := 123456789;
  P[Source] := 0;
  Prev[Source] := Source;
  G[Source, Source] := 0;
  For QQ := 1 To N Do
  Begin
    min := 123456789;
    For I := 1 To N Do
      If (Not V[I]) And (P[I] < min) Then
      Begin
        min := P[I];
        minI := I;
      End;
    If min > 123456700 Then
      Break;
    V[minI] := True;
    For I := 1 To N Do
      If G[minI, I] < 12345 Then
      Begin
        oldp := G[Prev[minI], minI];
        newp := P[minI] + Clip((G[minI, I]/2) - (oldp/4));
        If newp < P[I] Then
        Begin
          P[I] := newp;
          Prev[I] := minI;
        End;
      End;
  End;
  If P[Dest] > 12345700 Then
    WriteOut
  Else
    WriteOut(P[Dest]);
End;

Procedure BuggyBahur;

Begin
  ReadIn;
  Bahur;
  Halt;
End;

End.
