{ O(N+M*+K)
N - size of text,
M* - total size of all words,
K - number of occurences of words in the text

//Dynamic Programming
for every word j that ends at position i
a[i] := min ( a[i-1]+1, a[j - word[j].length ])
by default a[0] := 0

how to find every word j that ends at position i !?!?
//Aho-Corasick Algorithm
... :) ...

Kris
}

{$Q-,R-,S-}
program pass;
const
     InFile                     = 'pass.inp';
     OutFile                    = 'pass.out';
     MaxSize                    = 300;
     MaxM                       = 300;
     MaxN                       = 300000;
     BegChar                    = 'a';
     FinChar                    = 'z';
type
    Integer                     = LongInt;
    PNode                       = ^TNode;
    TNode                       = record
                                    Num : Integer;
                                    Fail, OutLink : PNode;
                                    Edge : array[BegChar..FinChar] of PNode;
                                  end;
    TWord                       = record
                                    S :array[1..MaxSize] of Char;
                                    L : Integer;
                                    P : PNode;
                                  end;
var
   A                            : array[0..MaxN] of Integer;
   B                            : array[1..MaxN] of Char;
   Word                         : array[1..MaxM] of TWord;
   Root                         : PNode;
   N, M                         : Integer;
   Cindex                       : Integer;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
procedure OutPut;
var
        Fo                      : Text;
begin
  Assign(Fo, OutFile); ReWrite(Fo);
  WriteLn(Fo, A[N]);
  Close(Fo);
  Halt(0);
end;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
procedure InPut;
var
   Fi                           : Text;
   I                            : Integer;
begin
{reading}
  Assign(Fi, InFile); ReSet(Fi);
  ReadLn(Fi, N, M);

  for I := 1 to N do begin Read(Fi, B[I] ); end;
  ReadLn(Fi);

  for I := 1 to M do
    with Word[I] do begin
     { ReadLn(Fi, Word[I].S);
      Word[I].L := Length( Word[I].S ); }
      L := 0;
      repeat
        Inc(L);
        Read(Fi, S[L]);
      until Eoln(Fi);
      ReadLn(Fi);
    end;
  Close(Fi);
end;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
procedure Init(var P : Pnode; Num : Integer; Fail : Pnode);
var
   C                            : Char;
begin
  New(P);
  P^.Num := Num;
  P^.Fail := Fail;
  P^.OutLink := nil;
  for C := BegChar to FinChar do P^.Edge[C] := nil;
end;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
procedure BuildTree;
var
   C                            : Char;
   K, I                         : Integer;
   Prev, CurFail                : PNode;
begin
{init for the root of the tree}
  Init(Root,0,nil);
{making the first level}
  for I := 1 to M do with Word[I] do begin
    C := S[1];
    if Root^.Edge[C] = nil
      then Init(Root^.Edge[C],0,Root);
    P := Root^.Edge[C];
    if L = 1 then P^.Num := I;
  end;
{making the other levels}
  for K := 2 to MaxSize do
    for I := 1 to M do with Word[I] do
      if K <= L then begin
        Prev := P;
        C := S[K];
        if Prev^.Edge[C] = nil then begin
          Init(Prev^.Edge[C],0,nil);
          P := Prev^.Edge[C];
          if L = K then P^.Num := I;
          CurFail := Prev^.Fail;
          while (CurFail <> Root) and
                (CurFail^.Edge[C] = nil) do CurFail := CurFail^.Fail;
          if CurFail^.Edge[C] = nil then P^.Fail := Root
                                    else P^.Fail := CurFail^.Edge[C];
          if P^.Fail^.Num = 0 then P^.OutLink := P^.Fail^.OutLink
                              else P^.OutLink := P^.Fail;
        end else begin
          P := Prev^.Edge[C];
          if L = K then P^.Num := I;
        end;
      end;
end;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
procedure CheckOccurrence(W : PNode);
begin
  while (W <> Root) and (W <> nil) do begin
    if (W^.Num > 0) and (A[Cindex - Word[W^.Num].L] < A[Cindex])
      then A[Cindex] := A[Cindex - Word[W^.Num].L];
    W := W^.OutLink;
  end;
end;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
procedure Go;
var
   W                            : PNode;
   C                            : Char;
   {-------------------}
   procedure Read_next_Char;
   begin
     if Cindex = N then OutPut;
     Inc(Cindex);
     C := B[Cindex];
     A[Cindex] := A[Cindex-1] + 1;
   end;

   {-------------------}
begin
  A[0] := 0;  Cindex := 0;

  Read_next_Char;
  W := Root;
  repeat
    while W^.Edge[C] <> nil do begin
      W := W^.Edge[C];
      CheckOccurrence(W);
      Read_next_Char;
    end;
    if W = Root then Read_next_Char
                else W := W^.Fail;
  until False;
end;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
begin
  InPut;
  BuildTree;
  Go;
end.

