{$IFDEF NORMAL}
  {$I-,Q-,R-,S-,V-,X-}
{$ENDIF NORMAL}
{$IFDEF DEBUG}
  {$I+,Q+,R+,S-,V-,X-}
{$ENDIF DEBUG}
{$IFDEF RELEASE}
  {$I-,Q-,R-,S-,V-,X-}
{$ENDIF RELEASE}
Const
  GraphNdxMax=30000;
  FinStr = '';
Type
  TNdx = Word;
  TData = LongInt;

  TGraphNdx = 0..GraphNdxMax;
  PNode=^TNode;
  TNode=
        Record
          Key:TNdx;
          Next:PNode;
        End;
  TGraph= Array[ TGraphNdx ] Of PNode;
  TUsed = Array[TGraphNdx]Of Boolean;

Var
  Graph : TGraph;
  Used : TUsed;
  Ans : TData;
  N : TNdx;
  M : TData;

   Procedure AddEdge(Node1, Node2 : TNdx);
     Var
       TmpNode : PNode;
     Begin
       New(TmpNode);
       TmpNode^.Key:=Node2;
       TmpNode^.Next:=Graph[Node1];
       Graph[Node1]:=TmpNode;
     End;

   Procedure InitGraphFull;
     Var
       I : TNdx;
     Begin
       For I:=1 To GraphNdxMax Do
         Graph[I]:=Nil;
     End;

   Procedure ReadIn;
     Var
       Fin : Text;
       I : TData;
       Node1, Node2 : TNdx;
     Begin
       Assign(Fin, FinStr);
       ReSet(Fin);

         ReadLn(Fin, N, M);
         For I:=1 To M Do
          Begin
            ReadLn(Fin, Node1, Node2);
            AddEdge(Node1, Node2);
            AddEdge(Node2, Node1);
          End;

       Close(Fin);
     End;

   Procedure InitUsed;
     Var
       I:TNdx;
     Begin
       For I:= 1 To N Do
         Used[I]:=False;
     End;

   Procedure Print;
     Begin
       WriteLn(Ans);
     End;

   Function FindConn(I : TNdx) : TData;
     Var
       CurNode : PNode;
       Conn : TData;
     Begin
       If Used[I] Then
         Exit;
       Used[I]:=True;
       CurNode:=Graph[I];
       Conn:=0;
       While CurNode <> Nil Do
        Begin
          If Not Used[CurNode^.Key] Then
           Begin
             Inc(Conn);
             Conn:=Conn + FindConn(CurNode^.Key);
           End;
          CurNode:=CurNode^.Next;
        End;
       FindConn:=Conn;
     End;

   Procedure Solve;
     Var
       I : TNdx;
       HowMany : TData;
     Begin
       Ans:=0;
       For I:=1 To N Do
         If Not Used[I] Then
          Begin
            HowMany:=FindConn(I) + 1;
            If HowMany > Ans Then
              Ans:=HowMany;
          End;
     End;

   Procedure KillGraph;
     Var
       Tmp1, Tmp2 : PNode;
       I : TNdx;
     Begin
       For I:=1 To N Do
        Begin
          Tmp1:=Graph[I];
          While Tmp1 <> Nil Do
           Begin
             Tmp2:=Tmp1;
             Tmp1:=Tmp1^.Next;
             DisPose(Tmp2);
           End;
          Graph[I]:=Nil;
        End;
     End;

Begin
  InitGraphFull;
  ReadIn;
  InitUsed;
  Solve;
  Print;
  KillGraph;
End.
