Const
 MaxN = 32000;
 MaxM = 510000;
 FIn  = '';
 FOut = '';

Type
 FriendsRec = Record
               X,Y : LongInt;
              End;

Var
 F1,F2   : Text;
 FrCnt,
 N,M,Ind : LongInt;
 G       : Array[1..MaxM*2] Of FriendsRec;
 Cnt     : LongInt;
 NotUsed : Array[1..MaxN*2] Of Boolean;
 LInd,
 RInd    : Array[1..MaxN*2] Of LongInt;

 Procedure Swap(Var FR1,FR2 : FriendsRec);
 Var
  Tmp : FriendsRec;
 Begin
  Tmp := FR1;
  FR1 := FR2;
  FR2 := Tmp;
 End;

 Procedure QSort(L,R : LongInt);
 Var
  I,J : LongInt;
  M   : LongInt;
 Begin
  I := L;
  J := R;
  M := G[(L+R) div 2].X;
  Repeat
   While G[I].X < M Do Inc(I);
   While G[J].X > M Do Dec(J);
   If I <= J Then
    Begin
     Swap(G[I],G[J]);
     Inc(I);
     Dec(J);
    End;
  Until I > J;

  If I<R Then QSort(I,R);
  If J>L Then QSort(L,J);
 End;

 Procedure SetFriends(I1,I2 : LongInt);
 Begin
  Inc(FrCnt);
  G[FrCnt].X := I1;
  G[FrCnt].Y := I2;
  Inc(FrCnt);
  G[FrCnt].X := I2;
  G[FrCnt].Y := I1;
 End;

 Procedure SortFriends;
 Var
  I,J : LongInt;
 Begin
  QSort(1,FrCnt);

  For J:=1 To FrCnt-2 Do
   If LInd[G[J].X] = 0 Then
    LInd[G[J].X] := J;

  For J:=FrCnt-2 DownTo 1 Do
   If RInd[G[J].X] = 0 Then
    RInd[G[J].X] := J;
 End;

 Procedure DFS(V : LongInt);
 Var
  I : LongInt;
 Begin
  NotUsed[V] := False;
  Inc(Cnt);

  {
  Writeln('dfs',V, ' ',Cnt);
  }

  For I:=LInd[V] To RInd[V] Do
   If NotUsed[G[I].Y] Then
    DFS(G[I].Y);
 End;

Var
 I,X,Y,
 MaxC  : LongInt;
Begin
 Assign(F1, FIn);
 Reset(F1);

 FrCnt := 0;

 Readln(F1, N, M);
 For I:=1 To M Do
  Begin
   Readln(F1, X, Y);
   SetFriends(X,Y);
  End;
 Close(F1);

 FillChar(LInd, SizeOf(Lind), 0);
 FillChar(RInd, SizeOf(Rind), 0);

 SetFriends(N+1,N+2);

 SortFriends;

 {
  For I:=1 To N Do
  Writeln(I, ': ', LInd[I], ' , ', RInd[I]);

 Writeln('Sorting done.');
 }

 Assign(F2, FOut);
 Rewrite(F2);

 FillChar(NotUsed, SizeOf(NotUsed), True);
 FillChar(Cnt, SizeOf(Cnt), 0);

 MaxC := 0;

 {
 Writeln('DFS...');
 }

 For I:=1 To N Do
  If NotUsed[I] Then
   If LInd[I] > 0 Then
    Begin
     {
     Write(I,'...  ');
     }
     Cnt  := 0;
     DFS(I);
     If Cnt > MaxC Then
      MaxC := Cnt;
    End;

 Writeln(F2, MaxC);

 Close(F2);
End.
