#include <stdio.h>
#define MAXK 220

int k[MAXK];

class CHeap
  {
    private:
    short data[MAXK];
    short pos;

    void swap(int p1,int p2)
      {
        short tmp=data[p1];
        data[p1]=data[p2];
        data[p2]=tmp;
      }

    void shiftup(short pos)
      {
        while(pos>1 && k[data[pos]]<k[data[pos/2]])
          {
            swap(pos,pos>>1);
            pos>>=1;
          }
      }

    void shiftdown(short p)
      {
        short newi;
        while(1)
          {
            newi=p*2;
            if(newi>=pos) break;
            if(newi+1<pos && k[data[newi+1]]<k[data[newi]]) newi++;
            if(k[data[newi]]<k[data[p]])
              {
                swap(p,newi);
                p=newi;
              }
            else break;
          }
      }

    public:
    CHeap() {pos=1;}

    short top()
      {
        if(pos==1) return -1;
        return data[1];
      }

    void push(short num)
      {
        data[pos]=num;
        pos++;
        shiftup(pos-1);
      }

    void pop()
      {
        swap(1,pos-1);
        pos--;
        shiftdown(1);
      }

    void update(short pos) { shiftdown(pos); }
      
  };

int broi;
CHeap heap;
short curr;

extern void srv(int,int,int *);

short FindMin()
  {
    return heap.top();
  }

void Fill()
  {
    for(int i=0;i<broi;i++)
      {
        srv(1,i+1,&k[i]);
        if(k[i]!=-1) heap.push(i);
      }
  }

int main()
  {
    srv(0,0,&broi);
    Fill();
    while(1)
      {
        curr=FindMin();
        if(curr==-1) break;
        srv(2,k[curr],NULL);
        srv(1,curr+1,&k[curr]);
        if(k[curr]==-1) heap.pop();
        else heap.update(1);
      }
    srv(3,0,NULL);
    return 0;
  }
