#include <stdio.h>

#define MAXN    30010

int parent[MAXN];
int friends[MAXN];
int visited[MAXN];
int count;

void add_friend(int a, int b) {
    int par;
    int curr;
    int tmp;

    curr = a;
    while (parent[curr] != curr)
          curr = parent[curr];
    par = curr;
    
    curr = a;
    while (parent[curr] != curr) {
          tmp = parent[curr];
          parent[curr] = par;
          curr = tmp;
    }

    curr = b;
    while (parent[curr] != curr) {
        tmp = parent[curr];
        parent[curr] = par;
        curr = tmp;
    }
    parent[curr] = par;
}

void read_data() {
     int i, edges;
     int tmp1, tmp2;

     for (i = 1; i < MAXN; i++)
         parent[i] = i;
     
     scanf("%d%d", &count, &edges);
     for (i = 0; i < edges; i++) {
         scanf("%d%d", &tmp1, &tmp2);
         add_friend(tmp1, tmp2);
     }
}

void solve() {
     int i, j;
     int cnt;
     int best = 0;

     for (i = 1; i <= count; i++) {
         if (visited[i]) continue;
         visited[i] = 1;
         cnt = 1;
         j = parent[i];
         while (parent[j] != j) {
               if (!visited[j]) {
                  visited[j] = 1;
                  cnt++;
               }
               j = parent[j];
         }
         friends[j] += cnt;
         if (friends[j] > best)
            best = friends[j];
     }

     printf("%d\n", best);
}

int main() {
    read_data();
    solve();
    
    return 0;
}
