#include <stdio.h>

#define MAXN    256

#define MIN(a,b)        ( heap[a].value<heap[b].value?a:b )

extern void srv(int, int, int*);

int is_empty[MAXN];
int count;

struct {
        int value;
        int queue;
} heap[MAXN];
int heap_size;

void add(int val, int q) {
        int curr;
        int tmp;

        curr = heap_size++;
        heap[curr].value = val;
        heap[curr].queue = q;

        while ((heap[curr].value < heap[curr/2].value) && (curr != 1)) {
                tmp = heap[curr].value;
                heap[curr].value = heap[curr/2].value;
                heap[curr/2].value = tmp;

                tmp = heap[curr].queue;
                heap[curr].queue = heap[curr/2].queue;
                heap[curr/2].queue = tmp;

                curr = curr/2;
        }
}

int get_top() {
        int res;
        int curr;
        int tmp;
        int next;

        res = heap[1].value;
        heap_size--;
        heap[1].value = heap[heap_size].value;
        heap[1].queue = heap[heap_size].queue;

        curr = 1;
        next = MIN(curr*2, curr*2+1);
        while ((heap[curr].value > heap[next].value) && next < heap_size) {
                tmp = heap[curr].value;
                heap[curr].value = heap[next].value;
                heap[next].value = tmp;

                tmp = heap[curr].queue;
                heap[curr].queue = heap[next].queue;
                heap[next].queue = tmp;

                curr = next;
                next = MIN(curr*2, curr*2+1);
        }

        return res;
}

void solve() {
        int i;
        int value;
        int queue;

        heap_size = 1;
        for (i = 1; i <= count; i++) {
                srv(1, i, &value);
                if (value == -1)
                        is_empty[i] = 1;
                else
                        add(value, i);
        }

        while (heap_size > 1) {
                queue = heap[1].queue;
                value = get_top();
                srv(2, value, NULL);
                if (!is_empty[queue]) {
                        srv(1, queue, &value);
                        if (value == -1)
                                is_empty[queue] = 1;
                        else
                                add(value, queue);
                }
        }
}

int main() {
        srv(0, 0, &count);
        solve();
        srv(3, 0, NULL);

        return 0;
}
