#include <stdio.h>
#include <string.h>

int max(int i1,int i2);

const int MAX_VC = 30000;

struct Node {
      int iV;
      Node *next;

      Node (int i){
	iV=i;
	next=NULL;
      }
      ~Node(){
	if (next)
	   delete next;
      }
};

class List {
      Node *root;
      Node *last;
      Node *cur;

      public:

      List(){
	root=new Node(-1);
	last=root;
	first();
      }
      ~List(){
	delete root;
      }
      void first(){
	cur=root;
      }
      void add(int iV){
	last->next=new Node(iV);
	last=last->next;
      }
      char next(int &iNext){
	cur=cur->next;
	if (cur==NULL)
	   return 0;
	iNext=cur->iV;
	return 1;
      }
};

class Vertex {
      List adj;

      public:

      void addAdj(int iV){
	adj.add(iV);
      }
      void first(){
	adj.first();
      }
      char next(int &iN){
	return adj.next(iN);
      }
};

class Graph {
      Vertex v[MAX_VC];
      char bVis[MAX_VC];
      int iVC;
      int iCurCompC;

      void dfs(int iV){
	iCurCompC++;
	bVis[iV]=1;

	int iNextV;

	v[iV].first();
	while (v[iV].next(iNextV))
	      if (bVis[iNextV]==0)
		 dfs(iNextV);
      }

      public:

      Graph(){
	iVC=0;
	memset(bVis,0,sizeof(bVis));
      }
      void setVC(int i){
	iVC=i;
      }
      void addEdge(int iV1,int iV2){
	iV1--;
	iV2--;
	v[iV1].addAdj(iV2);
	v[iV2].addAdj(iV1);
      }
      int findMaxComp(){
	int iR=-1;

	iCurCompC=0;
	for (int i=0;i<iVC;i++)
	    if (bVis[i]==0){
	       iCurCompC=0;
	       dfs(i);
	       iR=max(iR,iCurCompC);
	    }

	return iR;
      }
};

Graph g;

int max(int i1,int i2){
  return i1 > i2 ? i1 : i2;
}

void load(){
  FILE *fin=stdin;
  int iVC,iEC;
  int iV1,iV2;

  fscanf(fin,"%d%d",&iVC,&iEC);
  g.setVC(iVC);
  for (int i=0;i<iEC;i++){
      fscanf(fin,"%d%d",&iV1,&iV2);
      g.addEdge(iV1,iV2);
  }

  fclose(fin);
}

int solve(){
  return -1;
}

void save(int iR){
  printf("%d\n",iR);
}

int main(){
  load();
  save(g.findMaxComp());

  return 0;
}
