#include <stdio.h>

const int MAX_L = 100;

int iN;
char chCState[MAX_L];
int iP[MAX_L];

struct Sol {
       int iK;
       int iEnemy;
       int iAlly;

       void clear(){
         iEnemy=0;
         iAlly=0;
       }
};

void load(){
  FILE *fin=stdin; // fopen("game.in","r");
  char ch;

  fscanf(fin,"%d",&iN);
  fscanf(fin,"%c",&ch);
  for (int i=0;i<iN;i++){
      fscanf(fin,"%c",&ch);
      chCState[i]=ch;
  }

  fclose(fin);
}

void setSol(Sol &sol,int iK){
  sol.clear();
  sol.iK=iK;
  for (int i=0;i<iN;i++)
      if (iK % (i+1)==0){
         if ((i+1) % 2 ==0)
            sol.iAlly++;
         else
            sol.iEnemy++;
      }
}

inline bool better(Sol s1,Sol s2){
  if (s1.iEnemy > s2.iEnemy)
     return true;
  if (s1.iEnemy < s2.iEnemy)
     return false;
  if (s1.iAlly < s2.iAlly)
     return true;
  else
     return false;
}

int solve(){
  Sol best,cur;
  int i;

  for (i=0;i<iN;i++)
      if ((i+1)%2==0 && chCState[i]=='O'){
         setSol(best,i+1);
         break;
      }

  for (;i<=iN;i+=2)
      if ((i+1)%2 && chCState[i]=='O'){
         setSol(cur,i+1);
         if (better(cur,best))
            best=cur;
      }
         
  return best.iK;
}

void save(int iK){
  if (iK<1 || iK>iN){
     for (int i=0;i<iN;i++)
         if (chCState[i]=='O' && (i+1)%2==0)
            iK=i+1;
  }
  printf("%d\n",iK);
}

int main(){
  load();
  save(solve());

  return 0;
}
