#include <stdio.h>

#define SRV_INIT	0
#define SRV_GET		1
#define SRV_SET		2
#define SRV_END		3

extern void srv(int, int, int *);

//int seq[256];
int k;

typedef struct {
	int ID;
	int val;
} SHeap;

SHeap heap[256];
int heap_sz = 0;

void move_down(int node) {
	int next;
	SHeap val;
	
	next = 2*node; val = heap[node];
	while (next <= heap_sz) {
		if (next + 1 <= heap_sz && heap[next].val > heap[next + 1].val)
			next++;
		if (heap[next].val < val.val) {
			heap[node] = heap[next];
			node = next;
		}
		next *= 2;
	}
	heap[node] = val;
}

void move_up(int node) {
	int parent;
	SHeap val;

	parent = node/2; val = heap[node];
	while (parent >= 1) {
		if (heap[parent].val > val.val) {
			heap[node] = heap[parent];
			node = parent;
		}
		parent /= 2;
	}
	heap[node] = val;
}

void heap_insert(int val, int ID) {
	heap_sz++;
	heap[heap_sz].ID = ID;
	heap[heap_sz].val = val;
	move_up(heap_sz);
}

void heap_delete() {
	heap[1] = heap[heap_sz--];
	move_down(1);
}

int main() {
	int i, dummy;
	
	srv(SRV_INIT, 0, &k);

	for (i = 1; i <= k; i++) {
		srv(SRV_GET, i, &dummy);
		heap_insert(dummy, i);
	}

	while (heap_sz > 0) {
		srv(SRV_SET, heap[1].val, &dummy);
		srv(SRV_GET, heap[1].ID, &heap[1].val);
		if (heap[1].val == -1)
			heap_delete();
		else
			move_down(1);
	}
	srv(SRV_END, 0, &dummy);
	return 0;
}

/*
typedef struct {
	int ID;
	int val;
	int pos;
} SSeq;

int heap[256];
int heap_sz = 0;
SSeq seq[256];

void move_down(int node) {
	int next;
	int val;
	
	next = 2*node; val = heap[node];
	while (next <= heap_sz) {
		if (next + 1 <= heap_sz &&
			seq[heap[next]].val > seq[heap[next + 1]].val)
			next++;
		if (seq[heap[next]].val < seq[val].val) {
			heap[node] = heap[next];
			seq[next].pos = node;
			node = next;
		}
		next *= 2;
	}
	heap[node] = val;
	seq[val].pos = node;
}

void move_up(int node) {
	int parent, val;

	parent = node/2; val = heap[node];
	while (parent >= 1) {
		if (seq[heap[parent]].val > seq[val].val) {
			heap[node] = heap[parent];
			seq[parent].pos = node;
			node = parent;
		}
		parent /= 2;
	}
	heap[node] = val;
	seq[val].pos = node;
}

void heap_insert(int val) {
	heap[++heap_sz] = val;
	move_up(heap_sz);
}

void heap_delete() {
	heap[1] = heap[heap_sz--];
	move_down(1);
}

int main() {
	int i, dummy;
	
	srv(SRV_INIT, 0, &k);

	for (i = 1; i <= k; i++) {
		srv(SRV_GET, i, &seq[i].val);
		seq[i].ID = i;
		heap_insert(i);
	}

	while (heap_sz > 0) {
		i = heap[1];
		srv(SRV_SET, seq[i].val, &dummy);
		srv(SRV_GET, seq[i].ID, &seq[i].val);
		if (seq[i].val == -1)
			heap_delete();
		else
			move_down(1);
	}
	srv(SRV_END, 0, &dummy);
	return 0;
}
*/

