#include <stdio.h>
#include <stdlib.h>

#define MAXN 32768

typedef struct Vex TVex;
typedef struct Edge TEdge;

struct Vex {
	int v;
	TEdge *edges;
};

struct Edge {
	int v;
	TEdge *next;
};

int n, m;
TVex vs[MAXN];
TEdge *es;
int ec;
int csize, ans;

void readf(void);
void solve(void);
void writef(void);

int main(void) {
	readf();
	solve();
	writef();

	return 0;
}

void readf(void) {
	int i, a, b;

	void add_edge(int a, int b);

	scanf("%d%d", &n, &m);
	es = (TEdge*)malloc(sizeof(TEdge) * 2 * m);
	for (i = 0; i < m; ++i) {
		scanf("%d%d", &a, &b);
		--a;
		--b;
		add_edge(a, b);
		add_edge(b, a);
	}
}

void solve(void) {
	int i;

	void dfs(int v);

	for (i = 0; i < n; ++i)
		if (vs[i].v == 0) {
			csize = 0;
			dfs(i);
			if (csize > ans)
				ans = csize;
		}
}

void writef(void) {
	printf("%d\n", ans);
}

void add_edge(int a, int b) {
	TEdge *ne;

	ne = &es[ec++];
	ne->v = b;
	ne->next = vs[a].edges;
	vs[a].edges = ne;
}

void dfs(int v) {
	TEdge *e;

	++csize;
	vs[v].v = 1;
	for (e = vs[v].edges; e; e = e->next)
		if (vs[e->v].v == 0)
			dfs(e->v);
}
