#include <stdio.h>

#define MAXK 256

int heap[MAXK], heapsize;
int seq[MAXK];

int k;

extern void srv(int, int, int*);
void solve(void);

int main(void) {
	solve();

	return 0;
}

void solve(void) {
	int i;
	int answ;

	void add(int s);
	void movedown(int v);

	srv(0, 0, &k);

	for (i = 1; i <= k; ++i) {
		srv(1, i, &answ);
		if (answ != -1) {
			seq[i] = answ;
			add(i);
		}
	}

	while (heapsize > 0) {
		srv(2, seq[heap[0]], NULL);
		srv(1, heap[0], &answ);
		if (answ != -1)
			seq[heap[0]] = answ;
		else
			heap[0] = heap[--heapsize];
		if (heapsize > 0)
			movedown(0);
	}

	srv(3, 0, NULL);
}

void add(int s) {
	void moveup(int v);

	heap[heapsize] = s;
	moveup(heapsize++);
}

void moveup(int v) {
	int p, t;

	t = heap[v];
	while (v > 0) {
		p = (v - 1) / 2;
		if (seq[heap[p]] > seq[t]) {
			heap[v] = heap[p];
			v = p;
		}
		else
			break;
	}
	heap[v] = t;
}

void movedown(int v) {
	int c, t;

	t = heap[v];
	while ((c = 2 * v + 1) < heapsize) {
		if (c + 1 < heapsize && seq[heap[c]] > seq[heap[c+1]])
			++c;
		if (seq[heap[c]] < seq[t]) {
			heap[v] = heap[c];
			v = c;
		}
		else
			break;
	}
	heap[v] = t;
}
