type
  TCubeArray = array[1..12] of byte;
  PTCube = ^TCube;
  TCube = record
    c: TCubeArray;
    next: PTCube;
  end;

var
  m: array[1..12] of byte;
  o: array[1..6] of byte;
  s: TCubeArray;
  c,i: longint;
  p,q,t: PTCube;

procedure add;
begin
  new(t);
  t^.c:= s;
  t^.next:= nil;
  if p = nil then
  begin
    p:= t;
    q:= t;
  end else
  begin
    q^.next:= t;
    q:= q^.next;
  end;
end;

function equ(var a,b: TCubeArray): boolean;
var i: byte;
begin
  equ:= true;
  for i:= 1 to 12 do if a[i] <> b[i] then
  begin
    equ:= false;
    exit;
  end;
end;

function same(var a,b: TCubeArray): boolean;
begin
  same:= equ(a,b) or
    ((b[1] = a[2]) and (b[2] = a[3]) and (b[3] = a[4]) and (b[4] = a[1]) and
     (b[5] = a[6]) and (b[6] = a[7]) and (b[7] = a[8]) and (b[8] = a[5]) and
     (b[9] = a[10]) and (b[10] = a[11]) and (b[11] = a[12]) and (b[12] = a[9])) or

    ((b[1] = a[3]) and (b[2] = a[4]) and (b[3] = a[1]) and (b[4] = a[2]) and
     (b[5] = a[7]) and (b[6] = a[8]) and (b[7] = a[5]) and (b[8] = a[6]) and
     (b[9] = a[11]) and (b[10] = a[12]) and (b[11] = a[9]) and (b[12] = a[10])) or

    ((b[1] = a[4]) and (b[2] = a[1]) and (b[3] = a[2]) and (b[4] = a[3]) and
     (b[5] = a[8]) and (b[6] = a[5]) and (b[7] = a[6]) and (b[8] = a[7]) and
     (b[9] = a[12]) and (b[10] = a[9]) and (b[11] = a[10]) and (b[12] = a[11]));
end;

procedure rotate(var a: TCubeArray);
var t: byte;
begin
  t:= a[1]; a[1]:= a[9]; a[9]:= a[11]; a[11]:= a[3]; a[3]:= t;
  t:= a[5]; a[5]:= a[12]; a[12]:= a[8]; a[8]:= a[4]; a[4]:= t;
  t:= a[6]; a[6]:= a[10]; a[10]:= a[7]; a[7]:= a[2]; a[2]:= t;
end;

procedure rotleft(var a: TCubeArray);
var t: byte;
begin
  t:= a[5]; a[5]:= a[9]; a[9]:= a[6]; a[6]:= a[1]; a[1]:= t;
  t:= a[12]; a[12]:= a[10]; a[10]:= a[2]; a[2]:= a[4]; a[4]:= t;
  t:= a[8]; a[8]:= a[11]; a[11]:= a[7]; a[7]:= a[3]; a[3]:= t;
end;

procedure rotright(var a: TCubeArray);
var t: byte;
begin
  t:= a[6]; a[6]:= a[9]; a[9]:= a[5]; a[5]:= a[1]; a[1]:= t;
  t:= a[2]; a[2]:= a[10]; a[10]:= a[12]; a[12]:= a[4]; a[4]:= t;
  t:= a[7]; a[7]:= a[11]; a[11]:= a[8]; a[8]:= a[3]; a[3]:= t;
end;

function check: boolean;
var pp: PTCube;
begin
  check:= true;
  pp:= p;
  while pp <> nil do
  begin
    if same(pp^.c,s) then
    begin
      check:= false;
      exit;
    end;

    rotate(pp^.c);
    if same(pp^.c,s) then
    begin
      check:= false;
      exit;
    end;

    rotate(pp^.c);
    if same(pp^.c,s) then
    begin
      check:= false;
      exit;
    end;

    rotate(pp^.c);
    if same(pp^.c,s) then
    begin
      check:= false;
      exit;
    end;

    rotleft(pp^.c);
    if same(pp^.c,s) then
    begin
      check:= false;
      exit;
    end;

    rotright(pp^.c);
    rotright(pp^.c);
    if same(pp^.c,s) then
    begin
      check:= false;
      exit;
    end;

    pp:= pp^.next;
  end;
end;

procedure scan(x: byte);
var i: byte;
begin
  if x > 12 then
  begin
    if check then
    begin
      c:= c + 1;
      add;
    end;
  end else
  begin
    for i:= 1 to 6 do
      if o[i] > 0 then
      begin
        s[x]:= i;
        o[i]:= o[i] - 1;
        scan(x+1);
        o[i]:= o[i] + 1;
      end;
  end;
end;

begin
  for i:= 1 to 12 do read(m[i]);
  for i:= 1 to 6 do o[i]:= 0;
  for i:= 1 to 12 do inc(o[m[i]]);
  c:= 0;
  p:= nil; q:= nil;
  scan(1);
  writeln(c);
end.