#include <stdio.h>

const int MAX_N = 3000+1;
const int MAX_Op_C = 8;

struct Action {
       char chOp;
       int iOp;
};

bool bCanDo[MAX_N][256] = {false};
int minOpC[MAX_N][256]  = {0};
Action act[MAX_N][256]  = {0};
bool bComp[MAX_N][256]  = {false};
int iOp[MAX_Op_C];
int iOpC=0;
int iN;

void load(){
  FILE *fin=stdin;//=fopen("expr.in","r");

  fscanf(fin,"%d",&iN);

  while (!feof(fin)){
        fscanf(fin,"%d",&iOp[iOpC]);
        iOpC++;
  }
  iOpC--;
  
  fclose(fin);
}

inline int getAllOneMask(int iBit){
  return 255 - (1 << iBit);
}

inline void setExclude(int &iSet,int iBit){
  iSet=iSet & (getAllOneMask(iBit));
}

inline int newSum(int iS,char ch,int iOperand){
  if (ch=='+')
     return iS-iOp[iOperand];
  if (ch=='-')
     return iOp[iOperand]-iS;
  if (ch=='*')
     return iS/iOp[iOperand];
  if (ch=='/')
     return iOp[iOperand]/iS;
}

inline void setComp(int iSum,int iSet){
  int iNewSum=newSum(iSum,act[iSum][iSet].chOp,act[iSum][iSet].iOp);

  if (iNewSum==0)
     bComp[iSum][iSet]=false;
  else
     bComp[iSum][iSet]=true;
}

inline void set(int iSum,int iSet,int iNewSum,int iNewSet,char chOp,int iOp){
  if (iSum<0)
     return;
  if (!bCanDo[iNewSum][iNewSet])
     return;
  if (!bCanDo[iSum][iSet] ||
      minOpC[iSum][iSet]>1+minOpC[iNewSum][iNewSet]){
     bCanDo[iSum][iSet]=true;
     minOpC[iSum][iSet]=1+minOpC[iNewSum][iNewSet];
     act[iSum][iSet].chOp=chOp;
     act[iSum][iSet].iOp=iOp;
     setComp(iSum,iSet);
     return;
  }
}

void expr(int iSum,int iSet){
  bool b[8];
  int iNewSet;
  int iCurOp;

  for (int i=0;i<8;i++)
      b[i]=iSet & (1 << i);

  for (int i=0;i<iOpC;i++)
      if (b[i]){
         iNewSet=iSet;
         iCurOp=iOp[i];
         setExclude(iNewSet,i);
         
         // +
         if (iSum-iCurOp>=0)
            set(iSum,iSet,iSum-iCurOp,iNewSet,'+',i);

         // -
         if (iCurOp-iSum>=0)
            set(iSum,iSet,iCurOp-iSum,iNewSet,'-',i);

         // *

         if (iSum%iCurOp==0)
            set(iSum,iSet,iSum/iCurOp,iNewSet,'*',i);

         // /
         if (iCurOp%iSum==0)
            set(iSum,iSet,iCurOp/iSum,iNewSet,'/',i);

      }
}

void solve(){
  int iSum,iSet;

  for (iSet=0;iSet < 256;iSet++){
      bCanDo[0][iSet]=true;
      minOpC[0][iSet]=0;
  }
  for (iSum=1;iSum <= iN;iSum++)
      for (iSet=1;iSet < 256;iSet++)
          expr(iSum,iSet);
}

void print(int iSum,int iSet){
  int iNewSet=iSet;
  setExclude(iNewSet,act[iSum][iSet].iOp);
  int iNewSum=newSum(iSum,act[iSum][iSet].chOp,act[iSum][iSet].iOp);

  printf("%d",iOp[act[iSum][iSet].iOp]);

  if (iNewSum!=0){
     printf("%c",act[iSum][iSet].chOp);
     if (bComp[iNewSum][iNewSet])
         printf("(");
     print(iNewSum,iNewSet);
     if (bComp[iNewSum][iNewSet])
         printf(")");
  }
}

int main(){
  load();
  solve();
  printf("(");
  print(iN,255);
  printf(")\n");

  return 0;
}
