#include <stdio.h>
#include <iostream.h>

const int INF = 10000000;
const int MAX = 201;

struct Sol {
       int iPour;
       int iResult;

       void print(){
	 printf("%d %d\n",iPour,iResult);
       }
};

struct Pos {
       int i1,i2,i3;

       Pos(int i1,int i2,int i3){
	 set(i1,i2,i3);
       }
       Pos(){
         set(-1,-1,-1);
       }
       void set(int i1,int i2,int i3){
	 this->i1=i1;
	 this->i2=i2;
	 this->i3=i3;
       }
};

struct Node {
       Pos p;
       Node *next;

       Node (int i1,int i2,int i3){
	 next=NULL;
	 p.set(i1,i2,i3);
       }
};

class Queue {
      Node *root;
      Node *last;

      public:

      Queue(){
	root=new Node(-1,-1,-1);
	last=root;
      }
      ~Queue(){
	delete root;
      }
      void push(int i1,int i2,int i3){
	last->next=new Node(i1,i2,i3);
	last=last->next;
      }
      Pos pop(){
	Pos p=root->next->p;
	Node *n=root->next;
	root->next=n->next;
	if (root->next==NULL)
	   last=root;
	delete n;
	return p;
      }
      char empty(){
	return root->next==NULL;
      }
};

int iCap[3] = {0};
unsigned short int min[MAX][MAX][MAX] = {0};
int iDest;
Queue q;

void load(){
  FILE *fin=stdin;//fopen("fill.in","r");

  fscanf(fin,"%d%d%d",&iCap[0],&iCap[1],&iCap[2]);
  fscanf(fin,"%d",&iDest);

  fclose(fin);
}

inline int minInt(int i1,int i2){
  return i1 < i2 ? i1 : i2;
}

inline void set(int iA,int iB,int iC,int iV){
  if (iA==0 && iB==0 && iC==iCap[2])
     return;
  min[iA][iB][iC]=iV;
  q.push(iA,iB,iC);
}

void push(int iA,int iB,int iC){
  int iPour;
  int iA1,iB1,iC1;

  // iA -> iB
  iPour=minInt(iA,iCap[1]-iB);
  iA1=iA-iPour;
  iB1=iB+iPour;
  iC1=iC;
  if (min[iA1][iB1][iC1]==0){
     set(iA1,iB1,iC1,min[iA][iB][iC]+iPour);
  }

  // iA -> iC
  iPour=minInt(iA,iCap[2]-iC);
  iA1=iA-iPour;
  iB1=iB;
  iC1=iC+iPour;
  if (min[iA1][iB1][iC1]==0){
     set(iA1,iB1,iC1,min[iA][iB][iC]+iPour);
  }

  // iB -> iA
  iPour=minInt(iB,iCap[0]-iA);
  iA1=iA+iPour;
  iB1=iB-iPour;
  iC1=iC;
  if (min[iA1][iB1][iC1]==0){
     set(iA1,iB1,iC1,min[iA][iB][iC]+iPour);
  }

  // iB -> iC
  iPour=minInt(iB,iCap[2]-iC);
  iA1=iA;
  iB1=iB-iPour;
  iC1=iC+iPour;
  if (min[iA1][iB1][iC1]==0){
     set(iA1,iB1,iC1,min[iA][iB][iC]+iPour);
  }

  // iC -> iA
  iPour=minInt(iC,iCap[0]-iA);
  iA1=iA+iPour;
  iB1=iB;
  iC1=iC-iPour;
  if (min[iA1][iB1][iC1]==0){
     set(iA1,iB1,iC1,min[iA][iB][iC]+iPour);
  }

  // iC -> iB
  iPour=minInt(iC,iCap[1]-iB);
  iA1=iA;
  iB1=iB+iPour;
  iC1=iC-iPour;
  if (min[iA1][iB1][iC1]==0){
     set(iA1,iB1,iC1,min[iA][iB][iC]+iPour);
  }
}

inline char legal(int i1,int i2,int i3){
  if (i1==0 && i2==0 && i3==iCap[2])
     return 1;
  if (min[i1][i2][i3]==0)
     return 0;
  return 1;
}

char findBestSol(Sol &sol,int i){
  sol.iPour = INF;
  sol.iResult = i;

  int i1,i2;
  char c = 0;

  for (i1=0;i1<=iCap[1];i1++)
      for (i2=0;i2<=iCap[2];i2++)
	  if (legal(i,i1,i2)){
	     sol.iPour=minInt(sol.iPour,min[i][i1][i2]);
	     c=1;
	  }

  for (i1=0;i1<=iCap[0];i1++)
      for (i2=0;i2<=iCap[2];i2++)
	  if (legal(i1,i,i2)){
	     sol.iPour=minInt(sol.iPour,min[i1][i][i2]);
	     c=1;
	  }

  for (i1=0;i1<=iCap[0];i1++)
      for (i2=0;i2<=iCap[1];i2++)
	  if (legal(i1,i2,i)){
	     sol.iPour=minInt(sol.iPour,min[i1][i2][i]);
	     c=1;
	  }

  return c;
}

void solve(){
  Sol sol;

  if (iDest >= iCap[2]){
     sol.iPour=0;
     sol.iResult=iCap[2];
     sol.print();

     return;
  }
  
  int i1,i2,i3;
  Pos p;

  q.push(0,0,iCap[2]);
  while (!q.empty()){
	p=q.pop();
	push(p.i1,p.i2,p.i3);
  }

  for (int i=iDest;i>-1;i--)
      if (findBestSol(sol,i))
	 break;

  sol.print();
}

int main(){
  load();
  solve();

  return 0;
}
