#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <list>
#include <time.h>
#define TIME_LIMIT 0.7

using namespace std;

typedef struct
  {
    short line[12];
  } SCube;

int c[12];
short used[12];
short col[7];
SCube curr;
list<unsigned int> visited;
int br=0;

void Output();

void Init()
  {
    int i;
//    freopen("cube.in","rt",stdin);
    memset(used,0,sizeof(used));
    memset(col,0,sizeof(col));
    for(i=0;i<12;i++)
      {
        scanf("%d",&c[i]);
        col[c[i]]++;
      }      
  }

int Equal(SCube &c1,SCube &c2)
  {
    int i;
    for(i=0;i<12;i++)
      if(c1.line[i]!=c2.line[i]) return 0;
    return 1;
  }

unsigned int Code(SCube &cub)
  {
    unsigned int pow=1,res=0;
    for(int i=0;i<12;i++)
      {
        res+=(pow*(cub.line[i]-1));
        pow*=6;
      }
    return res;
  }  

SCube Decode(unsigned int cub)
  {
    SCube res;
    int pos=0;
    memset(res.line,0,sizeof(res.line));
    for(pos=0;pos<12;pos++)
      {
        res.line[pos]=cub%6+1;
        cub/=6;
      }
    return res;
  }

SCube Rotate(SCube cub,char dir)
  {
    SCube res;
    switch(dir)
      {
        case 'l' :
          res.line[3]=cub.line[0];
          res.line[2]=cub.line[1];
          res.line[0]=cub.line[2];
          res.line[1]=cub.line[3];
          res.line[9]=cub.line[4];
          res.line[8]=cub.line[5];
          res.line[4]=cub.line[6];
          res.line[5]=cub.line[7];
          res.line[10]=cub.line[8];
          res.line[11]=cub.line[9];
          res.line[7]=cub.line[10];
          res.line[6]=cub.line[11];
        break;
        case 'd' :
          res.line[9]=cub.line[0];
          res.line[4]=cub.line[1];
          res.line[8]=cub.line[2];
          res.line[2]=cub.line[3];
          res.line[5]=cub.line[4];
          res.line[6]=cub.line[5];
          res.line[1]=cub.line[6];
          res.line[3]=cub.line[7];
          res.line[7]=cub.line[8];
          res.line[10]=cub.line[9];
          res.line[11]=cub.line[10];
          res.line[0]=cub.line[11];
        break;
      }
    return res;
  }

void Check()
  {
    SCube tmp=curr;
    for(list<unsigned int>::iterator i=visited.begin();i!=visited.end();i++)
      {
        tmp=curr;
        
        if(*i==Code(tmp)) return;
        tmp=Rotate(tmp,'l');
        if(*i==Code(tmp)) return;
        tmp=Rotate(tmp,'l');
        if(*i==Code(tmp)) return;
        tmp=Rotate(tmp,'l');
        if(*i==Code(tmp)) return;

        tmp=curr;
        tmp=Rotate(tmp,'d');
        if(*i==Code(tmp)) return;
        tmp=Rotate(tmp,'d');
        if(*i==Code(tmp)) return;
        tmp=Rotate(tmp,'d');
        if(*i==Code(tmp)) return;

        tmp=Rotate(Rotate(curr,'l'),'d');
        if(*i==Code(tmp)) return;

        tmp=Rotate(Rotate(Rotate(curr,'l'),'l'),'d');
        if(*i==Code(tmp)) return;

        tmp=Rotate(Rotate(Rotate(curr,'l'),'d'),'d');
        if(*i==Code(tmp)) return;
        
        tmp=Rotate(Rotate(Rotate(Rotate(curr,'l'),'l'),'d'),'d');
        if(*i==Code(tmp)) return;

        tmp=Rotate(Rotate(Rotate(Rotate(curr,'l'),'l'),'l'),'d');
        if(*i==Code(tmp)) return;

        tmp=Rotate(Rotate(Rotate(Rotate(curr,'l'),'d'),'d'),'d');
        if(*i==Code(tmp)) return;

        tmp=Rotate(Rotate(Rotate(Rotate(Rotate(curr,'l'),'l'),'d'),'d'),'d');
        if(*i==Code(tmp)) return;

        tmp=Rotate(Rotate(Rotate(Rotate(Rotate(curr,'l'),'l'),'l'),'d'),'d');
        if(*i==Code(tmp)) return;

        tmp=Rotate(Rotate(Rotate(Rotate(Rotate(Rotate(curr,'l'),'l'),'l'),'d'),'d'),'d');
        if(*i==Code(tmp)) return;
        
      }
    visited.push_back(Code(curr));
    br++;
  }

void Find(int pos)
  {
    int i;
    if((float)clock()/CLOCKS_PER_SEC>TIME_LIMIT) Output();
    if(pos==12)
      {
//        br++;
        Check();
        return;
      }
    for(i=1;i<=6;i++)
      if(col[i])
        {
          col[i]--;
          curr.line[pos]=i;
          Find(pos+1);
          curr.line[pos]=0;
          col[i]++;
        }
  }

void Try()
  {
    int st1=0;
    int st2;
    for(int i=1;i<=6;i++)
      if(col[i]==10) st1=1;
      else if(col[i]==2) st2=1;
    if(st1 && st2)
      {
        printf("5\n");
        exit(0);
      }
  }

void Solve()
  {
    Find(0);
  }

void Output()
  {
    printf("%d\n",br);
    exit(0);
  }

int main()
  {
    clock();
    Init();
    Try();
    Solve();
    Output();
    return 0;
  }
