/* INCLUDES *****************************************************************/
   #include <iostream>
   #include <cstdlib>
   #include <values.h>

   #include <algorithm>

   using namespace std;

/* CONSTANTS ****************************************************************/
   int const MAXA = 10;
   int const MAXN = 3004;

   int const OPS_NONE = MAXINT;

   char const OP_NONE = '?';
   char const OP_PLUS = '+';
   char const OP_MINUS = '-';
   char const OP_MUL = '*';
   char const OP_DIV = '/';

/* CLASSES ******************************************************************/
   class node
   {
   public:
      node() {}
      ~node() {}

      int ops;
      int num;
      char op;

      bool used[MAXA];
   };

/* GLOBALS ******************************************************************/

   int n;
   int c_a;
   int a[MAXA];

   node m[MAXN * 2];

/* FUNCTIONS ****************************************************************/
/****************************************************************************/
   void done()
   {
      exit(0);
   }
/****************************************************************************/
   void init()
   {
      cin >> n;

      c_a = 0;
      while (1)
      {
         cin >> a[c_a];
         if (cin.fail()) break;
         ++c_a;
      }
   }
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
   void rec(int i)
   {
      if (i == 0) return;

      if (m[i].op == OP_PLUS)
      {
         if (i - m[i].num == 0)
         {
            cout << m[i].num;
         }
            else
         {
            cout << '(';
            rec(i - m[i].num);
            cout << '+' << m[i].num << ')';
         }
      }
         else
      if (m[i].op == OP_MINUS)
      {
         cout << '(';
         rec(i + m[i].num);
         cout << '-' << m[i].num << ')';
      }
         else
      if (m[i].op == OP_MUL)
      {
         cout << '(';
         rec(i / m[i].num);
         cout << '*' << m[i].num << ')';
      }
         else
      if (m[i].op == OP_DIV)
      {
         cout << '(';
         rec(i * m[i].num);
         cout << '/' << m[i].num << ')';
      }
   }
/****************************************************************************/
   void run()
   {
      sort(a, a + c_a);

      for (int i = 0; i < 2 * MAXN; ++i)
      {
         m[i].ops = OPS_NONE;
      }

      m[0].ops = -1;
      m[0].num = 0;
      m[0].op = OP_NONE;
      for (int i = 0; i < c_a; ++i)
         m[0].used[i] = false;

      for (int k = 0; k < c_a/*TO MAX, BUT WITH FLAG !!!*/; ++k)
      for (int i = 0; i < c_a; ++i)
         for (int j = MAXN - a[i]; j >= 0; --j)
            if (m[j].ops != OPS_NONE && !m[j].used[i])
            {
               node n;

               n.ops = m[j].ops + 1;
               n.num = a[i];
               for (int u = 0; u < c_a; ++u)
                  n.used[u] = m[j].used[u];
               n.used[i] = true;

               int l;

               // PLUS
               l = j + n.num;

               if ((l < 2 * MAXN) && (m[l].ops > n.ops))
               {
                  n.op = OP_PLUS;
                  m[l] = n;
               }

               // MINUS
               l = j - n.num;

               if ((l > 0) && (m[l].ops > n.ops))
               {
                  n.op = OP_MINUS;
                  m[l] = n;
               }
               
               // MUL
               l = j * n.num;

               if ((l <= 2 * MAXN) && (m[l].ops > n.ops))
               {
                  n.op = OP_MUL;
                  m[l] = n;
               }
               
               // DIV
               if (j % n.num == 0)
               {
                  l = j / n.num;
   
                  if ((l > 0) && (m[l].ops > n.ops))
                  {
                     n.op = OP_DIV;
                     m[l] = n;
                  }
               }

            }

      //cout << "OPS: " << m[n].ops << endl;
      rec(n);
      cout << endl;
   }
/****************************************************************************/
   int main()
   {
      init();
      run();
      done();

      return 0;
   }
/****************************************************************************/

