#include <stdio.h>
#include <limits.h>

#define MAXV 65536
#define MAXS 256

#undef min
#undef max

int k[MAXV], hp[MAXV];
int heap[MAXV], heapsize;
int a, b, c, d;
int afill, ad;

void readf(void);
void solve(void);
void writef(void);

int main(void) {
	readf();
	solve();
	writef();

	return 0;
}

void readf(void) {
	scanf("%d%d%d%d", &a, &b, &c, &d);
}

void solve(void) {
	int cd, x, y, z, i, p;

	int code(int a, int b);
	void decode(int code, int *a, int *b);
	void add(int v);
	int top(void);
	int min(int a, int b);
	int max(int a, int b);
	void relax(int nc, int c, int p);

	for (i = 0; i < MAXV; ++i) {
		k[i] = INT_MAX;
		hp[i] = -1;
	}

	cd = code(0, 0);
	k[cd] = 0;
	add(cd);
	ad = -1;
	while (heapsize > 0) {
		cd = top();
		decode(cd, &x, &y);
		z = c - x - y;
		if (x == d || y == d || z == d) {
			afill = k[cd];
			ad = d;
			break;
		}
		if (x < d && x > ad) {
			afill = k[cd];
			ad = x;
		}
		if (y < d && y > ad) {
			afill = k[cd];
			ad = y;
		}
		if (z < d && z > ad) {
			afill = k[cd];
			ad = z;
		}

		p = min(a - x, y);
		relax(code(x + p, y - p), cd, p);
		p = min(x, b - y);
		relax(code(x - p, y + p), cd, p);
		p = min(a - x, z);
		relax(code(x + p, y), cd, p);
		p = min(x, c - z);
		relax(code(x - p, y), cd, p);
		p = min(b - y, z);
		relax(code(x, y + p), cd, p);
		p = min(y, c - z);
		relax(code(x, y - p), cd, p);
	}
}

void writef(void) {
	printf("%d %d\n", afill, ad);
}

void relax(int nc, int c, int p) {
	void add(int v);
	void moveup(int v);

	if (hp[nc] == -1) {
		k[nc] = k[c] + p;
		add(nc);
	}
	else if (k[nc] > k[c] + p) {
		k[nc] = k[c] + p;
		moveup(hp[nc]);
	}
}

int top(void) {
	int r;

	void movedown(int v);

	r = heap[0];
	heap[0] = heap[--heapsize];
	hp[heap[0]] = 0;
	movedown(0);

	return r;
}

void add(int v) {
	void moveup(int v);

	heap[heapsize] = v;
	hp[v] = heapsize;
	moveup(heapsize++);
}

void moveup(int v) {
	int t, p;

	t = heap[v];
	while (v > 0) {
		p = (v - 1) / 2;
		if (k[heap[p]] > k[t]) {
			heap[v] = heap[p];
			hp[heap[v]] = v;
			v = p;
		}
		else
			break;
	}
	heap[v] = t;
	hp[t] = v;
}

void movedown(int v) {
	int t, c;

	t = heap[v];
	while ((c = 2 * v + 1) < heapsize) {
		if (c + 1 < heapsize && k[heap[c]] > k[heap[c+1]])
			++c;
		if (k[heap[c]] < k[t]) {
			heap[v] = heap[c];
			hp[heap[v]] = v;
			v = c;
		}
		else
			break;
	}
	heap[v] = t;
	hp[t] = v;
}

int code(int a, int b) {
	return (a * MAXS + b);
}

void decode(int code, int *a, int *b) {
	*a = code / MAXS;
	*b = code % MAXS;
}

int min(int a, int b) {
	return ((a < b) ? a : b);
}

int max(int a, int b) {
	return ((a > b) ? a : b);
}
