#include <stdio.h>
#include <string.h>

#define MAXN	10000

int f[256][MAXN + 1];
int used[256][MAXN + 1];
int a[10];
int n, m, mx;

#define OP_NONE	0
#define OP_PRE_SUB	1
#define OP_POST_SUB	2
#define OP_ADD	3
#define OP_MUL	5
#define OP_PRE_DIV	7
#define OP_POST_DIV	8
#define OP_START	9

inline int num_bits(int x) {
	int b;
	
	b = 0;
	while (x) {
		b += x&1;
		x >>= 1;
	}
	return b;
}

void use(int c, int s) {
	int t, i;
	
	for (i = 0, t = 1; t < mx; t <<= 1, i++)
		if ((c|t) != c) {
			if (a[i] + s <= MAXN)
				f[c|t][a[i] + s] = OP_ADD,
				used[c|t][a[i] + s] = i;
			if (a[i]*s <= MAXN)
				f[c|t][a[i]*s] = OP_MUL,
				used[c|t][a[i]*s] = i;
			if (a[i] > s)
				f[c|t][a[i] - s] = OP_PRE_SUB,
				used[c|t][a[i] - s] = i;
			if (s > a[i])
				f[c|t][s - a[i]] = OP_POST_SUB,
				used[c|t][s - a[i]] = i;
			if (s && (a[i]%s == 0))
				f[c|t][a[i]/s] = OP_PRE_DIV,
				used[c|t][a[i]/s] = i;
			if (s && (s%a[i] == 0))
				f[c|t][s/a[i]] = OP_POST_DIV,
				used[c|t][s/a[i]] = i;
		}
}

char line[128];
char line2[128];

void trace_back(int x, int s) {
	int num;
	
	if (f[x][s] == OP_START) {
		sprintf(line, "%i", a[used[x][s]]);
		return;
	}
	switch (f[x][s]) {
		case OP_ADD:
			num = a[used[x][s]];
			trace_back(x&~(1 << used[x][s]), s - num);
			sprintf(line2, "(%s+%i)", line, num);
		break;
		case OP_MUL:
			num = a[used[x][s]];
			trace_back(x&~(1 << used[x][s]), s/num);
			sprintf(line2, "(%s*%i)", line, num);
		break;
		case OP_POST_DIV:
			num = a[used[x][s]];
			trace_back(x&~(1 << used[x][s]), s*num);
			sprintf(line2, "(%s/%i)", line, num);
		break;
		case OP_PRE_DIV:
			num = a[used[x][s]];
			trace_back(x&~(1 << used[x][s]), num/s);
			sprintf(line2, "(%i/%s)", num, line);
		break;
		case OP_PRE_SUB:
			num = a[used[x][s]];
			trace_back(x&~(1 << used[x][s]), num - s);
			sprintf(line2, "(%i-%s)", num, line);
		break;
		case OP_POST_SUB:
			num = a[used[x][s]];
			trace_back(x&~(1 << used[x][s]), num + s);
			sprintf(line2, "(%s-%i)", line, num);
		break;
	}
	strcpy(line, line2);
}

int main() {
	int i, j, k;
	
	scanf("%i", &n);
	m = 0;
	while (scanf("%i", a + m) == 1)
		m++;

	
	mx = 1 << m;
	for (i = 0; i < m; i++) {
		f[1 << i][a[i]] = OP_START;
		used[1 << i][a[i]] = i;
	}
	for (i = 1; i < m; i++)
		for (j = 0; j < mx; j++)
			if (num_bits(j) == i) {
				for (k = 0; k <= MAXN; k++)
					if (f[j][k] != OP_NONE)
						use(j, k);
			}

	j = (mx << 1) - 1;
	for (i = 0; i < mx; i++)
		if (f[i][n] && num_bits(j) > num_bits(i))
			j = i;

	trace_back(j, n);
	printf("%s\n", line);
	
	return 0;
}

