#include <stdio.h>
#include <limits.h>
#include <time.h>

int f[256][256];
int d;
int a, b, c;

#define MIN(x, y) ((x) < (y) ? (x) : (y))

void DFS(int _a, int _b, int _c, int sum) {
	static int q;
	
	if (f[_a][_b] <= sum)
		return;

	f[_a][_b] = sum;
	if (_a == d || _b == d || _c == d)
		return;

	q = MIN(_a, b - _b);
	if (q > 0)
		DFS(_a - q, _b + q, _c, sum + q);
	q = MIN(_a, c - _c);
	if (q > 0)
		DFS(_a - q, _b, _c + q, sum + q);

	q = MIN(_b, a - _a);
	if (q > 0)
		DFS(_a + q, _b - q, _c, sum + q);
	q = MIN(_b, c - _c);
	if (q > 0)
		DFS(_a, _b - q, _c + q, sum + q);

	q = MIN(_c, a - _a);
	if (q > 0)
		DFS(_a + q, _b, _c - q, sum + q);
	q = MIN(_c, b - _b);
	if (q > 0)
		DFS(_a, _b + q, _c - q, sum + q);
}

int main() {
	int i, j;
	clock_t start;

	scanf("%i %i %i %i", &a, &b, &c, &d);
	start = clock();
	for (i = 0; i <= 200; i++)
		for (j = 0; j <= 200; j++)
			f[i][j] = INT_MAX;
	DFS(0, 0, c, 0);

	do {
		j = INT_MAX;
		for (i = 0; i <= 200; i++) {
			if (f[i][d] < j)
				j = f[i][d];
			if (f[d][i] < j)
				j = f[d][i];
			if (c - d - i >= 0 && c - d - i <= 200 &&
				f[i][c - d - i] < j)
				j = f[i][c - d - i];
		}
		d--;
	} while (j == INT_MAX);
	printf("%i %i\n", j, d + 1);
//	printf("Time: %.3lf\n", (clock() - start)/(double)CLOCKS_PER_SEC);
	return 0;
}

