#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#define MAXN 256

#define TLIMIT 2.5

int n, best;
int bcomp[MAXN][MAXN];
int bcc[MAXN];
int a[MAXN][MAXN];
int v[MAXN];
int comp[MAXN][MAXN];
int cc[MAXN];
int clevel;

clock_t st, ct;
double dt, bt;
double blimit = TLIMIT;
int f;

void readf(void);
void solve(void);
void writef(void);

int main(void) {
    st = clock();
    readf();
    solve();
    writef();
    
    return 0;
}

void readf(void) {
     int i, j;
     char c;
     
     scanf("%d\n", &n);
     for (i = 1; i < n; ++i) {
         for (j = 0; j < i; ++j) {
             scanf("%c", &c);
             a[j][i] = a[i][j] = c - '0';
         }
         fgetc(stdin);
     }
}

void solve(void) {
     int i;
     int b[MAXN];
     
     int create(int c, int l, int cb[]);

     for (i = 0; i < n; ++i)
         b[i] = 1;
     best = MAXN;
     clevel = 0;
     bt = TLIMIT / n;
     create(0, 0, b);
}

void writef(void) {
     int i, j;

     printf("%d\n", best);
     for (i = 0; i < best; ++i) {
         printf("%d\n", bcc[i]);
         printf("%d", bcomp[i][0] + 1);
         for (j = 1; j < bcc[i]; ++j)
             printf(" %d", bcomp[i][j] + 1);
         putchar('\n');
     }
}

int create(int c, int l, int cb[]) {
     int i, j, ac;
     int vn[MAXN], vc[MAXN], b[MAXN];

     int count(int vex, int cb[]);
     void sortv(int vn[], int vc[], int ac);

     ct = clock();
     dt = ((double)ct - (double)st) / CLK_TCK;
     if (dt >= TLIMIT)
        return 1;
     if (dt > bt) {
        bt += blimit;
        return 1;
     }

     ++clevel;

     if (c < best) {
          for (i = 0; i < n && cb[i] == 0; ++i)
              ;

          if (i < n) {
             if (c + 1 < best) {
                for (ac = 0; i < n; ++i)
                    if (cb[i] == 1) {
                       vn[ac] = i;
                       vc[ac++] = count(i, cb);
                    }
                if (f == 0 && clevel == 2 && ac / 2 != 0) {
                   f = 1;
                   blimit = TLIMIT / (ac / 2);
                }
                sortv(vn, vc, ac);
                for (i = 0; i < ac && c + 1 < best; ++i) {
                    v[vn[i]] = 1;
                    for (j = 0; j < n; ++j)
                        b[j] = cb[j] && a[vn[i]][j];
                    comp[c][l] = vn[i];
                    if (create(c, l + 1, b)) {
                       if (clevel == 2) {
                          ct = clock();
                          dt = ((double)ct - (double)st) / CLK_TCK;
                          if (dt >= TLIMIT) {
                             v[vn[i]] = 0;
                             --clevel;
                             return 1;
                          }
                       }
                       else {
                            v[vn[i]] = 0;
                            --clevel;
                            return 1;
                       }
                    }
                    v[vn[i]] = 0;
                }
             }
          }
          else {
               if (l == 0) {
                  best = c;
                  memcpy(bcc, cc, sizeof(cc));
                  for (i = 0; i < best; ++i)
                      for (j = 0; j < bcc[i]; ++j)
                          bcomp[i][j] = comp[i][j];
               }
               else if (c + 1 < best) {
                    cc[c] = l;
                    for (i = 0; i < n; ++i)
                        b[i] = !v[i];
                    if (create(c + 1, 0, b)) {
                       if (clevel == 2) {
                          ct = clock();
                          dt = ((double)ct - (double)st) / CLK_TCK;
                          if (dt >= TLIMIT) {
                             --clevel;
                             return 1;
                          }
                       }
                       else {
                            --clevel;
                           return 1;
                       }
                    }
               }
          }
     }

     --clevel;
     return 0;
}

int count(int vex, int cb[]) {
    int c, i;

    for (c = i = 0; i < n; ++i)
        if (cb[i] == 1 && a[vex][i] == 1)
           ++c;

    return c;
}

void sortv(int vn[], int vc[], int ac) {
     int i, j, t, s, g;

     g = ac;
     do {
        s = 0;
        g = (int)(g / 1.3);
        if (g < 1)
           g = 1;
        else if (g == 9 || g == 10)
             g = 11;
        for (j = g; j < ac; ++j) {
            i = j - g;
            if (vc[i] < vc[j]) {
               s = 1;
               t = vc[i];
               vc[i] = vc[j];
               vc[j] = t;
               t = vn[i];
               vn[i] = vn[j];
               vn[j] = t;
            }
        }
     }
     while (g > 1 || s != 0);
}

