/*
NAME: Ivan Anev
PROG: bintree
LANG: C
*/

#include <stdio.h>

#define MAXN 2048

int n, m;
int s[MAXN];
int c[MAXN];
int f[MAXN][MAXN];
int b[MAXN][MAXN];

void readf(void);
void solve(void);
void writef(void);

int main(void) {
	readf();
	solve();
	writef();

	return 0;
}

void readf(void) {
	int i;

	scanf("%d%d", &n, &m);
	for (i = 0; i < n; ++i)
		scanf("%d", &s[i]);
}

void solve(void) {
	int i, j, l, k, cost, t, cc;

	c[0] = 0;
	for (i = 1; i <= n; ++i)
		c[i] = c[i-1] + s[i-1];

	for (l = 0; l < n; ++l)
		for (i = 0; i < n - l; ++i) {
			j = i + l;
			b[i][j] = i;
			f[i][j] = f[i+1][j] + c[j+1] - c[i];
			cc = c[j+1] - c[i];
			for (k = (i + j + 1) / 2; k <= j && (t = f[i][k-1] + cc) < f[i][j]; ++k)
				if ((cost = t + f[k+1][j]) < f[i][j]) {
					b[i][j] = k;
					f[i][j] = cost;
				}
			for (k = (i + j + 1) / 2 - 1; k > i && (t = f[k+1][j] + cc) < f[i][j]; --k)
				if ((cost = t + f[i][k-1]) < f[i][j]) {
					b[i][j] = k;
					f[i][j] = cost;
				}
		}
}

void writef(void) {
	void print(int i, int j, int p);

	printf("%d\n", b[0][n-1] + 1);
	print(0, b[0][n-1] - 1, b[0][n-1]);
	print(b[0][n-1] + 1, n - 1, b[0][n-1]);
}

void print(int i, int j, int p) {
	if (i <= j) {
		printf("%d %d %c\n", b[i][j] + 1, p + 1, ((b[i][j] < p) ? '<' : '>'));
		print(i, b[i][j] - 1, b[i][j]);
		print(b[i][j] + 1, j, b[i][j]);
	}
}
