/*
NAME: Ivan Anev
PROG: diag
LANG: C
*/

#include <stdio.h>

#define MAXM 32
#define MAXP 32
#define MAXK 1024

int m, l, k, ans;
int p[MAXM];
int d[MAXM][MAXP];
int pos[MAXK];

void readf(void);
void solve(void);
void writef(void);

int main(void) {
	readf();
	solve();
	writef();

	return 0;
}

void readf(void) {
	int i, j;

	scanf("%d", &m);
	for (i = 0; i < m; ++i)
		scanf("%d", &p[i]);
	scanf("%d", &l);
	for (i = 0; i < m; ++i)
		for (j = 0; j < p[i]; ++j)
			scanf("%d", &d[i][j]);
}

void solve(void) {
	int i, j, t;
	int row[MAXM];

	int makeprev(void);

	for (i = 0; i < m; ++i)
		k += p[i];
	for (i = 1; i <= k; ++i)
		for (j = 0; j < m; ++j) {
			for (t = 0; t < p[j] && d[j][t] != i; ++t)
				;
			if (t < p[j]) {
				pos[i-1] = j;
				break;
			}
		}

	for (ans = i = 0; i < l && makeprev() == 0; ++ans, ++i)
		;

	if (i == l) {
		ans = -1;
		for (i = 0; i < m; ++i)
			row[i] = 0;
		for (i = 0; i < k; ++i)
			d[pos[i]][row[pos[i]]++] = i + 1;
	}
}

void writef(void) {
	int i, j;

	if (ans == -1) {
		for (i = 0; i < m; ++i) {
			printf("%d", d[i][0]);
			for (j = 1; j < p[i]; ++j)
				printf(" %d", d[i][j]);
			putchar('\n');
		}
	}
	else
		printf("%d\n", ans);
}

int makeprev(void) {
	int i, j;
	int row[MAXM];

	for (i = 0; i < m; ++i)
		row[i] = p[i];

	for (i = k - 1; i > 0; --i) {
		--row[pos[i]];
		for (j = pos[i] - 1; j >= 0 && (row[j] == p[j] || (j > 0 && row[j-1] <= row[j])); --j)
			;
		if (j >= 0) {
			pos[i] = j;
			++row[j];
			break;
		}
	}

	if (i == 0)
		return 1;

	++i;
	while (i < k) {
		for (j = m - 1; row[j] == p[j] || (j > 0 && row[j-1] <= row[j]); --j)
			;
		pos[i] = j;
		++row[j];
		++i;
	}

	return 0;
}
