/*
NAME: Ivan Anev
PROG: mountain
LANG: C
*/

#include <stdio.h>

#define MAXN 512

typedef struct Node TNode;
struct Node {
	int code, hh;
};

int n;
int height[MAXN];
int mh, mnode;
TNode heap[MAXN];
int heapsize;

void readf(void);
void solve(void);
void writef(void);

int main(void) {
	readf();
	solve();
	writef();

	return 0;
}

void readf(void) {
	scanf("%d", &n);
}

void solve(void) {
	int a, b;

	void find(int a, int b);
	void enqueue(int a, int b);
	void dequeue(int *a, int *b);

	enqueue(0, n);
	while (heapsize > 0) {
		dequeue(&a, &b);
		find(a, b);
	}
}

void writef(void) {
	printf("-1 %d %d\n", mnode, mh);
	fflush(stdout);
}

void find(int a, int b) {
	int hh, hn;

	void enqueue(int a, int b);

	if (a + 1 < b) {
		if (b - a == 2 && height[a] == 0 && height[b] == 0) {
			height[a+1] = 1;
			if (mh == 0) {
				mh = 1;
				mnode = a + 1;
			}
		}
		else {
			hh = (b - a + height[a] + height[b]) / 2;
			if (hh > mh) {
				hn = a + hh - height[a];
				printf("%d\n", hn);
				fflush(stdout);
				scanf("%d", &height[hn]);
				if (height[hn] > mh) {
					mnode = hn;
					mh = height[hn];
				}
				enqueue(hn, b);
				enqueue(a, hn);
			}
		}
	}
}

void enqueue(int a, int b) {
	void moveup(int v);

	heap[heapsize].hh = (b - a + height[a] + height[b]) / 2;
	heap[heapsize].code = a * MAXN + b;
	moveup(heapsize++);
}

void dequeue(int *a, int *b) {
	void movedown(int v);

	*a = heap[0].code / MAXN;
	*b = heap[0].code % MAXN;
	heap[0] = heap[--heapsize];
	if (heapsize > 0)
		movedown(0);
}

void moveup(int v) {
	int p;
	TNode t;

	t = heap[v];
	while (v > 0) {
		p = (v - 1) / 2;
		if (heap[p].hh < t.hh) {
			heap[v] = heap[p];
			v = p;
		}
		else
			break;
	}
	heap[v] = t;
}

void movedown(int v) {
	int c;
	TNode t;

	t = heap[v];
	while ((c = 2 * v + 1) < heapsize) {
		if (c + 1 < heapsize && heap[c].hh < heap[c+1].hh)
			++c;
		if (heap[c].hh > t.hh) {
			heap[v] = heap[c];
			v = c;
		}
		else
			break;
	}
	heap[v] = t;
}
