#include <stdio.h>
#include <string.h>

#define MAX_N	2048
long s[MAX_N];
long sum[MAX_N];
long n, m;
long f[MAX_N][MAX_N];
short p[MAX_N][MAX_N];

long search(int left, int right) {
	int i, best_i;
	long x, best = 0x7FFFFFFF;

	if (left > right)
		return 0;
	if (left == right) {
		p[left][right] = left;
		return 0;
	}
	if (f[left][right] == -1) {
		for (i = left; i <= right; i++) {
			x = search(left, i - 1) + search(i + 1, right) +
				sum[right] - sum[left - 1] - s[i];
			if (x < best)
				best = x, p[left][right] = i;
		}

		f[left][right] = best;
	}
	return f[left][right];
}

void restore_right(int parent, int left, int right);
void restore_left(int parent, int left, int right);

void restore_left(int parent, int left, int right) {
	if (left > right)
		return;
	printf("%i %i <\n", p[left][right], parent);
	restore_left(p[left][right], left, p[left][right] - 1);
	restore_right(p[left][right], p[left][right] + 1, right);
}

void restore_right(int parent, int left, int right) {
	if (left > right)
		return;
	printf("%i %i >\n", p[left][right], parent);
	restore_left(p[left][right], left, p[left][right] - 1);
	restore_right(p[left][right], p[left][right] + 1, right);
}

int main() {
	int i;

	scanf("%i %i", &n, &m);
	sum[0] = 0;
	for (i = 1; i <= n; i++) {
		scanf("%i", s + i);
		sum[i] = sum[i - 1] + s[i];
	}

	memset(f, 0xff, sizeof(long)*MAX_N*MAX_N);
	search(1, n);

	printf("%i\n", p[1][n]);
	restore_left(p[1][n], 1, p[1][n] - 1);
	restore_right(p[1][n], p[1][n] + 1, n);

	return 0;
}
