#include <stdio.h>
#include <stdlib.h>

#define MAXN		2010

int s[MAXN];

struct node {
	int n;
	int cost;
} nodes[MAXN];

int c1, c2;
int t1[MAXN*MAXN], t2[MAXN];
int cnt;

int node_cmp(const void *a, const void *b) {
	if ( ((struct node*)a)->cost > ((struct node*)b)->cost)
		return -1;

	if ( ((struct node*)a)->cost < ((struct node*)b)->cost)
		return 1;

	if ( abs( cnt - ((struct node*)a)->n) < abs(cnt - ((struct node*)b)->n) )
		return -1;

	return 1;
}

int place_node(int *tree, int n) {
	int c;
        int tmp;

	tmp = 0;
	c = 1;

	while (tree[c] != 0) {
		tmp++;
		if (n < tree[c])
			c = c*2;
		else
			c = c*2 + 1;
	}

	tree[c] = n;
	return tmp;
}

void do_greedy() {
	int i;
	int tmp;

	for (i = 0; i < cnt; i++) {
		tmp = place_node(t1, nodes[i].n);
		c1 += tmp * nodes[i].cost;
	}
}

void print_recurse(int *tree, int i) {

	if (tree[i*2] != 0) {
		printf("%d %d <\n", tree[i*2], tree[i]);
		print_recurse(tree, i*2);
	}
	if (tree[i*2 + 1] != 0) {
		printf("%d %d >\n", tree[i*2 + 1], tree[i]);
		print_recurse(tree, i*2 + 1);
	}
}

void print_tree(int *tree) {

	printf("%d\n",  tree[1]);

	print_recurse(tree, 1);
}

int balanced_helper(int l, int r) {
	int tmp;
	int m;

	if (l == r) {
		tmp = place_node(t2, l);
		return tmp*s[l];
	}

	m = (l+r)/2;
	tmp = place_node(t2, m);

	return tmp*s[m] + balanced_helper(l, m-1) + balanced_helper(m+1, r);
}

void do_balanced() {
	balanced_helper(1, cnt);
}

void solve() {

	qsort(nodes, cnt, sizeof(struct node), node_cmp);
	do_greedy();
	do_balanced();

	if (c1 < c2)
		print_tree(t1);
	else
		print_tree(t2);
}

int main() {
	int i;
	int tmp;

	scanf("%d%d", &cnt, &tmp);
	for (i = 0; i < cnt; i++) {
		scanf("%d", &tmp);
		nodes[i].n = i + 1;
		nodes[i].cost = tmp;
		s[i] = tmp;
	}

	solve();

	return 0;
}
