#include <stdio.h>
#include <stdlib.h>

#define MAXM		24
#define MAXP		32

int m;
int p[MAXM];
int diag[MAXM][MAXP];
int cnt;
int l;

int find_next(int *x, int *y) {
	int i, j;
	int min;

	min = 0;
	for (i = 0; i < m; i++)
		for (j = 0; j < p[i]; j++)
			if (diag[i][j] == min + 1) {
				min++; continue;
			} else {
				*x = i; *y = j;
				return 1;
			}

	return -1;
}

void find_num(int num, int *x, int *y) {
	int i, j;

	for (i = 0; i < m; i++)
		for (j = 0; j < p[i]; j++)
			if (diag[i][j] == num) {
				*x = i; *y = j;
				return;
			}
}

void move(int x1, int y1, int x2, int y2) {
	int i, j;
	int tmp;
	int num;
	int max;

	tmp = diag[x1][y1];
	diag[x1][y1] = diag[x2][y2];
	diag[x2][y2] = tmp;
	max = tmp - 1;

	num = 1;
	for (i = 0; i < p[0]; i++) {
		for (j = 0; j < m; j++) {
			if (diag[j][i] >= max) break;
			if (i > p[j]) break;

			diag[j][i] = num;
			num++;
		}
	}
}

int gen_prev() {
	int x1, y1, x2, y2;

	if (find_next(&x1, &y1) == -1)
		return -1;
	find_num(diag[x1][y1] - 1, &x2, &y2);
	move(x1, y1, x2, y2);

	return 0;
}

void solve() {
	int i, j;

	for (i = 0; i < l; i++) {
		if (gen_prev() == -1) {
			printf("%d\n", i);
			exit(0);
		}
	}

	for (i = 0; i < m; i++) {
		printf("%d", diag[i][0]);
		for (j = 1; j < p[i]; j++)
			printf(" %d", diag[i][j]);
		printf("\n");
	}
}

int main() {
	int i, j;

	scanf("%d", &m);
	for (i = 0; i < m; i++) {
		scanf("%d", &p[i]);
		cnt += p[i];
	}
	scanf("%d", &l);

	for (i = 0; i < m; i++)
		for (j = 0; j < p[i]; j++)
			scanf("%d", &diag[i][j]);

	solve();

	return 0;
}
