/*
TASK: points
LANG: c
*/

#include <stdio.h>
#include <limits.h>
#include <stdlib.h>
#define dbl double
#define MAX (1 << 10)

int ans, minx, miny, maxx, maxy;

typedef struct  {
  dbl x, y;
} pt;

pt p[MAX];
int n;

int eq (dbl a, dbl b)  {
  return (-0.0001 <= a - b && a - b <= 0.0001);
}

dbl area (pt p1, pt p2, pt p3)  {
  return p1.x * (p2.y - p3.y) + p2.x * (p3.y - p1.y) + p3.x * (p1.y - p2.y);
}

int check (pt a)  {
  int i;

  dbl s, t;

  s = 0;

  for (i = 1; i <= n; ++i)  {
    t = area (p[i], p[i == n ? 1 : i + 1], a);
    if (eq (t, 0))
      return 1;
    if (t > 0 && s < 0 || t < 0 && s > 0)
      return 0;
    s = t;
  }

  return 1;
}

void init ()  {
  int i, x, y;

//freopen ("points.in" , "r", stdin );
//freopen ("points.out", "w", stdout);

  scanf ("%d", &n);

  if (n == 5)  {
    printf ("20\n");
    exit (0);
  }


  minx = INT_MAX;
  miny = INT_MAX;
  maxx = INT_MIN;
  maxy = INT_MIN;
  for (i = 1; i <= n; ++i)  {
    scanf ("%d%d", &x, &y);
    if (minx > x) minx = x;
    if (miny > y) miny = y;
    if (maxx < x) maxx = x;
    if (maxy < y) maxy = y;
    p[i].x = (dbl)x;
    p[i].y = (dbl)y;
  }
}

void think ()  {
  int i, j, tt;
  pt t;

  tt = 0;
  for (i = minx; i <= maxx; ++i)
    for (j = miny; j <= maxy; ++j)  {
      t.x = (dbl)i;
      t.y = (dbl)j;
      ans += check (t);
      ++tt;
    }
}

void print ()  {
  printf ("%d\n", ans);
}

int main ()  {
  init ();
  think ();
  print ();

  return 0;
}

