/*
TASK:string
LANG:C
*/

//#define DEBUG_ME

#include <stdio.h>
#include <string.h>

#define IN      "string.in"
#define MAX     100100
#define MAXS    20
#define INF     0x7fffffff

long n, best, start;
long sorted[MAX];
char data[MAX][MAXS];

long heap[MAX], num;

int myCmp(long ind1, long ind2)
{
   int ret;

   ret=strcmp(data[ind1], data[ind2]);

   if(ret) return ret;

   return ind1-ind2;
}

void heap_add(long ind)
{
   long prev, cur;

   if(!num)
   {
     num=1;
     heap[1]=ind;
     return;
   }

   cur=num+1;

   while(cur>1)
   {
      prev=cur/2;

      if(myCmp(heap[prev], ind)>0)
      {
        heap[cur]=heap[prev];
        cur=prev;
      }
      else
        break;
   }

   num++;
   heap[cur]=ind;
}

long heap_get()
{
   long cur, next1, next2, ret, last;

   ret=heap[1];
   last=heap[num--];

   cur=1;

   while(1)
   {
      next1=cur*2;
      next2=next1+1;

      if(next1>num) break;

      if(next2>num || myCmp(heap[next1], heap[next2])<0)
      {
        if(myCmp(heap[next1], last)<0)
        {
          heap[cur]=heap[next1];
          cur=next1;
        }
        else
          break;
      }
      else
      {
        if(myCmp(heap[next2], last)<0)
        {
          heap[cur]=heap[next2];
          cur=next2;
        }
        else
          break;
      }
   }

   heap[cur]=last;

   return ret;
}

int main()
{
   long i, j;

#ifdef DEBUG_ME
   freopen(IN, "r", stdin);
#endif

   scanf("%ld", &n);

   for(i=0; i<n; i++)
      scanf("%s", data[i]);

#ifdef DEBUG_ME
   fclose(stdin);
#endif

   for(i=0; i<n; i++)
      heap_add(i);

   for(i=0; i<n; i++)
      sorted[i]=heap_get();

   best=INF;
   start=-1;

   for(i=0; i<n; i++)
   {
      for(j=i+1; j<n; j++)
         if(strcmp(data[sorted[i]], data[sorted[j]])) break;
      j--;

      if(j-i+1<best || (j-i+1==best && sorted[i]<start))
      {
        best=j-i+1;
        start=sorted[i];
      }

      i=j;
   }

/*   for(i=0; i<n; i++)
      printf("%s\n", data[sorted[i]]);*/

   printf("%s\n", data[start]);

   return 0;
}

