/*
TASK: STRING
LANG: C
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define MAXN             100010
#define MAXL             27

#define INF              2000000000

typedef struct s1
{
  char let;
  int brp;
  char brn;
  int firstv;
  char end;
  struct s1 *par;
  struct s1 *nasl[MAXL];

} tnode;

int n;
tnode *root;
int glmin;
int firstv;
tnode *best;
char ans[20];
int brans;

void init()
{
  int i;

  root = (tnode*)malloc(sizeof(tnode));

  for(i=0;i<MAXL;i++)
    root->nasl[i] = NULL;

  root->par = NULL;
  root->brp = 0;
  root->firstv = 0;
  root->brn = 0;
  root->end = 0;

}

void InsertString(char *str, int num)
{
  int i,i2;
  int len;
  tnode *cur;
//  tnode *tmp;
  int clet;

  len = strlen(str);
/*  str[len] = 'Z'+1;
  str[len+1] = '\0';
  len++;*/

  cur = root;
  cur->brp++;

  for(i=0;i<len;i++)
  {
    clet = str[i]-'A';
    if((cur->nasl[clet])!=NULL)  // ako ima prodalzhenie
    {
      cur = cur->nasl[clet];
      cur->brp++;
    }
    else
    {
      cur->brn++;

      cur->nasl[clet] = (tnode*)malloc(sizeof(tnode));
      //tmp = cur->nasl[clet];

      for(i2=0;i2<MAXL;i2++)
        cur->nasl[clet]->nasl[i2] = NULL;

      cur->nasl[clet]->let = str[i];
      cur->nasl[clet]->brp = 1;
      cur->nasl[clet]->par = cur;
      cur->nasl[clet]->firstv = num;
      cur->nasl[clet]->brn = 0;
      cur->nasl[clet]->end = 0;

      cur = cur->nasl[clet];
    }
  }

  cur->end = 1;
}

void DFS(tnode *node)
{
  int i;

  if(node->end==1)
  {
    if(glmin>node->brp)
    {
      glmin = node->brp;
      firstv = node->firstv;
      best = node;
    }
    else
    {
      if(glmin==node->brp)
      {
        if(firstv>node->firstv)
        {
          firstv = node->firstv;
          best = node;
        }
      }
    }
  }

  for(i=0;i<MAXL;i++)
    if((node->nasl[i])!=NULL)
    {
      DFS(node->nasl[i]);
    }
}

void solve()
{
  int i;
  char str[20];
  tnode *cur;

  scanf("%d",&n);

//  printf("inserting\n");

  for(i=0;i<n;i++)
  {
    scanf("%s",str);

    InsertString(str,i);
  }



  glmin = INF;
  best = NULL;

//  printf("dfs\n");

  DFS(root);

  cur = best;
  brans = 0;

//  printf("find path\n");

  while(cur->par!=NULL)
  {
    ans[brans] = cur->let;
    cur = cur->par;
    brans++;
  }

}

void output()
{
  int i;

  for(i=brans-1;i>=0;i--)
  {
    printf("%c",ans[i]);
  }

  printf("\n");
}

int main()
{
//  freopen("stringt.txt","r",stdin);

  init();
  solve();
  output();

//  printf("%d\n",sizeof(tnode));

  return 0;
}

