#include <stdio.h>
#include <stdlib.h>
#include <string.h>

static int n;
static int move[128][2];
static int junk1;
static int junk2;
static int junk3[524288];
static int junk4[524288];
static int junk5[524288];
static int junk6[524288];
static int junk7[524288];
static FILE *fn;
static FILE *fo;
static int kx, ky, cx, cy, bx, by, nx, ny;
static int st=0, turn=0;
static int moves=0;

static void init() {
	int i;
	char tmp1, tmp2, tmp3, tmp4, tmp5, tmp6;

	fn = fopen("chess.in", "r");
	fscanf(fn, "%c%c %c%c %c%c", &tmp1, &tmp2, &tmp3, &tmp4, &tmp5, &tmp6);
	kx = tmp1-'a';
	ky = tmp2-'1';
	cx = tmp3-'a';
	cy = tmp4-'1';
	bx = tmp5-'a';
	by = tmp6-'1';
	fscanf(fn, "%d", &n);
	srand(n);
	for (i=0; i<n; i++) fscanf(fn, "%d %d", &move[i][0], &move[i][1]);
	fclose(fn);
	fo = fopen("chess.out", "w");
	st = 1;
}

static void quit(char *errmsg) {
	fprintf(fo, "ERROR: %s!\n", errmsg);
	fclose(fo);
	exit(0);
}

static void win() {
	fprintf(fo, "Black King is captured!\nCongratulations! You win! You made %d moves.\n", moves);
	turn = 2;
}

void moveKing(char a, long b) {
	char errmsg[256];

	if (!st) init();
	if (a<'a' || a>'h' || b<1 || b>8) {
		sprintf(errmsg, "Subroutine moveKing() called with invalid arguments: %c%d", a, b);
		quit(errmsg);
	}
	if (turn==1) quit("White King is moved, but the Black side is on turn");
	if (turn==2) quit("White King is moved after the end of the game");
	nx = a-'a';
	ny = b-1;
	if (nx-kx>1 || kx-nx>1 || ny-ky>1 || ky-ny>1 || (nx==kx && ny==ky)) {
		sprintf(errmsg, "Invalid King move from %c%d to %c%d", 'a'+kx, 1+ky, a, b);
		quit(errmsg);
	}
	if (nx==cx && ny==cy) {
		sprintf(errmsg, "Invalid King move: King moved over Colonel on %c%d", a, b);
		quit(errmsg);
	}
	kx = nx;
	ky = ny;
	moves++;
	turn = 1;
	fprintf(fo, "White King: %c%c\n", 'a'+kx, '1'+ky);
	if (kx==bx && ky==by) win();
}

void moveColonel(char a, long b) {
	char errmsg[256];
	int i;

	if (!st) init();
	if (a<'a' || a>'h' || b<1 || b>8) {
		sprintf(errmsg, "Subroutine moveColonel() called with invalid arguments: %c%d", a, b);
		quit(errmsg);
	}
	if (turn==1) quit("White Colonel is moved, but the Black side is on turn");
	if (turn==2) quit("White Colonel is moved after the end of the game");
	if (cx<0) quit("White Colonel is moved after it has been captured");
	nx = a-'a';
	ny = b-1;
	for (i=0; i<n; i++) if (cx+move[i][0]==nx && cy+move[i][1]==ny) break;
	if (i==n) {
		sprintf(errmsg, "Invalid Colonel move from %c%d to %c%d", 'a'+cx, 1+cy, a, b);
		quit(errmsg);
	}
	if (nx==kx && ny==ky) {
		sprintf(errmsg, "Invalid Colonel move: Colonel moved over King on %c%d", a, b);
		quit(errmsg);
	}
	cx = nx;
	cy = ny;
	moves++;
	turn = 1;
	fprintf(fo, "White Colonel: %c%c\n", 'a'+cx, '1'+cy);
	if (cx==bx && cy==by) win();
}

void getKing(char *a, long *b) {

	if (!st) init();
	if (turn==0) quit("getKing() called, but the White side is on turn");
	if (turn==2) quit("getKing() is called after the end of the game");
	while (1) {
		nx = rand()%3+bx-1;
		ny = rand()%3+by-1;
		if (nx>=0 && nx<=7 && ny>=0 && ny<=7 && (nx!=bx || ny!=by)) break;
	}
	bx = nx;
	by = ny;
	turn = 0;
	*a = 'a'+bx;
	*b = 1+by;
	fprintf(fo, "Black King: %c%c\n", 'a'+bx, '1'+by);
	if (cx==bx && cy==by) {
		fprintf(fo, "White Colonel is captured!\n");
		cx = -1;
	}
	if (kx==bx && ky==by) {
		fprintf(fo, "White King is captured!\nSorry! You lose!\n");
		turn = 2;
	}
}
