#include <stdio.h>
#include <math.h>

int w, h, k;
int n[2];
int x[2][1024], y[2][1024];
int mid[2];
int m;
int mx[2][16384], my[2][16384];
int turn;

int obtuse(int x1, int y1, int x2, int y2, int x3, int y3) {
	return (x1-x3)*(x1-x3)+(y1-y3)*(y1-y3) > (x1-x2)*(x1-x2)+(y1-y2)*(y1-y2) + (x2-x3)*(x2-x3)+(y2-y3)*(y2-y3);
}

double orient(int x1, int y1, int x2, int y2, int x3, int y3) {
	return x1*y2+x2*y3+x3*y1-x2*y1-x3*y2-x1*y3;
}

double bsrch(int pal, int hand, int lo, int hi) {
	int mi;

	while (lo+1<hi) {
		mi = (lo+hi)/2;
		if (obtuse(pal, 0, x[hand][mi]+mx[hand][turn], y[hand][mi]+my[hand][turn], x[hand][mi-1]+mx[hand][turn], y[hand][mi-1]+my[hand][turn])) {
			lo = mi;
		} else hi = mi;
	}
	if (lo<hi) {
		if (obtuse(pal, 0, x[hand][lo]+mx[hand][turn], y[hand][lo]+my[hand][turn], x[hand][hi]+mx[hand][turn], y[hand][hi]+my[hand][turn])) hi = lo;
		else if (obtuse(pal, 0, x[hand][hi]+mx[hand][turn], y[hand][hi]+my[hand][turn], x[hand][lo]+mx[hand][turn], y[hand][lo]+my[hand][turn])) lo = hi;
		if (lo<hi) return orient(pal, 0, x[hand][hi]+mx[hand][turn], y[hand][hi]+my[hand][turn], x[hand][lo]+mx[hand][turn], y[hand][lo]+my[hand][turn]) /
			sqrt((x[hand][hi]-x[hand][lo])*(x[hand][hi]-x[hand][lo])+(y[hand][hi]-y[hand][lo])*(y[hand][hi]-y[hand][lo]));
	}
	return sqrt((x[hand][lo]+mx[hand][turn]-pal)*(x[hand][lo]+mx[hand][turn]-pal)+(y[hand][lo]+my[hand][turn])*(y[hand][lo]+my[hand][turn]));
}

int main(void) {
	int i, j, left, lo, hi, mi;
	double zero, max, avg, d;
	int ans;
	double t1, t2;

	scanf("%d %d %d", &w, &h, &k);
	for (i=0; i<k; i++) {
		scanf("%d", &n[i]);
		mid[i] = 1;
		for (j=1; j<=n[i]; j++) {
			scanf("%d %d", &x[i][j], &y[i][j]);
			if (y[i][j]<y[i][mid[i]]) mid[i] = j;
		}
	}
	scanf("%d", &m);
	for (i=1; i<=m; i++) {
		for (j=0; j<k; j++) {
			scanf("%d %d", &mx[j][i], &my[j][i]);
			mx[j][i] += mx[j][i-1];
			my[j][i] += my[j][i-1];
		}
	}

	for (turn=0; turn<=m; turn++) {
		if (k==1) {
			zero = bsrch(0, 0, 1, mid[0]);
			max = bsrch(w, 0, mid[0], n[0]);
			if (zero>max) printf("0\n");
			else printf("%d\n", w);
		} else {
			zero = bsrch(0, 0, 1, mid[0]);
			d = bsrch(0, 1, 1, mid[1]);
			if (d<zero) zero = d;
			max = bsrch(w, 0, mid[0], n[0]);
			d = bsrch(w, 1, mid[1], n[1]);
			if (d<max) max = d;
			if (x[0][mid[0]]+mx[0][turn]<x[1][mid[1]]+mx[1][turn]) left = 0;
			else left = 1;
			lo = x[left][mid[left]]+mx[left][turn];
			hi = x[!left][mid[!left]]+mx[!left][turn];
			if (bsrch(lo, left, mid[left], n[left]) < bsrch(lo, !left, 1, mid[!left]) && bsrch(hi, !left, 1, mid[!left]) < bsrch(hi, left, mid[left], n[left])) {
				while (lo+1<hi) {
					mi = (lo+hi)/2;
					t1 = bsrch(mi, left, mid[left], n[left]);
					t2 = bsrch(mi, !left, 1, mid[!left]);
					if (t1==t2) {
						avg = t1;
						ans = mi;
						lo = hi = mi;
						break;
					} else if (t1<t2) lo = mi;
					else hi = mi;
				}
				if (lo<hi) {
					avg = bsrch(lo, left, mid[left], n[left]);
					d = bsrch(hi, !left, 1, mid[!left]);
					if (d>avg) {
						avg = d;
						ans = hi;
					} else ans = lo;
				}
			} else avg = 0;
			if (zero>=avg && zero>=max) printf("0\n");
			else if (max>=zero && max>=avg) printf("%d\n", w);
			else printf("%d\n", ans);
		}
	}

	return 0;
}
