#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define MAX_TOWNS 512
#define MAX_CHANGES 1024
#define MAXWF 1024

int current[3];
int limits[3];
int ntowns;
int need[MAX_TOWNS][3];
int N;
int changes[MAX_CHANGES][5];

typedef int DP_TAB[MAXWF][MAX_CHANGES][2];

DP_TAB tab1, tab2;

int list_used[MAX_CHANGES];
int nused;



int find_best(int current_wf, int beg_change, int lasttown, DP_TAB tab, int type_wf);
void simulate(int current_wf, int beg_change, int lasttown, DP_TAB tab, int type_wf);
int cmp_int(const void *a, const void *b);




int main(void)
{
  int i, j;
  int mFood, mWater;
  int mTravel = 0;

  /*freopen("trip.in", "rt", stdin);*/
  for (i = 0; i < 3; i++)  scanf("%d", &current[i]);
  for (i = 0; i < 2; i++)  scanf("%d", &limits[1+i]);
  scanf("%d", &ntowns);
  for (i = 0; i < ntowns-1; i++) {
    for (j = 0; j < 3; j++)  scanf("%d", &need[i][j]);
    mTravel += need[i][0];
  }
  scanf("%d", &N);
  for (i = 0; i < N; i++) {
    for (j = 0; j < 4; j++)  scanf("%d", &changes[i][j]);
    changes[i][0]--;
    changes[i][4] = 1 + i;
  }

  qsort(changes, N, sizeof(changes[0]), cmp_int);
  changes[N][0] = ntowns-1;

  memset(tab1, -1, sizeof(tab1));
  memset(tab2, -1, sizeof(tab2));

  mFood  = find_best(current[1], 0, 0, tab1, 1);
  mWater = find_best(current[2], 0, 0, tab2, 2);
  simulate(current[1], 0, 0, tab1, 1);
  simulate(current[2], 0, 0, tab2, 2);

  qsort(list_used, nused, sizeof(list_used[0]), cmp_int);
  
  /*printf("%d\n", current[0]-mFood-mWater-mTravel);*/
  printf("%d\n", nused);
  for (i = 0; i < nused; i++) {
    printf("%d%s", list_used[i], (i+1<nused)?" ":"\n");
  }

  return 0;
}



int find_best(int current_wf, int beg_change, int lasttown, DP_TAB tab, int type_wf)
{
  int i;
  int res, res1;
  int current_wf_old = current_wf;

  if (tab[current_wf][beg_change][0] >= 0)  return tab[current_wf][beg_change][0];
  if (lasttown == ntowns-1) {
    return 0;
  }

  /* stigame do razmqnata */
  for (i = lasttown; i < changes[beg_change][0]; i++) {
    current_wf -= need[i][type_wf];
  }
  tab[current_wf_old][beg_change][1] = 0; /* ne se polzwa tazi razmqna */
  if (current_wf >= 0) {
    res1 = find_best(current_wf, beg_change+1, changes[beg_change][0], tab, type_wf);
    res = res1;
    if (changes[beg_change][1]+1 == type_wf) {
      current_wf += changes[beg_change][3];
      res1 = changes[beg_change][2];
      if (current_wf > limits[type_wf])  current_wf = limits[type_wf];
      res1 += find_best(current_wf, beg_change+1, changes[beg_change][0], tab, type_wf);
    }
    if (res1 < res) {
      res = res1;
      tab[current_wf_old][beg_change][1] = 1;  /* polzwa se razmqnata */
    }
  }
  else {
    res = current[0] + 1; /* poweche otkolkoto imame */ 
  }
  return tab[current_wf_old][beg_change][0] = res;
}



void simulate(int current_wf, int beg_change, int lasttown, DP_TAB tab, int type_wf)
{
  int i;
  int current_wf_old = current_wf;

  if (lasttown == ntowns-1) {
    return;
  }
  for (i = lasttown; i < changes[beg_change][0]; i++) {
    current_wf -= need[i][type_wf];
  }

  if (tab[current_wf_old][beg_change][1] == 0) {  /* ne se polzwa tazi razmqna */
    simulate(current_wf, beg_change+1, changes[beg_change][0], tab, type_wf);
  }
  else {  /* polzwa se razmqnata */
    current_wf += changes[beg_change][3];
    if (current_wf > limits[type_wf])  current_wf = limits[type_wf];
    simulate(current_wf, beg_change+1, changes[beg_change][0], tab, type_wf);
    list_used[nused++] = changes[beg_change][4];
  }
}



int cmp_int(const void *a, const void *b)
{
  return ((int *)a)[0] - ((int *)b)[0];
}

