#include <stdio.h>
#include <algorithm>
using namespace std;

const double eps = 0.000001;

const int N = 2002;

struct Type{
	int p, q;
	double ang;
};

struct Point{
	int num;
	double x, y;
	double ang;
};

Type res[N];
Point a[N];
int i, j, n;


void Input(){
	scanf("%d", &n);
	for(i=0; i<=n; i++){
		scanf("%lf%lf", &a[i].x, &a[i].y);		
		a[i].num = i;
	}
}

double abs(double p){
	return p > 0 ? p : -p;
}

double Angle(Point p, Point q){
	double dx,dy,ax,ay;
	double ret = 0;

	dx = q.x-p.x;
	ax = abs(dx);
	dy = q.y-p.y;
	ay = abs(dy);
	
	if(dx == 0 && dy == 0)
		ret = 0;
	else
		ret = dy / (ax + ay);
	
	if(dx < 0)
		ret = 2 - ret;
	else
		if(dy < 0)
			ret += 4;

	ret = 90.0*ret;

	return ret;
}

bool byAngle(Point p, Point q){
	return p.ang < q.ang;
}
bool resbyAngle(Type p, Type q){
	return (q.ang - p.ang) > eps;
}

bool sort1(Type p, Type q){
	return (p.p < q.p) || (p.p == q.p && p.q < q.q);
}


void Solve(){
	for(int i=1; i<=n; i++)
		a[i].ang = Angle(a[0], a[i]);

	sort(a, a+n+1, byAngle);

	for(i=1; i<n; i++){
		res[i].p = a[i].num;
		res[i].q = a[i+1].num;
		res[i].ang = a[i+1].ang - a[i].ang;
	}
	res[n].p = a[1].num;
	res[n].q = a[n].num;
	res[n].ang = 360.0 + a[1].ang - a[n].ang;

	
	for(i=1; i<=n; i++)
		if(res[i].p > res[i].q){
			int temp = res[i].p;
			res[i].p = res[i].q;
			res[i].q = temp;
		}

	sort(res+1, res+n+1, sort1);
	stable_sort(res+1, res+n+1, resbyAngle);

	for(i=1; i<=n; i++)
		if((180.0 - res[i].ang) > 0 && res[i].ang > eps)
			printf("%d %d\n", res[i].p, res[i].q);
}

int main(){
	Input();
	Solve();
	return 0;
}
