#include <iostream.h>
#include <stdlib.h>

int n, m;
int ec = 0;

struct vert
{
 int v; unsigned int w;
} heap[ 10001 ];

int hc = 0;

long b[ 10001 ];
long d[ 10001 ];

struct edge
{
 int u;
 int v;
 int w;
} edges[ 200007 ];


int cmp( const void* a, const void* b )
{
 edge* p = (edge*)a;
 edge* q = (edge*)b;

 return (p->u) - (q->u);
}


void init( )
{
// ifstream cin( "fast.in" );
 cin>>n>>m;

 int i;
 int u, v, w;
 for ( i=1; i<=m; i++ )
 {
  cin>>u>>v>>w;

  edges[ ++ec ].u = u;
  edges[ ec ].v = v;
  edges[ ec ].w = w;

  edges[ ++ec ].u = v;
  edges[ ec ].v = u;
  edges[ ec ].w = w;
 }

 qsort( edges+1, ec, sizeof( edges[ 1 ] ), cmp );

 u = 1;
 b[ u ] = 1;
 edges[ ec+1 ].u = 6;
 for ( i=1; i<=ec; i++ )
 {
  if ( edges[ i ].u != u )
	 {
		b[ edges[ i ].u ] = i;
		u = edges[ i ].u;
	}
 }
 b[ n+1 ] = ec;
}

void add( int v, int w )
{
 heap[ ++hc ].v = v;
 heap[ hc ].w = w;

 int x = hc;
 int p = x / 2;
 vert c;

 while ( p > 0 && heap[ p ].w < heap[ x ].w )
 {
   c = heap[ p ];
	heap[ p ] = heap[ x ];
	heap[ x ] = c;

	x = p;
	p = x / 2;
 }
}


void deletemax( vert &res )
{
 res = heap[ 1 ];
 heap[ 1 ] = heap[ hc-- ];

 int x = 1;
 int l = 2*x;
 int r = ( 2*x ) + 1;
 int largest = x;
 vert c;

 while ( l <= hc )
 {
  	largest = x;

	if ( heap[ largest ].w < heap[ l ].w )
	  largest = l;

	if ( r <= hc && heap[ largest ].w < heap[ r ].w )
	  largest = r;
	if ( largest == x )
	  break;

   c = heap[ largest ];
	heap[ largest ] = heap[ x ];
	heap[ x ] = c;

	x = largest;
	l = 2*x;
	r = ( 2*x ) + 1;
 }
}


void dijkstra( )
{
 	int i, j;
	int u, v;

	for ( i=2; i<=n; i++ )
	{
	 d[ i ] = -1;
	 }

	for ( i=1; i<=ec; i++ )
	{
	 if ( edges[ i ].u != 1 )
		break;

	 add( edges[ i ].v, edges[ i ].w );
	 d[ edges[ i ].v ] = edges[ i ].w;
	}

	d[ 1 ] = 10000;
	vert c;

	while( hc > 0 )
	{
	 deletemax( c );

	 if ( c.w == -1 )
		break;

    for ( i=b[ c.v ]; i<b[ c.v+1 ]; i++ )
	 {
		u = c.v;
		v = edges[ i ].v;

		long int d1 = edges[ i ].w > c.w ? c.w : edges[ i ].w;

		if ( d1 > d[ v ] )
		 {
		   d[ v ] = d1;
			add( v, d1 );
		 }
	 }
	}
}


void solve( )
{
 dijkstra( );

 if ( d[ n ] == -1 )
	 cout<<0<<endl;
 else
	cout<<d[ n ]<<endl;
}


void main( )
{
 	init( );
	solve( );
}
