Type TAngle = Record
        P1 : Integer;
        P2 : Integer;
        Angle : Real;
     End;

     TPoint = Record
        X, Y : Real;
     End;

Var       N : Integer;

     Angles : Array[1..2020] Of TAngle;
     Points : Array[1..2020] Of TPoint;
     ACount : Integer;
     PCount : Integer;

       Quad : Array[1..2020] Of Integer;
     QCount : Integer;

Procedure SortQuadDown(ff, tt : Integer);
Var i, j : Integer;
    T : Integer;
Begin
   For i := ff To tt - 1 Do
      For j := i + 1 To tt Do
         If Points[Quad[j]].Y > Points[Quad[i]].Y Then Begin
            T := Quad[i];
            Quad[i] := Quad[j];
            Quad[j] := T;
         End;
End;

Procedure SortQuadUp(ff, tt : Integer);
Var i, j : Integer;
    T : Integer;
Begin
   For i := ff To tt - 1 Do
      For j := i + 1 To tt Do
         If Points[Quad[j]].Y < Points[Quad[i]].Y Then Begin
            T := Quad[i];
            Quad[i] := Quad[j];
            Quad[j] := T;
         End;
End;

Procedure AddAngle(P1, P2 : Integer);
Var A1 : Real;
    A2 : Real;
     A : Real;
    X1, X2, Y1, Y2 : Real;
Begin
   X1 := Points[P1].X; Y1 := Points[P1].Y;
   X2 := Points[P2].X; Y2 := Points[P2].Y;
   If (X1 >= 0) And (Y1 >= 0) Then Begin
      If X1 = 0 Then A1 := pi/2 Else Begin
         A1 := Y1/X1;
         A1 := ArcTan(A1);
      End;
   End Else Begin
      If (X1 <= 0) And (Y1 >= 0) Then Begin
         If X1 = 0 Then A1 := pi/2 Else Begin
            If Y1 = 0 Then A1 := pi Else Begin
               A1 := -X1/Y1;
               A1 := ArcTan(A1) + pi/2;
            End;
         End;
      End Else Begin
         If (X1 <= 0) And (Y1 <= 0) Then Begin
            If X1 = 0 Then A1 := 3*pi/2 Else Begin
               A1 := Y1/X1;
               A1 := ArcTan(A1) + pi;
            End;
         End Else Begin
            If X1 = 0 Then A1 := 3*pi/2 Else Begin
               If Y1 = 0 Then A1 := 2*pi Else Begin
                  A1 := -X1/Y1;
                  A1 := ArcTan(A1) + 3*pi/2;
               End;
            End;
         End;
      End;
   End;
   If (X2 >= 0) And (Y2 >= 0) Then Begin
      If X2 = 0 Then A2 := pi/2 Else Begin
         A2 := Y2/X2;
         A2 := ArcTan(A2);
      End;
   End Else Begin
      If (X2 <= 0) And (Y2 >= 0) Then Begin
         If X2 = 0 Then A2 := pi/2 Else Begin
            If Y2 = 0 Then A2 := pi Else Begin
               A2 := -X2/Y2;
               A2 := ArcTan(A2) + pi/2;
            End;
         End;
      End Else Begin
         If (X2 <= 0) And (Y2 <= 0) Then Begin
            If X2 = 0 Then A2 := 3*pi/2 Else Begin
               A2 := Y2/X2;
               A2 := ArcTan(A2) + pi;
            End;
         End Else Begin
            If X2 = 0 Then A2 := 3*pi/2 Else Begin
               If Y2 = 0 Then A2 := 2*pi Else Begin
                  A2 := -X2/Y2;
                  A2 := ArcTan(A2) + 3*pi/2;
               End;
            End;
         End;
      End;
   End;
   A := Abs(A1-A2);
   If A > pi Then A := 2*pi - A;
   If A = pi Then A := 0;
   If A > 0 Then Begin
      Inc(ACount);
      Angles[ACount].P1 := P1;
      Angles[ACount].P2 := P2;
      Angles[ACount].Angle := A;
   End;
End;

Procedure SortPts;
Var i : Integer;
    ff : Integer;
Begin
   (* Quadrant 1 *)
   QCount := 0;
   ff := 1;
   For i := 1 To N Do
      If (Points[i].X >= 0) And (Points[i].Y >= 0) Then Begin
         Inc(QCount);
         Quad[QCount] := i;
      End;
   SortQuadUp(ff,QCount);

   (* Quadrant 2 *)
   ff := QCount + 1;
   For i := 1 To N Do
      If (Points[i].X <= 0) And (Points[i].Y >= 0) Then Begin
         Inc(QCount);
         Quad[QCount] := i;
      End;
   SortQuadDown(ff, QCount);

   (* Quadrant 3 *)
   ff := QCount + 1;
   For i := 1 To N Do
      If (Points[i].X <= 0) And (Points[i].Y <= 0) Then Begin
         Inc(QCount);
         Quad[QCount] := i;
      End;
   SortQuadDown(ff, QCount);

   (* Quadrant 4 *)
   ff := QCount + 1;
   For i := 1 To N Do
      If (Points[i].X >= 0) And (Points[i].Y <= 0) Then Begin
         Inc(QCount);
         Quad[QCount] := i;
      End;
   SortQuadUp(ff, QCount);
End;

Procedure AddAngles;
Var i : Integer;
Begin
   For i := 1 To QCount - 1 Do AddAngle(Quad[i], Quad[i+1]);
   AddAngle(Quad[QCount], 1);
End;

Procedure SortAngles;
Var T : TAngle;
    i, j : Integer;
Begin
   For i := 1 To ACount - 1 Do
      For j := i + 1 To Acount Do
         If Angles[j].Angle < Angles[i].Angle Then Begin
            T := Angles[i];
            Angles[i] := Angles[j];
            Angles[j] := T;
         End;
End;

Procedure Output;
Var i : Integer;
Begin
   For i := 1 To ACount Do Begin
      If Angles[i].P1 > Angles[i].P2 Then
         WriteLn(Angles[i].P2, ' ', Angles[i].P1)
      Else WriteLn(Angles[i].P1, ' ', Angles[i].p2);
   End;
End;

Procedure Input;
Var i : Integer;
    XRel, YRel : Longint;
    XX, YY : Longint;
Begin
   ACount := 0;
   PCount := 0;
   ReadLn(N);
   ReadLn(XRel, YRel);
   For i := 1 To N Do Begin
      ReadLn(XX, YY);
      Inc(PCount);
      Points[PCount].X := XX - XRel;
      Points[PCount].Y := YY - YRel;
   End;
End;

BEGIN
   Input;
   SortPts;
   AddAngles;
   SortAngles;
   Output;
END.