#include <stdio.h>
#include <stdlib.h>

#define MAXN 10001
#define MAXV 65001

typedef struct SNasl TNasl;

struct SNasl{
        int V,W;
        struct SNasl* Next;
} ; 

typedef struct {
          struct SNasl *Nasl;
        }  TVex;

TVex Vex[MAXN];        
int N, M, V[MAXN], BestW = 0, Max;
int D[MAXN];

void Out(int R) {
     printf("%d\n", R);
     exit(0);
}

void Add(int a, int b, int W) { /* Dobavia a-b */
     TNasl *T;
     T = (TNasl *)malloc(sizeof(TNasl));
     T->V = b;
     T->W = W;     
     T->Next = Vex[a].Nasl;
     Vex[a].Nasl = T;
   
}

void DFS(int i) { 
   int j;
   TNasl *T;
   T = Vex[i].Nasl;
   V[i] = 1;
   while(T!=NULL) {
      j = T->V;
      if(!V[j]) DFS(j);
      T = T->Next;
   }
}

void Dijkstra(void) {
     int i, j, w, max, ind;
     TNasl *T;
     for(i=1; i<=N; i++) { D[i] = 0; V[i] = 0; }
     D[1] = MAXV;
     
     while(1) {
        max = 0;
        for(i=1; i<=N; i++) 
         if(!V[i] && D[i] > max) { max = D[i]; ind = i; }
         if(ind==N) break;
         V[ind] = 1;
         T = Vex[ind].Nasl;
         while(T!=NULL) { j=T->V; w=T->W; w = (max>w)?w:max;  if(D[j] < w) D[j] = w;  T=T->Next;}
         
     }    
}

void Init(void) {
     int i, j, k, w;
     scanf("%d %d", &N, &M);
     for(i=1; i<=N; i++) Vex[i].Nasl = NULL;
     for(k=1; k<=M; k++)
     {
       scanf("%d %d %d", &i, &j, &w); Add(i, j, w);
     } 
}


void Solve(void) {
   int i;
   for(i=1; i<=N; i++) V[i] = 0;
   DFS(1);
   if(!V[N]) Out(0); /* V edna komponenta li sa 1 i N ? */
   Dijkstra(); 
   Out(D[N]);
}

int main(void) {
    Init();
    Solve();
    return 0;
}

