Program ProbamDaMislim;
  Type Te = Byte;
       graph = ^Top;
       Sp = ^Rib1;
       Top = Record
               inf:Te;
               next:graph;
               nasl:Sp;
             End;
       Rib1 = Record
                link1:graph;
                width:Integer;
                link2:Sp;
              End;
  Var g,r,g1:graph;
      i,n,k,e:Integer;
      c,d:Te;
      p:Sp;

  Procedure Create(Var g:graph);
    Var i:Byte;
        u:graph;
  Begin
    Read(n);
    g:=nil;
    For i:=1 to n do
      Begin
        new(u);
        u^.inf:=i;
        u^.next:=g;
        u^.nasl:=nil;
        g:=u;
      End;
  End;


  Procedure PrintGraph(g:graph);
    Var t:Sp;
  Begin
   While g<>nil do
     Begin
       Write(g^.inf,'-->');
       t:=g^.nasl;
       While t<>nil do
         Begin
           Write(t^.link1^.inf,', ');
           t:=t^.link2;
         End;
       WriteLn;
       g:=g^.next;
     End;
  End;


  Procedure Found(a: Te; g: graph; Var u: graph);
  Begin
    u:=g;
    While (u^.inf<>a) do
      u:=u^.next;
  End;

  Procedure AddRib(a,b: Te; r:Integer; Var g: graph);
   Var u,v:graph;
       t:Sp;

  Begin
    Found(a,g,u);
    Found(b,g,v);
    new(t);
    t^.link2:=u^.nasl;
    t^.link1:=v;
    t^.width:=r;
    u^.nasl:=t;
  End;

  Procedure DelRib(a,b: Te; Var g: graph);
    Var u,v:graph;
        s,t:Sp;
  Begin
    Found(a,g,u);
    Found(b,g,v);
    t:=u^.nasl;
    While t^.link1<>v do
      Begin
        s:=t;
        t:=t^.link2;
      End;
    If t = u^.nasl Then
      Begin
        u^.nasl:=t^.link2;
        Dispose(t);
      End
    Else
      Begin
        s^.link2:=t^.link2;
        Dispose(t);
      End;
  End;

  Procedure DelGraph(Var g:graph; i:Integer);
    Var t:SP;
        u:graph;
  Begin
    u:=g;
    While u<>nil do
      Begin
        t:=u^.nasl;
        While t<>nil do
          Begin
            If t^.width=i Then DelRib(u^.inf,t^.link1^.inf,g);
            t:=t^.link2;
          End;

        u:=u^.next;
      End;
  End;


  Procedure AddTop(a:Te; Var g:graph);
    Var u:graph;
  Begin
    new(u);
    u^.inf:=a;
    u^.next:=g;
    u^.nasl:=nil;
    g:=u;
  End;

  Procedure PrintRib(g:graph);
    Var u:graph;
        t:Sp;
  Begin
    u:=g;
    While u<>nil do
      Begin
        t:=u^.nasl;
        While t<>nil do
          Begin
            Write(u^.inf,'-->');
            Write(t^.link1^.inf);
            t:=t^.link2;
            WriteLn;
          End;
        u:=u^.next;
      End;
  End;

  Procedure CopyGraph(g:graph; Var g1:graph);
    Var h,r:graph;
        t:Sp;
  Begin
    If g=nil Then g1:=nil
    Else
      Begin
        h:=g;
        While h<>nil do
          Begin
            new(r);
            r^.inf:=h^.inf;
            r^.next:=g1;
            r^.nasl:=h^.nasl;
            g1:=r;
            h:=h^.next;
          End;
      End;
  End;

  Function Rib(a,b:Te; g:graph): Boolean;
    Var u:graph;
        t:Sp;
  Begin
    Found(a,g,u);
    Rib:=False;
    t:=u^.nasl;
    While t<>nil do
      Begin
        If t^.link1^.inf = b Then Rib:=True;
        t:=t^.link2;
      End;
  End;

  Function Way(g:graph; a,b:Te): Boolean;
    Function W1(a:Te): Boolean;
      Var u:graph;
          s,t:Sp;
          b1:Boolean;
    Begin
      If a=b Then W1:=True
      Else
        If Rib(a,b,g) Then W1:=True
        Else
          Begin
            Found(a,g,u);
            t:=u^.nasl;
            If t=nil Then W1:=False
            Else
              Begin
                s:=t;
                u^.nasl:=nil;
                Repeat
                  b1:=W1(t^.link1^.inf);
                  t:=t^.link2;
                Until b1 or (t=nil);
                u^.nasl:=s;
                W1:=b1;
              End;
          End;
    End;
  Begin
    Way:=W1(a);
  End;




Begin
  Create(g);
  ReadLn(k);
  For i:=1 to k do
    Begin
      ReadLn(c,d,e);
      AddRib(c,d,e,g);
      AddRib(d,c,e,g);
    End;
  If not Way(g,1,n) Then Begin WriteLn('0'); halt End;
  i:=0;
  Repeat
    i:=i+1;
    DelGraph(G,i);

  Until not Way(g,1,n);
  WriteLn(i);




End.