#include <stdio.h>
#include <stdlib.h>

#define MAXN	16384
#define MAXM	32768

#define MIN(a,b) ( (a)<(b)?(a):(b) )

struct ss {
	int v1, v2;
	int w;
} s[MAXM];
int n, m;
int b[MAXN];
int d[MAXN];

int h[MAXN];
int p[MAXN];

int scmp(const void *a, const void *b) {
	if (((struct ss*)a)->v1 == ((struct ss*)b)->v1)
		return ((struct ss*)a)->v2 - ((struct ss*)b)->v2;
	return ((struct ss*)a)->v1 - ((struct ss*)b)->v1;
}

void read_data() {
	int i;
	
	scanf("%d%d", &n, &m);
	for (i = 0; i < m; i++) {
		scanf("%d%d%d", &s[2*i].v1, &s[2*i].v2, &s[2*i].w);
		s[2*i+1].v1 = s[2*i].v2;
		s[2*i+1].v2 = s[2*i].v1;
		s[2*i+1].w = s[2*i].w;
	}
	qsort(s, 2*m, sizeof(struct ss), scmp);
	b[s[0].v1 - 1] = 0;
	for (i = 1; i < 2*m; i++) {
		if (s[i].v1 != s[i-1].v1)
			b[s[i].v1-1] = i;
	}
}

void shift_up(int i) {
	int c;
	int t;

	c = i;
	while ((c > 1) && (d[h[c]] > d[h[c/2]])) {
		t = h[c];
		h[c] = h[c/2];
		h[c/2] = t;
		p[h[c]] = c;
		c /= 2;
	}
	p[h[c]] = c;
}

void shift_down(int i) {
	int c;
	int t;
	int q;

	c = i;
	while (c*2 < h[0]) {
		if (d[h[c*2]] > d[h[c*2+1]])
			q = c*2;
		else
			q = c*2+1;
		if (d[h[q]] > d[h[c]]) {
			t = h[c];
			h[c] = h[q];
			h[q] = t;
			p[h[c]] = c;
			c = q;
		} else
			break;
	}
	p[h[c]] = c;
}

void push(int a) {
	h[h[0]] = a;
	p[a] = h[0];
	shift_up(h[0]);
	h[0]++;
}

void pop() {
	h[0]--;
	h[1] = h[h[0]];
	h[h[0]] = MAXN - 1;
	shift_down(1);
}

void solve() {
        int i;
	int c;

	h[0] = 1;
	push(0);
	d[0] = 65500;
	while (h[0] > 1) {
		c = h[1];
		pop();

		for (i = b[c]; s[i].v1 == c + 1; i++) {
			if (d[s[i].v2 - 1] < MIN(d[c], s[i].w)) {
				d[s[i].v2-1] = MIN(d[c], s[i].w);
				if (p[s[i].v2-1] > 0)
					shift_up(p[s[i].v2-1]);
				else
					push(s[i].v2-1);
			}
		}
	}

	printf("%d\n", d[n-1]);
}

int main() {
	read_data();
	solve();
	return 0;
}
