#include <stdio.h>
#include <math.h>
#include <stdlib.h>

#define MAXN	2048
#define MIN(a, b) ( (a)<(b)?(a):(b) )
#define MAX(a, b) ( (a)>(b)?(a):(b) )
#define eps 0.000001

struct ps {
	int x, y;
	int n;
	double t;
} p[MAXN];
int c;

struct as {
	int v1, v2;
	double cs;
} a[MAXN];

int pcmp(const void *a, const void *b) {
	return ((struct ps*)a)->t - ((struct ps*)b)->t;
}

int acmp(const void *a, const void *b) {
	if (fabs(((struct as*)a)->cs - ((struct as*)b)->cs) < eps) {
		if (((struct as*)a)->v1 == ((struct as*)b)->v2)
			return ((struct as*)a)->v2 - ((struct as*)b)->v2;
			
		return ((struct as*)a)->v1 - ((struct as*)b)->v1;
	}
	return (((struct as*)a)->cs - ((struct as*)b)->cs<0?-1:1);
}

double dist(int a, int b) {
	return (p[a].x - p[b].x)*(p[a].x - p[b].x) +
		(p[a].y - p[b].y)*(p[a].y - p[b].y);
}

void read_data() {
	int i;
	
	scanf("%d", &c);
	scanf("%d%d", &p[0].x, &p[0].y);
	for (i = 1; i <= c; i++) {
		scanf("%d%d", &p[i].x, &p[i].y);
		p[i].x -= p[0].x;
		p[i].y -= p[0].y;
		p[i].t = atan2(p[i].y, p[i].x);
		p[i].n = i;
	}
}

void solve() {
        int i;
	int q;

	qsort(p + 1, c, sizeof(struct ps), pcmp);
	q = 0;
	for (i = 1; i < c; i++) {
		if ((p[i+1].t - p[i].t < M_PI) &&
			(p[i+1].x*p[i].y != p[i].x*p[i+1].y)) {
			a[q].v1 = MIN(p[i].n, p[i+1].n);
			a[q].v2 = MAX(p[i].n, p[i+1].n);
			a[q].cs = (dist(i, i+1) - dist(0, i) - dist(0, i+1))/
				(sqrt(dist(0, i))*sqrt(dist(0, i+1)));
			q++;
		}
	}
	if (p[c].t - p[1].t > M_PI) {
		a[q].v1 = MIN(p[1].n, p[c].n);
		a[q].v2 = MAX(p[1].n, p[c].n);
		a[q].cs = (dist(1, c) - dist(0, 1) - dist(0, c))/
				(sqrt(dist(0, 1))*sqrt(dist(0, c)));
		q++;
	}

	qsort(a, q, sizeof(struct as), acmp);

	for (i = 0; i < q; i++) {
		//printf("%f - ", a[i].cs);
		printf("%d %d\n", a[i].v1, a[i].v2);
	}
}

int main() {
	read_data();
	solve();
	return 0;
}
