#define MAX 2000

unsigned int max_points;
int orgin[2];
int point[MAX][2];
float vector[MAX][2];

void find_angles ()
{
    unsigned int i, j;

    for ( i = 0; i < max_points; i++ )
        for ( j = i + 1; j < max_points; j++ )
            printf ( "angle: %u, 0, %u\n", i + 1, j + 1 );
};

void create_vectors ( void )
{
    unsigned int i;
    float x, y, dest;

    for ( i = 0; i < max_points; i++ ) {
        x = point[i][0] - orgin[0];
        y = point[i][1] - orgin[1];

        dest = sqrt ( x*x + y*y );
        vector[i][0] = x / dest;
        vector[i][1] = y / dest;
    }
}

void sort_float_massive ( float *massive, unsigned int count, float *vector_massive )
{
    unsigned int i, j;
    float x;
    
    for ( i = 0; i < count; i++ ) {
        x = massive[i];
        j = i - 1;
        while ( massive[i] < massive[j] && j >= 0 ) {
          massive[j+1] = massive[j-1];
          vector_massive[(j+1)*2] = vector_massive[(j-1)*2];
          vector_massive[(j+1)*2 + 1] = vector_massive[(j-1)*2 + 1];
          j--;
        }
        massive[j+1] = massive[i];
        vector_massive[(j+1)*2] = vector_massive[i*2];
        vector_massive[(j+1)*2 + 1] = vector_massive[i*2 + 1];
    }
};

void sort_vectors ( void )
{
    float left_part_tg[MAX];
    float left[MAX][2];
    float right_part_tg[MAX];
    float right[MAX][2];
    float middle_uppart_tg[MAX];
    float middle_downpart_tg[MAX];
    float middle_up[MAX][2];
    float middle_down[MAX][2];
    unsigned int k = 0, l = 0, mu = 0, md = 0;
    unsigned int i;
    
    for ( i = 0; i < max_points; i++ ) {
        if ( vector[i][0] > 0 ) {
            right_part_tg[k] = vector[i][1] / vector[i][0];
            right[k][0] = vector[i][0];
            right[k][1] = vector[i][1];
            k++;
        }
        else if ( vector[i][0] < 0 ) {
            left_part_tg[l] = vector[i][1] / vector[i][0];
            left[l][0] = vector[i][0];
            left[l][1] = vector[i][1];
            l++;
        }
        else {
            if ( vector[i][1] > 0 ) {
                middle_uppart_tg[mu] = vector[i][1];
                middle_up[mu][0] = vector[i][0];
                middle_up[mu][1] = vector[i][1];
                mu++;
            }
            else {
                middle_downpart_tg[md] = vector[i][1];
                middle_down[md][0] = vector[i][0];
                middle_down[md][1] = vector[i][1];
                md++;
            }
        }
    }
    
    sort_float_massive ( right_part_tg, k, right);
    sort_float_massive ( left_part_tg, l, left );
};

void print_vectors ( void )
{
    unsigned int i;

    for ( i = 0; i < max_points; i++ ) {
        printf ( "vector %u: %3.2f, %3.2f\n", i, vector[i][0], vector[i][1] );
    }
};

main ()
{
    unsigned int i;

    printf ( "points: " );
    scanf ( "%u", &max_points );
    printf ( "orgin point: " );
    scanf ( "%u %u", &orgin[0], &orgin[1] );
    for ( i = 0; i < max_points; i++ ) {
        printf ( "ray point: " );
        scanf ( "%u %u", &point[i][0], &point[i][1] );
    }

//    find_angles ();

    create_vectors ();
    sort_vectors ();
    print_vectors ();

    getch ();
};
