#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#define MAX (1 << 11)

typedef struct  {
  double x, y;
  int n;
} pt;

typedef struct  {
  int x, y;
  double sz;
} ang;


pt p[MAX];
ang a[MAX];
int pn, an;

double area (pt p1, pt p2, pt p3)  {
  return p1.x * (p2.y - p3.y) + p2.x * (p3.y - p1.y) + p3.x * (p1.y - p2.y);
}

double dist (pt p1, pt p2)  {
  return hypot (p1.x - p2.x, p1.y - p2.y);
}

int qd (pt e)  {
  if (e.y >= 0 && e.x >  0) return 1;
  if (e.y >  0 && e.x <= 0) return 2;
  if (e.y <= 0 && e.x <  0) return 3;
  if (e.y <  0 && e.x >= 0) return 4;

  return 0;
}

int cmp (const void *e1, const void *e2)  {
  double t;

  if (((pt*)e1) -> y >= p[1].y && ((pt*)e2) -> y <  p[1].y) return -1;
  if (((pt*)e1) -> y <  p[1].y && ((pt*)e2) -> y >= p[1].y) return +1;

  t = area (p[1], *(pt*)e2, *(pt*)e1);

  if (t > 0) return +1;
  if (t < 0) return -1;
  return qd (*(pt*)e1) - qd (*(pt*)e2);
}

void init ()  {
  int i;

//freopen ("rays.in" , "r", stdin );
//freopen ("rays.out", "w", stdout);

  scanf ("%d", &pn);

  ++pn;

  for (i = 1; i <= pn; ++i)  {
	scanf ("%lf%lf", &p[i].x, &p[i].y);
	p[i].n = i - 1;
  }

  qsort (p + 2, pn - 1, sizeof(pt), cmp);
}

int cmp2 (const void *e1, const void *e2)  {
  double t;

  if (((ang*)e2) -> sz == ((ang*)e1) -> sz)
	return ((ang*)e1) -> x != ((ang*)e2) -> x ? ((ang*)e1) -> x - ((ang*)e2) -> x : ((ang*)e1) -> y - ((ang*)e2) -> y;

  t = ((ang*)e2) -> sz - ((ang*)e1) -> sz;

  if (t > 0) return +1;
  if (t < 0) return - 1;

  return 0;
}

void think ()  {
  int i, t, tt;

  for (i = 2; i <= pn; ++i)  {
    t = i == pn ? 2 : i + 1;
	if (area (p[i], p[1], p[t]) < 0)  {
	  ++an;

	  a[an].x = p[i].n;
	  a[an].y = p[t].n;

	  if (a[an].x > a[an].y)  {
		tt = a[an].x;
		a[an].x = a[an].y;
		a[an].y = tt;
	  }

	  a[an].sz  = ((p[i].x - p[1].x) * (p[t].x - p[1].x) + (p[i].y - p[1].y) * (p[t].y - p[1].y));
          a[an].sz /= dist (p[1], p[i]) * dist (p[1], p[t]);
	}
  }

  qsort (a + 1, an, sizeof(ang), cmp2);
}

void print ()  {
  int i;

  for (i = 1; i <= an; ++i)
    printf ("%d %d\n", a[i].x, a[i].y);
}


int main ()  {
  init ();
  think ();
  print ();

  return 0;
}
