/*
  NOI Oblasten krag, 2004
  GRUPA A
  ID: Nikolay Valtchanov
  SMG SOFIA
*/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define MAXN 2048
#define EPS 0.00001

typedef struct sang sang;
struct sang {
       int i, j;
       float cos;
};
int nang;

sang ang[MAXN];
int pts[MAXN];
int x[MAXN], y[MAXN];
int n;


int zero (float a) {
    return (a < EPS && a > -EPS);
};

float cwise (int i, int j, int k) {
    float r;
    r = x[i]*y[j]+x[j]*y[k]+x[k]*y[i]-x[j]*y[i]-x[k]*y[j]-x[i]*y[k];
    if (zero(r)) return 0;
    else return r;
}

int cmp1 (const void *i, const void *j) {
    float r;
    r = cwise(0,pts[*((int*)i)],pts[*((int *)j)]);
    if (zero(r)) return 0;
    if (r < 0) return 1;
    else return -1;
}

int cmp2 (const void *a, const void *b) {
    sang *p,*q; float r;
    p = (sang *)a; q = (sang *)b;
    r = q->cos-p->cos;
    if (!zero(r)) {
       if (r < 0) return -1;
       else return 1;
    }
    else {
         if (p->i > q->i || (p->i == q->i && p->j > q->j))
            return 1;
         else return -1;
    }
}

void read () {
     int i;
//     freopen("rays.in","r",stdin);
     scanf("%d",&n);
     for (i = 0; i <= n; i++)
         scanf("%d %d",&x[i],&y[i]);
}

void print () {
     int i;
     for (i = 0; i < nang; i++)
         printf("%d %d\n",ang[i].i,ang[i].j);
}

void solve () {
     int i,j; float a,b,c; sang t;
     
     for (i = 0; i < n; i++) pts[i] = i+1;
         
     qsort(pts,n,sizeof(int),cmp1);

     pts[n] = pts[0];
     /*
     for (i = 0; i < n; i++) {
         for (j = i+1; j <= n && cwise(0,pts[i],pts[j]) == 0; j++) ;
         do {
            if (j == n+1) break;
            
             if (cwise(pts[i],0,pts[j]) < 0) {
                if (pts[i] > pts[j]) {
                   ang[nang].i = pts[j];
                   ang[nang].j = pts[i];
                } else {
                  ang[nang].i = pts[i];
                  ang[nang].j = pts[j];
                }
                nang++;
             }
             
             j++;
         } while (j <= n && cwise(0,pts[j-1],pts[j]) == 0);
     } */

     for (i = 0; i < n; i++) {
         j = i+1;
         if (cwise(pts[i],0,pts[j]) < 0) {
                if (pts[i] > pts[j]) {
                   ang[nang].i = pts[j];
                   ang[nang].j = pts[i];
                } else {
                  ang[nang].i = pts[i];
                  ang[nang].j = pts[j];
                }
                nang++;
             }

         }

     for (i = 0; i < nang; i++) {
         c = hypot(x[ang[i].i]-x[ang[i].j],y[ang[i].i]-y[ang[i].j]);
         a = hypot(x[ang[i].i]-x[0],y[ang[i].i]-y[0]);
         b = hypot(x[0]-x[ang[i].j],y[0]-y[ang[i].j]);
         ang[i].cos = (a*a+b*b-c*c)/(2*a*b);
     }

/*
     for (i = 0; i < nang; i++)
         for (j = i+1; j < nang; j++)
             if (ang[i].cos < ang[j].cos) {
                t = ang[i];
                ang[i] = ang[j];
                ang[j] = t;
             }
*/
     qsort(ang,nang,sizeof(sang),cmp2);
}


int main () {
    read();
    solve();
    print();
    return 0;
}

