#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#define NMAX 2000

struct Point
{
  long int x;
  long int y;
};

struct angle
{
  float sin;
  float cos;
};

struct radVector
{
  int blank;
  int basePoint;
  long int x;
  long int y;
  float r;
  struct angle Fi;
};

Point A[NMAX+1];
radVector* vA[NMAX];
int n;
angle Angles[NMAX];

void InitVector()
{
  for(int i = 0; i < n; i++)
  {
    vA[i]->blank = 0;
    vA[i]->basePoint = i+1;
    vA[i]->x = A[i+1].x - A[0].x;
    vA[i]->y = A[i+1].y - A[0].y;
    vA[i]->r = sqrt(vA[i]->x*vA[i]->x + vA[i]->y*vA[i]->y);
    vA[i]->Fi.sin = vA[i]->y / vA[i]->r;
    vA[i]->Fi.cos = vA[i]->x / vA[i]->r;
  }
}

void getAngle(radVector *a, radVector *b, angle *result)
{
  result->sin = a->Fi.sin*b->Fi.cos - a->Fi.cos*b->Fi.sin;
  result->cos = a->Fi.cos*b->Fi.cos - a->Fi.sin*b->Fi.sin;
}

int cmpAngles(angle *a, angle *b)
{
  if(a->sin > b->sin)
  {
    if(b->cos >= 0) return -1;
    else return 1;
  }
  else if(a->sin < b->sin)
  {
    if(b->cos >= 0) return 1;
    else return -1;
  }
  return 0;
}

int cmp(const void *a, const void *b)
{
  radVector *p = (radVector *)a;
  radVector *q = (radVector *)b;
  return cmpAngles(&p->Fi, &q->Fi);
}

void sort()
{
  int MIN;
  radVector *t;
  for(int i = 0; i < n-1; i++)
  {
    MIN = i;
    for(int j = i+1; j < n; j++)
      if(cmpAngles(&vA[i]->Fi, &vA[j]->Fi) > 0)
        MIN = j;
    t = vA[i];
    vA[i] = vA[MIN];
    vA[MIN] = t;
  }
}

void main()
{
  int i, j;
  int MIN;
  scanf("%d", &n);
  for(i = 0; i < n; i++)
    vA[i] = (radVector *)malloc(sizeof(radVector));
  for(i = 0; i <= n; i++)
    scanf("%D %D", &A[i].x, &A[i].y);
  InitVector();
  qsort(vA[0], n, sizeof(vA[0]), cmp);
  vA[0]->basePoint = 1;
  //sort();
  for(j = 0; j < n-1; j++)
    getAngle(vA[j], vA[j+1], &Angles[j]);
  for(i = 0; i < n-1; i++)
  {
    MIN = i;
    for(j = i+1; j < n-1; j++)
      if(cmpAngles(&Angles[MIN], &Angles[j]) > 0)
        MIN = j;
    printf("%d %d\n", vA[MIN]->basePoint, vA[MIN+1]->basePoint);
    Angles[MIN].sin = 0.0;
    Angles[MIN].cos = -1.0;
  }
  free(vA);
}