#include <stdio.h>
#include <stdlib.h>

#define MAXN            10010
#define MAXM            100010
#define INF             2000000000

typedef struct s1
{
  int fr,to;
  int w;
} trebro;

typedef struct s2
{
  int ind;
  int val;

} hnode;


int n,m;
int brn[MAXN];
int *nasl[MAXN];
int *wnasl[MAXN];
trebro rebra[MAXM];
int dist[MAXN];
int vis[MAXN];
hnode heap[2*MAXN];
int count;
int hpos[MAXN];

void init()
{
  int i;

  for(i=0;i<MAXN;i++)
  {
    brn[i] = 0;
    dist[i] = 0;
    vis[i] = 0;
  }
}


void input()
{
  int i;
  int fr,to,w;

  scanf("%d %d",&n,&m);

  for(i=0;i<m;i++)
  {
    scanf("%d %d %d",&fr,&to,&w);

    rebra[i].fr = fr;
    rebra[i].to = to;
    rebra[i].w = w;

    brn[fr]++;
    brn[to]++;
  }

//  qsort(rebra,m,sizeof(trebro),cmp);
}

void MakeHeap()
{
  count = 1;
}

void InsertAll()
{
  int i;

  heap[1].ind = 1;
  heap[1].val = INF;
  hpos[1] = 1;

  for(i=2;i<=n;i++)
  {
    heap[i].ind = i;
    heap[i].val = 0;
    hpos[i] = i;
  }

  count = n+1;
}

int Pop()
{
  int save;
  int ind,nind;
  hnode buf;

  save = heap[1].ind;

  heap[1] = heap[count-1];
  hpos[heap[1].ind] = 1;
  count--;

  ind = 1;

  while(ind*2<count)
  {
    nind = ind*2;

    if(nind+1<count)
      if(heap[nind].val<heap[nind+1].val)
        nind++;

    if(heap[nind].val>heap[ind].val)
    {
      buf = heap[nind];
      heap[nind] = heap[ind];
      heap[ind] = buf;

      hpos[heap[ind].ind] = ind;
      hpos[heap[nind].ind] = nind;

      ind = nind;
    }
    else
      break;
  }

  return (save);
}

void Update(int num)
{
  int ind;
  hnode buf;

  ind = hpos[num];
  heap[ind].val = dist[num];

  while(ind>1)
  {
    if(heap[ind].val>heap[ind/2].val)
    {
      buf = heap[ind];
      heap[ind] = heap[ind/2];
      heap[ind/2] = buf;

      hpos[heap[ind].ind] = ind;
      hpos[heap[ind/2].ind] = ind/2;

      ind/=2;
    }
    else
      break;
  }

}

void output()
{
  if(dist[n]!=INF)
    printf("%d\n",dist[n]);
  else
    printf("%d\n",0);

  exit(0);
}

void Dijkstra()
{
  int i;
  int curb;
  hnode tmp;
  int tind,tval;
  int min;

  MakeHeap();
  dist[1] = INF;

  InsertAll();

  while(count>1)
  {
    curb = Pop();

    if(dist[curb]==0 || count==0)
      break;

    if(curb==n)
      output();

    for(i=0;i<brn[curb];i++)
    {
      tind = nasl[curb][i];
      tval = wnasl[curb][i];
      min = dist[curb];
      if(min>tval)
        min = tval;

      if(dist[tind]<min)
      {
        dist[tind] = min;
        Update(tind);
      }
    }

  }
}

void solve()
{
  int i;
  int fr,to,w;

  for(i=1;i<=n;i++)
  {
    nasl[i] = (int*)malloc(sizeof(int)*(brn[i]+2));
    wnasl[i] = (int*)malloc(sizeof(int)*(brn[i]+2));
    brn[i] = 0;
  }

  for(i=0;i<m;i++)
  {
    fr = rebra[i].fr;
    to = rebra[i].to;
    w = rebra[i].w;

    nasl[fr][brn[fr]] = to;
    wnasl[fr][brn[fr]] = w;
    brn[fr]++;

    nasl[to][brn[to]] = fr;
    wnasl[to][brn[to]] = w;
    brn[to]++;
  }



  Dijkstra();

}

int main()
{

//  printf("Reading from file...\n");
//  freopen("fasttest.inp","r",stdin);

  init();
  input();
  solve();
  output();

  return 0;
}

