#include <stdio.h>
#include <stdlib.h>

#define MAXN 11000
#define MAXM 100100
#define INF 2000000000

typedef struct {
	int dist,index;
} HS;

typedef struct {
	int x,y,w;
} TS;

HS heap[MAXN];
int pos[MAXN];
int m,n,size;
int start[MAXN],end[MAXN];
int par[MAXN];
TS t[2*MAXM];

int parent(int index) { return index/2; }
int left(int index) { return 2*index; }
int right(int index) { return 2*index+1; }

void hup(int index) {
int p = parent(index);
	while (p>=1) {
		if (heap[p].dist<heap[index].dist) {
		HS tmp = heap[p];
			heap[p] = heap[index];
			heap[index] = tmp;
			pos[heap[index].index] = index;
			pos[heap[p].index] = p;
			index = p;
			p = parent(index);
		} else return;
	}
}

void hdown(int index) {
int l=left(index),r=right(index),best;
HS tmp;
	while (index<=size) {
		best = index;
		l = left(index);
		r = right(index);
		if (l<=size && heap[l].dist>heap[best].dist)
			best = l;
		if (r<=size && heap[r].dist>heap[best].dist)
			best = r;
		if (best==index) break;
		tmp = heap[best];
		heap[best] = heap[index];
		heap[index] = tmp;
		pos[heap[index].index] = index;
		pos[heap[best].index] = best;
		index = best;
	}
}

int _min(int a,int b) {
	return (a<b)?a:b;
}

void hadd(int index,int value) {
	heap[size+1].index=index;
	heap[size+1].dist=value;
	pos[index] = size+1;
	size++;
	hup(size);
}

void hpop() {
	pos[heap[1].index] = -1;
	heap[1] = heap[size];
	size--;
	hdown(1);
}

int binsearch(int x,int y) {
int l = 0;
int r = 2*m;
int mid;
	while (l<=r) {
		mid = (l+r)/2;
		if (t[mid].x==x && t[mid].y==y) return mid;
		if ((t[mid].x==x && t[mid].y<y) || t[mid].x<x)
			l = mid+1;
		if ((t[mid].x==x && t[mid].y>y) || t[mid].x>x)
			r = mid-1;
	}
	return -1;
}

int maxflow() {
int dist,p,ind,i,npos,flow,x,pos1,pos2,index;
int sumflow = 0;
/*	while (1) {
		*/heap[1].index = 1;
		heap[1].dist=INF;
		pos[1] = 1;
		for (i=2;i<=n;i++) {
			heap[i].index=i;
			heap[i].dist=0;
			pos[i] = i;
		}
		size = n;
		while (size>=1) {
			dist = heap[1].dist;
			ind = heap[1].index;
			if (ind==n) break;
			hpop();
			for (i=start[ind];i<=end[ind];i++) {
				p = pos[t[i].y];
				if (p==-1) continue;
				if (heap[p].dist<_min(t[i].w,dist)) {
					heap[p].dist= _min(t[i].w,dist);
					par[heap[p].index] = ind;
					hup(p);
				}
			}
		}
		npos = pos[n];
		flow = heap[npos].dist;
		return flow;
/*
		if (flow==0) break;		
		sumflow+=flow;
		index = n;
		while (index!=1) {
			x = par[index];
			pos1 = binsearch(index,x);
			pos2 = binsearch(x,index);
			t[pos1].w+=flow;
			t[pos2].w-=flow;
			index = x;
		}
	}*/
	return sumflow;
}

int cmp(const void *a, const void *b) {
int ax = ((TS *)a)->x;
int ay = ((TS *)a)->y;
int bx = ((TS *)b)->x;
int by = ((TS *)b)->y;
	if (ax==bx)
		return ay-by;
	else
		return ax-bx;
}



int main () {
int i;
	//FILE *f = fopen ( "fast.in" , "r");
	scanf("%d%d",&n,&m);
	for (i=0;i<m;i++) {
		scanf("%d%d%d",&t[i].x,&t[i].y,&t[i].w);
		t[m+i].x = t[i].y;
		t[m+i].y = t[i].x;
		t[m+i].w = t[i].w;
	}
	//fclose(f);
	qsort(t,2*m,sizeof(TS),cmp);
	start[t[0].x] = 0;
	for (i=1;i<2*m;i++) 
		if (t[i].x!=t[i-1].x) {
			start[t[i].x] = i;
			end[t[i-1].x] = i-1;
		}
	end[t[2*m-1].x]=2*m-1;
//	printf("%d\n%d\n%d\n%d\n",binsearch(1,2),binsearch(5,3),binsearch(3,4),binsearch(4,3));
	printf("%d\n",maxflow());
	return 0;
}