#include <stdio.h>
#include <math.h>
#include <stdlib.h>

#define EPS 0.00001
#define MAXP 2048

typedef struct {
	int x,y,index;
	long double alpha;
} TS;

typedef struct {
	long double alpha;
	int r1,r2;
} TS2;

TS m[MAXP];
TS2 a[MAXP];

int diff(long double a,long double b) {
	return (a!=b);
}

int cmp(const void *a,const void *b) {
long double alpha1 = ((TS *)a)->alpha;
long double alpha2 = ((TS *)b)->alpha;
	if (alpha1>alpha2)
		return 1;
	else
		return -1;
}

int cmp2(const void *a,const void *b) {
long double alpha1 = ((TS2 *)a)->alpha;
long double alpha2 = ((TS2 *)b)->alpha;
int ar1 = ((TS2 *)a)->r1;
int ar2 = ((TS2 *)a)->r2;
int br1 = ((TS2 *)b)->r1;
int br2 = ((TS2 *)b)->r2;

	if (!diff(alpha1,alpha2)) {
		if (ar1==br1)
			return ar2-br2;
		else
			return ar1-br1;
	} else {
		if (alpha1>alpha2)
			return 1;
		else
			return -1;
	}
}


int main () {
int i,n,x0,y0,count,next,start;
long double PI;
int can;
	//FILE *f = fopen ( "rays.in" , "r");
	PI = atan2(0,-1);
	scanf("%d%d%d",&n,&x0,&y0);
	for (i=0;i<n;i++) {
		scanf("%d%d",&m[i].x,&m[i].y);
		m[i].alpha = atan2(m[i].y-y0,m[i].x-x0);
		if (m[i].alpha<0)
			m[i].alpha+=2*PI;
		m[i].index = i;
	}
	//fclose(f);
	can = 0;
	qsort(m,n,sizeof(TS),cmp);
	for (i=0;i<n-1;i++) 
		if (diff(m[i].alpha,m[i+1].alpha)) {
			can = 1;
			break;
		}
	if (!can) return 0;
	count = 0;
	for (i=0;i<n;i++) {
		next = (i+1)%n;
		while (m[next].alpha == m[i].alpha) {
			next++;
			next%=n;
		}
		start = next;
		while (!diff(m[start].alpha,m[next].alpha)) {
			a[count].alpha = m[start].alpha-m[i].alpha;
			if (a[count].alpha>PI) a[count].alpha=2*PI-a[count].alpha;
			if (a[count].alpha<0) a[count].alpha+=2*PI;
			if (a[count].alpha>2*PI) a[count].alpha-=2*PI;
			if (a[count].alpha>=PI) {
				start++;
				continue;
			}
			a[count].r1 = m[i].index;
			a[count].r2 = m[start].index;
			if (a[count].r2<a[count].r1) {
			int tmp = a[count].r2;
				a[count].r2 = a[count].r1;
				a[count].r1 = tmp;
			}
			count++;
			start++;
		}
	}
	qsort(a,count,sizeof(TS2),cmp2);
	for (i=0;i<count;i++) 
		if (
			diff(a[i].alpha,0) && 
			diff(a[i].alpha,PI) && 
			(
				(i==0) || 
				(i>0 && 
					(a[i].r1!=a[i-1].r1 || 
					a[i].r2!=a[i-1].r2)
				)
			)
		   )
			printf("%d %d\n",a[i].r1+1,a[i].r2+1);
	return 0;
}