/*
PROG : fast
NAME : vladimir nedev
*/

//#define DEBUG

#include <stdio.h>

#define IN              "FAST.IN"
#define OUT             "FAST.OUT"
#define MAXN            10100
#define MAXM            100100
#define INF             0x7fffffff
#define min(a,b)        (((a)<(b))?(a):(b))

long n, m;
long *list[MAXN], *list_weight[MAXN], count[MAXN];

long ribs[MAXM][3];
long best[MAXN], used[MAXN];

void deikstra()
{
   long i, j, max, maxind, v, wei, tmp;

   best[0]=INF;

   for(i=0; i<n; i++)
   {
      max=0;
      maxind=-1;

      for(j=0; j<n; j++)
         if(!used[j] && best[j]>max)
         {
           max=best[j];
           maxind=j;
         }

      if(maxind==-1)
        break;
      used[maxind]=1;

      for(j=0; j<count[maxind]; j++)
      {
         v=list[maxind][j];
         wei=list_weight[maxind][j];
         tmp=min(best[maxind], wei);

         if(best[v]<tmp)
           best[v]=tmp;
      }
   }
}

int main()
{
   long i, j, v1, v2, wei;

#ifdef DEBUG
   freopen(IN, "r", stdin);
#endif
   scanf("%ld%ld", &n, &m);
   for(i=0; i<m; i++)
   {
      scanf("%ld%ld%ld", &v1, &v2, &wei);
      v1--;
      v2--;

      count[v1]++;
      count[v2]++;

      ribs[i][0]=v1;
      ribs[i][1]=v2;
      ribs[i][2]=wei;
   }
#ifdef DEBUG
   fclose(stdin);
#endif

   for(i=0; i<n; i++)
      if(count[i])
      {
        list[i]=(long*)malloc(sizeof(long)*count[i]);
        list_weight[i]=(long*)malloc(sizeof(long)*count[i]);
        count[i]=0;
      }

   for(i=0; i<m; i++)
   {
      v1=ribs[i][0];
      v2=ribs[i][1];
      wei=ribs[i][2];

      list[v1][count[v1]]=v2;
      list_weight[v1][count[v1]]=wei;
      count[v1]++;

      list[v2][count[v2]]=v1;
      list_weight[v2][count[v2]]=wei;
      count[v2]++;
   }

   deikstra();

   printf("%ld\n", best[n-1]);

   for(i=0; i<n; i++)
      if(count[i])
      {
        free((void*)list[i]);
        free((void*)list_weight[i]);
      }

   return 0;
}

