/*
PROG : rays
NAME : vladimir nedev
*/

#include <stdio.h>
#include <math.h>
#include <stdlib.h>

//#define DEBUG

#define IN      "RAYS.IN"
#define OUT     "RAYS.OUT"
#define MAX     2010
#define EPS     0.0000000001

#define DIST(x1, y1, x2, y2)    sqrt((x1-x2)*(x1-x2) + (y1-y2)*(y1-y2))
#define DIST_SQR(x1, y1, x2, y2) ((x1-x2)*(x1-x2) + (y1-y2)*(y1-y2))

long n, res_num;
long x[MAX], y[MAX], sorted[MAX];
double dot_cos[MAX];

short valid[MAX*MAX][2];
double angle[MAX];

long list[MAX][2], list_count, where[MAX];

long face(long x1, long y1, long x2, long y2, long x3, long y3)
{return x1*(y2-y3) + x2*(y3-y1) + x3*(y1-y2);}

void generate_lists()
{
   long i, j, k, first, second;

   for(i=0; i<n-1; i++)
   {
      first=sorted[i];
      second=sorted[i+1];
      j=i+1;

      while(j<n && face(x[0], y[0], x[first], y[first], x[second], y[second])==0)
      {
        if(y[second]<y[0] && y[first]>y[0] ||
          (y[second]==y[0] && y[first]==y[0] && x[second]<x[0] && x[first]>x[0]))
        {
          break;
        }

        j++;
        first=second;
        second=sorted[j];
      }

      list[list_count][0]=i;
      list[list_count][1]=j-1;
      list_count++;

      for(k=i; k<j; k++)
         where[sorted[k]]=list_count-1;

      i=j-1;
   }

   if(i==n-1)
   {
     list[list_count][0]=n-1;
     list[list_count][1]=n-1;
     list_count++;

     where[sorted[n-1]]=list_count-1;
   }
}

void add(long l1, long l2)
{
   long i, j, first, second;

   first=sorted[list[l1][0]];
   second=sorted[list[l2][0]];

   if(face(x[0], y[0], x[first], y[first], x[second], y[second]) > 0)
   {
     for(i=list[l1][0]; i<=list[l1][1]; i++)
        for(j=list[l2][0]; j<=list[l2][1]; j++)
        {
           first=sorted[i];
           second=sorted[j];

           if(first<second)
           {
             valid[res_num][0]=first;
             valid[res_num][1]=second;
           }
           else
           {
             valid[res_num][0]=second;
             valid[res_num][1]=first;
           }

           res_num++;
        }
   }
}

void do_lists()
{
   long i;

   for(i=0; i<list_count-1; i++)
      add(i, i+1);

   add(list_count-1, 0);
}

int angle_cmp(const void *el1, const void *el2)
{
   short *d1, *d2, t1, t2, t3, t4, l1, l2;
   double a1, a2;
   d1=(short*)el1;
   d2=(short*)el2;

   t1=d1[0];
   t2=d1[1];

   t3=d2[0];
   t4=d2[1];

   l1=where[t1];
   if(where[t2]<l1) l1=where[t2];

   if((where[t1]==0&&where[t2]==list_count-1)
      ||
      (where[t2]==0&&where[t1]==list_count-1))
   {
    l1=list_count-1;
   }

   l2=where[t3];
   if(where[t4]<l2)l2=where[t4];

   if((where[t3]==0&&where[t4]==list_count-1)
      ||
      (where[t4]==0&&where[t3]==list_count-1))
   {
    l2=list_count-1;
   }

   if(fabs(angle[l1]-angle[l2])<EPS)
   {
     if(t1<t3) return -1;
     else
       if(t1>t3) return 1;
       else
       {
         if(t2<t4)
           return -1;
         else
           if(t2>t4)
             return 1;
           else
             return 0;
       }
   }
   else
     if(angle[l1]>angle[l2])
       return -1;
     else
       return 1;
}

double cos_theorem(long x1, long y1, long x2, long y2, long x3, long y3)
{
   double a, b, c;

   a=DIST_SQR(x2, y2, x3, y3);
   b=DIST_SQR(x1, y1, x2, y2);
   c=DIST_SQR(x1, y1, x3, y3);

   return (a-b-c)/(-(2*sqrt(b)*sqrt(c)));
}

void sort_stuff()
{
   long i;

   for(i=0; i<list_count-1; i++)
      angle[i]=cos_theorem(x[0], y[0], x[sorted[list[i][0]]], y[sorted[list[i][0]]],
                                       x[sorted[list[i+1][0]]], y[sorted[list[i+1][0]]]);

   if(list_count>1)
     angle[i]=cos_theorem(x[0], y[0], x[sorted[list[i][0]]], y[sorted[list[i][0]]],
                          x[sorted[list[0][0]]], y[sorted[list[0][0]]]);

   qsort(valid, res_num, sizeof(short)*2, angle_cmp);
}

int cos_cmp(const void *el1, const void *el2)
{
   long i1=*((long*)el1);
   long i2=*((long*)el2);
   long pro, d1, d2;

   d1=y[i1]-y[0];
   d2=y[i2]-y[0];
   pro=d1*d2;

   if(pro>0)
   {
     if(d1>0)
     {
       if(fabs(dot_cos[i1]-dot_cos[i2])<EPS)
         return 0;
       else
         if(dot_cos[i1] > dot_cos[i2]) return -1;
         else
           return 1;
     }
     else
     {
       if(fabs(dot_cos[i1]-dot_cos[i2])<EPS)
         return 0;
       else
         if(dot_cos[i1] < dot_cos[i2]) return -1;
         else
           return 1;
     }
   }
   else
     if(pro<0)
     {
       if(d1>0) return -1;
       else     return 1;
     }
     else
     {
       if(d1==0 && d2==0)
       {
         if(x[i1]>x[i2]) return -1;
         else            return 1;
       }
       else
         if(d1==0)
         {
           if(x[i1]>x[0])
             return -1;

           if(y[i2]>=y[0]) return 1;
           else            return -1;
         }
         else
         {
           if(x[i2]>x[0])
             return 1;

           if(y[i1]>=y[0]) return -1;
           else            return 1;
         }
     }
}

void solve()
{
   long i, j, first, second;

   for(i=1; i<=n; i++)
   {
      dot_cos[i]=((double)(x[i]-x[0]))/DIST(x[0], y[0], x[i], y[i]);
      sorted[i-1]=i;
   }

   qsort(sorted, n, sizeof(long), cos_cmp);

   generate_lists();

   do_lists();

   sort_stuff();
}

int main()
{
   long i;

#ifdef DEBUG
   freopen(IN, "r", stdin);
#endif
   scanf("%ld", &n);
   for(i=0; i<=n; i++)
      scanf("%ld%ld", x+i, y+i);
#ifdef DEBUG
   fclose(stdin);
#endif

   solve();

#ifdef DEBUG
   freopen(OUT, "w", stdout);
#endif
   for(i=0; i<res_num; i++)
      printf("%ld %ld\n", valid[i][0], valid[i][1]);

#ifdef DEBUG
   fclose(stdout);
#endif

   return 0;
}

