#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAXN 10050
#define MAXM 100050
#define INF 70000

#define LEFT(a) (2*(a + 1) - 1)
#define RIGHT(a) (2*(a + 1))
#define MIN(a,b) ((a) > (b) ? (b) : (a))
#define PARENT(a) ((a - 1) / 2)

int n,m;
int *nasl[MAXN], *len[MAXN], br_nasl[MAXN];
int rbs[MAXM][3];

int dist[MAXN];
int heap[MAXN];
int back_heap[MAXN];
int heap_size;

/*
 *   Heap functions
 */
void PushDown(int pos)
  {
    int next,tmp;
    while (1)
      {
        next = pos;
        if (LEFT(pos)  < heap_size && dist[heap[next]] < dist[heap[LEFT(pos)]])  next = LEFT(pos);
        if (RIGHT(pos) < heap_size && dist[heap[next]] < dist[heap[RIGHT(pos)]]) next = RIGHT(pos);
        if (next == pos) break;
        back_heap[heap[pos]]  = next;
        back_heap[heap[next]] = pos;

        tmp        = heap[pos];
        heap[pos]  = heap[next];
        heap[next] = tmp;

        pos = next;
      }
  }

void PushUp(int pos)
  {
    int tmp;
    while (pos && dist[heap[pos]] > dist[heap[PARENT(pos)]])
      {
        back_heap[heap[pos]]         = PARENT(pos);
        back_heap[heap[PARENT(pos)]] = pos;

        tmp               = heap[pos];
        heap[pos]         = heap[PARENT(pos)];
        heap[PARENT(pos)] = tmp;

        pos = PARENT(pos);
      }
  }

/*
 *   Init all data and read input
 */
void Init()
  {
    int i;

    memset(br_nasl,0,sizeof(br_nasl));
//    freopen("fast.in","rt",stdin);
    scanf("%d%d",&n,&m);
    for (i = 0;i < m;i++)
      {
        scanf("%d%d%d",&rbs[i][0],&rbs[i][1],&rbs[i][2]);
        rbs[i][0]--;
        rbs[i][1]--;
        br_nasl[rbs[i][0]]++;
        br_nasl[rbs[i][1]]++;
      }
    for (i = 0;i < n;i++)
      {
        nasl[i] = (int*)malloc(sizeof(int)*br_nasl[i]);
        len[i]  = (int*)malloc(sizeof(int)*br_nasl[i]);
        br_nasl[i] = 0;
      }
    for (i = 0;i < m;i++)
      {
        nasl[rbs[i][0]][br_nasl[rbs[i][0]]]   = rbs[i][1];
        len [rbs[i][0]][br_nasl[rbs[i][0]]++] = rbs[i][2];

        nasl[rbs[i][1]][br_nasl[rbs[i][1]]]   = rbs[i][0];
        len [rbs[i][1]][br_nasl[rbs[i][1]]++] = rbs[i][2];
      }
  }


/*
 *  Run diikstra with heap!
 */
void Solve()
  {
    int i;
    memset(dist,0,sizeof(dist));
    dist[0] = INF;

    // Build the heap
    for (i = 0;i < n;i++) heap[i] = back_heap[i] = i;
    heap_size = n;

    // Run the algorithm
    while (heap_size)
      {
        int max = heap[0];
        // Extract the minimal element
        if (dist[max] == 0) break;
        heap[0] = heap[--heap_size];
        PushDown(0);

        // Process all edges
        for (i = 0;i < br_nasl[max];i++)
          if (dist[nasl[max][i]] < MIN(dist[max],len[max][i]))
            {
               dist[nasl[max][i]] = MIN(dist[max],len[max][i]);
               PushUp(back_heap[nasl[max][i]]);
            }
      }
  }

void Output()
  {
    printf("%d\n",dist[n - 1]);
  }

int main()
  {
    Init();
    Solve();
    Output();
    return 0;
  }
