#include <stdio.h>
#include <math.h>

#define MAXN 2050
#define EPS 0.000000000001
#define ABS(a) ((a) > 0 ? (a) : (-(a)))

typedef struct
  {
    int x,y;
    double angle;
    int index;
  } SRay;

typedef struct
  {
    int i1,i2;
    double angle;
  } SAngle;

SRay rays[MAXN];
int base[2];
int n;
SAngle angles[MAXN];
int a_br = 0;

int cmp(const void *a,const void *b)
  {
    int S = ((SRay*)a)->x*((SRay*)b)->y - ((SRay*)a)->y*((SRay*)b)->x;
    if (S > 0) return -1;
    if (S < 0) return 1;
    if (S == 0) return ((SRay*)b)->index - ((SRay*)a)->index;
  }

int cmpa(const void *a,const void *b)
  {
    if (((SAngle*)a)->angle > ((SAngle*)b)->angle) return 1;
    if (((SAngle*)a)->angle < ((SAngle*)b)->angle) return -1;
    if (((SAngle*)a)->i1 < ((SAngle*)b)->i1) return -1;
    if (((SAngle*)a)->i1 > ((SAngle*)b)->i1) return 1;
    return (((SAngle*)a)->i2 - ((SAngle*)b)->i2);
  }

void Init()
  {
    int i;

//    freopen("rays.in","rt",stdin);
    scanf("%d",&n);
    scanf("%d%d",&base[0],&base[1]);
    for (i = 0;i < n;i++)
      {
        scanf("%d%d",&rays[i].x,&rays[i].y);
        rays[i].index = i + 1;
        rays[i].x -= base[0];
        rays[i].y -= base[1];
      }
  }

double FindAngle(int i1,int i2)
  {
    double res1,res2;
    res1 = atan2(rays[i1].y,rays[i1].x);
    res2 = atan2(rays[i2].y,rays[i2].x);
    return res2 - res1;
  }

void Solve()
  {
    int i,j,k;

    qsort(rays,n,sizeof(rays[0]),cmp);

    for (i = 0;i < n;i++)
        {
          double angle = FindAngle(i,(i + 1) % n),angle2;
          if (angle < -M_PI) angle += 2*M_PI;
          if (angle > 0 && angle < M_PI && rays[i].index < rays[(i + 1) % n].index)
            {
              angles[a_br].i1 = rays[i].index;
              angles[a_br].i2 = rays[(i + 1) % n].index;
              angles[a_br++].angle = angle;

              k = (i - 1 + n) % n;
              angle2 = FindAngle(k,i);
              while (ABS(angle2) < EPS)
                {
                  if (rays[k].index < rays[(i + 1) % n].index)
                    {
                      angles[a_br].i1 = rays[k].index;
                      angles[a_br].i2 = rays[(i + 1) % n].index;
                      angles[a_br++].angle = angle;
                    }
                  k = (k - 1 + n) % n;
                  angle2 = FindAngle(k,i);
                }

              k = (i + 2) % n;
              angle2 = FindAngle((i + 1) % n,k);
              while (ABS(angle2) < EPS)
                {
                  if (rays[i].index < rays[k].index)
                    {
                      angles[a_br].i1 = rays[i].index;
                      angles[a_br].i2 = rays[k].index;
                      angles[a_br++].angle = angle;
                    }
                  k = (k + 1) % n;
                  angle2 = FindAngle((i + 1) % n,k);
                }
             }
        }

     qsort(angles,a_br,sizeof(angles[0]),cmpa);
  }

void Output()
  {
    int i;

    for (i = 0;i < a_br;i++)
      printf("%d %d\n",angles[i].i1,angles[i].i2);
  }

int main()
  {
    Init();
    Solve();
    Output();
    return 0;
  }
