#include <algorithm>
#include <cmath>
#include <iostream>

using namespace std;

typedef double Real;

const Real eps = 0.0001;//JG suffix?

class Point {
	public:
	Real x;
	Real y;
};

inline istream& operator >>(istream& is, Point& p) {
	return is >> p.x >> p.y;
}

int N;
Point A[2000];//JG 2000?
Point B[2000];
Real ang1[2000];
int p[2000];
Point ang_pa[2000];
Point ang_pb[2000];
int ang_ia[2000];
int ang_ib[2000];
Real ang_cos[2000];
int ang_p[2000];
int pp;

inline Real sqr(Real x) {
	return x * x;
}

int mycmp(const void* p1, const void* p2) {
	Real ang_a = ang1[*reinterpret_cast<const int *>(p1)];
	Real ang_b = ang1[*reinterpret_cast<const int *>(p2)];
	if (abs(ang_a - ang_b) <= eps) {
		return 0;
	}
	if(ang_a < ang_b) return -1;
	return +1;
}


int mycmp2(const void* p1, const void* p2) {
	Real cos_a = ang_cos[*reinterpret_cast<const int *>(p1)];
	Real cos_b = ang_cos[*reinterpret_cast<const int *>(p2)];
	if (abs(cos_a - cos_b) <= eps) {
		return 0;
	}
	if (cos_a > cos_b) return -1;
	return +1;
}

Real f(const Point& p, const Point& p1, const Point& p2) {
	return (p1.y - p2.y) * p.x + (p2.x - p1.x) * p.y + p1.x * p2.y - p2.x * p1.y;
}

Real calcSin(const Point& p1, const Point& p0, const Point& p2) {
	Real Ax = p1.x - p0.x;
	Real Ay = p1.y - p0.y;
	Real Bx = p2.x - p0.x;
	Real By = p2.y - p0.y;
	Real lenA = sqrt(sqr(Ax) + sqr(Ay));
	Real lenB = sqrt(sqr(Bx) + sqr(By));
	Real cp = Ax * By - Bx * Ay;
	return cp / (lenA * lenB);
}

Real calcCos(const Point& p1, const Point& p0, const Point& p2) {
	Real Ax = p1.x - p0.x;
	Real Ay = p1.y - p0.y;
	Real Bx = p2.x - p0.x;
	Real By = p2.y - p0.y;
	Real lenA = sqrt(sqr(Ax) + sqr(Ay));
	Real lenB = sqrt(sqr(Bx) + sqr(By));
	Real dp = Ax * Bx + Ay * By;
	return dp / (lenA * lenB);
}

int main() {
	/*
	double y = -10;
	double x = 0;
	cout << atan2(y, x) / PI << "*pi" << '\n';
	*/
	cin >> N;
	for (int i = 0; i <= N; i++) {
		cin >> A[i];
	}

	for (int i = 1; i <= N; i++) {
		ang1[i] = atan2(A[i].y, A[i].x);
	}

	for (int i = 1; i <= N; i++) {
		p[i] = i;
	}
	/*
	for (int i = 1; i <= N; i++) {
		cout << "ang1[" << i << "]=" << ang1[i] << '\n';
	}
	*/
	
	qsort(p + 1, N, sizeof(int), mycmp);
	/*
	for (int i = 1; i < N; i++) {
		cout << "p[" << i << "]=" << p[i] << '\n';
	}
	*/

	pp = 0;
	for (int i = 1; i <= N - 1; i++) {
		int ia = p[i];
		int ib = p[i + 1];
		Point pa = A[ia];
		Point pb = A[ib];
		if (abs(f(A[0], pa, pb)) <= eps) continue;
		Real tmp_sin = calcSin(pa, A[0], pb);
		if (tmp_sin < 0) continue;//JG ygyl po-golqm ot 180 gradusa
		ang_ia[pp] = ia;
		ang_ib[pp] = ib;
		ang_pa[pp] = pa;
		ang_pb[pp] = pb;
		pp++;
	}
	if (true) {
		int ia = p[N];
		int ib = p[1];
		Point pa = A[ia];
		Point pb = A[ib];
		if (abs(f(A[0], pa, pb)) <= eps) goto xyz;
		Real tmp_sin = calcSin(pa, A[0], pb);
		if (tmp_sin < 0) goto xyz;//JG ygyl po-golqm ot 180 gradusa
		ang_ia[pp] = ia;
		ang_ib[pp] = ib;
		ang_pa[pp] = pa;
		ang_pb[pp] = pb;
		pp++;
	}
	xyz:

	/*
	for (int i = 0; i < pp; i++) {
		cout << "ang_ia[" << i << "]=" << ang_ia[i] << '\n';
		cout << "ang_ib[" << i << "]=" << ang_ib[i] << '\n';
	}
	*/
	for (int i = 0; i < pp; i++) {
		ang_cos[i] = calcCos(ang_pa[i], A[0], ang_pb[i]);
	}

	for (int i = 0; i < pp; i++) ang_p[i] = i;
	qsort(ang_p, pp, sizeof(int), mycmp2);

	for (int i = 0; i < pp; i++) {
		cout << ang_ia[ang_p[i]] << ' ' << ang_ib[ang_p[i]]/* << ' ' << ang_cos[ang_p[i]]*/ << '\n';
	}
}
