program rays;

const
	MAXN				= 2000;

type
	Integer				= LongInt;
	TPoint				= record
		x, y			: Integer;
	end;
	TAwi				= record
		a			: Real;
		ind			: Integer;
	end;
	TResAng				= record
		a, b			: Integer;
		ang			: Real;
	end;

var
	P				: Array [1 .. MAXN] of TPoint;
	awi				: Array [1 .. MAXN + 20] of TAwi;
	r				: Array [1 .. MAXN + 20] of TResAng;
	N				: Integer;
	caa, resa			: Integer;
	x0, y0				: Integer;

procedure readInput;
var
	i				: Integer;
	x, y				: Integer;
begin
	readln(N);
	readln(x0, y0);
	for i := 1 to N do begin
		readln(x, y);
		x := x - x0;
		y := y - y0;
		P[i].x := x;
		P[i].y := y;
	end;
end;

procedure sort(a, b: Integer);
var
  	i, j					: Integer;
	x					: Real;
	temp					: TAwi;
begin
  	i := a;
	j := b;
	x := Awi[(a + b) div 2].a;
  	repeat
    		while (Awi[i].a < x) do
			i := i + 1;
    		while (x < Awi[j].a) do
			j := j - 1;
    		if (i <= j) then begin
      			temp := Awi[i];
			Awi[i] := Awi[j];
			Awi[j] := temp;
      			i := i + 1;
			j := j - 1;
    		end;
  	until (i > j);
  	if (a < j) then
		sort(a, j);
  	if (i < b) then
		sort(i, b);
end;

procedure asort(a, b: Integer);
var
  	i, j					: Integer;
	x					: Real;
	xa, xb					: Integer;
	temp					: TResAng;
begin
  	i := a;
	j := b;
	x := r[(a + b) div 2].ang;
	xa := r[(a + b) div 2].a;
	xb := r[(a + b) div 2].b;
  	repeat
    		while (r[i].ang < x) do
			i := i + 1;
		while (r[i].ang = x) and (r[i].a < xa) do
			i := i + 1;
		while (r[i].ang = x) and (r[i].a = xa) and (r[i].b < xb) do
			i := i + 1;
    		while (x < r[j].ang) do
			j := j - 1;
		while (x = r[j].ang) and (xa < r[j].a) do
			j := j - 1;
		while (x = r[j].ang) and (xa = r[j].a) and (xb < r[j].b) do
			j := j - 1;
    		if (i <= j) then begin
      			temp := r[i];
			r[i] := r[j];
			r[j] := temp;
      			i := i + 1;
			j := j - 1;
    		end;
  	until (i > j);
  	if (a < j) then
		asort(a, j);
  	if (i < b) then
		asort(i, b);
end;

procedure Solve;
var
	pnt				: TPoint;
	i				: Integer;
	cos, cosdiv, tan		: Real;
	ang				: Real;
	tmp				: Integer;

begin
	caa := 0;
	pnt.x := 1; pnt.y := 0;
	for i := 1 to N do begin

		if (P[i].x = 0) and (P[i].y > 0) then
			ang := Pi / 2
		else if (P[i].x < 0) and (P[i].y = 0) then
			ang := Pi
		else if (P[i].x = 0) and (P[i].y < 0) then
			ang := 1.5 * Pi
		else if (P[i].x > 0) and (P[i].y = 0) then
			ang := 2 * Pi
		else begin

		cos := (P[i].x * pnt.x) + (P[i].y * pnt.y);
		cosdiv := sqrt(sqr(P[i].x) + sqr(P[i].y));
		cos := cos / cosdiv;
		tan := sqrt(1 - sqr(cos));
		tan := tan / cos;
		ang := ArcTan(tan);

		if (P[i].x < 0) and (P[i].y > 0) then
			ang := ang + Pi
		else if (P[i].x < 0) and (p[i].y < 0) then
			ang := ang + (Pi * 1.5)
		else if (P[i].x > 0) and (P[i].y < 0) then
			ang := ang + (1.5 * Pi);

		end;

		caa := caa + 1;
		Awi[caa].ind := i;
		Awi[caa].a := ang;
	end;
	sort(1, caa);

	resa := 0;
	for i := 1 to (caa - 1) do
		if (Awi[i + 1].a - Awi[i].a < Pi) and (Awi[i + 1].a - Awi[i].a > 0.0001) then begin
			resa := resa + 1;
			r[resa].a := Awi[i + 1].ind;
			r[resa].b := Awi[i].ind;
			r[resa].ang := Awi[i + 1].a - Awi[i].a;
		end;

	ang := Awi[1].a + (2 * Pi) - Awi[caa].a;
	if (ang < Pi) and (ang > 0.0001) then begin
			resa := resa + 1;
			r[resa].a := Awi[1].ind;
			r[resa].b := Awi[caa].ind;
			r[resa].ang := ang;
	end;

	for i := 1 to resa do
		if (r[i].a > r[i].b) then begin
			tmp := r[i].a;
			r[i].a := r[i].b;
			r[i].b := tmp;
		end;

	asort(1, resa);

end;

procedure writeOutput;
var
	i					: Integer;
begin
	for i := 1 to resa do
		writeln(r[i].a, ' ', r[i].b);
end;

begin
	readInput;
	Solve;
	writeOutput;
end.