program fast;

const
	MAXN					= 10000;
	MAXM					= 100000;
	MAXW					= 65000;

type
	Integer					= LongInt;
	TNode					= record
		i, j, w				: Integer;
	end;	

var
	Node					: Array [1 .. MAXM] of TNode;
	best					: Array [1 .. MAXN] of Integer;
	N, M					: Integer;

procedure readInput;
var
	i, a, b, w				: Integer;
begin
	readln(N, M);
	for i := 1 to M do begin
		readln(a, b, w);
		if (a < b) then begin
			Node[i].i := a;
			Node[i].j := b;
		end else begin
			Node[i].i := b;
			Node[i].j := a;
		end;
		Node[i].w := w;
	end;
end;

procedure sort(a, b: Integer);
var
  	i, j, x					: Integer;
	temp					: TNode;
begin
  	i := a;
	j := b;
	x := Node[(a + b) div 2].j;
  	repeat
    		while (Node[i].j < x) do
			i := i + 1;
    		while (x < Node[j].j) do
			j := j - 1;
    		if (i <= j) then begin
      			temp := Node[i];
			Node[i] := Node[j];
			Node[j] := temp;
      			i := i + 1;
			j := j - 1;
    		end;
  	until (i > j);
  	if (a < j) then
		sort(a, j);
  	if (i < b) then
		sort(i, b);
end;

function min(a, b: Integer): Integer;
begin
	if (a < b) then
		min := a
	else
		min := b;
end;

procedure Solve;
var
	i, w					: Integer;
begin
	best[1] := MAXW;
	for i := 2 to N do
		best[i] := 0;
	sort(1, M);
	for i := 1 to M do
		if (best[Node[i].i] > 0) then begin
			w := min(best[Node[i].i], Node[i].w);
			if (w > best[Node[i].j]) then
				best[Node[i].j] := w;
		end;
			
end;

procedure writeOutput;
begin
	writeln(best[N]);
end;

begin
	readInput;
	Solve;
	writeOutput;
end.
	