#include <stdio.h>
#include <stdlib.h>

#define MAXN 100100

typedef struct {
        int a,b,c;
} TRib;

typedef struct {
        int node;
        long long dist,odist;
        int len;
} TNode;

typedef struct {
        int node;
        int counter;
} TS;

TNode *a[MAXN];
int q[MAXN];
int parent[MAXN];
long long rd[MAXN];
int used[MAXN];
int sz[MAXN];
TRib t[MAXN];
long long best[MAXN],sol[MAXN],up[MAXN];
int pos[MAXN];
int n,m;
TS stack[MAXN];

int cmp(const void *a, const void *b) {
    return (((TNode *)b)->dist+((TNode *)b)->len)-(((TNode *)a)->dist+((TNode *)a)->len);
}

void DFS(int node) {
int i;
     if (used[node])
        return;
     used[node] = 1;
     for (i=0;i<sz[node];i++) {
         if (!used[a[node][i].node]) {
                  DFS(a[node][i].node);
                  if (best[node]<(a[node][i].len+best[a[node][i].node]))
                     best[node]  =  (long long)a[node][i].len+best[a[node][i].node];
         }
     }
}

/*void DFS(int nd) {
int i,node,stsz;
    stack[0].node = nd;
    stack[0].counter = 0;
    stsz = 1;
    while (stsz>0) {
          node = stack[stsz-1].node;
          used[node] = 1;
          i = stack[stsz-1].counter;
          if (i)
          if (best[node]<(a[node][i-1].len+best[a[node][i-1].node]))
             best[node]  =  (long long)a[node][i-1].len+best[a[node][i-1].node];
          if (i>=sz[node]) {
             stsz--;
          } else {
             while (i<sz[node] && used[a[node][i].node]) i++;
             stack[stsz-1].counter = i+1;
             if (i<sz[node]) {
                stack[stsz].node = a[node][i].node;
                stack[stsz].counter = 0;
                stsz++;
             }
          }
    }
}
  */

void BFS(int node) {
int top = 0,x,y,i,qsz;
long long RD;
     q[0] = node;
     rd[node] = 0;
     parent[node] = -1;
     used[node] = 1;
     qsz = 1;
     while (top<qsz) {
           x = q[top];
           RD = rd[x];
           top++;
           for (i=0;i<sz[x];i++) {
               y = a[x][i].node;
               if (!used[y]) {
                  used[y] = 1;
                  q[qsz] = y;
                  rd[y] = RD+a[x][i].len;
                  parent[y] = x;
                  qsz++;
               }
           }
     }
//     for (i=1;i<=n;i++)
//         printf("%d : %d %lld\n",i,parent[i],rd[i]);
}

long long max(long long a,long long b) {
     return (a>b)?a:b;
}

void BFS2(int node) {
int top = 0,x,y,i,qsz;
long long dx;
     q[0] = node;
     used[node] = 1;
     qsz = 1;
     while (top<qsz) {
           x = q[top];
           top++;
           sol[x] = max(best[x],max(a[parent[x]][pos[x]].odist,up[parent[x]])+a[parent[x]][pos[x]].len);
           if (x!=node)
              up[x] = max(a[parent[x]][pos[x]].odist,up[parent[x]])+a[parent[x]][pos[x]].len;
           else
              up[x] = 0;
           for (i=0;i<sz[x];i++) {
               y = a[x][i].node;
               if (!used[y]) {
                  used[y] = 1;
                  q[qsz] = y;
                  qsz++;
               }
           }
     }
     best[node] = -1;
     for (i=0;i<sz[node];i++) {
         dx = a[node][i].dist+a[node][i].len;
         if (dx>sol[node])
            sol[node] = dx;
     };
}

int main () {
int i,x,z,y,j;
unsigned short test = 0;
//    freopen("paths.in" ,"r",stdin);
    scanf("%d%d",&n,&m);
    for (i=0;i<m;i++) {
        scanf("%d%d%d",&t[i].a,&t[i].b,&t[i].c);
        sz[t[i].a]++;
        sz[t[i].b]++;
    }
    for (i=1;i<=n;i++)
        a[i] = (TNode *)malloc(sizeof(TNode)*(sz[i]+2));
    memset(sz,0,sizeof(sz));
    for (i=0;i<m;i++) {
        x = t[i].a;
        y = t[i].b;
        z = t[i].c;
        a[x][sz[x]].node = y;
        a[x][sz[x]].len = z;
        sz[x]++;
        a[y][sz[y]].node = x;
        a[y][sz[y]].len = z;
        sz[y]++;
    }
    memset(used,0,sizeof(used));
    BFS(1);
    memset(used,0,sizeof(used));
    for (i=1;i<=n;i++)
        best[i] = 0;
    DFS(1);
    for (i=1;i<=n;i++) {
        for (j=0;j<sz[i];j++)
            if (a[i][j].node!=parent[i])
               a[i][j].dist = best[a[i][j].node];
            else {
               a[i][j].dist = 0;
               a[i][j].len = 0;
            }
        qsort(a[i],sz[i],sizeof(TNode),cmp);
        for (j=0;j<sz[i];j++)
          if (a[i][j].node!=parent[i])
            pos[a[i][j].node] = j;
        if (sz[i]==1) {
           a[i][0].odist = 0;
        } else {
          a[i][0].odist = (long long)a[i][1].dist+a[i][1].len;
          for (j=1;j<sz[i];j++)
            a[i][j].odist = (long long)a[i][0].dist+a[i][0].len;
        }
    }
//    for (i=1;i<=n;i++)
//        for (j=0;j<sz[i];j++)
//            printf("[%d;%d] : %d %d\n",i,a[i][j].node,a[i][j].dist,a[i][j].odist);
    memset(used,0,sizeof(used));
    BFS2(1);
    for (i=1;i<=n;i++)
        printf("%lld\n",sol[i]);

    return 0;
}
