#include <ctime>
#include <iostream>

int ind_val;
int dep_val;
int curr_val;
int refs[30];
int nfunc;
int nvar;
time_t t0, t1;

class function
{
public:
	int nvals;
	int nrefs;
	int vals[32];
	int refs[5];
};

function functions[10];

int x_pow_2(int x)
{
	switch(x)
	{
		case 0: return 1;
		case 1: return 2;
		case 2: return 4;
		case 3: return 8;
		case 4: return 16;
		case 5: return 32;
		default: return 0;
	}
}

void check(int fn, int s, int flags[30])
{
	std::time(&t1);
	if (difftime(t1, t0) > 0.99)
		return;
	if (fn == nfunc)
	{
		if (s < dep_val) dep_val = s;
		return;
	}

	function& f = functions[fn];
	for (int i = 0; i < f.nvals; i++)
	{
		if (f.vals[i] + s < dep_val)
		{
			int myflags[30];
			for (int j = 0; j < 30; j++) myflags[j] = -1;
			int k = i;
			for (int j = 0; j < f.nrefs; j++)
			{
				myflags[f.refs[f.nrefs-j-1]] = k%2;
				k >>= 1;
			}
			bool flag = true; int newflags[30];
			for (int j = 0; j < 30 && flag; j++)
			{
				if ((flags[j] == 0 && myflags[j] == 1) || (flags[j] == 1 && myflags[j] == 0))
					flag = false;
				else if (flags[j] != -1) newflags[j] = flags[j]; else newflags[j] = myflags[j];
			}

			if (flag)
				check(fn+1, s+f.vals[i], newflags);
		}
	}
}

int main()
{
	for (int i = 0; i < 30; i++)
		refs[i] = 0;

	ind_val = 0;
	dep_val = 0;

	std::cin >> nfunc >> nvar;
	for (int i = 0; i < nfunc; i++)
	{
		std::cin >> functions[i].nrefs;
		functions[i].nvals = x_pow_2(functions[i].nrefs);
		for (int j = 0; j < functions[i].nrefs; j++)
		{
			std::cin >> functions[i].refs[j];
			functions[i].refs[j]--;
			refs[functions[i].refs[j]]++;
		}
		for (int j = 0; j < functions[i].nvals; j++)
			std::cin >> functions[i].vals[j];
	}

	std::time(&t0);	

	for (int i = 0; i < nfunc; i++)
	{
		function& f = functions[i];
		bool flag = true;
		for (int j = 0; j < f.nrefs; j++)
			if (refs[f.refs[j]] != 1)
				flag = false;
		if (flag)
		{
			int min = 1001;
			for (int j = 0; j < f.nvals; j++)
				if (f.vals[j] < min)
					min = f.vals[j];
			ind_val += min;
			f = functions[--nfunc];
		}
	}

	for (int i = 0 ; i < nfunc; i++)
		dep_val += functions[i].vals[0];

	int flg[30];
	for (int i = 0; i < 30; i++) flg[i] = -1;
	check(0, 0, flg);

	std::cout << ind_val + dep_val << '\n';

	return 0;
}
