//#define DEBUG

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#define IN      "minval.in"
#define OUT     "minval.out"
#define MAX     400
#define INF     0x7fffffff

const long max_time=(long)((0.85)*(double)CLOCKS_PER_SEC);

long n, m, num[MAX], all[MAX], best;
long used[MAX][MAX];

char mat[MAX][MAX];

struct DATA
{
   long value;
   long num;
}data[MAX][MAX];

int get_ind(long row, long col)
{
   return (row*33)+col;
}

void output()
{
#ifdef DEBUG
   freopen(OUT, "w", stdout);
#endif

   printf("%ld\n", best);

#ifdef DEBUG
   fclose(stdout);
#endif
}

long path[MAX];

void recurse(long depth, long sum)
{
   long i, j, ind1, val;

   if(depth==m)
   {
     best=sum;

     if(clock()>=max_time)
     {
       output();
       exit(0);
     }

     return;
   }

   if(clock()>=max_time)
   {
     output();
     exit(0);
   }

   for(i=0; i<all[depth]; i++)
   {
      ind1=get_ind(depth, data[depth][i].num);
      val=data[depth][i].value;

      if(sum+val>=best) return;

      for(j=0; j<depth; j++)
         if(!mat[path[j]][ind1]) break;

      if(j!=depth) continue;

      path[depth]=ind1;

      recurse(depth+1, sum+val);
   }
}

char inuse[50];
int possible(long r1, long c1, long r2, long c2)
{
   long i, j, t, prog;
   memset(inuse, 0, sizeof(inuse));

   t=data[r1][c1].num;
   prog=0;

   while(prog<num[r1])
   {
      if(inuse[used[r1][prog]]!=0 && inuse[used[r1][prog]]!=(t%2)+1)
        return 0;

      if(t%2)
        inuse[used[r1][prog]]=2;
      else
        inuse[used[r1][prog]]=1;

      t/=2;
      prog++;
   }

   t=data[r2][c2].num;
   prog=0;

   while(prog<num[r2])
   {
     if(inuse[used[r2][prog]]!=0 && inuse[used[r2][prog]]!=(t%2)+1)
       return 0;

     if(t%2)
        inuse[used[r2][prog]]=2;
      else
        inuse[used[r2][prog]]=1;

     t/=2;
     prog++;
   }

   return 1;
}

int cmp(const void *el1, const void *el2)
{
   return ((struct DATA*)el1)->value-((struct DATA*)el2)->value;
}

void solve()
{
   long i, j, k, l;

   for(i=0; i<m; i++)
      for(j=i+1; j<m; j++)
         for(k=0; k<all[i]; k++)
            for(l=0; l<all[j]; l++)
               if(possible(i, k, j, l))
               {
                 mat[get_ind(i, k)][get_ind(j, l)]=1;
                 mat[get_ind(j, l)][get_ind(i, k)]=1;
               }

   for(i=0; i<m; i++)
      qsort(data[i], all[i], sizeof(struct DATA), cmp);

   best=INF;

   recurse(0, 0);
}

void input()
{
   long i, j, k, t;

   scanf("%ld%ld", &m, &n);

   for(i=0; i<m; i++)
   {
      scanf("%ld", num+i);

      for(j=0; j<num[i]; j++)
      {
         scanf("%ld", &t);
         used[i][num[i]-j-1]=t;
      }

      all[i]=(1<<num[i]);

      for(j=0; j<all[i]; j++)
      {
         scanf("%ld", &t);
         data[i][j].value=t;
         data[i][j].num=j;
      }
   }
}

int main()
{
   clock();

#ifdef DEBUG
   freopen(IN, "r", stdin);
#endif

   input();

#ifdef DEBUG
   fclose(stdin);
#endif

   solve();
   output();

   return 0;
}

