#include <stdio.h>
#include <stdlib.h>

const int MAX = 40;

bool bVar[MAX] = {false};
int iFuncC;
int iVarC;
int iDep[MAX][MAX];
int iDepC[MAX];
int iCC = 0;
int iCV[MAX];
int iVal[MAX][MAX];
bool bC[MAX] = {false};

int iMin = 100000;

inline int min(int i1,int i2){
    return i1 < i2 ? i1 : i2;
}

inline int powof2(int iPow){
    int iR = 1;
    for (int i=0;i<iPow;i++)
        iR *= 2;
    return iR;
}

void load(){
    //FILE *fin = fopen("minval.in","r");
    FILE *fin = stdin;

    fscanf(fin,"%d%d",&iFuncC,&iVarC);
    for (int i=0;i<iFuncC;i++) {
         fscanf(fin,"%d",&iDepC[i]);
         for (int i1=0;i1<iDepC[i];i1++){
             fscanf(fin,"%d",&iDep[i][iDepC[i]-1-i1]);
             iDep[i][iDepC[i]-1-i1]--;
         }
         double dC = powof2(iDepC[i]);
         for (int i1=0;i1<dC;i1++)
             fscanf(fin,"%d",&iVal[i][i1]);
    }

    //fclose(fin);
}

int intCmp(const void *e1, const void *e2){
    return *((const int*)e1) - *((const int*)e2);
}

void addCommon(int iNum){
    if (iCC == 0) {
        iCV[0] = iNum;
        iCC++;
        bC[iNum] = true;
        return;
    }
    if (iNum == iCV[iCC-1])
        return;
    iCV[iCC] = iNum;
    iCC++;
    bC[iNum] = true;
}

void findCommonVars(){
    int iDepArr[MAX*100];
    int iL = 0;

    for (int iF=0;iF<iFuncC;iF++)
        for (int iD=0;iD<iDepC[iF];iD++)
            iDepArr[iL++]=iDep[iF][iD];

    qsort(iDepArr,iL,sizeof(int),&intCmp);

    for (int i=0;i<iL-1;i++){
        if (iDepArr[i] == iDepArr[i+1])
            addCommon(iDepArr[i]);
    }
}

bool good(int iF,int iVarVal){
    for (int i=0;i<iDepC[iF];i++)
        if (bC[iDep[iF][i]]) {
           bool b = (iVarVal & (1 << i));
           if (b != bVar[iDep[iF][i]])
               return false;
        }
    return true;
}

int evalFunc(int iF){
    int iMin = 100000;
    int iVarValC = powof2(iDepC[iF]);

    for (int i=0;i<iVarValC;i++)
        if (good(iF,i))
            iMin = min(iMin,iVal[iF][i]);

    return iMin;
}

int eval(){
    int iS = 0;

    for (int i=0;i<iFuncC;i++)
        iS+=evalFunc(i);

    return iS;
}

void setCommonVars(int iNum){
    if (iNum >= iCC){
        iMin = min(iMin,eval());
        return;
    }
    bVar[iCV[iNum]] = true;
    setCommonVars(iNum+1);
    bVar[iCV[iNum]] = false;
    setCommonVars(iNum+1);
}

void solve(){
    findCommonVars();
    setCommonVars(0);
}

void save(){
    printf("%d\n",iMin);
}

int main(){
    load();
    solve();
    save();

    return 0;
}
