{$D-, O-, Q-, R-, S-}

const
  maxn = 100001;
  maxh = 1000000;

  inf  = maxlongint div 2;

  infile  = '';
  outfile = '';

type
  pnode = ^tnode;
  tnode = record
    v, l : longint;
    n    : pnode;
  end;

  trec = record a, b, l : longint; end;

var
  f : text;

  a, b, c, i, j, n, m, mm : longint;

  len : longint;
  h   : array[1..maxh] of trec;

  pn  : pnode;
  arr : array[1..maxn] of pnode;

  res, res2  : array[1..maxn] of longint;
  used : array[1..maxn] of boolean;

function min(a, b : longint) : longint;
begin if a<b then min:=a else min:=b; end;

procedure swap(var a, b : trec);
var t : trec;
begin t:=a; a:=b; b:=t; end;

//////////////////////// HEAP \\\\\\\\\\\\\\\\\\\\\
procedure pop(var p : trec);
var
  x1, x2, cur, csh1, csh2 : longint;
begin
  cur:=1;
  p:=h[1];
  h[1]:=h[len];
  dec(len);

  while true do
  begin
    csh1 := cur shl 1;
    csh2 := csh1 + 1;

    if csh1 > len then x1:=maxlongint else x1:=h[csh1].l;
    if csh2 > len then x2:=maxlongint else x2:=h[csh2].l;

    if (x1 <> maxlongint)or(x2 <> maxlongint) then
    begin
      if min(x1, x2) > h[cur].l then break
      else if x1 < x2 then
           begin swap(h[cur], h[csh1]); cur:=csh1; end
      else begin swap(h[cur], h[csh2]); cur:=csh2; end;
    end
    else break;
  end;
end;

procedure push(p : trec);
var tmp, cur : longint;
begin
  inc(len);
  h[len]:=p;
  cur:=len;

  while true do
  begin
    if cur = 1 then break;
    tmp := cur shr 1;
    if h[tmp].l > h[cur].l then begin swap(h[tmp], h[cur]); cur:=tmp; end
    else break;
  end;
end;

////////////////////////// END \\\\\\\\\\\\\\\\\\\\

procedure input;
begin
  assign(f, infile);
  reset(f);
  readln(f, n, m);
  for i:=1 to m do
  begin
    readln(f, a, b, c);
    new(pn);
    with pn^ do
    begin
      v := b;
      l := c;
      n := arr[a];
    end;
    arr[a]:=pn;

    new(pn);
    with pn^ do
    begin
      v := a;
      l := c;
      n := arr[b];
    end;
    arr[b]:=pn;
  end;
  close(f);
end;

procedure dijkstra(st : longint);
var pp : pnode; reb : trec;
begin
  mm:=0;

//  fillchar(used, sizeof(used), 0);
  filldword(res, n, inf);

  pp:=arr[st];
  while pp <> nil do
  begin
    with pp^ do
    begin
//      res[v]:=l; if l < mm then mm:=l;
      reb.a:=st; reb.b:=v; reb.l:=l; push(reb);
    end;
    pp:=pp^.n;
  end;

  res[st]:=0;
  while true do
  begin
    if len = 0 then break;
    pop(reb);

    if res[reb.a] + reb.l < res[reb.b] then
    begin
      res[reb.b]:=res[reb.a] + reb.l;
//      if res[reb.b] > mm then mm:=res[reb.b];

      pp:=arr[reb.b];
      reb.a:=reb.b;
      while pp <> nil do
      begin
        reb.b:=pp^.v; reb.l:=pp^.l;
        push(reb);
        pp:=pp^.n;
      end;
    end;
  end;

  for j:=1 to n do if (res[j] > mm)and(res[j] <> inf) then mm:=res[j];
  writeln(f, mm);
end;

procedure solve;
begin
  assign(f, outfile);
  rewrite(f);

  for i:=1 to n do
  begin
  //  if i mod 1000 = 0 then writeln(i);
    dijkstra(i);
  end;

  close(f);
end;

begin
  input;
  solve;
end.
