#include <stdio.h>
#include <string.h>

const int MAX_PIC_C = 1500;
const double MAX_TOTAL_H = 2000*1000;

struct Pic {
    double dW,dH;
};

int iPicC;
double dWallW;
Pic pics[MAX_PIC_C];
double dSol[MAX_PIC_C];
bool bSolved[MAX_PIC_C];

inline void swap(double &d1,double &d2){
    double d = d1;
    d1 = d2;
    d2 = d;
}

void load(){
    //FILE *fin = fopen("pict.in","r");
    FILE *fin =  stdin;

    memset(bSolved,0,sizeof(bSolved));
    fscanf(fin,"%d %lf",&iPicC,&dWallW);
    for (int i=0;i<iPicC;i++){
        fscanf(fin,"%lf%lf",&(pics[i].dW),&(pics[i].dH));
        if (pics[i].dW < pics[i].dH)
            swap(pics[i].dH,pics[i].dW);
    }

    //fclose(fin);
}

inline double min(double d1,double d2){
    return d1 < d2 ? d1 : d2;
}

inline double max(double d1,double d2){
    return d1 > d2 ? d1 : d2;
}

double findBestLineH(int iFirst,int iLast,double dW){
    if (iFirst > iLast && dW >= 0)
        return 0;
    if (dW <= 0)
        return MAX_TOTAL_H;

    double d1 = max(pics[iFirst].dW,
                    findBestLineH(iFirst+1,iLast,dW-pics[iFirst].dH));
    double d2 = max(pics[iFirst].dH,
                    findBestLineH(iFirst+1,iLast,dW-pics[iFirst].dW));

    return min(d1,d2);
}

double bestLineH(int iFirst,int iLast){
    double dS = 0;
    for (int i=iFirst;i<=iLast;i++)
        dS += pics[i].dH;
    if (dS > dWallW)
        return MAX_TOTAL_H;
    else
        return findBestLineH(iFirst,iLast,dWallW);
}

double solve(int iNum){
    if (iNum == iPicC)
        return 0;
    if (bSolved[iNum])
        return dSol[iNum];
    bSolved[iNum] = true;
    double dR = MAX_TOTAL_H;

    for (int i=iNum;i<iPicC;i++){
        double dBestLine = bestLineH(iNum,i);
        dR = min(dR,dBestLine+solve(i+1));
        if (dBestLine == MAX_TOTAL_H)
            break;
    }

    dSol[iNum] = dR;
    return dSol[iNum];
}

double solve(){
    return solve(0);
}

void save(double d){
    printf("%.6lf\n",d);
}

int main(){
    load();
    save(solve());

    return 0;
}
