#include <stdio.h>

#define REAL double
#define MAXP 1501
#define MINUS -100000
#define PREC 1000000

typedef struct {
   int small,big;
} TPic;

int pics[MAXP][MAXP];
long long sol[MAXP];
long long occupied;
int max_small,cbig;
TPic m[MAXP];
TPic heap[MAXP];
int hsz;
int w;

int max(int a,int b) { return (a>b)?a:b; }

int left(int index) { return 2*index; }
int right(int index) { return 2*index+1; }
int parent(int index) { return index/2; }

int smaller(TPic a,TPic b) {
    if (a.big < b.big ) return 1;
    return 0;
}

void hdown(int index) {
TPic temp;
int l,r,best;
     while (index<=hsz) {
           l = left(index);
           r = right(index);
           best = index;
           if (l<=hsz && smaller(heap[l],heap[best]))
              best = l;
           if (r<=hsz && smaller(heap[r],heap[best]))
              best = r;
           if (best!=index) {
              temp = heap[index];
              heap[index] = heap[best];
              heap[best] = temp;
              index = best;
           } else
             return;

     }
}

void hup(int index) {
TPic temp;
int p;
     while (index>0) {
           p = parent(index);
           if (smaller(heap[index],heap[p])) {
              temp = heap[index];
              heap[index] = heap[p];
              heap[p] = temp;
              index = p;
           } else
             return;
     }
}


void hadd(TPic what) {
     hsz++;
     heap[hsz] = what;
     hup(hsz);
     occupied+=what.big;
}

void hdel() {
     occupied-=heap[1].big;
     occupied+=heap[1].small;
     if (heap[1].big>cbig)
        cbig = heap[1].big;
     heap[1] = heap[hsz];
     hsz--;
     hdown(1);
}

int greater(long long a,long long b) {
    return a>b;
}


int main () {
int i,n,j;
long double tw,small,big;

//    freopen ( "pict.in" , "r", stdin);
    scanf("%d%Lf",&n,&tw);
    w = tw*PREC;
    for (i=1;i<=n;i++) {
        scanf("%Lf%Lf",&small,&big);
        m[i].small = small*PREC;
        m[i].big = big*PREC;
        if (m[i].small>m[i].big) {
        int temp = m[i].big; m[i].big = m[i].small; m[i].small = temp;
        }
    }
    for (i=1;i<=n;i++) {
        hsz = 0;
        max_small=-1;
        cbig = -1;
        occupied = 0;
        for (j=i;j<=n;j++) {
            hadd(m[j]);
            if (m[j].small>max_small)
               max_small = m[j].small;
            while (greater(occupied,w) && hsz>0) {
                  hdel();
            }
            if (greater(occupied,w))
               pics[i][j] = MINUS;
            else
               pics[i][j] = max(max_small,cbig);
        }
    }
    for (i=1;i<=n;i++) {
        sol[i] = 2000000000000;
        for (j=0;j<i;j++) {
            if (pics[j+1][i]>0) {
            long long mx = sol[j]+(long long)pics[j+1][i];
                 if (mx<sol[i])
                    sol[i] = mx;
            }
        }
    }
    if (sol[i]==2000000000000)
       printf("No solution.\n");
    else
       printf("%f\n",sol[n]/(float)PREC);
    return 0;
}
