{this is the secure edition of the totolib module}

unit totolib;
interface
{uses sysutils;}

function post_comb(p1, p2, p3, p4, p5, p6 : integer) : integer;

implementation

const MAX_TRY = 45;
const MAX_SCORE  = 10;

type isArr = array [1..6 ] of integer;
     ibArr = array [1..49] of boolean;
     StringArray = array [1..6 ] of String;

const try_rem : integer = MAX_TRY;
      inited : boolean = FALSE;
      init_fish : boolean = TRUE;
           
     
var iiisol : IsArr;
    bbbsol : IbArr;
    l0g : Text;



{-----------------------------------------------------}    
{ Internal Fns }

Procedure BailOut(msg : string; score : integer);
 begin
 writeln(l0g, msg);
 writeln(l0g, score);
 writeln(l0g,'---');
 close(l0g);
 halt(0);
 end;
         

Function Formula(tries : integer) : integer;
 begin
 case tries of
  1..28: Formula := MAX_SCORE;
 29..31: Formula := 80 * MAX_SCORE div 100;
 32..35: Formula := 60 * MAX_SCORE div 100;
 36..40: Formula := 40 * MAX_SCORE div 100;
 41..45: Formula := 20 * MAX_SCORE div 100;
 end;
 end;
 
function test_fish(a : IsArr) : boolean;
 var i,j : integer;
 begin
 test_fish := false;
 for i := 1 to 6 do if (a[i]<1) or (a[i]>49) then exit;
 for j := 2 to 6 do
    for i := 1 to j - 1 do if a[i]=a[j] then exit;
 test_fish := true;
 end;

function Tokenize( s : string; var ss : StringArray) : boolean;
 var i : integer;
 begin
 Tokenize := false;
 s := ' ' + s + ' ';
 for i := 1 to 6 do
     begin
     if pos(' ', s) <> 1 then
        exit;
     while (length(s)>0) and (s[1] = ' ') do
           delete(s, 1, 1);
     ss[i] := copy(s, 1, pos(' ', s)-1);
     delete(s, 1, pos(' ', s) -1 );
     end;
 Tokenize := true;
 end;

function Decode(var ss : StringArray; var a : IsArr) : boolean;
 var i, j : integer;
 begin
 Decode := fALSE;
 for i := 1 to 6 do
     begin
     if length(ss[i]) <> 8 then exit;
     for j := 1 to 8 do if not (ss[i][j] in ['0', '1']) then exit;
     a[i] := 0;
     for j := 1 to 8 do a[i] := a[i] * 2 + ord(ss[i][j]) - ord('0');
     end;
 Decode := tRUE;
 end;

function input_from_file(fn : string; var a : IsArr) : boolean;
 var t : Text;
     ss : StringArray;
     s : string;
 begin
 input_from_file := false;
 assign(t, fn);
 {$I-}
 reset(t);
 close(t);
 {$I+}
 if ioresult <> 0 then
    begin
    writeln(l0g, 'File "', fn, '" does not exist; Check you path!');
    exit;
    end;
 reset(t);
 {readln(t, a[1], a[2], a[3], a[4], a[5], a[6]);}
 readln(t, s);
 close(t);
 if not Tokenize(s, ss) then
    begin
    WriteLn(l0g, 'Given fish is bad. Blahhing up');
    exit;
    end;
 if not Decode(ss, a) then
    begin
    WriteLn(l0g, 'Input format is invalid. Blahhing up');
    exit;
    end;
 if not test_fish(a) then
    begin
    WriteLn(l0g, 'Given fish is bad.');
    exit;
    end;
 Writeln(l0g, 'File "', fn, '" read successfully.');
 input_from_file := true;
 end;


{ -------------------------------------------------------------------------- }
{ User FNs Implementations }

Procedure Init;
 var a : IsArr;
     i : integer;
 begin
 if inited then
    begin
    WriteLn('Uhh! What happened! Init was called more than once!');
    Writeln(L0g, 'Attempt to call init() multiple times.');
    BailOut('ACCESS DENIED', 0);
    end;
 inited := TRUE;
 assign(l0g, 'toto.log');
 {$I-}
 rewrite(l0g);
 {$I+}
 if ioresult <> 0 then
    begin
    writeln('Cannot open log file. Sorry.');
    halt(1);
    end;
 if not input_from_file('toto.in', a) then
     begin
     BailOut('NO_FILE', 0);
     end;
 fillchar(bbbsol, sizeof(bbbsol), 0);
 iiisol := a;
 for i := 1 to 6 do bbbsol[a[i]] := true;
 end;


function post_comb(p1, p2, p3, p4, p5, p6 : integer) : integer;
 var z : IsArr;
     i, r : integer;
 begin
 if not inited then
    begin
    init;
    end;
 z[1] := p1; z[2] := p2; z[3] := p3; z[4] := p4; z[5] := p5; z[6] := p6;
 write(l0g,'post_comb(',p1,',',p2,',',p3,',',p4,',',p5,',',p6,') : ');
 if not test_fish(z) then
    begin
    writeln(l0g,'Bad Combination!');
    BailOut('WRONG COMB',0);
    end;
 if try_rem < 1 then
    begin
    write(l0g,'Max tries exceeded. Combination was (');
    for i := 1 to 6 do write(l0g,iiisol[i]:3);
    writeln(l0g,').');
    BailOut('LIMIT', 0);
    end;
 {Ok, run test.}
 dec(try_rem);
 r := 0;
 for i := 1 to 6 do if bbbsol[z[i]] then inc(r);
 if r < 6 then
    begin
    Writeln(l0g, r, ' (query no. ',MAX_TRY-try_rem,')');
    post_comb := r;
    exit;
    end else
    begin
    WriteLn(l0g,'6 - SUCCESS');
    WriteLn(l0g,'Answered correctly after ',MAX_TRY-try_rem,' queries.');
    BailOut('OK', formula(MAX_TRY-try_rem));
    end;
 end;


END.
