#include <cstdio>
#include <queue>
#include <vector>

using namespace std;

typedef vector<int>::iterator iter;
vector<int> node[128];
vector<pair<int,int> > edge;
vector<int> len;
int n, m;

vector<double> end_burn(6100);
vector<int> burned(6100);
struct cmp {
	bool operator()(int x, int y) {
		 return end_burn[x] > end_burn[y];
	}
};
priority_queue<int, vector<int>, cmp> q;

double solve(int x) {
    int i;
	double t;

    for (i = 0; i < n + m; i++)
        burned[i] = 0;

    burned[x] = 1;
    end_burn[x] = node[x].size();
    q.push(x);
    while (!q.empty()) {
        x = q.top();
        t = end_burn[x];
        q.pop();
        if (burned[x] == 2)
            continue;
        burned[x] = 2;
        if (x >= n) { //edge
            x -= n;
            int u = edge[x].first;
            int v = edge[x].second;
            if (burned[u] == 0) {
                burned[u] = 1;
                end_burn[u] = t + node[u].size();
                q.push(u);
            }
            if (burned[v] == 0) {
                burned[v] = 1;
                end_burn[v] = t + node[v].size();
                q.push(v);
            }
        }
        else {
            //node
            for (iter it = node[x].begin(); it != node[x].end(); ++it) {
                if (burned[n + *it] == 1) {
                    burned[n + *it] = 2;
                    end_burn[n + *it] -= (end_burn[n + *it] - t)/2.0;
                }
                if (burned[n + *it] == 0) {
                    burned[n + *it] = 1;
                    end_burn[n + *it] = t + len[*it];
                    q.push(n + *it);
                }
            }
        }
    }

    double mx = end_burn[0];
    for (i = 0; i < n + m; i++)
        if (mx < end_burn[i])
            mx = end_burn[i];

    return mx;
}

void input() {
    int x, y, l;

    scanf("%i %i", &n, &m);
    for (int i = 0; i < m; i++) {
        scanf("%i %i %i", &x, &y, &l);
        x--; y--;
        edge.push_back(make_pair(x,y));
        len.push_back(l);
        node[x].push_back(i);
        node[y].push_back(i);
    }
}

int main() {
    double t, mx;

    input();
    mx = 1e100;
    for (int i = 0; i < n; i++) {
        t = solve(i);
        if (t < mx)
            mx = t;
    }

    printf("%.1lf\n", mx);

    return 0;
}
