#include <stdlib.h>
#include <stdio.h>

static int phase=0;
static int questions = 0;
static FILE *in;
static FILE *out;

static long n,k;
static long tablesize;
static long rage,rweight;

static long t[1028][1028];
static bool asked[1028][1028];


void init(long *N,long *K) {

	if (phase==0) {

		in = fopen("ceoi.in" , "r");
		out = fopen ("ceoi.out" , "w");
		fscanf(in,"%d%d%d",&n,&rage,&rweight);
		for (int i=1;i<=n;i++) {
			for (int j=1;j<=n;j++) {
				fscanf(in,"%d",&t[i][j]);
			}
		}

		tablesize = n*n;
		k = *K = t[rage][rweight];
		*N = n;
		 
	} else {

		fprintf(out,"-1\nMore than one call to init()\n");
		exit(0);

	}

	phase++;

}

long ask(long age,long weight) {

	if (!phase) {
		fprintf(out,"-1\nMust call init() first!\n");
		exit(0);
	}

	questions++;

	if (questions>tablesize) {
		fprintf(out,"-1\nToo many calls to ask!\n");
		exit(0);
	}

	if (age<1 || age>n || weight<1 || weight>n) {
		fprintf(out,"-1\nInvalid age-weight(%d;%d)!\n",age,weight);
		exit(0);
	}

	if (asked[age][weight])
	{
		fprintf(out,"-1\nTwo calls to ask() with the same arguemtns!(%d;%d)!\n",age,weight);
		exit(0);
	}

	asked[age][weight] = true;
	return t[age][weight];
}

void answer(long age,long weight) {

	if (!phase) {
		fprintf(out,"-1\nMust call init() first!\n");
		exit(0);
	}

	if (age<1 || age>n || weight<1 || weight>n) {

		fprintf(out,"-1\nAge/weight out of bounds!\n");
		exit(0);
	} else {

		if (t[age][weight]==k) {
			fprintf(out,"%d\nCorrect!\n",questions);
			exit(0);
		} else {
			fprintf(out,"-1\n%d friends required, %d friends matching your answer!\n",k,t[age][weight]);
			exit(0);

		}
	}
}
