/*
TASK:BASE
LANG:C++
*/
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <ctime>
#include <cstring>
using namespace std;

#define MAXN 16384

struct TNasl {
		int b;
		TNasl *Next;
};

TNasl *Vex[MAXN];
TNasl *Vex1[MAXN];

int N, M;
int Vis[MAXN];
int cnt;
int PostNum[MAXN];
int Comp[MAXN];
int PostSort[MAXN];
int C = 0;

void AddEdge(int u, int v) {
		TNasl *T;
		T = (TNasl *)malloc(sizeof(TNasl));
		T->b = v;
		T->Next = Vex[u];
		Vex[u] = T;		
}

void AddEdge1(int u, int v) {
		TNasl *T;
		T = (TNasl *)malloc(sizeof(TNasl));
		T->b = v;
		T->Next = Vex1[u];
		Vex1[u] = T;		
}

bool cmp(int a, int b) {
	return PostNum[a]>PostNum[b];
}

void Init(void) {
		int u,v,i;
		TNasl *T;
		scanf("%d%d",&N,&M);
		
		for(i=1; i<=N; i++) { Vex[i]=NULL; Vex1[i]=NULL; }
		
		for(i=1; i<=M; i++)
		{
			scanf("%d%d",&u,&v);
			AddEdge(u,v);
			AddEdge1(v,u);
		}
		
		/*for(i=1; i<=N; i++)
		{
				T = Vex[i];
				printf("%d: ",i);
				while(T!=NULL) {
					printf("%d ",T->b);
					T = T->Next;
				}
				printf("\n");
		}
		printf("Obarnatiq graf\n");
		for(i=1; i<=N; i++)
		{
				T = Vex1[i];
				printf("%d: ",i);
				while(T!=NULL) {
					printf("%d ",T->b);
					T = T->Next;
				}
				printf("\n");
		}*/
}

void DFS1(int v) {
		int u;
		TNasl *T;
		Vis[v]=1;
		T = Vex[v];
		while(T!=NULL)
		{
				u = T->b;
				if(Vis[u]==0) DFS1(u);
				T = T->Next;
		}
		PostNum[v]=++cnt;		
}

void DFS2(int v) {
		int u;
		TNasl *T;
		T = Vex1[v];
		Vis[v]=1;
		Comp[v] = C;
		while(T!=NULL)
		{
			u = T->b;
			if(Vis[u]==0) DFS2(u);
			T=T->Next;
		}
		
}

void Solve(void) {
	int i;
	int b;
		memset(Vis,0,sizeof(Vis));
		cnt = 0;
		for(i=1; i<=N; i++)
		{
			if(Vis[i]==0) DFS1(i);
		}
		
		for(i=1; i<=N; i++) PostSort[i]=i;
		sort(PostSort+1,PostSort+N+1,cmp);
		
		//for(i=1; i<=N; i++) printf("PN[%d]=%d\n",PostSort[i],PostNum[PostSort[i]]);
		memset(Vis,0,sizeof(Vis));
		for(i=1; i<=N; i++)		
			if(Vis[PostSort[i]]==0)
			{
				C++;
				DFS2(PostSort[i]);
			}
			
		
		int Res=0;	
		for(i=1; i<=N; i++)
		{				
				TNasl *T = Vex[i];				
				while(T!=NULL) {
					b = T->b;
					if(Comp[i]!=Comp[b]) { Res++;	/*printf("%d->%d\n",i,b);*/ }
					T = T->Next;
				}				
		}
		
		/*for(i=1; i<=N; i++)		
				printf("Comp[%d]=%d\n",i,Comp[i]);*/
		printf("%d\n",Res);
}

int main(int argc, char **argv) {
	  Init();
	  Solve();	
	return 0;
}
