/*
TASK: base
LANG: C++
*/

#include <queue>
#include <stack>
#include <cstdio>
#include <vector>

class vertex
{
public:
	vertex() : a(0), b(0) {}

	unsigned int a;
	unsigned int b;

	std::vector<unsigned int> next;
};

int main()
{
	unsigned int n, m;
	std::scanf("%u %u", &n, &m);
	std::vector<vertex> graph(n);
	unsigned int x, y;
	for (unsigned int i = 0; i < m; i++)
	{
		std::scanf("%u %u", &x, &y);
		x--; y--;
		graph[x].next.push_back(y);
	}

	std::queue<unsigned int> s;
	std::stack<unsigned int> traverse;
	unsigned int c = 1;
	for (unsigned int i = 0; i < n; i++)
	{
		if (graph[i].a) continue;

		s.push(i);
		graph[i].a = c;
		while (!s.empty())
		{
			unsigned int k = s.front(); s.pop();
			traverse.push(k);
			for (unsigned int j = 0; j < graph[k].next.size(); j++)
				if (!graph[graph[k].next[j]].a)
				{
					graph[graph[k].next[j]].a = c;
					s.push(graph[k].next[j]);
				}
		}

		c++;
	}

	c = 1;
	while (!traverse.empty())
	{
		unsigned int i = traverse.top(); traverse.pop();
		if (graph[i].b) continue;

		s.push(i);
		graph[i].b = c;
		while (!s.empty())
		{
			unsigned int k = s.front(); s.pop();
			for (unsigned int j = 0; j < graph[k].next.size(); j++)
				if (!graph[graph[k].next[j]].b)
				{
					graph[graph[k].next[j]].b = c;
					s.push(graph[k].next[j]);
				}
		}

		c++;
	}

	c = 0;
	for (unsigned int i = 0; i < n; i++)
		for (unsigned int j = 0; j < graph[i].next.size(); j++)
			if (graph[graph[i].next[j]].a != graph[i].a || graph[graph[i].next[j]].b != graph[i].b)
			{
				//std::printf("%u %u - %u %u, %u %u\n", i+1, graph[i].next[j]+1, graph[graph[i].next[j]].a, graph[i].a, graph[graph[i].next[j]].b, graph[i].b);
				//std::printf("%u %u\n", i+1, graph[i].next[j]+1);
				c++;
			}

	std::printf("%u\n", c);

	return 0;
}
