/*
TASK: base
LANG: C++
*/

#include <cstdio>
#include <cstdlib>

const int MAXN = 10000;
const int MAXM = 100000;

struct el {
	int to;
    int next;
};

int N, M;
bool used[MAXN];
bool used2[MAXN];
int prenum[MAXN];
int pn;
int vec[MAXN];
el buf[MAXM];
int vec2[MAXN];
el buf2[MAXM];
int cnt;

void dfs (int a) {
//	printf ("dfs - %d\n", a);
	if (used[a])
    	return;
    used[a] = 1;

    for (int k = vec[a]; k != -1; k = buf[k].next)
    	dfs (buf[k].to);

	prenum[a] = pn++;
}

void bdfs (int a) {
	if (used[a] || used2[a])
		return;

//    printf ("bdfs - %d\n", a);

    used[a] = 1;

    for (int i = vec2[a]; i != -1; i = buf2[i].next) {
    	if (used2[buf2[i].to])
        	continue;
        bdfs (buf2[i].to);
		cnt++;
    }
}

int CMP (const void *a, const void *b) {
	return (prenum[*(const int*)(b)] - prenum[*(const int*)(a)]);
}

int main () {
	scanf ("%d%d", &N, &M);

    int i,j;
	for (i = 0; i < N; ++i) {
    	vec[i] = vec2[i] = -1;
        used[i] = used2[i] = 0;
    }

    int a,b;
    for (i = 0; i < M; ++i) {
    	scanf ("%d%d", &a, &b);
        --a, --b;
        buf[i].to = b;
        buf[i].next = vec[a];
        vec[a] = i;

        buf2[i].to = a;
        buf2[i].next = vec2[b];
        vec2[b] = i;
    }



/*    for (i = 0; i < N; ++i) {
    	printf ("%d- >", i);
        for (j = vec2[i]; j != -1; j = buf2[j].next)
        	printf (" %d", buf2[j].to);
        printf ("\n");
    }
*/
    for (i = 0; i < N; ++i)
    	dfs (i);

    int index[MAXN];
    for (i = 0; i < N; ++i)
    	index[i] = i;

    qsort (index, N, sizeof(int), CMP);

/*    for (i = 0; i < N; ++i)
    	printf ("%d ", index[i]);
    printf ("\n");
*/
    for (i = 0; i < N; ++i)
    	used[i] = 0;

    for (i = 0; i < N; ++i) {
    	bdfs (index[i]);
//		printf ("***********\n");
    	for (j = 0; j < N; ++j)
        	if (used[j]) {
            	used[j] = 0;
                used2[j] = 1;
            }
    }

    printf ("%d\n", M - cnt);

	return 0;
}
