/*
TASK:MARK
LANG:C++
*/
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <ctime>
using namespace std;

#define MAXK 128

long long gcd(long long a, long long b) {
		if(b==0) return a;
		return gcd(b,a%b);
}

long long lcm(long long a, long long b) {
	long long t = gcd(a,b);
	long long r = (a/t)*b;
	return r;
}

struct TDrob {
		long long a,b;		
};

struct TInt {
		TDrob F,L;
};

int N,P,K;
int M[MAXK];
TDrob T;

void OprDrob(TDrob &z) {
	long long d = gcd(z.a,z.b);
	if(d>1)
	{
		z.a/=d;
		z.b/=d;
	}
}

void AddDrob(TDrob x, TDrob y, TDrob &z)
{
		long long k = lcm(x.b,y.b);
		z.a = x.a*(k/x.b)+y.a*(k/y.b);
		z.b = k;
		OprDrob(z);
	
}

void SubDrob(TDrob x, TDrob y, TDrob &z)
{
		long long k = lcm(x.b,y.b);
		z.a = x.a*(k/x.b)-y.a*(k/y.b);
		z.b = k;
		OprDrob(z);	
}

void Init(void) {	
	int j,i;
	scanf("%d%d%d",&N,&P,&K);
	
	for(i=0; i<=N; i++) M[i]=0;
	for(i=0; i<K; i++) { scanf("%d",&j); M[j]=1; }
	
	scanf("%lld%lld",&(T.a),&(T.b));	
	//printf("%lld/%lld\n",T.a,T.b);
}

int IsInInterval(TInt D, TDrob a) {
		TDrob z;
		SubDrob(a,D.F,z);
		//printf("z=%lld %lld\n",z.a,z.b);
		if(z.a<0) return 0;
		
		SubDrob(D.L,a,z);
		//printf("z=%lld %lld\n",z.a,z.b);
		if(z.a<=0) return 0;
		
		return 1;
}

void Solve(void) {		
	TInt D;
	TDrob Last,Last2;
	TDrob Tmp;
				
	int i,j;
			
	D.F.a = 0; D.F.b = 1;
	D.L.a = 1; D.L.b = 1;
	
	
	
	for(i=1; i<=P; i++)
	{	
			SubDrob(D.L,D.F,Tmp);
			Tmp.b*=N;
			//OprDrob(Tmp);
			Last = D.F;
			//printf("%lld/%lld\n",Tmp.a,Tmp.b);
			for(j=1; j<=N; j++)
			{				
				//printf("j=%d\n",j);
				AddDrob(Last,Tmp,Last2);
				//printf("Last2 %lld %lld\n",Last2.a,Last2.b);
				D.F = Last;
				D.L = Last2;
				Last = Last2;
				if(IsInInterval(D,T)) break;
				//printf("%lld/%lld  %lld/%lld\n",D.F.a,D.F.b,D.L.a,D.L.b);
			}
			if(M[j]==1) break;
	}
	if(i>P) printf("0\n");
	else printf("%d\n",i);
	
}

int main(void) {
	Init();
	Solve();
	/*TDrob x,y,z;
	x.a=1; x.b=2;
	y.a=1; y.b=3;
	SubDrob(x,y,z);
	printf("%lld/%lld\n",z.a,z.b);*/
	//printf("%lld\n",lcm(a,b));
	return 0;
}
