/*
TASK: MARK
LANG: C
*/
#include<stdio.h>
#include<string.h>

#define MAXN 128
#define SIZE 32
#define MOD 1000000000

typedef struct lnum lnum;

struct lnum
{
	long d[SIZE];
    int l;
};

int can[MAXN];

void set(lnum *a,long c)
{
    if(c==0) a->l=0;
    else if(c/MOD) a->l=2;
    else a->l=1;
    memset(a->d,0,SIZE*sizeof(a->d[0]));
    a->d[0]=c%MOD;
    a->d[1]=c/MOD;
}

void copy(lnum *a,lnum *b)
{
	a->l=b->l;
	memcpy(a->d,b->d,SIZE*sizeof(a->d[0]));
}

void add(lnum *a,lnum *b)
{
     int i,take=0,len=(a->l>b->l)?a->l:b->l;
     for(i=0;i<len;i++)
     {
		a->d[i]+=b->d[i]+take;
        if(a->d[i]>=MOD) { a->d[i]-=MOD; take=1; }
        else take=0;
     }
     if(take) a->d[i++]=1;
     a->l=i;
}

void sub(lnum *a,lnum *b)
{
	int i,take=0,len=(a->l>b->l)?a->l:b->l;
	for(i=0;i<len;i++)
	{
		a->d[i]-=b->d[i]+take;
		if(a->d[i]<0) { a->d[i]+=MOD; take=1; }
		else take=0;
	}
	while(a->l>=0&&a->d[a->l-1]==0) a->l--;
}

void mult(lnum *a,int n)
{
    int i,take=0,tmp;
    for(i=0;i<a->l;i++)
	{
		tmp=a->d[i]*n;
		a->d[i]=tmp%MOD+take;
		take=tmp/MOD;
	}
}

int cmp(lnum *a,lnum *b)
{
	int i;
	if(a->l!=b->l) return a->l-b->l;
	for(i=a->l-1;i>=0;i--) if(a->d[i]!=b->d[i]) return a->d[i]-b->d[i];
	return 0;
}

void print(lnum *a)
{
    int i;
    if(a->l==0) printf("%d",0);
    else printf("%d",a->d[a->l-1]);
    for(i=a->l-2;i>=0;i--) printf("%09d",a->d[i]);
    printf("\n");
}

int main()
{
    int n,p,k,i,tmp;
    long long a,b;
	lnum l,r,tl,tr,s,z,x;
	scanf("%d%d%d",&n,&p,&k);
	for(i=0;i<k;i++)
	{
		scanf("%d",&tmp);
		can[tmp]=1;
	}
    scanf("%ld%ld",&a,&b);
	set(&x,a);
	set(&z,b);
	set(&l,0);
	copy(&r,&z);
	for(k=0;k<p;k++)
	{
		copy(&s,&r); sub(&s,&l);
		mult(&z,n);
		mult(&l,n);
		mult(&r,n);
		mult(&x,n);
		copy(&tl,&l);
		copy(&tr,&tl); add(&tr,&s);
		for(i=0;i<n;i++)
		{
			if(cmp(&x,&tl)>=0&&cmp(&x,&tr)<0)
			{
				if(can[i+1])
				{
					printf("%d\n",k+1);
					return 0;
				}
				copy(&l,&tl);
				copy(&r,&tr);
				break;
			}
			copy(&tl,&tr);
			add(&tr,&s);
		}
	}
	printf("%d\n",0);
	return 0;
}

