/*
TASK:MONUMENT
LANG:C++
*/

#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
using namespace std;

struct TPoint {
	double x,y;
}Point[512];

int N;
double minx=2000,miny=2000,maxx=-2000,maxy=-2000;

int Cross(TPoint P1, TPoint P2, double y) {
		if( (P1.y<=y && P2.y>=y) || (P1.y>=y && P2.y<=y) ) return 1;
		return 0;
}

void CrossY(double y, double &x1, double &x2) {
			int i;
			int f=0;
			for(i=0; i<N && f<2; i++)
			{
				if(Cross(Point[i],Point[i+1],y))
				{
					f++;
					if(f==1)
					{
						if(Point[i].x==Point[i+1].x) x1=Point[i].x;
						else
						{
							double k = (Point[i].y-Point[i+1].y)/(Point[i].x-Point[i+1].x);
							double b = Point[i].y-k*Point[i].x;
							x1 = (y-b)/k;
						}
					}
					else
					{
						if(Point[i].x==Point[i+1].x) x2=Point[i].x;
						else
						{
							double k = (Point[i].y-Point[i+1].y)/(Point[i].x-Point[i+1].x);
							double b = Point[i].y-k*Point[i].x;
							x2 = (y-b)/k;
						}
					}
				}
			}
			if(x1>x2) { double T=x1; x1=x2; x2=T; }			
}

double Distance(TPoint P1, TPoint P2) {
			return sqrt((P1.x-P2.x)*(P1.x-P2.x)+(P1.y-P2.y)*(P1.y-P2.y));			
}

double S(TPoint P1, TPoint P2, TPoint P3) {
	double T;
	T = (P1.x-P2.x)*(P1.y+P2.y)+(P2.x-P3.x)*(P2.y+P3.y)+(P3.x-P1.x)*(P3.y+P1.y);
	if(T<0) T=-T;	
	return T;
}

double Dist(TPoint P1, TPoint P2, TPoint P) {
		double D;
		double D1,D2,D3;
		D1 = Distance(P,P1);
		D2 = Distance(P,P2);
		D3 = S(P1,P2,P)/Distance(P1,P2);
		D=D1;
		if(D2<D) D=D2;
		if(D3<D) D=D3;
		return D;
}

double Check(TPoint P) {
	int i;
	double R=2000;
	for(i=0; i<N; i++)
	{
			double T = Dist(Point[i],Point[i+1],P);
			if(T<R) R=T;
	}
	
	return R;
}

double CheckY(double y, double x1, double x2) {
		double l=x1;
		double r=x2;		
		double m;
		double D1, D2, D3;
		TPoint P1,P2,P3;
		P1.y=y; P2.y=y; P3.y=y;
		
		while(l<=r)
		{
			m=(l+r)/2;
		  P1.x = m;
			P2.x = m-0.001;  	
			P3.x = m+0.001;  				
			D1 = Check(P1); 						
			D2 = Check(P2); 
			D3 = Check(P3);
			if(D2>=D1 && D1>=D3) l=m+0.001;
			else if(D2<=D1 && D1<=D3) r=m-0.001;
			else break;						
		}
		
		return D1;								
}

void Solve(void) {
	int i;	
	double x,y;
	scanf("%d",&N);	
	for(i=0; i<N; i++) 
	{
		scanf("%lf%lf",&(Point[i].x),&(Point[i].y));
	//	printf("%lf %lf\n",Point[i].x,Point[i].y);
		if(Point[i].x<minx) minx = Point[i].x;
		if(Point[i].x>maxx) maxx = Point[i].x;
		if(Point[i].y<miny) miny = Point[i].y;
		if(Point[i].y>maxy) maxy = Point[i].y;
	}
	
	Point[N] = Point[0];
	TPoint R;
	R.x = (minx+maxx)/2;
	R.y = (miny+maxy)/2;
	
	double Res=2000;
	//printf("%lf %lf\n",R.x,R.y);
	Res = Check(R);
	double x1,x2;
	double up,down,T;
	up=R.y;
	down=R.y;
	
	while(1)
	{		
		up+=0.01;
		down-=0.01;
		
		if(clock()/(double)CLOCKS_PER_SEC>0.90) break;
		
		if(up<maxy)
		{
			CrossY(up,x1,x2);
			T = CheckY(up,x1,x2);
			if(T>Res) Res=T;
			//if(T<Res) up=maxy+1;
		}
		
		if(down>miny)
		{			
			CrossY(down,x1,x2);
			T = CheckY(down,x1,x2);
			if(T>Res) Res=T;
			//if(T<Res) down=miny-1;
		}
		
		if(down<miny && up>maxy) break;		
	}
	
	/*for(y=R.y+0.001; y<=maxy; y=y+0.001)
	{
			
			//printf("%lf %lf\n",x1,x2);
	}
	
	for(y=R.y-0.01; y>=miny; y=y-0.01)
	{
			CrossY(y,x1,x2);
			double T = CheckY(y,x1,x2);
			if(T>Res) Res=T;
			//printf("%lf %lf\n",x1,x2);
	}*/
	//for(x=R.x; x<=
	/*double T = CheckX(R.y);
	printf("T=%lf\n",T);*/
	printf("%lf\n",Res);
	
}

int main(void) {
	clock();
	Solve();
	return 0;
}

	
