/*
TASK:monument
LANG:C++
*/

#include <iostream>
#include <fstream>
#include <math.h>
#include <stdlib.h>
#include<algorithm>

using namespace std;
#define maxN 400
typedef struct point { double x,y; };
typedef struct line { double a,b,c; };
typedef struct round { point O;double r; };

point P[maxN+2];
line L[maxN*maxN],S[maxN+1];
int N,M;
bool flag;
double best=0;

void init();
line takeline(point A,point B);
point cross(line p,line q);
double distLP(point A,line p);
point InK(point A,point B,point C);
bool InP(point A);
double minD(point A);
double dist(point A,point B);
line orto(line p,point A);

int main()
{
 init();
 int i,j,x,y;
/* for (i=1;i<N;i++)
    for (j=i+1;j<=N;j++) {
       point Tmp=cross(takeline(P[i],P[i+1]),takeline(P[j],P[j+1]));
       if (flag) {
       point O=InK(P[i],P[j+1],Tmp);
       L[++M]=takeline(Tmp,O); } }*/
 for (i=1;i<=N;i++) {
    point O=InK(P[i-1],P[i],P[i+1]);
    L[++M]=takeline(P[i],O); }
 for (i=1;i<=N;i++) S[i]=takeline(P[i],P[i+1]);
 for (x=1;x<M;x++)
    for (y=x+1;y<=M;y++) {
       point Z=cross(L[x],L[y]);
       if (flag)
          if (minD(Z)>best)
             if (InP(Z))
                best=minD(Z); }
 cout<<best<<endl;
 return 0;
}

void init()
{
// ifstream fin("monument.in");
 cin>>N;
 for (int i=1;i<=N;i++) cin>>P[i].x>>P[i].y;
 P[N+1]=P[1];
 P[0]=P[N];
// fin.close();
}

line takeline(point A,point B)
{
 line Res;
 Res.a=A.y-B.y;
 Res.b=B.x-A.x;
 Res.c=A.x*B.y-A.y*B.x;
 return Res;
}

point cross(line p,line q)
{
 point Res;
 double c1=p.b*q.c-q.b*p.c;
 double c2=q.a*p.c-p.a*q.c;
 double z=p.a*q.b-p.b*q.a;
 flag=1;
 if (z==0) { flag=0;return Res; }
 Res.x=c1/z;Res.y=c2/z;
 return Res;
}

double distLP(point A,line p)
{
 double cc=A.x*p.a+A.y*p.b+p.c;
 if (cc<0) cc=-cc;
 return cc/sqrt(p.a*p.a+p.b*p.b);
}

point InK(point A,point B,point C)
{
 double a=dist(B,C),b=dist(A,C),c=dist(A,B),p=(a+b+c)/2;
 point Lc,Lb;
 Lc.x=A.x+(p-a)*(B.x-A.x)/c;
 Lc.y=A.y+(p-a)*(B.y-A.y)/c;
 Lb.x=A.x+(p-a)*(C.x-A.x)/b;
 Lb.y=A.y+(p-a)*(C.y-A.y)/b;
 line o1=orto(takeline(A,B),Lc);
 line o2=orto(takeline(A,C),Lb);
 return cross(o1,o2);
}

bool InP(point A)
{
 point TT;
 TT.x=8593484;
 TT.y=7643431;
 line k=takeline(A,TT);
 int answ=0;
 for (int i=1;i<=N;i++) {
    point ff=cross(k,S[i]);
    double minx=P[i].x,maxx=P[i+1].x;
    if (minx>maxx) swap(minx,maxx);
    double miny=P[i].y,maxy=P[i+1].y;
    if (miny>maxy) swap(miny,maxy);
    if (ff.x>=minx&&ff.x<=maxx&&ff.y>=miny&&ff.y<=maxy&&ff.x>=A.x&&ff.y>=A.y)
       answ++; }
 return (answ%2==1);
}

double minD(point A)
{
 double Res=488343,cn;
 for (int i=1;i<=N;i++) {
    cn=distLP(A,takeline(P[i],P[i+1]));
    if (cn<best) return cn;
    if (cn<Res) Res=cn; }
 return Res;
}

double dist(point A,point B)
{
 return sqrt((A.x-B.x)*(A.x-B.x)+(A.y-B.y)*(A.y-B.y));
}

line orto(line p,point A)
{
 line Res;
 Res.a=p.b;
 Res.b=-p.a;
 Res.c=-A.x*Res.a-A.y*Res.b;
 return Res;
}


