/*
LANG: C++
TASK: burn
*/

#include <cstdio>
#include <limits>

const int MAXN = 100;
const int MAXM = 6000;
const int MAXHEAP = 16384;
const int NOT_IN = -1;
const int POPPED = -2;
const double MAXD = std::numeric_limits<double>::max();
const double MIND = std::numeric_limits<double>::min();

struct el {
    int to;
    bool f;
    int num;
    double dst;
    int next;
};

struct el2 {
    int e1;
    int e2;
    double len;
};

struct heap {
    int num;
    double fin;
    int id;//1 - purvi krai; 2 - 2ri krai; 3 -  vuzel; 0 - dogarq6t kanap (zapalen ot 1i2 krai)
};

int N, M;
heap h[MAXHEAP];
int hlen;
int index[MAXM];//SAMO ZA KANAPITE - za drugoto imame used
int index2[MAXN];//ZA VUZLITE

/*
void prnth (heap a) {
    printf ("%d %lf %d\n", a.num, a.fin, a.id);
}
*/
void init () {
    int i;
    for (i = 1; i < MAXHEAP; ++i)
        h[i].fin = MAXD;
    h[0].fin = MIND;

    hlen = 1;

    for (i = 0; i < N; ++i)
        index2[i] = NOT_IN;
    for (i = 0; i < M; ++i)
        index[i] = NOT_IN;
}

heap pop () {
    heap ret = h[1];

    if (ret.id != 3)
        index[ret.num] = POPPED;
    else
        index2[ret.num] = POPPED;

    heap tomove = h[--hlen];
    h[hlen].fin = MAXD;
    
    if (hlen == 1)
        return ret;

    int p1 =1, p2 =2;
    
    for (;;) {
        if (h[p2+1].fin < h[p2].fin)
            ++p2;

        if (h[p2].fin < tomove.fin) {
            h[p1] = h[p2];

            if (h[p2].id != 3)
                index[h[p2].num] = p1;
            else
                index2[h[p2].num] = p1;
            p1 = p2;
            p2 *= 2;
        } else
            break;
    }
    h[p1] = tomove;
    if (tomove.id != 3)
        index[tomove.num] = p1;
    else
        index2[tomove.num] = p1;

    return ret;
}

void siftup (heap a) {
//    printf ("sift up - ");
//    prnth (a);

    int p1 = (a.id != 3 ? index[a.num] : index2[a.num]);
    int p2 = p1 / 2;
//    printf ("p1 , p2 == %d %d\n", p1, p2);

    for (;;) {
        if (a.fin < h[p2].fin) {
            h[p1] = h[p2];

            if (h[p2].id != 3)
                index[h[p2].num] = p1;
            else
                index2[h[p2].num] = p1;

            p1 = p2;
            p2 /= 2;
        } else
            break;
    }
//    printf ("put at - %d\n", p1);
    h[p1] = a;

    if (a.id != 3)
        index[a.num] = p1;
    else
        index2[a.num] = p1;
}

double calcfin (int, double, double);

void add (heap a) {
    if (a.id == 1 || a.id == 2) {
        if (index[a.num] == NOT_IN) {
            index[a.num] = hlen++;
            siftup (a);
        } else if (index[a.num] != POPPED) {//in but not popped -> id == 0
            a.id == 0;
            a.fin = calcfin (a.num, h[index[a.num]].fin, a.fin);
            siftup (a);
        }
    } else if (a.id == 3) {
        if (index2[a.num] == NOT_IN) {
            index2[a.num] = hlen++;
            siftup (a);
        }/* else if (index2[a.num] != POPPED) {//fired sooner -> so there's no way to make it better
            if (h[index2[a.num]].fin > a.fin) {
                h[index2[a.num]].fin = a.fin;
                siftup (a);
            }
        }*/
    }
}

int vec[MAXN];
el buf[MAXM*2];
el2 avec[MAXM];
int br[MAXN];

double calcfin (int num, double fstfin, double secfin) {
    return fstfin - (avec[num].len - secfin + fstfin) / 2;
}

double dijkstra (int s) {
//    printf ("dijkstra - %d\n", s);
    init ();
    
    heap crnt, crnt2;
    crnt.id = 3;
    crnt.num = s;
    crnt.fin = br[s];
    add (crnt);
    int k;

    double ctime;
    
    while (hlen > 1) {
        crnt = pop ();
//        printf ("popped - ");
//        prnth (crnt);
        ctime = crnt.fin;

        if (crnt.id == 1 || crnt.id == 2) {
            if (crnt.id == 1) {
                crnt2.id = 3;
                crnt2.num = avec[crnt.num].e1;
                crnt2.fin = crnt.fin + br[avec[crnt.num].e1];
            } else {
                crnt2.id = 3;
                crnt2.num = avec[crnt.num].e2;
                crnt2.fin = crnt.fin + br[avec[crnt.num].e2];
            }
//            printf ("\tadd - ");
//            prnth (crnt2);
            add (crnt2);
        } else if (crnt.id) {
            for (k = vec[crnt.num]; k != -1; k = buf[k].next) {
//                printf ("nghbr - %d %d %lf\n", buf[k].to, buf[k].f, buf[k].dst);
                if (buf[k].f) {
                    crnt2.id = 1;
                    crnt2.num = buf[k].num;
                    crnt2.fin = crnt.fin + buf[k].dst;
                } else {
                    crnt2.id = 2;
                    crnt2.num = buf[k].num;
                    crnt2.fin = crnt.fin + buf[k].dst;
                }
//                printf ("\tadd - ");
//                prnth (crnt2);
                add (crnt2);
            }
        }
    }
//    printf ("************** %lf *****************\n", ctime);
    return ctime;
}

int main () {
    scanf ("%d%d", &N, &M);

    int i;
    int a,b;
    double l;
    int bp =0;
    for (i = 0; i < N; ++i) vec[i] = -1;
    for (i = 0; i < M; ++i) {
        scanf ("%d%d%lf", &a, &b, &l);
        --a; --b;
        avec[i].e1 = a;
        avec[i].e2 = b;
        avec[i].len = l;
        
        buf[bp].to = b;
        buf[bp].f = 0;
        buf[bp].dst = l;
        buf[bp].num = i;
        buf[bp].next = vec[a];
        vec[a] = bp++;
        
        buf[bp].to = a;
        buf[bp].f = 1;
        buf[bp].dst = l;
        buf[bp].num = i;
        buf[bp].next = vec[b];
        vec[b] = bp++;

        ++br[a];
        ++br[b];
    }
/*    int j;
    for (i = 0; i < N; ++i) {
        printf ("%d -> ", i);
        for (j = vec[i]; j != -1; j = buf[j].next)
            printf (" (%d %d %lf)", buf[j].to, buf[j].f, buf[j].dst);
        printf ("\n");
    }
    for (i = 0; i < M; ++i)
        printf ("%d %d %lf\n", avec[i].e1, avec[i].e2, avec[i].len);\
    printf ("*************\n");
*/
    double ctime;
    double btime = std::numeric_limits<double>::max();
    for (i = 0; i < N; ++i) {
        if ((ctime = dijkstra (i)) < btime)
            btime = ctime;
    }
    
    printf ("%lf\n", btime);
}
