/*
TASK: BURN
LANG: C
*/
#include<stdio.h>

#define MAXN 128
#define MAXM 16384
#define INF 10e16

int n,m,br,ans[MAXN],beg[MAXN],used[MAXN],burn[MAXN];
double d[MAXN],f[MAXM];

struct edge
{
        int l,r,c,num,next;
} e[MAXM];

void add(int l,int r,int c,int num)
{
        e[br].l=l; e[br].r=r;
        e[br].c=c; e[br].num=num;
        e[br].next=beg[l]; ans[l]++;
        beg[l]=br++;
}

double dijkstra(int v1)
{
        int i,j,v2,reb;
        double min=INF,max=0;
        for(i=0;i<n;i++) { d[i]=INF; used[i]=0; }
        for(i=0;i<m;i++) { f[i]=0; burn[i]=0; }
        d[v1]=ans[v1];
        while(1)
        {
                v1=-1; min=INF;
                for(i=0;i<n;i++)
                {
                        if(!used[i]&&d[i]<min) { min=d[i]; v1=i; }
                }
                if(v1==-1) break;
                if(d[v1]>max) max=d[v1];
                used[v1]=1;
                for(i=beg[v1];i!=-1;i=e[i].next)
                {
                        v2=e[i].r; reb=e[i].num;
                        if(burn[reb]==0)
                        {
                                if(d[v1]+e[i].c+ans[v2]<d[v2]) d[v2]=d[v1]+e[i].c+ans[v2];
                                f[reb]=d[v1]+e[i].c;
                                burn[reb]=1;
                        }
                        else if(f[reb]>d[v1])
                        {
                                f[reb]=d[v1]+(f[reb]-d[v1])/2;
                                if(f[reb]>max) max=f[reb];
                        }
                }
        }
        return max;
}

int main()
{
        int i,l,r,c;
        double cur,min=INF;
        //freopen("burn.in","r",stdin);
        scanf("%d%d",&n,&m);
        for(i=0;i<n;i++) beg[i]=-1;
        for(i=0;i<m;i++)
        {
                scanf("%d%d%d",&l,&r,&c);
                add(l-1,r-1,c,i);
                add(r-1,l-1,c,i);
        }
        for(i=0;i<n;i++)
        {
                cur=dijkstra(i);
                if(cur<min) min=cur;
        }
        printf("%.1lf\n",min);
        return 0;
}
