/*
TASK:burn
LANG:C++
*/
# include <stdio.h>
# include <limits.h>
# define MAXN 256
# define MAXM 12005

struct node{
    int y,ind,d,next;
};
node data[MAXM+MAXN];
int br[MAXN];
int in[MAXM][3], cnt[MAXN];
bool used[MAXN];
int dist[MAXN];
int tb[MAXM];

double T;
int n, m, fp=1, MOD;

void readf() {
//    freopen("burn.in","r",stdin);
    scanf("%d %d",&n,&m);
    MOD = n+1;
    for ( int i=0 ; i<m ; i++ ) {
	scanf("%d %d %d",&in[i][0],&in[i][1],&in[i][2]);
	cnt[in[i][0]]++;
	cnt[in[i][1]]++;
    }
}

void add(int a, int b, int d, int ind) {
    data[fp].y = b;
    data[fp].d = d;
    data[fp].ind = ind;
    data[fp].next = br[a];
    br[a] = fp++;
}

void build() {
    for ( int i=1 ; i<=n ; i++ ) {
	add(i,i+MOD,cnt[i],m);
    }
    for ( int i=0 ; i<m ; i++ ) {
	add(in[i][0]+MOD,in[i][1],in[i][2],i);
	add(in[i][1]+MOD,in[i][0],in[i][2],i);
    }
}

void init() {
    for ( int i=0 ; i<MAXN ; i++ ) {
	used[i] = 0;
	dist[i] = INT_MAX;
    }
    for ( int i=0 ; i<=m ; i++ ) 
	tb[i] = -1;
}

void solve(int v) {
    double mintime=0;
    int next,min,q;
    dist[v] = 0;
    next = v;
    do {
	used[next] = 1;
//	printf("%d %d\n",next,dist[next]);
	if ( mintime<dist[next] )
	    mintime = dist[next];
	int p = br[next];
	while (p) {
//	    printf("edge %d %d %d\n",next,data[p].y,q);
	    if ( used[data[p].y]==0 && dist[data[p].y]>dist[next]+data[p].d ) {
		dist[data[p].y] = dist[next]+data[p].d;
		tb[data[p].ind] = dist[next];	
	    } else if ( tb[data[p].ind]==-1 ) {
		tb[data[p].ind] = dist[next];
	    } else {
		q = data[p].d-(dist[next]-tb[data[p].ind]);
//		printf("%d %d %d\n",next,data[p].y,q);
		if ( q>0 && mintime<dist[next]+q/2.0 ) {
		    mintime = dist[next]+q/2.0;
		}
		tb[data[p].ind] = -1;
	    }
	    p = data[p].next;
	}
	min=INT_MAX;
	next = -1;
	for ( int i=1 ; i<2*MOD+10 ; i++ )
	    if ( used[i]==0 && dist[i]<min ) {
		min = dist[i];
		next = i;
	    }
	
    }while(next!=-1);
    if ( mintime < T ) {
	T = mintime;
    }
}

int main() {
    readf();
    build();
    T = INT_MAX;
    for ( int i=1 ; i<=n ; i++ ) {
	init();
	solve(i);
//	printf("T %.1lf\n",T);
    }
    printf("%.1lf\n",T);
    return 0;
}

