program river;

const
	MAXN					= 10000;
	e					= 0.000001;
	INF					= 99999999;

type
	Integer					= LongInt;
	TPoint					= record
		x, y				: Integer;
	end;

var
	pn, pm					: Array [1 .. MAXN] of TPoint;
	dn, dm					: Array [1 .. MAXN] of Real;
	n, m, i, l, r				: Integer;

procedure readInput;
begin
	readln(n, m);
	for i := 1 to n do
		readln(pn[i].x, pn[i].y);
	for i := 1 to m do
		readln(pm[i].x, pm[i].y);
end;

function cmp(a, b: Real): Boolean;
var
	t					: Real;
begin
	t := a-b;
	if (t > e) then cmp := False
	else cmp := True;
end;

function cross(p0, p1, p2: TPoint): Integer;
begin
	cross := (p1.x - p0.x) * (p2.y - p0.y) - (p2.x - p0.x) * (p1.y - p0.y);
end;

function dist(a, b: TPoint): Real;
begin
	dist := sqrt(sqr(a.x-b.x)+sqr(a.y-b.y));
end;

procedure Solve;
var
	pl, pr					: TPoint;
	cl,cr					: Integer;
	c					: Integer;
begin
	l := 1; r := 1;
	for i := 1 to N do
		dn[i] := INF;
	for i := 1 to M do
		dm[i] := INF;
	dn[1] := 0.000000;
	while (True) do begin
		if (l=n+1) then begin
			c := r;
			r := r+1;
			if (c = m) then
				Exit;
			pl := pn[l-1]; pr := pm[r];
			cl := l-1; cr := r;
			while (True) do begin
				if (cl=n+1) and (cr=m+1) then
					break;
				if (cl=n+1) then begin
					if (cross(pm[c],pl,pm[cr])<=0) and
					(cross(pm[c],pr,pm[cr])>=0) then begin
						if (dm[c] + dist(pm[c], pm[cr]) < dm[cr]) then
							dm[cr] := dm[c] + dist(pm[c], pm[cr]);
						pr := pm[cr];
					end else if (cross(pm[c],pl,pm[cr])>0) then break;
					cr := cr+1;
				end else
				if (cr=m+1) then begin
					if (cross(pm[c],pl,pn[cl])<=0) and
					(cross(pm[c],pr,pn[cl])>=0) then begin
						if (dm[c] + dist(pm[c], pn[cl]) < dn[cl]) then
							dn[cl] := dm[c] + dist(pm[c], pn[cl]);
						pl := pn[cl];
					end else if (cross(pm[c],pr,pn[cl])<0) then break;
					cl := cl+1;
				end else
				if (pn[cl].y < pm[cr].y) then begin
					if (cross(pm[c],pl,pn[cl])<=0) and
					(cross(pm[c],pr,pn[cl])>=0) then begin
						if (dm[c] + dist(pm[c], pn[cl]) < dn[cl]) then
							dn[cl] := dm[c] + dist(pm[c], pn[cl]);
						pl := pn[cl];
					end else if (cross(pm[c],pr,pn[cl])<0) then break;
					cl := cl+1;
				end else begin
					if (cross(pm[c],pl,pm[cr])<=0) and
					(cross(pm[c],pr,pm[cr])>=0) then begin
						if (dm[c] + dist(pm[c], pm[cr]) < dm[cr]) then
							dm[cr] := dm[c] + dist(pm[c], pm[cr]);
						pr := pm[cr];
					end else if (cross(pm[c],pl,pm[cr])>0) then break;
					cr := cr+1;
				end;
			end;
		end else
		if (pn[l].y < pm[r].y) or ((pn[l].y = pm[r].y) and (cmp(dn[l], dm[r]))) then begin
			c := l;
			l := l+1;
			if (l=n+1) then begin
				if (dm[m] > dn[c] + dist(pn[n], pm[m])) then
					dm[m] := dn[c] + dist(pn[n], pm[m]);
				continue;
			end;
			pl := pn[l]; pr := pm[r];
			cl := l; cr := r;
			while (True) do begin
				if (cl=n+1) and (cr=m+1) then
					break;
				if (cl=n+1) then begin
					if (cross(pn[c],pl,pm[cr])<=0) and
					(cross(pn[c],pr,pm[cr])>=0) then begin
						if (dn[c] + dist(pn[c], pm[cr]) < dm[cr]) then
							dm[cr] := dn[c] + dist(pn[c], pm[cr]);
						pr := pm[cr];
					end else if cross(pn[c],pl,pm[cr]) > 0 then break;
					cr := cr+1;
				end else
				if (cr=m+1) then begin
					if (cross(pn[c],pl,pn[cl])<=0) and
					(cross(pn[c],pr,pn[cl])>=0) then begin
						if (dn[c] + dist(pn[c], pn[cl]) < dn[cl]) then
							dn[cl] := dn[c] + dist(pn[c], pn[cl]);
						pl := pn[cl];
					end else if (cross(pn[c],pr,pn[cl])<0) then break;
					cl := cl+1;
				end else
				if (pn[cl].y < pm[cr].y) then begin
					if (cross(pn[c],pl,pn[cl])<=0) and
					(cross(pn[c],pr,pn[cl])>=0) then begin
						if (dn[c] + dist(pn[c], pn[cl]) < dn[cl]) then
							dn[cl] := dn[c] + dist(pn[c], pn[cl]);
						pl := pn[cl];
					end else if (cross(pn[c],pr,pn[cl])<0) then break;
					cl := cl+1;
				end else begin
					if (cross(pn[c],pl,pm[cr])<=0) and
					(cross(pn[c],pr,pm[cr])>=0) then begin
						if (dn[c] + dist(pn[c], pm[cr]) < dm[cr]) then
							dm[cr] := dn[c] + dist(pn[c], pm[cr]);
						pr := pm[cr];
					end else if(cross(pn[c],pl,pm[cr])>0) then break;
					cr := cr+1;
				end;
			end;

		end else begin
			c := r;
			r := r+1;
			if (c = m) then
				Exit;
			pl := pn[l]; pr := pm[r];
			cl := l; cr := r;
			while (True) do begin
				if (cl=n+1) and (cr=m+1) then
					break;
				if (cl=n+1) then begin
					if (cross(pm[c],pl,pm[cr])<=0) and
					(cross(pm[c],pr,pm[cr])>=0) then begin
						if (dm[c] + dist(pm[c], pm[cr]) < dm[cr]) then
							dm[cr] := dm[c] + dist(pm[c], pm[cr]);
						pr := pm[cr];
					end else if (cross(pm[c],pl,pm[cr])>0) then break;
					cr := cr+1;
				end else
				if (cr=m+1) then begin
					if (cross(pm[c],pl,pn[cl])<=0) and
					(cross(pm[c],pr,pn[cl])>=0) then begin
						if (dm[c] + dist(pm[c], pn[cl]) < dn[cl]) then
							dn[cl] := dm[c] + dist(pm[c], pn[cl]);
						pl := pn[cl];
					end else if (cross(pm[c],pr,pn[cl])<0) then break;
					cl := cl+1;
				end else
				if (pn[cl].y < pm[cr].y) then begin
					if (cross(pm[c],pl,pn[cl])<=0) and
					(cross(pm[c],pr,pn[cl])>=0) then begin
						if (dm[c] + dist(pm[c], pn[cl]) < dn[cl]) then
							dn[cl] := dm[c] + dist(pm[c], pn[cl]);
						pl := pn[cl];
					end else if (cross(pm[c],pr,pn[cl])<0) then break;
					cl := cl+1;
				end else begin
					if (cross(pm[c],pl,pm[cr])<=0) and
					(cross(pm[c],pr,pm[cr])>=0) then begin
						if (dm[c] + dist(pm[c], pm[cr]) < dm[cr]) then
							dm[cr] := dm[c] + dist(pm[c], pm[cr]);
						pr := pm[cr];
					end else if (cross(pm[c],pl,pm[cr])>0) then break;
					cr := cr+1;
				end;
			end;
		end;
	end;
end;

begin
	readInput;
	Solve;
        writeln(dm[m]:1:4);
end.