#include<stdio.h>
#include<stdlib.h>
#include<math.h>

#define MAXN 32768
#define INF 20000000

typedef struct point { int x,y,flg; } point;

int n,h[MAXN],pos[MAXN];
double d[MAXN],f[MAXN];
point p[MAXN];

void shift_down(int i)
{
    int x=h[i],j=i<<1;
    while(j<=h[0])
    {
        if(j<h[0]&&d[h[j]]+f[h[j]]>d[h[j+1]]+f[h[j+1]]) j++;
        if(d[x]+f[x]<=d[h[j]]+f[h[j]]) break;
        h[i]=h[j]; pos[h[i]]=i;
        i=j; j<<=1;
    }
    h[i]=x; pos[h[i]]=i;
}

void shift_up(int i)
{
    int x=h[i],j=i>>1;
    while(j>=1)
    {
        if(d[x]+f[x]>=d[h[j]]+f[h[j]]) break;
        h[i]=h[j]; pos[h[i]]=i;
        i=j; j>>=1;
    }
    h[i]=x; pos[h[i]]=i;
}

void push(int x)
{
    h[++h[0]]=x; pos[h[0]]=h[0];
    shift_up(h[0]);
}

int pop()
{
    int res=h[1];
    h[1]=h[h[0]--]; pos[h[1]]=1;
    shift_down(1);
    pos[res]=-1;
    return res;    
}

int cmp(const void *e1,const void *e2)
{
    if(((point*)e1)->y!=((point*)e2)->y) return ((point*)e1)->y-((point*)e2)->y;
    return ((point*)e1)->flg-((point*)e2)->flg;
}

int cross(point a,point b,point c) { return (b.x-a.x)*(c.y-a.y)-(c.x-a.x)*(b.y-a.y); }

double dist(point a,point b) { return sqrt((a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y)); }

void update(int x)
{
    int i,xli,xri;
    double di;
    point l,r;
    l.x=-INF; r.x=INF; l.y=r.y=p[x].y;
    for(i=x+1;i<n;i++)
    {
        xli=cross(p[x],l,p[i]);
        xri=cross(p[x],r,p[i]);
        if(xli<=0&&xri>=0)
        {
            if(pos[i]!=-1)
            {
                di=d[x]+dist(p[x],p[i]);
                if(di<d[i])
                {
                    d[i]=di;
                    if(!pos[i])
                    {
                        f[i]=dist(p[i],p[n-1]);
                        push(i);
                    }
                    else shift_up(pos[i]);
                } 
            }
        }
        if(p[i].flg==0&&xli<0) l=p[i];
        if(p[i].flg==1&&xri>0) r=p[i];
        if(cross(p[x],l,r)>0) break;  
    }
}

int main()
{
    int m,i;
    scanf("%d%d",&n,&m);
    for(i=0;i<n;i++) { scanf("%d%d",&p[i].x,&p[i].y); p[i].flg=0; }
    for(i=n;i<n+m;i++) { scanf("%d%d",&p[i].x,&p[i].y); p[i].flg=1; }
    n+=m;
    qsort(p,n,sizeof(p[0]),cmp);
    for(i=0;i<n;i++) d[i]=INF;
    d[0]=0; f[0]=dist(p[0],p[n-1]);
    push(0);
    while(h[0])
    {
        i=pop();
        if(i==n-1) break;
        update(i);
    }
    printf("%.4lf\n",d[n-1]);
    return 0;
}
