#include<stdio.h>
#include<math.h>
#include<stdlib.h>

#define MAX 10005 //**********************************************

#define LEFT  -1
#define RIGHT  1

typedef struct { int x, y; }    point;
typedef struct { int x, y, t; } stack;

stack S[MAX*2];
int l;

point A[MAX], B[MAX];
int n, m;

double sum;

void input ()
{
   int i;

//   freopen ("river.in", "r", stdin);

   scanf ("%d%d", &n, &m);

   for (i=1; i<=n; i++)
      scanf ("%d%d", &A[i].x, &A[i].y);

   for (i=1; i<=m; i++)
      scanf ("%d%d", &B[i].x, &B[i].y);
}

int orient (int x1, int y1, int x2, int y2, int x3, int y3)
{
   return x1*(y2-y3)-y1*(x2-x3)+x2*y3-x3*y2 > 0 ? LEFT : RIGHT;
}

double dist (int x1, int y1, int x2, int y2)
{
   return sqrt( (x2-x1)*(x2-x1) + (y2-y1)*(y2-y1) );
}

int cmp (const void *a, const void *b)
{
   return (*((stack *)a)).y - (*((stack *)b)).y;
}

void solve ()
{
   int i, now;

   S[l].x=A[1].x;
   S[l].y=A[1].y;
   S[l].t=1;
   l++;

   for (i=2; i<n; i++)
      if (orient(S[l-1].x, S[l-1].y, B[m].x, B[m].y, A[i].x, A[i].y) == RIGHT)
      {
	 S[l].x=A[i].x;
	 S[l].y=A[i].y;
	 S[l].t=1;
	 l++;
      }

   for (i=2; i<m; i++)
      if (orient(S[l-1].x, S[l-1].y, B[m].x, B[m].y, B[i].x, B[i].y) == LEFT)
      {
	 S[l].x=B[i].x;
	 S[l].y=B[i].y;
	 S[l].t=2;
	 l++;
      }

   S[l].x=B[m].x;
   S[l].y=B[m].y;
   S[l].t=2;
   l++;


   qsort (S, l, sizeof(S[0]), cmp);

   for (i=0; i<l-1; i++)
   {
      if (S[i].t != S[i+1].t)
	 sum += dist (S[i].x, S[i].y, S[i+1].x, S[i+1].y);
      else
	 if (S[i].t == 1)
	 {
	    if (orient(S[i].x, S[i].y, S[i+1].x, S[i+1].y, S[i+2].x, S[i+2].y) == LEFT)
	       sum += dist (S[i].x, S[i].y, S[i+1].x, S[i+1].y);
	    else
	    {
	       S[i+1].x=S[i].x;
	       S[i+1].y=S[i].y;
	       S[i+1].t=S[i].t;
	    }
	 }
	 else
	 {
	    if (orient(S[i].x, S[i].y, S[i+1].x, S[i+1].y, S[i+2].x, S[i+2].y) == RIGHT)
	       sum += dist (S[i].x, S[i].y, S[i+1].x, S[i+1].y);
	    else
	    {
	       S[i+1].x=S[i].x;
	       S[i+1].y=S[i].y;
	       S[i+1].t=S[i].t;
	    }
	 }
   }
}

/*

void solve ()
{
   int i, j, now;
   int a=0, b=1;


   for (i=1, now=2; i<=n; now++)
   {
      if (orient(A[a][i].x, A[a][i].y, A[b][now].x, A[b][now].y, A[1][m].x, A[1][m].y) == RIGHT)
      {

      }
      j=i+1;

    again: ;
      while
      (
	 A[a][j].y<A[b][now].y &&
	 orient(A[a][i].x, A[a][i].y, A[b][now].x, A[b][now].y, A[a][j].x, A[a][j++].y) == RIGHT
      )
      {
	 sum += dist(A[a][i].x, A[a][i].y, A[a][j-1].x, A[a][j-1].y);
	 i++;
	 goto again;
      }

      // LEFT

   }
}
*/

int main ()
{
   input ();
   solve ();

   printf ("%.4lf\n", sum);

   return 0;
}