#include <stdio.h>
#include <math.h>
#define min(a,b) (((a)<(b))?(a):(b))

 typedef
  struct
   {
    int x,y;
   } point;

 point a[10002];
 point b[10002];
 point t[20002];
 int g[20002];
 int n,m;

 int orient (point a,point b,point c)
  {
   long long pom=(long long)a.x*(long long)(b.y-c.y)+(long long)a.y*(long long)(c.x-b.x)+(long long)b.x*(long long)c.y-(long long)b.y*(long long)c.x;
   if (pom<0) return -1;
   if (pom>0) return 1;
   return 0;
  }

 double dist (point a,point b)
  {
   return sqrt((a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y));
  }

 double diff (int k,int j,int i)
  {
   double k1,k2;
   k1=atan2(t[k].y-t[i].y,t[k].x-t[i].x);
   k2=atan2(t[j].y-t[i].y,t[j].x-t[i].x);
   if (k1<0) k1+=2*acos(-1);
   if (k2<0) k2+=2*acos(-1);
   return min(fabs(k1-k2),2*acos(-1)-fabs(k1-k2));
  }

 double solve (int i,int j)
  {
   int k,o;
   o=-1;
   for (k=i+1;k<j;k++)
    if (orient(t[k],t[i],t[j])==g[k])
     if (o==-1 || diff(k,j,i)>diff(o,j,i))
      o=k;
   if (o==-1)
    return dist(t[i],t[j]);
     else
      return solve(i,o)+solve(o,j);
  }

 int main ()
  {
   int i,j,k;
   scanf("%d%d",&n,&m);
   for (i=1;i<=n;i++)
    scanf("%d%d",&a[i].x,&a[i].y);
   for (i=1;i<=m;i++)
    scanf("%d%d",&b[i].x,&b[i].y);
   i=j=1;
   k=0;
   while (i<=n || j<=m)
    if (i==n+1 || a[i].y>b[j].y)
     {
      t[++k]=b[j++];
      g[k]=1;
     }
     else
      if (j==m+1 || a[i].y<=b[j].y)
       {
        t[++k]=a[i++];
        g[k]=-1;
       }
   printf("%.4lf\n",solve(1,k));
   return 0;
  }
