#include <cstdio>
#include <cstdlib>
using namespace std;

#define MAXK 600
#define min(a,b) ((a)<(b)?(a):(b))
#define max(a,b) ((a)>(b)?(a):(b))
#define EPS 0.000000000001

struct TRect {
	int x1,y1;
	int x2,y2;
}Rect[MAXK];

struct TNasl {
	int b;
	TNasl *Next;
};

struct TVex {
	double x,y;	
	TNasl *Nasl;
}Vex[7000];

int Cnt;

int N, M;
int K;
int Q[10000];
int W[7000];
int V[7000];
int T, B;

double S(double x1, double y1, double x2, double y2, double x3, double y3)
{
	return (x1-x2)*(y1+y2)+(x2-x3)*(y2+y3)+(x3-x1)*(y3+y1);
}

int Cross(double x1, double y1, double x2,double y2, double x3, double y3, double x4, double y4)
{
	double S1, S2, S3, S4;
	S1 = S(x1,y1,x2,y2,x3,y3);
	S2 = S(x1,y1,x2,y2,x4,y4);
	
	S3 = S(x3,y3,x4,y4,x1,y1);
	S4 = S(x3,y3,x4,y4,x2,y2);
		
	//printf("%.2f %.2f %.2f %.2f %.2f %.2f %.2f %.2f",x1,y1,x2,y2,x3,y3,x4,y4); 
	//printf("%.6f %.6f %.6f %.6f\n",S1*S2,S2,S3,S4);
	//if(S1==0 || S2==0 || S3==0 || S4==0) return 1;
	
	if(S1*S2<=-EPS && S3*S4<=-EPS) return 1;
	return 0;
	
}

void Swap(int *x, int *y) {
	int t;
	t = *x;
	*x = *y;
	*y = t;
}

void Init(void) {
	int i;
	scanf("%d%d%d",&N,&M,&K);
	for(i=0; i<K; i++)
	{
		scanf("%d%d%d%d",&(Rect[i].x1),&(Rect[i].y1),&(Rect[i].x2),&(Rect[i].y2));
		if(Rect[i].x2<Rect[i].x1) Swap(&(Rect[i].x1),&(Rect[i].x2));		
		if(Rect[i].y2<Rect[i].y1) Swap(&(Rect[i].y1),&(Rect[i].y2));
	}
}

void GetVex(int i) {
	int x1,y1,x2,y2;
	double x,y;
	x1 = Rect[i].x1;
	y1 = Rect[i].y1;
	x2 = Rect[i].x2;
	y2 = Rect[i].y2;
	
	x=(double)x1-0.5;
	y=(double)y1+0.5;
	if(x>0 && y<M)
	{
		Cnt++;
		Vex[Cnt].x = x; Vex[Cnt].y=y;
	}
		
		
	x=(double)x1-0.5;
	y=(double)y1-0.5;
	if(x>0 && y>0)
	{
		Cnt++;
		Vex[Cnt].x = x; Vex[Cnt].y=y;
	}
	
	x=(double)x1+0.5;
	y=(double)y1-0.5;
	if(x<N && y>0)
	{
		Cnt++;
		Vex[Cnt].x = x; Vex[Cnt].y=y;
	}
	
	x=(double)x1+0.5;
	y=(double)y2+0.5;
	if(x<N && y<M)
	{
		Cnt++;
		Vex[Cnt].x = x; Vex[Cnt].y=y;
	}
	
	x=(double)x1-0.5;
	y=(double)y2+0.5;
	if(x>0 && y<M)
	{
		Cnt++;
		Vex[Cnt].x = x; Vex[Cnt].y=y;
	}
	
	x=(double)x1-0.5;
	y=(double)y2-0.5;
	if(x>0 && y>0)
	{
		Cnt++;
		Vex[Cnt].x = x; Vex[Cnt].y=y;
	}
	
	x=(double)x2+0.5;
	y=(double)y2+0.5;
	if(x<N && y<M)
	{
		Cnt++;
		Vex[Cnt].x = x; Vex[Cnt].y=y;
	}
	
	x=(double)x2-0.5;
	y=(double)y2+0.5;
	if(x>0 && y<M)
	{
		Cnt++;
		Vex[Cnt].x = x; Vex[Cnt].y=y;
	}
	
	x=(double)x2-0.5;
	y=(double)y2-0.5;
	if(x>0 && y>0)
	{
		Cnt++;
		Vex[Cnt].x = x; Vex[Cnt].y=y;
	}
	
	x=(double)x2+0.5;
	y=(double)y1+0.5;
	if(x<N && y<M)
	{
		Cnt++;
		Vex[Cnt].x = x; Vex[Cnt].y=y;
	}
	
	x=(double)x2-0.5;
	y=(double)y1+0.5;
	if(x>0 && y<M)
	{
		Cnt++;
		Vex[Cnt].x = x; Vex[Cnt].y=y;
	}
	
	x=(double)x2-0.5;
	y=(double)y2-0.5;
	if(x>0 && y>0)
	{
		Cnt++;
		Vex[Cnt].x = x; Vex[Cnt].y=y;
	}
}


void Check(int i, int j) {
	int z;
	double x1,y1,x2,y2,x3,y3,x4,y4;
	x1 = Vex[i].x; y1=Vex[i].y;
	x2 = Vex[j].x; y2=Vex[j].y;
	
	for(z=0; z<K; z++)
	{
		if(Cross(x1,y1,x2,y2,(double)Rect[z].x1,(double)Rect[z].y1,(double)Rect[z].x2,(double)Rect[z].y1)) return;
		if(Cross(x1,y1,x2,y2,(double)Rect[z].x1,(double)Rect[z].y1,(double)Rect[z].x1,(double)Rect[z].y2)) return;
		if(Cross(x1,y1,x2,y2,(double)Rect[z].x1,(double)Rect[z].y2,(double)Rect[z].x2,(double)Rect[z].y2)) return;
		if(Cross(x1,y1,x2,y2,(double)Rect[z].x2,(double)Rect[z].y1,(double)Rect[z].x2,(double)Rect[z].y2)) return;
		
	}
	
	TNasl *T;
	T = (TNasl*)malloc(sizeof(TNasl));
	T->b = j;
	T->Next = Vex[i].Nasl;
	Vex[i].Nasl = T;
	
	T = (TNasl*)malloc(sizeof(TNasl));
	T->b = i;
	T->Next = Vex[j].Nasl;
	Vex[j].Nasl = T;
}

void Out(int X) {
	int P[7000];
	int T=0;
	if(X==-1) printf("-1\n");
	else
	{
		int Curr = Cnt;
		//int Curr=W[Cnt];
		while(Curr!=0)
		{
		 	P[T++] = Curr;	
		 	Curr = W[Curr];
		}
		printf("%d\n",T);
		for(int i=T-1; i>=0; i--) printf("%.2f %.2f\n",Vex[P[i]].x, Vex[P[i]].y);
	}
	exit(0);
}

void Solve(void) {
	int i,j;
	for(i=0; i<K; i++)
	{
		GetVex(i);		
	}
	
	Cnt++;
	Vex[0].x=0; Vex[0].y=0;
	Vex[Cnt].x = N-0.5; Vex[Cnt].y=M-0.5;
	
	for(i=0; i<Cnt; i++)
		for(j=i+1; j<=Cnt; j++)
		{
			Check(i,j);
		}
	
	/*TNasl *T;
	T = Vex[0].Nasl;
	while(T)
	{
		printf("%.2f %.2f\n",Vex[T->b].x, Vex[T->b].y);
		T = T->Next;
	}*/
	//for(i=0; i<=Cnt; i++) printf("%.2f %.2f\n",Vex[i].x,Vex[i].y);
	T =0; B=0;
	Q[T++] = 0;
	V[0] = 1;
	while(1)
	{
		if(B>T) Out(-1);
		int X = Q[B++];
		//printf("%d\n",X);
		TNasl *Tmp;
		Tmp = Vex[X].Nasl;
		while(Tmp!=NULL)
		{
			int Y = Tmp->b;
			if(V[Y]==0)
			{
				Q[T++] = Y;
				W[Y] = X;
				V[Y] = 1;
			}
			
			if(Y==Cnt)
			{
				W[Y] = X;
				Out(0);
			}
			Tmp=Tmp->Next;
		}
	}
		
}

int main(void) {
	Cnt = 0;
	Init();
	Solve();
	// printf("%d\n",Cross(0.5,7.5,23.5,9.5,19,4,19,9));
	return 0;
}
