#include <stdio.h>
#include <queue>
#define MAXN 512
using namespace std;

 typedef
  struct
   {
    double x,y;
   }
  point;

 typedef
  struct
   {
    point p1,p2;
   }
  line;
  
 priority_queue< pair< pair<double,double> ,long> > g;
 long n,m;
 double X,Y;
 point b[MAXN*12];
 line a[MAXN];
 long q[MAXN*12];
 long marked[MAXN*12];
 long prev[MAXN*12];
 long s,e;
 long z;
 long list[16];
 long px[MAXN*12];
 long py[MAXN*12];
 long sx[MAXN*12];
 long sy[MAXN*12];
 point r[MAXN*12];
 double move[4][2]={ {-0.5,-0.5},
                     { 0.5, 0.5},
                     { 0.5,-0.5},
                     {-0.5, 0.5} };

 point make_point (double a,double b)
  {
   point e;
   e.x=a;
   e.y=b;
   return e;
  }

 line make_line (point a,point b)
  {
   line e;
   e.p1=a;
   e.p2=b;
   return e;
  }

 long same (point a,point b)
  {
   if (a.x==b.x && a.y==b.y) return 0;
    else return 1;
  }  

 long orient (point a,point b,point c)
  {
   double pom;
   pom=a.x*(b.y-c.y)+a.y*(c.x-b.x)+b.x*c.y-c.x*b.y;
   if (pom<0) return -1;
   if (pom>0) return 1;
   return 0;
  }

 long cross_lines (line a,line b)
  {
   if (orient(b.p1,a.p1,a.p2)*orient(b.p2,a.p1,a.p2)<=0
   &&  orient(a.p1,b.p1,b.p2)*orient(a.p2,b.p1,b.p2)<=0)
    return 0;
     else
      return 1;
  }    

 long cross_any (line o)
  {
   long i;
   line e;   
   if (same(o.p1,o.p2)==0) return 0;
   for (i=1;i<=n;i++)
    {
     e=make_line(a[i].p1,make_point(a[i].p2.x,a[i].p1.y));
     if (cross_lines(e,o)==0) break;
     e=make_line(a[i].p1,make_point(a[i].p1.x,a[i].p2.y));
     if (cross_lines(e,o)==0) break;
     e=make_line(a[i].p2,make_point(a[i].p2.x,a[i].p1.y));
     if (cross_lines(e,o)==0) break;
     e=make_line(a[i].p2,make_point(a[i].p1.x,a[i].p2.y));
     if (cross_lines(e,o)==0) break;          
    }
   if (i>n) return 0;
    else return 1;
  }

 long inside (point t)
  {
   long i;
   if (t.x<0 || t.y<0 || t.x>X || t.y>Y) return 1;
   for (i=1;i<=n;i++)
    if (a[i].p1.y<=t.y && t.y<=a[i].p2.y
    &&  a[i].p1.x<=t.x && t.x<=a[i].p2.x) return 1;
   return 0;
  }

 void back (long i)
  {
   if (i==m-1) return;
   back(prev[i]);
   if (n==0 || same(r[n],b[i])==1)
    r[++n]=b[i];
  }

 void get (long k)
  {
   long i,j;
   z=0;
// up x
   for (j=1;j<=3;j++)
    {
     i=px[k]+j;
     if (i<=m && cross_any(make_line(b[k],b[sx[i]]))==0)
      list[++z]=sx[i];
    }
// down x
   for (j=1;j<=3;j++)
    {
     i=px[k]-j;
     if (i>0 && cross_any(make_line(b[k],b[sx[i]]))==0)
      list[++z]=sx[i];
    }
// up y
   for (j=1;j<=3;j++)
    {
     i=py[k]+j;
     if (i<=m && cross_any(make_line(b[k],b[sy[i]]))==0)
      list[++z]=sy[i];
    }
// down y
   for (j=1;j<=3;j++)
    {
     i=py[k]-j;
     if (i>0 && cross_any(make_line(b[k],b[sy[i]]))==0)
      list[++z]=sy[i];
    }
  }

 int main ()
  {
   long i,tmp,j;
   point pom;
   scanf("%lf%lf",&X,&Y);
   scanf("%ld",&n);
   for (i=1;i<=n;i++)
    scanf("%lf%lf%lf%lf",&a[i].p1.x,&a[i].p1.y,&a[i].p2.x,&a[i].p2.y);
   m=0;
   for (i=1;i<=n;i++)
    for (j=0;j<4;j++)
     {
      pom=make_point(a[i].p1.x+move[j][0],a[i].p1.y+move[j][1]);
      if (inside(pom)==0) b[++m]=pom;
      pom=make_point(a[i].p2.x+move[j][0],a[i].p2.y+move[j][1]);
      if (inside(pom)==0) b[++m]=pom;
      pom=make_point(a[i].p1.x+move[j][0],a[i].p2.y+move[j][1]);
      if (inside(pom)==0) b[++m]=pom;
      pom=make_point(a[i].p2.x+move[j][0],a[i].p1.y+move[j][1]);
      if (inside(pom)==0) b[++m]=pom;            
     }
   b[++m]=make_point(0,0);
   b[++m]=make_point(X,Y);
//
   for (i=1;i<=m;i++)
    g.push(make_pair( make_pair(b[i].x,b[i].y) ,i));
   for (i=m;i>=1;i--)
    {
     tmp=g.top().second;
     sx[i]=tmp;
     px[tmp]=i;
     g.pop();
    }
   for (i=1;i<=m;i++)
    g.push(make_pair( make_pair(b[i].y,b[i].x) ,i));
   for (i=m;i>=1;i--)
    {
     tmp=g.top().second;
     sy[i]=tmp;
     py[tmp]=i;
     g.pop();
    }    
//
   s=e=1;   
   q[1]=m-1;
   marked[m-1]=1;
   while (s<=e)
    {
     if (marked[tmp]>4*n || marked[m]!=0) break;
     tmp=q[s];
     get(tmp);
     for (i=1;i<=z;i++)
      if (marked[list[i]]==0)
       {
        marked[list[i]]=marked[tmp]+1;
        prev[list[i]]=tmp;
        q[++e]=list[i];
       }
     s++;
    }
   if (marked[m]==0)
    printf("-1\n");
     else
      {
       n=0;
       back(prev[m]);
       printf("%ld\n",n);
       for (i=1;i<=n;i++)
        printf("%.2lf %.2lf\n",r[i].x,r[i].y);
      }
   return 0;
  }
  
