//Boris Nikolaev Daskalov SMG 12 A klas
#include <stdio.h>
#include <stdlib.h>

typedef struct
{
 int x1,x2,y1,y2;
} Rect;
typedef struct
{
 double x,y;
} Point;
typedef struct edge
{
 int to;
 struct edge *next;
} Edge;
typedef struct
{
 int x;
 int t;
} EndP;
int n,m;
int k;
Rect r[512];
EndP l[1024];
Point v[1024*512];
Edge* e[1024*512];
int vn;
int vp[1024];
int ep[1024];
int en;
int icmp(const void* a,const void* b)
{
 return *((int*)a)-*((int*)b);
}

int ep_cmp(const EndP* a,const EndP* b)
{
 return a->x - b->x;
}

void find_holes()
{
 int i,j,c,p,y;
 for(i=0;i<en;i++)
 {
   c=0;
   vp[i]=vn;
   for(j=0;j<k;j++)
     if(r[j].x1<=ep[i] && ep[i]<=r[j].x2)
     {
        l[c].x=r[j].y1;
        l[c++].t=1;
        l[c].x=r[j].y2;
        l[c++].t=-1;
     }
   l[c].x=m;
   l[c++].t=1;
   qsort(l,c,sizeof(l[0]),(int (*)(const void*,const void*))ep_cmp);
   p=0;
   y=0;
   for(j=0;j<c;j++)
   {
    if(p==0)
    {
       p+=l[j].t;
       if(l[j].x>y)
       {
        v[vn].x=ep[i];
        if(ep[i]==0 && y==0)
            v[vn].y=0;
        else if(ep[i]==n && j==c-1)
            v[vn].y=m;
        else
            v[vn].y=(double)(l[j].x+y) / 2;
        vn++;
       }
    }
    else
    {
        p+=l[j].t;
        if(p==0)
              y=l[j].x;
    }
   }
 }
 vp[en]=vn;
}

inline int s(Point *a,Point *b,Point *c)
{
 return ((a->x-c->x)*(b->y-c->y)-(a->y-c->y)*(b->x-c->x)) > 0 ;
}
inline int intersect(Point* a,Point *b,Point* c,Point *d)
{
 if(s(a,b,c)==s(a,b,d))
   return 0;
 if(s(c,d,a)==s(c,d,b))
   return 0;
 return 1;
}

int isect(Point* a,Point* b,Rect* r)
{
 Point c,d;
 c.x=r->x1;
 c.y=r->y1;
 d.x=r->x1;
 d.y=r->y2;
 if(intersect(a,b,&c,&d))
    return 1;
 d.x=r->x2;
 d.y=r->y1;
 if(intersect(a,b,&c,&d))
    return 1;
 c.x=r->x2;
 c.y=r->y2;
 if(intersect(a,b,&c,&d))
    return 1;
 d.x=r->x1;
 d.y=r->y2;
 if(intersect(a,b,&c,&d))
    return 1;
 return 0;
}

void build_edges()
{
 int i,j,z,x;
 Edge* p;
 for(z=0;z<en-1;z++)
 {
  for(i=vp[z];i<vp[z+1];i++)
   for(j=vp[z+1];j<vp[z+2];j++)
   {
     for(x=0;x<k;x++)
        if(isect(&v[i],&v[j],&r[x]))
          break;
     if(x<k)
            continue;
//     printf("%d %d\n",i,j);
     p=(Edge*)malloc(sizeof(Edge));
     p->to=j;
     p->next=e[i];
     e[i]=p;
     
     p=(Edge*)malloc(sizeof(Edge));
     p->to=i;
     p->next=e[j];
     e[j]=p;
   }

 }
}
int fifo[512*1024];
int par[512*1024];
int dist[512*1024];
char u[512*1024];
void bfs()
{
 int r,w;
 int x;
 Edge* p;
 fifo[0]=0;
 par[0]=-1;
 dist[0]=0;
 r=0;w=1;
 u[0]=1;
 for(;r<w && !u[vn-1];r++)
 {
  for(p=e[fifo[r]];p!=NULL;p=p->next)
     if(!u[p->to])
     {
        u[p->to]=1;
        fifo[w++]=p->to;
        par[p->to]=fifo[r];
        dist[p->to]=dist[fifo[r]]+1;
     }
 }
}
void print(int x)
{
 if(par[x]!=0)
  print(par[x]);
 printf("%.2f %.2f\n",v[x].x,v[x].y);
}
int main()
{
 int i,w,x;
 scanf("%d %d %d",&n,&m,&k);
 for(i=0;i<k;i++)
 {
    scanf("%d %d %d %d",&(r[i].x1),&(r[i].y1),&(r[i].x2),&(r[i].y2));
    ep[en++]=r[i].x1;
    ep[en++]=r[i].x2;
    if((r[i].x1==0 && r[i].y1==0) || (r[i].x2==n && r[i].y2==m))
    {
     printf("-1");
     return 0;
    }

 }
 ep[en++]=0;
 ep[en++]=n;
 qsort(ep,en,sizeof(ep[0]),icmp);
 for(i=1,w=0;i<en;i++)
  if(ep[i]!=ep[w])
    ep[++w]=ep[i];
 en=w+1;
 find_holes();
 build_edges();
 bfs();
 if(u[vn-1] && dist[vn-1]>(4*k+1))
 {
   for(i=vn-1;par[i]>0;i=par[i])
   {
    for(x=0;x<k;x++)
     if(isect(&v[i],&v[par[par[i]]],&r[x]))
        break;
    if(x==k)
    {
     par[i]=par[par[i]];
     dist[vn-1]--;
    }
   }
 }
  if(u[vn-1])
   {
     printf("%d\n",dist[vn-1]-1);
       if(dist[vn-1]>1)
           print(par[vn-1]);
   }
   else
     printf("-1");

 return 0;
}
