# include <stdio.h>
# define MAXN (1<<9)
# define Ep 0.000000001

struct point{
    double x,y;
};
struct line{
    point a,b;
};

line data[MAXN*4];
point d[MAXN*4];

int mat[MAXN*4][MAXN*4];
int br[MAXN*4];
char used[MAXN*4];

int n,m,k,brl,brp;

int Os(point a, point b, point c) {
    double st = a.x*b.y+a.y*c.x+b.x*c.y-a.x*c.y-a.y*b.x-b.y*c.x;
    if ( st>Ep ) return 1;
    if ( st<-Ep ) return -1;
    return 0;
}

void addline(double a, double b, double c, double d) {
    data[brl].a.x = a;
    data[brl].a.y = b;
    data[brl].b.x = c;
    data[brl++].b.y = d;
}

void addpoint(double a, double b) {
    d[brp].x = a;
    d[brp++].y = b;    
}

void readf() {
    int a,b,c,d;
//    freopen("path.in","r",stdin);
    scanf("%d %d %d",&n,&m,&k);
    addline(0,0,n,0);
    addline(0,0,0,m);
    addline(n,m,n,0);
    addline(n,m,0,m);
    addpoint(0+0.2,0+0.2);
    addpoint(n-0.2,m-0.2);
    for ( int i=0 ; i<k ; i++ ) {
	scanf("%d %d %d %d",&a,&b,&c,&d);
	addpoint(a-0.2,b-0.2);
	addpoint(c+0.2,d+0.2);
	addpoint(a-0.2,d+0.2);
	addpoint(c+0.2,b-0.2);	
	addline(a,b,a,d);
	addline(a,b,c,b);
	addline(c,d,a,d);
	addline(c,d,c,b);
    }    
}

int is(point a, point b, point c, point d) {
    if ( Os(a,b,c)*Os(a,b,d)!=1 && Os(c,d,a)*Os(c,d,b)!=1 )
	return 1;
    return 0;
}

void add(int a, int b) {
    mat[a][br[a]++] = b;
    mat[b][br[b]++] = a;
}

void solve() {
    int p=0;
    for ( int i=0 ; i<brp-1 ; i++ ) {
	for ( int j=i+1 ; j<brp ; j++ ) {
	    p=0;
	    for ( int l=0 ; l<brl ; l++ ) {
		if ( is(d[i],d[j],data[l].a,data[l].b) ) {
		    p = 1;
		}
	    }
	    if ( p==0 ) {
		add(i,j);
	    }
	}
    }
//    printf("%d %d\n",brp,brl);
}

void bfs() {
    int tail[MAXN*4];
    int comes[MAXN*4];
    int p1,p2;
    p1 = 0; p2 = 1;
    tail[0] = 0;
    comes[0] = 0;
    used[0] = 1;
    while (p1!=p2) {
	if ( tail[p1]==1 ) break;
	for ( int i=0 ; i<br[tail[p1]] ; i++ ) {
	    if ( used[mat[tail[p1]][i]]==0 ) {
		used[mat[tail[p1]][i]] = 1;
		tail[p2++] = mat[tail[p1]][i];
		comes[mat[tail[p1]][i]] = tail[p1];	
	    }
	}
	p1++;
    }
    if ( tail[p1]==1 ) {
	int ans[MAXN*4],anslen,x;
	anslen = 0;
	x = comes[tail[p1]];
	while ( x ) {
	    ans[anslen++] = x;
	    x = comes[x];
	}
	printf("%d\n",anslen);
	for ( int i=anslen-1 ; i>=0 ; i-- ) {
	    printf("%.2lf %.2lf\n",d[ans[i]].x,d[ans[i]].y);
	}
    } else {
	printf("-1\n");
    }
}

int main() {
    readf();
    solve();
    bfs();    
    return 0;
}

