#include <map>
#include <cstdio>
#include <vector>
#include <climits>
#include <algorithm>

class waypoint
{
public:
	waypoint() : x(UINT_MAX), y(UINT_MAX), i(UINT_MAX) {}
	waypoint(const unsigned int& X, const unsigned int& Y, const unsigned int& I = 0) : x(X), y(Y), i(I) {}

	unsigned int x;
	unsigned int y;
	unsigned int i;
};

class rectangle
{
public:
	unsigned int w;
	unsigned int s;
	unsigned int e;
	unsigned int n;
};

inline bool operator< (const rectangle& a, const rectangle& b)
{
	return a.w < b.w;
}

inline bool operator< (const waypoint& a, const waypoint& b)
{
	return a.x < b.x;
}

bool path(waypoint a, waypoint b, rectangle r)
{
	if (a.x >= r.w && a.x < r.e && a.y >= r.s && a.y < r.n) return false;
	if (b.x >= r.w && b.x < r.e && b.y >= r.s && b.y < r.n) return false;

	
}

int main()
{
	unsigned int N, M, K;
	std::scanf("%u %u %u", &N, &M, &K);
	std::vector<rectangle> rects(K);
	for (unsigned int i = 0; i < K; i++)
		std::scanf("%u %u %u %u", &(rects[i].w), &(rects[i].s), &(rects[i].e), &(rects[i].n));

	std::sort(rects.begin(), rects.end());

	std::vector<waypoint> wpts;
	for (unsigned int i = 0; i < K; i++)
	{
		if (rects[i].w > 0 && rects[i].s > 0) wpts.push_back(waypoint(rects[i].w-1, rects[i].s-1));
		if (rects[i].w > 0 && rects[i].n < M) wpts.push_back(waypoint(rects[i].w-1, rects[i].n));
		if (rects[i].e < N && rects[i].s > 0) wpts.push_back(waypoint(rects[i].e, rects[i].s-1));
		if (rects[i].e < N && rects[i].n < M) wpts.push_back(waypoint(rects[i].e, rects[i].n));
	}

	std::sort(wpts.begin(), wpts.end());

	/*for (unsigned int i = 0; i < wpts.size(); i++)
		std::printf("(%u, %u)\n", wpts[i].x, wpts[i].y);*/

	std::printf("-1\n");

	return 0;
}
