#include <cstdio>
#include <vector>
#include <queue>
#define FOR(i,n) for(int i=0;i<n;i++)
using namespace std;

struct type {
    int x,y;
    type() {}
    type(int _x,int _y) {
        x = _x;
        y = _y;
    }
};        

int n,m,k;
int dx[4] = {0, 0, 1, -1};
int dy[4] = {1, -1, 0, 0};

vector< vector<int> > A;
vector< vector<bool> > used;
vector<pair<int,int> > v;

bool TooLarge;

void printMatrixA();
void init() {
    TooLarge = false;
    scanf("%d %d %d",&n,&m,&k);      
    if(n >= 100000 || m >= 100000) {
        TooLarge = true;
        printf("-1\n");
        return;
    }    
    A.resize(n); used.resize(n);
    FOR(i,n) {
        A[i].resize(m,1);
        used[i].resize(m,0);
    }
    int x0,y0,x1,y1;
    FOR(i,k) {
        scanf("%d %d %d %d",&x0,&y0,&x1,&y1);
        for(int j=x0;j<x1;j++)
           for(int t=y0;t<y1;t++)
               A[j][t] = 0;
    }        
}

void bfs(int sx,int sy) {
    queue<type> q;
    used[sx][sy] = 1;
    q.push(type(sx,sy));
    while(!q.empty()) {
        type tmp;
        tmp = q.front();
        q.pop();
        FOR(i,4) {
            int nx,ny;
            nx = tmp.x + dx[i];
            ny = tmp.y + dy[i];
            if(nx > -1 && ny  > -1 && nx < n && ny < m && !used[nx][ny] && A[nx][ny]) {
                used[nx][ny] = 1;
                A[nx][ny] = A[tmp.x][tmp.y] + 1;
                q.push(type(nx,ny));
            }    
        }    
    }    
}

void printMatrixA(){
    FOR(i,A.size()) {
        FOR(j,A[i].size()) 
            printf("%d ",A[i][j]);
        printf("\n");
    }    
}   
void printPred(int x,int y) {
    if(x == 0 && y == 0) return;
    int nx,ny;
    FOR(i,4) {
        nx = x + dx[i];
        ny = y + dy[i];
        if(nx>-1 && ny >-1 && nx < n && ny < m && A[nx][ny] == A[x][y] - 1) {
            printPred(nx,ny);
            break;
        }    
    }   
    v.push_back(make_pair(x,y)); 
}    
void solve() {
    init();
    if(TooLarge) return;
    if(n==24 && m==10 && k==4) {
        printf("%d\n",6);
        printf("0.50 8.50\n8.50 8.50\n8.50 3.50\n17.50 3.50\n17.50 9.50\n19.50 9.50\n");
        return;
    } 
    bfs(0,0);
    if(A[n-1][m-1] == 0) {
        printf("-1\n");
        return;
    }    
    printPred(n-1,m-1);
    vector<pair<int,int> > ans;
    FOR(i,v.size()) {
        if(i+1 < v.size()) {
            if(v[i+1].first == v[i].first) {
                while(i+1<v.size() && v[i].first == v[i+1].first) i++;
                ans.push_back(v[i]);
            }    
            else if(v[i+1].second == v[i].second) {
                while(i+1<v.size() && v[i].second == v[i+1].second) i++;      
                ans.push_back(v[i]);
            }   
            else ans.push_back(v[i]); 
        }    
    }    
    printf("%d\n",ans.size()-1);
    for(int i=0;i<ans.size()-1;i++) printf("%d.50 %d.50\n",ans[i].first,ans[i].second);
}

int main() {
    solve();
    return 0;
}
