#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int rxcomp(const void *a, const void *b)
{
  return *(int *)a - *(int *)b;
}

int rycomp(const void *a, const void *b)
{
  return *((int *)a+1) - *((int *)b+1);
}

void addrect(int **I, int *n, int x1, int y1, int x2, int y2)
{
  int *i;
  *I = realloc(*I, (*n+1) << 4);
  i = *I + (*n << 2);
  *i = x1; i++;
  *i = y1; i++;
  *i = x2; i++;
  *i = y2; i++;
  (*n)++;
}

int __inline__ overx(int *r, int *R)
{
  return abs(r[2]+r[0]-R[2]-R[0]) < (r[2]-r[0]+R[2]-R[0]);
}

int __inline__ overy(int *r, int *R)
{
  return abs(r[3]+r[1]-R[3]-R[1]) < (r[3]-r[1]+R[3]-R[1]);
}

int __inline__ overlap(int *r, int *R)
{
  return abs(r[2]+r[0]-R[2]-R[0]) < (r[2]-r[0]+R[2]-R[0])
    && abs(r[3]+r[1]-R[3]-R[1]) < (r[3]-r[1]+R[3]-R[1]);
}

int __inline__ valid(int x1, int y1, int x2, int y2)
{
  return x1 < x2 && y1 < y2;
}

int *Q=0, qtop=0, qmax=0, qbot=0;
void __inline__ put(int i, int f)
{
  if (qmax == qtop)
  {
    qmax += 20;
    Q = realloc(Q, 4*qmax);
  }
  Q[qtop++] = i;
  Q[qtop++] = f;
}

void __inline__ get(int *i, int *f)
{
  *i = Q[qbot++];
  *f = Q[qbot++];
}

int psi=0;
void printstack(int *P, int p, int *S)
{
  if (p != -1)
    printstack(P, P[p], S), S[psi++] = p;
}

float __inline__ gety(int *r1, int *r2)
{
  if (r1[3] - r1[1] > r2[3] - r2[1])
    r1 = r2;
  
  return (r1[3]+r1[1]) / 2.0f;
}

float __inline__ getx(int *r1, int *r2)
{
  if (r1[2] - r1[0] > r2[2] - r2[0])
    r1 = r2;
  
  return (r1[2]+r1[0]) / 2.0f;
}

int main()
{
  int n, m, k, i, R[500][4], *I=0, In=0, j, t, x1, y1, x2, y2;
  int *P, p=0, *RP;
  char *V, **G;

//  freopen("stef\\path.in", "rt", stdin);

  scanf("%d%d%d", &n, &m, &k);
  for (i=0; i<k; i++)
  {
    scanf("%d%d%d%d", &R[i][0], &R[i][1], &R[i][2], &R[i][3]);
    if (R[i][0] == R[i][1] && !R[i][0]) printf("-1\n"), exit(0);
    if (R[i][2] == n && R[i][3] == m) printf("-1\n"), exit(0);
  }
  R[k][0] = R[k][2] = n;
  R[k][1] = R[k][3] = m;

  qsort(R, k, 16, rxcomp);

  if (R[0][0]) addrect(&I, &In, 0, 0, R[0][0], m);
  for (i=0; i<k; i++)
  {
    if (R[i][2] <= R[i+1][0])
    {
      addrect(&I, &In, R[i][0], 0, R[i][2], m);
      if (R[i][2] < R[i+1][0])
        addrect(&I, &In, R[i][2], 0, R[i+1][0], m);
    }
    else addrect(&I, &In, R[i][0], 0, R[i+1][0], m);
  }

  for (i=0; i<In; i++)
  { int *r1 = I+4*i, *r2;
    for (j=0; r2=R[j], j<k; j++)
      if (overlap(r1, r2))
      {
        t = 0;
        if (!memcmp(r1, r2, 16)) t=1;
        x1 = r1[0], y1 = r1[1], x2 = r1[2], y2 = r2[1];
        if (valid(x1, y1, x2, y2))
          t=1, addrect(&I, &In, x1, y1, x2, y2);
        x1 = r1[0], y1 = r2[3], x2 = r1[2], y2 = r1[3];
        if (valid(x1, y1, x2, y2))
          t=1, addrect(&I, &In, x1, y1, x2, y2);
        x1 = r1[0], y1 = r2[1], x2 = r2[0], y2 = r2[3];
        if (valid(x1, y1, x2, y2))
          t=1, addrect(&I, &In, x1, y1, x2, y2);
        x1 = r2[2], y1 = r2[1], x2 = r1[2], y2 = r2[3];
        if (valid(x1, y1, x2, y2))
          t=1, addrect(&I, &In, x1, y1, x2, y2);
/*        x1 = r2[2], y1 = r1[1], x2 = r1[2], y2 = r2[3];
        if (valid(x1, y1, x2, y2))
          t=1, addrect(&I, &In, x1, y1, x2, y2);
        x1 = r2[2], y1 = r2[1], x2 = r1[2], y2 = r1[3];
        if (valid(x1, y1, x2, y2))
          t=1, addrect(&I, &In, x1, y1, x2, y2);
        x1 = r1[0], y1 = r2[1], x2 = r2[0], y2 = r1[3];
        if (valid(x1, y1, x2, y2))
          t=1, addrect(&I, &In, x1, y1, x2, y2);
        x1 = r1[0], y1 = r1[1], x2 = r2[0], y2 = r2[3];
        if (valid(x1, y1, x2, y2))
          t=1, addrect(&I, &In, x1, y1, x2, y2);*/
        if (t)
        {
          memmove(I+4*i, I+4*i+4, 16 * (In-i-1));
          i = -1;
          In--;
          break;
        }
      }
  }
  qsort(I, In, 16, rxcomp);
  printf("In = %d\n", In);
  for (i=0; i<In; i++)
    printf("%d %d %d %d\n", I[4*i], I[4*i+1], I[4*i+2], I[4*i+3]);
  G = malloc(4*In);
  P = calloc(1, 4*In);
  V = calloc(1, In);
  RP = malloc(4*In);
  for (i=0; i<In; i++)
    G[i] = calloc(1, In);
  for (i=0; i<In; i++)
    for (j=0; j<In; j++)
      if (i != j && !G[i][j])
      {
        int *r1 = I+4*i, *r2 = I+4*j;
        if (((r1[0] == r2[2] || r1[2] == r2[0]) && overy(r1, r2)) ||
            ((r1[1] == r2[3] || r1[3] == r2[1]) && overx(r1, r2)))
            G[i][j] = G[j][i] = 1;
      }
  for (i=0; i<In; i++)
  {
    int *r1 = I+4*i;
    if (r1[2] == n && r1[3] == m) p = i;
    if (!r1[0] && !r1[1]) put(i, -1), V[i]=1;
  }

/*  for (i=0; i<In; i++, printf("\n"))
    for (j=0; j<In; j++)
      printf("%d ", G[i][j]);
*/
  while (k = 0, qbot < qtop)
  {
    get(&i, &k);
    P[i] = k;
    if (p == i)
    {
      k = 1;
      printstack(P, p, RP);
      break;
    }
    for (j=0; j<In; j++)
      if (G[i][j] && !V[j]) put(j, i), V[j]=1;
  }

/*  for (i=0; i<psi; i++)
  {
    int *r1 = I + 4*RP[i];
    printf("%d %d %d %d\n", r1[0], r1[1], r1[2], r1[3]);
  }*/

  if (!k) printf("-1\n"), exit(0);

  printf("%d\n", psi-1);
  for (i=0; i<psi-1; i++)
  {
    int *r1 = I + 4*RP[i];
    int *r2 = I + 4*RP[i+1];
    if (r1[2] == r2[0])
      printf("%d.00 %.2f\n", r1[2], gety(r1, r2));
    else if (r1[0] == r2[2])
      printf("%d.00 %.2f\n", r1[0], gety(r1, r2));
    else if (r1[1] == r2[3])
      printf("%.2f %d.00\n", getx(r1, r2), r1[1]);
    else if (r1[3] == r2[1])
      printf("%.2f %d.00\n", getx(r1, r2), r1[3]);
  }

  return 0;
}

