program code.checker;
{ Matrix Equivalence  }
{ Columns Permutation }

{$APPTYPE CONSOLE}

uses
  SysUtils;

const
  m = 9;
  n = 9;

type
  Matrix = array [1..m,1..n] of 0..1;
  Perm = array [0..n] of 1..n;
  RowPerm = array [0..m] of 1..m;

var
  D0, D : Matrix;
  a,ar: Perm;
  c : RowPerm;
  num1,num2  : string;
  done,last : boolean;
  InFile, OutFile: text;
  InFileName: string[12];
  work1,work2: string[12];
  p,result,i,i2,j,j1,j2: integer;
  cnt: integer;

Procedure GetMatrix(m,n:integer; var D: Matrix);
var
  i,j: integer;
  ch: char;
begin
  for i:=1 to m do
    begin
      for j:=1 to n do
        begin
          if not eoln(InFile) then
            begin
              read(InFile,ch);
              if ch=' ' then ch:='0';
            end
          else
            ch:='0';
          D[i,j]:=ord(ch)-ord('0');
        end;
      readln(InFile);
    end;
end;

Function okCode(m,n:integer; var D: Matrix):Boolean;
var
  i,p,q,r,found: integer;
begin
  okCode:=false;
  for p:=1 to n do
  for q:=1 to n do
  if p<>q then
  for r:=1 to n do
  if (p<>r) and (q<>r) then
    begin
      found:=0;
      for i:=1 to m do
        if (D[i,p]=1) and (D[i,q]=0) and (D[i,r]=0) then
          found:=1;
      if found=0 then
       begin
         writeln(0);
         writeln(num1,' is not a code');
         writeln('Bad columns: ',p,',',q,',',r);
         exit;
       end;
    end;

  okCode:=true;
end;


Procedure InvMatrix(m,n:integer; var D: Matrix);
var
  i,j: integer;
begin
  for i:=1 to m do
    for j:=1 to n do
      if D[i,j]=0 then
        D[i,j]:=1
      else
        D[i,j]:=0;
end;


Procedure NextPerm( var a:Perm; p: integer; var last: boolean);

label 10,20;

var i,j,w:integer;

begin
   if (p<1) or (p>n-1) then
     p:=n-1;

      for i:=p+2 to n do
        begin
          w:=a[i];
          for j:=i-1 downto p+1 do
            begin
              if a[j]>=w then
                begin
                  a[j+1]:=w;
                  goto 10;
                end;
              a[j+1]:=a[j];
            end;
          a[p+1]:=w;
10:
        end;

   for  i:=p downto 1 do
    if a[i]<a[i+1] then
      goto 20;

   last:=true;
   exit;

20:
  last:=false;
  p:=i;
  j:=n;


 while a[p] >= a[j] do
   j:=j-1;
 w:=a[p]; a[p]:=a[j]; a[j]:=w;

  i:=p+1; j:=n;
  while i<j do
    begin
      w:=a[i]; a[i]:=a[j]; a[j]:=w;
      i:=i+1; j:=j-1;
    end;

end; { NextPerm }


procedure Reverse(var a,b: perm);
var
  i: integer;
begin
  for i:=1 to n do
    b[a[i]]:=i;
end;

Procedure PrintLnPerm(var a: perm);
var
  used: array[1..n] of boolean;
  i,j: integer;
  jstr: string[3];
  cycles: string;

begin
  for i:=1 to n do
    used[i]:=false;
  Cycles:='';
  for i:=1 to n do
    if not used[i] then
     if a[i]<>i then
      begin
        Cycles:=Cycles+'(';
        j:=i;
        Str(j,jstr);
        Cycles:=Cycles+jstr;
        used[j]:=true;
        j:=a[j];
        while not used[j] do
          begin
            Cycles:=Cycles+',';
            Str(j,jstr);
            Cycles:=Cycles+jstr;
            used[j]:=true;
            j:=a[j]
          end;
        Cycles:=Cycles+')';
      end;
  writeln(Cycles);
end;


Function Order(i1,i2: integer):boolean;

var
  j: integer;

begin
  for j:=1 to n do
    if D[i1,a[j]]<>D[i2,a[j]] then
      begin
        if D[i1,a[j]]>D[i2,a[j]] then
          order:=true
        else
          order:=false;
        exit;
      end;
  order:=true;
end;


Procedure SortRows(r1,r2:integer);

label 10;

var i1,i2,w: integer;

begin
  for i1:=r1+1 to r2 do
    begin
      w:=c[i1];
      for i2:=i1-1 downto r1 do
        begin
          if order(c[i2],w) then
            begin
              c[i2+1]:=w;
              goto 10;
            end;
          c[i2+1]:=c[i2];
        end;
      c[r1]:=w;
10:
    end;
end;

Procedure Compare(r1,r2:integer; var result,p: integer);
var
  i,j: integer;

begin
   for j:=1 to n do
      for i:=r1 to r2 do
        if D[c[i],a[j]] <> D0[i,j] then
          begin
           {       j }
            p:=j;
            if D[c[i],a[j]] > D0[i,j] then
              result:=1
            else
              result:=2;
            exit;
          end;
   p:=n-1;
   result:=0;
end;

begin
  { TODO -oUser -cConsole Main : Insert code here }

  if ParamCount<>1 then
  begin
    writeln('Argument error');
    writeln('Usage: code.checker file_name');
    exit;
  end;

  InFileName := ParamStr(1);
  assign(InFile,InFileName);
  {$I-}
  reset(InFile);
  {$I+}
  if IOResult <> 0 then
  begin
    writeln(0);
    writeln('Cannot open ',InFileName);
    exit;
  end;

  if eof(InFile) then
    begin
      writeln(0);
      writeln('Empty file ',InFileName);
      exit;
    end;

  Work1:='w1.dat';
  Work2:='w2.dat';

  assign(InFile,InFileName);
  assign(OutFile,Work1);
  reset(InFile);
  rewrite(OutFile);

  cnt:=0;
  WHILE not eof(InFile) do
  BEGIN
    cnt:=cnt+1;
    readln(InFile,num1);
    GetMatrix(m,n,D);
    if not okCode(m,n,D) then
      begin
        close(InFile);
        close(OutFile);
        exit;
      end;

      for j:=1 to n do
        a[j]:=j;
      for i:=1 to m do
        c[i]:=i;
      SortRows(1,m);
      for i:=1 to m do
        for j:=1 to n do
          D0[i,j]:=D[c[i],a[j]];

    while not eof(InFile) do
      begin
      readln(InFile,num2);
      GetMatrix(m,n,D);

      for j:=1 to n do
        a[j]:=j;
      for i:=1 to m do
        c[i]:=i;

      repeat
        SortRows(1,m);
        Compare(1,m,result,p);
        if  (result=0) then
          begin
            close(InFile);
            close(OutFile);
            writeln(0);
            writeln('Equivalent codes');
            write(num1,'<--',num2,' : ');
            Reverse(a,ar);
            PrintLnPerm(ar);
            exit;
          end;
        NextPerm(a,p,last);
      until last;

      writeln(OutFile,num2);
      for i:=1 to m do
        begin
          for j:=1 to n do
            write(OutFile,D[i,j]);
          writeln(OutFile);
        end;

     end;

    close(InFile);
    close(OutFile);

   if odd(cnt) then
     begin
       assign(InFile,Work1);
       assign(OutFile,Work2);
     end
   else
     begin
        assign(InFile,Work2);
        assign(OutFile,Work1);
     end;

  reset(InFile);
  rewrite(OutFile);

END;

close(InFile);
close(OutFile);

writeln(4*cnt);
writeln('Correct solution');

end.


