/*
TASK:oper
LANG:C++
*/

#include <stdio.h>
#include <string.h>

const int VALUE_MAX = 101;
const int ARG_COUNT_MAX = 31;

int iF[VALUE_MAX][VALUE_MAX];
int arg_max;
int args[ARG_COUNT_MAX];
int argc;

// (x,y,z) - can we build value z using arguments x through y, inclusive.
bool can_do[ARG_COUNT_MAX][ARG_COUNT_MAX][VALUE_MAX]; 

void init()
{
	memset(iF,0,sizeof(iF));
	memset(can_do,0,sizeof(can_do));
}

void load()
{	
	//stdin = fopen("oper.in","r");

	scanf("%d",&arg_max);
	for (int iY=1;iY<=arg_max;iY++)
		for (int iX=1;iX<=arg_max;iX++)
			scanf("%d",&(iF[iY][iX]));

	scanf("%d",&argc);
	for (int i=0;i<argc;i++)
		scanf("%d",&(args[i]));
}

// (iL*...*iM)*(...*iR)
void split(int iL,int iM,int iR)
{
	//printf("%d %d %d\n",iL,iM,iR);
	for (int iV1=1;iV1<=arg_max;iV1++)
		for (int iV2=1;iV2<=arg_max;iV2++)
			if (can_do[iL][iM][iV1] && can_do[iM+1][iR][iV2])
				can_do[iL][iR][iF[iV1][iV2]] = true;
		
}

void solve()
{
	for (int i=0;i<argc;i++)
		can_do[i][i][args[i]] = true;

	for (int iS=1;iS<=argc;iS++) 
		for (int iL=0;iL<argc && iL+iS<argc;iL++) {
			int iR = iL + iS;
			for (int iM=iL;iM<iR;iM++)
				split(iL,iM,iR);
		}
}

void save()
{
	int iR = 0;
	
	for (int i=1;i<=arg_max;i++)
		if (can_do[0][argc-1][i]) {
			iR++;
			//printf("can do %d\n",i);
		}

	printf("%d\n",iR);
}

int main()
{
	init();
	load();
	solve();
	save();

	return 0;
}
