/*
TASK: oper
LANG: C++
*/
#include <cstdio>
#include <vector>
#include <algorithm>

class answer
{
public:
	answer(const unsigned int& v) : value(v) {}

	unsigned int value;
};

inline void merge(const std::vector<unsigned int>& a, const std::vector<unsigned int>& b, std::vector<unsigned int>& r, const std::vector<std::vector<unsigned int> >& f)
/* For every x of a and y of b, adds f(x, y) to r if not already there. */
{
	bool eq = a.size() == b.size();
	for (unsigned int i = 0; i < a.size() && eq; i++)
		eq = a[i] == b[i];

	if (eq)
	{
		r.resize(a.size());
		for (unsigned int i = 0; i < a.size(); i++)
			r[i] = a[i];
		return;
	}

	for (unsigned int i = 0; i < a.size(); i++)
		for (unsigned int j = 0; j < b.size(); j++)
			r.push_back(f[a[i]-1][b[j]-1]);

	std::sort(r.begin(), r.end());
	r.erase(std::unique(r.begin(), r.end()), r.end());
}

int main()
{
	try
	{
		unsigned int k, n;
		std::scanf("%u", &k);
		std::vector<std::vector<unsigned int> > f(k);
		for (unsigned i = 0; i < k; i++)
		{
			f[i].resize(k);
			for (unsigned int j = 0; j < k; j++)
				std::scanf("%u", &(f[i][j]));
		}
		std::scanf("%u", &n);
		std::vector<std::vector<std::vector<unsigned int> > > values(n+1);
		for (unsigned int i = 1; i <= n; i++)
			values[i].resize(n-i+1);

		unsigned int x;
		for (unsigned int i = 0; i < n; i++)
		{
			std::scanf("%u", &x);
			values[1][i].push_back(x);
		}

		/* BEGIN */
		for (unsigned int i = 2; i <= n; i++)
		{
			bool eq = true;
			for (unsigned int j = 0; j < values[i].size(); j++)
			{
				for (unsigned int m = 1; m <= i-1; m++)
					merge(values[m][j], values[i-m][j+m], values[i][j], f);

				if (j != 0 && eq)
				{
					eq = values[i][0].size() == values[i][j].size();
					for (unsigned int m = 0; m < values[i][j].size() && eq; m++)
						eq = values[i][0][m] == values[i][j][m];
				}
			}

			if (eq) throw answer(values[i][0].size());
		}
		/* END */

		std::printf("%u\n", values[n][0].size());

		return 0;
	}
	catch (answer a)
	{
		std::printf("%u\n", a.value);
		return 0;
	}
}
