/*
TASK:perm
LANG:C++
*/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

const int L_MAX = 52;

const int SOL[] = {1,2,5,14,42,132,429,1430,4862,16796,58786,208012,742900,2674440,
	           9694845,35357670,129644790,477638700,1197892050};

int iL;
int iPerm[L_MAX];
int iLargest[L_MAX]; // (x) - The largest element in the first x inclusive
int iR = 0;
bool bNext = false;

int iP1[L_MAX];

void swap(int iPos,int iSwap)
{
	int tmp = iPerm[iPos];
	iPerm[iPos] = iPerm[iSwap];
	iPerm[iSwap] = tmp;
}

int max(int i1,int i2)
{
	return i1 > i2 ? i1 : i2;
}

bool cmp()
{
	for (int i=0;i<iL;i++)
		if (iPerm[i] != iP1[i])
			return false;
	return true;
}

void print()
{
	if (iR == SOL[iL-1] && !bNext) {
		for (int i=0;i<iL;i++)
			iPerm[i]=i;
	}
	
	for (int i=0;i<iL;i++) {
		printf("%d",iPerm[i]+1);
		if (i!=iL-1)
			printf(" ");
	}
	printf("\n");
	exit(0);
}

void generate(int iPos,int iMin)
{
	if (iPos == iL) {
		/*			
		for (int i=0;i<iL;i++)
			printf("%d ",iPerm[i]+1);
		printf("\n");
		*/
		iR++;
		if (bNext || iR == SOL[iL-1])
			print();
		if (cmp())
			bNext = true;		
		return;	
	}
	for (int iSwap=iPos;iSwap<iL;iSwap++) {
		if (iPerm[iSwap] < iMin)
			continue;
		
		swap(iPos,iSwap);
		
		int old_largest = iLargest[iPos];
		if (iPos==0)
			iLargest[iPos] = iPerm[iPos];
		else
			iLargest[iPos] = max(iLargest[iPos-1],iPerm[iPos]);	
		
		int new_min = iMin;
		if (iLargest[iPos-1] > iPerm[iPos])
			new_min = iPerm[iPos];
				
		generate(iPos+1,new_min);
		
		iLargest[iPos] = old_largest;

		swap(iPos,iSwap);
	}
}

int main()
{
	scanf("%d",&iL);
	printf("%d\n",SOL[iL-1]);
	
	for (int i=0;i<L_MAX;i++) {
		iPerm[i] = i;
		iLargest[i] = i;
	}
	if (iL <= 11) {
		for (int i=0;i<iL;i++) {
			scanf("%d",&(iP1[i]));
			iP1[i]--;
		}
				
		generate(0,-1);
	} else {
		for (int i=0;i<iL;i++) {
			printf("%d",iPerm[i]+1);
			if (i!=iL-1)
				printf(" ");
		}
		printf("\n");
	}
	
	return 0;
}
