#include <fstream.h>
#include <math.h>
#include <string.h>

#define NMax 100

typedef unsigned char boolean;
typedef struct {long x,y,z;} vector;
unsigned n;
vector vec[NMax],vecsol;
unsigned no_mixture=0;
int care[4];
boolean luat[NMax];
boolean gata1,gata2;

long det(long a, long b, long c,
         long d, long e, long f,
         long g, long h, long i)
{
        return a*e*i+b*f*g+c*d*h-c*e*g-b*d*i-a*f*h;
}

boolean sunt_coliniari(vector vec1,vector vec2)
{
        if ( ( vec1.y*vec2.z-vec1.z*vec2.y==0 ) &&
             ( vec1.z*vec2.x-vec1.x*vec2.z==0 ) &&
             ( vec1.x*vec2.y-vec1.y*vec2.x==0 ) )
               return 1;
        return 0;
}

boolean sunt_liniar_independenti(vector vec1, vector vec2, vector vec3)
//verifica daca 3 vectori sunt liniar independenti, altfel spus nu sunt coplanari
{
        if (vec1.x*vec2.y*vec3.z+vec2.x*vec3.y*vec1.z+vec3.x*vec1.y*vec2.z-
            vec3.x*vec2.y*vec1.z-vec2.x*vec1.y*vec3.z-vec1.x*vec3.y*vec2.z!=0) return 1;
        return 0;
}

void back1(unsigned pos)
{
        if (pos==3)
        {
                if (!sunt_liniar_independenti(vec[care[1]],vec[care[2]],vecsol))
                   {
                        //cu cat amplific substanta A:
                        long a=vecsol.x*vec[care[2]].y-vec[care[2]].x*vecsol.y;
                        //cu cat amplific substanta B:
                        long b=vec[care[1]].x*vecsol.y-vecsol.x*vec[care[1]].y;
                        //cu cat amplific substanta finala:
                        long d=vec[care[1]].x*vec[care[2]].y-vec[care[2]].x*vec[care[1]].y;
                        if ( (a*vec[care[1]].z+b*vec[care[2]].z==d*vecsol.z) &&
                              ( ( (a<0) && (b<0) && (d<0) ) || ( (a>=0) && (b>=0) && (d>=0) ) ) )
                                gata1=1;
                   }
                return;
        }
        for (int i=care[pos-1]+1; i<n; i++)
            if (!luat[i])
            {
                luat[i]=1;
                care[pos]=i;
                back1(pos+1);
                if (gata1) return;
                luat[i]=0;
            }
}

void back2(unsigned pos)
{
        if (pos==4)
        {
                //cu cat amplific substanta A:
                long a=det(vecsol.x,vec[care[2]].x,vec[care[3]].x,
                          vecsol.y,vec[care[2]].y,vec[care[3]].y,
                          vecsol.z,vec[care[2]].z,vec[care[3]].z);
                //cu cat amplific substanta B:
                long b=det(vec[care[1]].x,vecsol.x,vec[care[3]].x,
                          vec[care[1]].y,vecsol.y,vec[care[3]].y,
                          vec[care[1]].z,vecsol.z,vec[care[3]].z);
                //cu cat amplific substanta C:
                long c=det(vec[care[1]].x,vec[care[2]].x,vecsol.x,
                          vec[care[1]].y,vec[care[2]].y,vecsol.y,
                          vec[care[1]].z,vec[care[2]].z,vecsol.z);
                //cu cat amplific substanta finala:
                long d=det(vec[care[1]].x,vec[care[2]].x,vec[care[3]].x,
                          vec[care[1]].y,vec[care[2]].y,vec[care[3]].y,
                          vec[care[1]].z,vec[care[2]].z,vec[care[3]].z);
                /*cout<<care[1]<<" "<<care[2]<<" "<<care[3]<<endl;
                cout<<a<<" "<<b<<" "<<c<<endl;
                cout<<a*vec[care[1]].x+b*vec[care[2]].x+c*vec[care[3]].x-d*vecsol.x<<endl;
                cout<<a*vec[care[1]].y+b*vec[care[2]].y+c*vec[care[3]].y-d*vecsol.y<<endl;
                cout<<a*vec[care[1]].z+b*vec[care[2]].z+c*vec[care[3]].z-d*vecsol.z<<endl;*/
                if ( ( (a<0) && (b<0) && (c<0) && (d<0) ) ||
                     ( (a>=0) && (b>=0) && (c>=0) && (d>=0) ) && (abs(a)+abs(b)+abs(c)+abs(d)!=0) )
                       gata2=1;
                return;
        }
        for (int i=care[pos-1]+1; i<n; i++)
            if (!luat[i])
            {
                //if ( (pos==1)
                //    || ( (pos==2) && (!sunt_coliniari(vec[care[1]],vec[i])) )
                //    || ( (pos==3) && (sunt_liniar_independenti(vec[care[1]],vec[care[2]],vec[i])) ) )
                {
                        luat[i]=1;
                        care[pos]=i;
                        back2(pos+1);
                        if (gata2) return;
                        luat[i]=0;
                }
            }
}

boolean possible()
{
        care[0]=-1;

        //cautam 1 vector coliniar cu vectorul solutie
        for (int i=0; i<n; i++)
            if (sunt_coliniari(vec[i],vecsol))
                return 1;

        //cautam 2 vectori coplanari cu vectorul solutie
        gata1=0;
        memset(luat,0,n*sizeof(boolean));
        back1(1);
        if (gata1) return 1;

        //cautam 3 vetori liniar independenti
        gata2=0;
        memset(luat,0,n*sizeof(boolean));
        back2(1);
        if (gata2) return 1;
        return 0;
}

void write()
{
        ofstream fout("amestec.out");
        //fout<<"Mixture "<<no_mixture<<"\n";
        if (possible()) fout<<"DA";
        else fout<<"NU";
        //if (possible()) fout<<"Possible\n\n";
        //else fout<<"Impossible\n\n";
}

void read()
{
        ifstream fin("amestec.in");
        //while (1)
        {
                fin>>n;
                //if (n==0) break;
                no_mixture++;
                for (int i=0; i<n; i++)
                    fin>>vec[i].x>>vec[i].y>>vec[i].z;
                fin>>vecsol.x>>vecsol.y>>vecsol.z;
                write();
        }
}

void main()
{
        read();
}