// George Drumea - P45
// Rezolvarea mea:
//   Se obtine reprezentarea ternara a numarului (impartiri repetate cu 3)
//   ex: 10200221 (in ordine inversa - de fapt este 12200201)
//   Scopul este ca prin adunari de puteri ale lui trei la numarul
//	 respectiv sa aduc numarul (in baza trei) la o forma ce contine
//   numai 0 si 1 pentru a-l putea obtine din puterile lui trei ramase
//   Acest lucru se face destul de simplu: de fiecare data cand am un 2
//   trebuie sa adun 1 si sa setez transportul la 1 (si evident sa scriu)
//   puterea lui 3 pe primul rand. Binenteles ca trebuie luat in calcul si
//	 transportul, iar cand termin trebuie sa vad daca nu cumva transportul
//   este nenul (cand am un numar de forma: 20 si adun 1 la 2 si obtin 100
//   deci pentru 6 se scrie: 3\n9\n)
//   Sper ca ati inteles ceva ;)

#include <stdio.h>

void huge_init(int * v, unsigned long value)
{
	for (v[0] = 0; value; v[++v[0]] = value % 10, value /= 10);
}

void huge_copy(int * d, int * s)
{
	int i;

	for (i = d[0] = s[0]; i; d[i] = s[i], i--);
}

int huge_div3(int * v)
{
	int t, i;

	for (t = 0, i = v[0]; i > 0;)
	{
		t = t * 10 + v[i];
		v[i--] = t / 3;
		t %= 3;
	}
	while (!v[v[0]] && v[0])
		v[0]--;
	return t;
}

void huge_mul3(int * v)
{
	int i, j;

	for (i = 1, j = 0; i <= v[0]; i++)
	{
		j += v[i] * 3;
		v[i] = j % 10;
		j /= 10;
	}
	for (;j;v[++v[0]] = j % 10, j /= 10);
}

void huge_fprint(FILE * f, int * v)
{
	int i;

	for (i = v[0]; i; i--)
		fprintf(f, "%d", v[i]);
	fprintf(f, " ");
}

int N[101];

void readdata()
{
	FILE * f;
	int i, j, k, ok, t;

	f = fopen("pastila.in", "rt");
	for (i = 101, ok = 1; ok;)
	{
		t = fgetc(f);
		if (t < '0' || t > '9')
			ok = 0;
		else
			N[i--] = t - '0';
	}
	for (j = i + 1, k = i; j <= 101; j++)
		N[j - k] = N[j];
	N[0] = 101 - k;
	fclose(f);
}

int L1[250], L2[250];
int P[250];

void solve()
{
	int ok, q, t, p, i;
	FILE * f;

	L1[0] = L2[0] = 0;

	t = 0; p = 0;
	while (1)
	{
		q = huge_div3(N);
		switch (q)
		{
			case 0: if (t) { L2[++L2[0]] = p; t = 0; }
					break;
			case 1: if (t) { L1[++L1[0]] = p; } else { L2[++L2[0]] = p; }
					break;
			case 2: if (!t) { L1[++L1[0]] = p; t = 1; }
		}
		p++;
		if (!N[0])
			break;
	}
	if (t)
		L2[++L2[0]] = p;

	f = fopen("pastila.out", "wt");

	huge_init(P, 1);
	for (p = 0, i = 1; i <= L1[0]; i++)
	{
		while (p < L1[i])
		{
			huge_mul3(P);
			p++;
		}
		huge_fprint(f, P);
	}
	fprintf(f, "\n");

	huge_init(P, 1);
	for (p = 0, i = 1; i <= L2[0]; i++)
	{
		while (p < L2[i])
		{
			huge_mul3(P);
			p++;
		}
		huge_fprint(f, P);
	}
	fprintf(f, "\n");

	fclose(f);
}

void main()
{
	readdata();
	solve();
}