#include <stdio.h>
#include <string.h>

unsigned char C1[10001], C2[10001];
int L1=0, L2=0;
char Result=0;

void ReadData(void)
{ FILE *F=fopen("PATRAT.IN", "rt");
  while ((C1[L1]=fgetc(F))!='\n') C1[L1++]-='0';
  while ((C2[L2]=fgetc(F))!='\n') C2[L2++]-='0';
  fclose(F);
}

int Included(unsigned char *C2, int L2, int L)
// C1 coincide cu C2 pana la al L-1-lea caracter, deci C1 este inclus in C2.
// Intoarce 1 daca ceea ce urmeaza din C2 este un patratel strict interior,
// 0 daca este un patratel tangent.
{ int Seen[5]={0, 0, 0, 0, 0};
  for (;L<L2; Seen[C2[L++]]=1);
  return(Seen[1]&&Seen[4] || Seen[2]&&Seen[3]);
}

void AssertRest(int RX, int RY, unsigned char C)
{
  if (RX==-1 && (C==2 || C==4) ||
      RX== 1 && (C==1 || C==3) ||
      RY==-1 && (C==3 || C==4) ||
      RY== 1 && (C==1 || C==2)) Result='H';
}

void SetXRest(int &RX1, int &RX2, unsigned char C1, unsigned char C2)
// Seteaza restrictiile RX pentru viitoarele valori din C in functie de
// tendintele relative ale lui C1 si C2
{ if (!RX1)
    { if ((C1==1 || C1==3) && (C2==2 || C2==4))
        { RX1=1; RX2= -1; }
        else if ((C1==2 || C1==4) && (C2==1 || C2==3))
               { RX1=-1; RX2=1; }
    }
}

void SetYRest(int &RY1, int &RY2, unsigned char C1, unsigned char C2)
// Seteaza restrictiile RY pentru viitoarele valori din C in functie de
// tendintele relative ale lui C1 si C2
{ if (!RY1)
    { if ((C1==1 || C1==2) && (C2==3 || C2==4))
        { RY1=1; RY2= -1; }
        else if ((C1==3 || C1==4) && (C2==1 || C2==2))
               { RY1=-1; RY2=1; }
    }
}

void Tangent(char *C, int RX, int RY, int LStop, int L)
// C1 s-a terminat, iar C2 continua sa se micsoreze. Trebuie verificat daca
// C2 ramane tangent fata de C1, pe latura sau pe colt
{
  while (L<LStop && !Result) AssertRest(RX, RY, C[L++]);
  if (!Result) Result=(RX && RY) ? 'G' : 'F';
}

void Exterior(int L)
{ int RX1=0, RY1=0, RX2=0, RY2=0;
  for (; L<L1 && L<L2 && !Result; L++)
    { AssertRest(RX1, RY1, C1[L]);
      AssertRest(RX2, RY2, C2[L]);
      SetXRest(RX1, RX2, C1[L], C2[L]);
      SetYRest(RY1, RY2, C1[L], C2[L]);
    }
  if (Result) return;   // Patratele sunt exterioare
  if (L==L1) Tangent(C2, RX2, RY2, L2, L);
    else Tangent(C1, RX1, RY1, L1, L);
}

void BravoPatratel(void)
{ int L=0;
  while (C1[L]==C2[L] && L<L1 && L<L2) L++;
  if (L==L1 && L==L2) Result='A';
    else if (L==L1)
           Result=Included(C2, L2, L) ? 'C' : 'E';
           else if (L==L2)
                  Result=Included(C1, L1, L) ? 'B' : 'D';
                  else Exterior(L);
}

void main(void)
{
  ReadData();
  BravoPatratel();
  printf("%c\n", Result);
}
