unit Gemeni;

interface

function Ginit:Integer;
function Gsize:Integer;
function Gempty(k:Integer):Boolean;
function Gyourmove:Integer;
procedure Gmymove(k:Integer);

implementation

const MAX_SIZE=1000;

var _G_inited, _G_whoami, _G_whoseturn:Boolean;
var _G_N:Integer;
var _G_board:array[1..MAX_SIZE] of byte;

procedure Error(S:String);
begin
  WriteLn('Error talking to player ', 1+Ord(_G_whoami), ': ', S);
  Halt(1);
end;

function Ginit:Integer;
var i:Integer;
begin
  if _G_inited then Error('Ginit called twice');
  _G_inited:=True;
  for i:=1 to _G_N do _G_board[i]:=0;
  if _G_whoami then Ginit:=2 else Ginit:=1;
end;

procedure _G_initValues;
var i:Integer;
begin
  if ParamCount<>2 then Error('Need two parameters!: N and my side (1/2)');
  _G_inited:=False;
  Val(ParamStr(1), _G_N, i);
  _G_whoami:=(ParamStr(2)='2');
  _G_whoseturn:=False;
  WriteLn('Ok, I am player ', ParamStr(2), ' and N is ', _G_N);
end;

function Gsize:Integer;
begin
  if not _G_inited then Error('Ginit not called');
  Gsize:=_G_N;
end;

function Gempty(k:Integer):Boolean;
begin
  if not _G_inited then Error('Ginit not called');
  if (k<1) or (k>_G_N)
     then Error('Gempty accessed a square outside the board');
  Gempty:=(_G_board[k]=0);
end;

procedure _G_isitover(winner:Boolean);
var i:Integer;
    over:Boolean;
begin
  over:=True;
  for i:=1 to _G_N -1 do
    if (_G_board[i]=0) and (_G_board[i+1]=0)
      then over:=False;
  if over
    then begin
           if winner then i:=2 else i:=1;
           WriteLn('Game over! Player ', 1+Ord(winner), ' wins!');
           Halt;
         end;
end;

procedure Gmymove(k:Integer);
var F:Text;
begin
  if not _G_inited then Error('Ginit not called');
  if (k<1) or (k>=_G_N)
    then Error('Gmymove accessed a square outside the board');
  if (_G_board[k]=1) or (_G_board[k+1]=1)
    then Error('Gmymove accessed a full square');
  if _G_whoseturn xor _G_whoami
    then Error('It ain''t your turn!');
  _G_board[k]:=1; _G_board[k+1]:=1;
  Assign(F, '$move$.tmp'); Rewrite(F);
  Write(F, k); Close(F);
  WriteLn('Player ', 1+Ord(_G_whoami), ' moves at ', k, ' and ', k+1);
  _G_isitover(_G_whoami);
  _G_whoseturn:=not _G_whoseturn;
end;

function Gyourmove:Integer;
var F:Text;
    k:Integer;
begin
  if not _G_inited then Error('Ginit was not called');
  if _G_whoseturn=_G_whoami
    then Error('It was YOUR turn!');
  Write('Write your move in $move$.tmp and press <Enter>...');
  ReadLn;
  Assign(F, '$move$.tmp'); Reset(F);
  Read(F, k); Close(F); Erase(F);
  _G_board[k]:=1; _G_board[k+1]:=1;
  Gyourmove:=k;
  WriteLn('I see that player ', 2-Ord(_G_whoami), ' moves at ', k, ' and ', k+1);
  _G_isitover(not _G_whoami);
  _G_whoseturn:=not _G_whoseturn;
end;

begin
  _G_initValues;
end.
