/*
Algoritmul forta bruta rafinat cu neextinderea dreptunghiului curent cu coordonata (llx,lly) daca contine 0

Complexitate timp: O(m^2*n^2)
Complexitate spatiu: O(1), netinand cont de spatiul ocupat de matrice
*/

#include <stdlib.h>
#include <stdio.h>
#include "comdef.h"

#define MAX 700

typedef u8 *vector;

vector b[MAX];
i16 m,n;
i32 maxArea=0;

void Read()
{
    i16 aux;
    i16 x,y;

    FILE *fin=fopen("matrix.in","rt");

    fscanf(fin,"%hd%hd",&m,&n);
    for (y=0; y<m; y++)
    {
        b[y]=(vector)malloc(sizeof(u8)*n);                
        for (x=0; x<n; x++)
        {
            fscanf(fin,"%hd",&aux);
            b[y][x]=(u8)aux;
        }
    }
    
    fclose(fin); 
}

#define AREA(llx,lly,urx,ury) (llx>urx || lly>ury)?0:(urx-llx+1)*(ury-lly+1)

void GrowOnes(i32 llx, i32 lly, i32 &urx, i32 &ury)
{
    i32 xMax;
    i32 x,y;

    urx=llx-1;
    ury=lly-1;
    
    xMax=n-1;

    for (y=lly; y<m; y++)
    {
        if (b[y][llx]==0)
            break;
        
        for (x=llx; x<=xMax && (b[y][x]==1); x++);
        x--;

        xMax=x;
        
        if (AREA(llx,lly,x,y)>maxArea)
        {
            urx=x;
            ury=y;
        }
    }
}

void Solve()
{
    i32 best_llx=0,best_lly=0,
        best_urx=-1,best_ury=-1;
    i32 llx,lly,urx,ury; //ll=lower-left, ur=upper-right (where (0,0) is lower and to the left of (1,1) )

    maxArea=0;

    for (llx=0; llx<n; llx++)
        for (lly=0; lly<m; lly++)
        {
            GrowOnes(llx,lly,urx,ury);
            if (AREA(llx,lly,urx,ury)>maxArea)
            {
                maxArea=AREA(llx,lly,urx,ury);
                best_llx=llx;
                best_lly=lly;
                best_urx=urx;
                best_ury=ury;
            }
            
        }

    //printf("(%ld,%ld)->(%ld,%ld)\n",best_lly,best_llx,best_ury,best_urx);
    printf("%ld",maxArea);
}

void main()
{
    freopen("matrix.out","wt",stdout);
    Read();
    Solve();
    for (i16 y=0; y<m; y++)
        free(b[y]);
}