/*
Algoritmul forta bruta

Complexitate timp: O(m^3*n^3)
Complexitate spatiu: O(1), netinand cont de spatiul ocupat de matrice
*/

#include <stdlib.h>
#include <stdio.h>
#include "comdef.h"

#define MAX 700

typedef u8 *vector;

vector b[MAX];
i16 m,n;

void Read()
{
    i16 aux;
    i16 x,y;

    FILE *fin=fopen("matrix.in","rt");

    fscanf(fin,"%hd%hd",&m,&n);
    for (y=0; y<m; y++)
    {
        b[y]=(vector)malloc(sizeof(u8)*n);                
        for (x=0; x<n; x++)
        {
            fscanf(fin,"%hd",&aux);
            b[y][x]=aux;
        }
    }

    fclose(fin); 
}

boolean AllOnes(i32 llx, i32 lly, i32 urx, i32 ury)
{
    i32 x,y;

    for (y=lly; y<=ury; y++)
        for (x=llx; x<=urx; x++)
            if (b[y][x]==0)
                return false;
    
    return true;
}

void Solve()
{
    i32 llx,lly,urx,ury; //ll=lower-left, ur=upper-right (where (0,0) is lower and to the left of (1,1) )
    i32 maxArea=0;

    for (lly=0; lly<m; lly++)
        for (llx=0; llx<n; llx++)
            for (ury=lly; ury<m; ury++)
                for (urx=llx; urx<n; urx++)
                    if ( maxArea<(urx-llx+1)*(ury-lly+1) && 
                         AllOnes(llx,lly,urx,ury) )
                    {
                        //se pot memora si coordonatele dreptunghiului solutie
                        //printf("(%ld,%ld)->(%ld,%ld)\n",lly,llx,ury,urx);
                        maxArea=(urx-llx+1)*(ury-lly+1);
                    }

    printf("%ld",maxArea);
}

void main()
{
    freopen("matrix.out","wt",stdout);
    Read();
    Solve();
    for (i16 y=0; y<m; y++)
        free(b[y]);
}