/*
     Solutie a la DDJ April 1999
*/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <limits.h>
#include "comdef.h"

#define MMAX 700
#define NMAX 700

//folosesc o lista dublu-inlantuita cu informatie utila indecsii din vectorul c. Tin minte primul si ultimul element din lista (head, respectiv tail), care se pastreaza intotdeauna. In lista se introduc elemente inainte de tail.
struct ListElem
{
    struct ListElem *next, *prev;
    u16 index;
};

ListElem *head, *tail, *crt;

void AddBeforeTail(u16 index)
{
    tail->prev->next=(ListElem *)malloc(sizeof(ListElem));
    tail->prev->next->next=tail;
    tail->prev->next->prev=tail->prev;
    tail->prev=tail->prev->next;

    tail->prev->index=index;
}

void DeleteCrtElem()
{
    //ListElem *aux=crt->next;
    ListElem *aux=crt->prev;

    crt->prev->next=crt->next;
    crt->next->prev=crt->prev;
    free(crt);
    
    crt=aux;
}

void Solve()
{
    u16 m,n;
    u16 i,j;
    i16 c[NMAX+2];
    u16 length[NMAX+2];
    u16 aux;
    u16 indexMax;
    u32 maxArea=0;

    FILE *fin=fopen("matrix.in","rt");
        
    fscanf(fin,"%hu%hu",&m,&n);

    memset(c+1,0,sizeof(u16)*n);

    //tail si head contin indecsii la elementele 0 si n+1 din vectorul c, care elemente contin -1 (pentru a se putea determina daca este maxim local fara bataie de cap in cazul in care se incearca elementele 1 si n din c)
    head=(ListElem *)malloc(sizeof(ListElem));
    tail=(ListElem *)malloc(sizeof(ListElem));

    head->prev=NULL;
    head->next=tail;
    head->index=0;

    tail->prev=head;
    tail->next=NULL;
    tail->index=n+1;

    c[0]=-1;
    c[n+1]=-1;
    
    for (i=0; i<m; i++)
    {
        for (j=1; j<=n; j++)
        {
            fscanf(fin,"%hu",&aux);
            if (aux==0)
                c[j]=0;
            else
                c[j]++;
        
            AddBeforeTail(j);
        }                    
        
        crt=head->next;
        
        for (j=1; j<=n; j++)
            length[j]=1;
        
        for (j=1; j<=n; j++)
        {
            for (;;)
            {
                if (crt==tail || crt==head)
                    crt=head->next;
                if ( c[crt->index] >= c[crt->prev->index] && 
                     c[crt->index] >= c[crt->next->index] )
                    break;
                crt=crt->next;
            }
            
            if (maxArea<u32(length[crt->index])*c[crt->index])
                maxArea=u32(length[crt->index])*c[crt->index];
            
            if (c[crt->prev->index]<c[crt->next->index])
                indexMax=crt->next->index;
            else
                indexMax=crt->prev->index;
            length[indexMax]+=length[crt->index];
            
            DeleteCrtElem();            
        }
    }
    
    
    FILE *fout=fopen("matrix.out","wt");
    fprintf(fout,"%lu",maxArea);
    fclose(fout);

    free(head);
    free(tail);

    fclose(fin);
}

void main()
{
    Solve();
}