program Observabile;
{$N+}
const NMax=100;
type Line=record
            A, B, C:Extended;     { Parametrii dreptei }
            X0, Y0:Extended;      { Punctul de referinta }
            KMin, KMax:Extended;  { Domeniul de observabilitate }
          end;
     LineVector=array[1..NMax] of Line;
var L:LineVector;
    PX, PY:Extended; { Punctul de observatie }
    N, NObserv:Integer;

procedure InitData;
{ Citeste datele si parametrizeaza dreptele }
var i:Integer;
begin
  Assign(Input, 'observ.in'); Reset(Input);
  ReadLn(PX, PY);
  ReadLn(N);
  for i:=1 to N do
    with L[i] do
      begin
        ReadLn(A, B, C);
        { Fixam un reper pe dreapta }
        if A=0  { Dreapta paralela cu Ox }
          then begin
                 X0:=0; Y0:=-C/B;
               end
          else begin
                 X0:=-C/A; Y0:=0;
               end;
      end;
  Close(Input);
end;

function Sgn(X, Y:Extended; i:Integer):Integer;
{ Intoarce 1 sau -1 dupa cum (X,Y) se afla intr-un semiplan sau altul
  determinat de L[i] }
begin
  if L[i].A*X+L[i].B*Y+L[i].C>0
    then Sgn:=1
    else Sgn:=-1;
end;

function Intersect(i, j:Integer; var Xi, Yi:Extended):Boolean;
var Det:Extended;
begin
  Det:=L[i].A*L[j].B-L[i].B*L[j].A;
  if Det=0 then Intersect:=False
           else begin
                  Intersect:=True;
                  Xi:=(L[i].B*L[j].C-L[i].C*L[j].B)/Det;
                  Yi:=(L[i].C*L[j].A-L[i].A*L[j].C)/Det;
                end;
end;

procedure Obstruct(i,j:Integer);
var Xi, Yi, Xi1, Yi1, Ki:Extended;
    Inters:Boolean;
begin
  Inters:=Intersect(i, j, Xi, Yi);
  if Inters
    then with L[i] do
           begin
             if B=0 then Ki:=(Y0-Yi)/A
                    else Ki:=(Xi-X0)/B; { Aflam parametric punctul de int. }
             Xi1:=X0+(Ki+1)*B;
             Yi1:=Y0-(Ki+1)*A;
             if Sgn(PX, PY, j)=Sgn(Xi1, Yi1, j) { P vede [Ki, +inf) }
               then if Ki>KMin then KMin:=Ki
                               else
               else if Ki<KMax then KMax:=Ki    { P vede (-inf, Ki] }
           end
    else if (Sgn(PX, PY, i)=Sgn(L[j].X0, L[j].Y0, i))  { L[j] ascunde L[i] }
            and (Sgn(PX, PY, j)<>Sgn(L[i].X0, L[i].Y0, j))
           then begin
                  L[i].KMin:=1; L[i].KMax:=0;
                end;
end;

procedure Stare;
{ Verifica pe rand daca fiecare dreapta este observabila }
var i,j:Integer;
begin
  NObserv:=0;
  for i:=1 to N do
    with L[i] do
      begin
        KMin:=-1e100;
        KMax:=+1e100; { Initial toata dreapta este vizibila }
        for j:=1 to N do
          if i<>j then Obstruct(i,j);
        if KMin<KMax then Inc(NObserv);
      end;
end;

begin
  InitData;
  Stare;
  WriteLn(NObserv);
end.
