
{ Dumitru Bogdan }

{ O scurta explicatie a rezolvarii.
  Pentru inceput, as dori sa remarc faptul ca problema a mai fost propusa
 o data, la un concurs PACO (in '98, parca). Daca nu ma insel, acolo nu
 era permisa fixarea elementelor fictive 0 si N+1, ceea ce complica putin
 lucrurile. Oricum, cele 2 rezolvari au multe puncte comune.
  Deci : pentru inceput, sortez o copie a vectorului, pastrand de asemenea
 si indicii initiali. Determin astfel, pentru fiecare element al vectorului
 initial, pozitia sa in sirul final (sirul sortat crescator).
  Localizez minimul si fixez elementul din dreapta lui, aducandu-l astfel
 pe prima pozitie.
  Apoi procedez inductiv : sa presupunem ca am reusit sa aduc primele K
 elemente ale vectorului pe primele K pozitii, sortate DEScrescator, ca
 mai jos.

                       restul elementelor
    K K-1 K-2 ... 1 |______________________|

  Acum incerc sa aduc si al K+1 - lea element. Aceasta se face
 astfel :
  - il localizez (sa spunem ca el se afla pe pozitia P);

    K K-1 K-2 ... 1 |______| P |___________|

  - fixez pozitia P, ceea ce duce la configuratia urmatoare :

    |______| 1 2 ... K-1 K-2 P |___________|

  - fixez pozitia P+1, obtinand un nou vector, in care primele K+1 elemente
 ale sale apar pe primele K+1, sortate tot descrescator :

    P K K-1 K-2 |__________________________|

                adica

    K+1 K K-1 K-2 |________________________|

  Rezolvarea este acum (cred) evidenta : K ia valori de la 2 la N si pentru
 fiecare K, se efectueaza pasii de mai sus. Se obtine un vector sortat
 descrescator. Se fixeaza apoi pozitia N+1, ceea ce inverseaza sensul
 sortarii.
  Cateva observatii :
  - acest algoritm efectueaza intotdeauna exact 2*N fixari;
  - numarul de fixari ar putea fi micsorat (uneori - de pilda pe exemplul
 din problema - se fixeaza aceeasi pozitie de mai multe ori consecutiv,
 ceea ce evident duce la aceeasi configuratie; din motive de lene :-) nu am
 eliminat acest 'bug';
  - complexitate :
    - sortarea initiala este O(N*logN);
    - se fac N localizari; o localizare este O(N), deci O(N^2);
    - se fac 2*N fixari; o fixare este O(N), deci O(N^2);
    Algoritmul este deci patratic, o complexitate acceptabila pentru
  limitele date.}

program ordonare;

const ni='sir.in';
      no='sir.out';
      nmax=1000;

var f:text;
    a,b,p,pz:array [1..nmax] of word;
    n,i,j,med,aux,x,y,poz:word;

procedure load;
begin
     assign(f,ni);reset(f);
     readln(f,n);
     for i:=1 to n do
        readln(f,a[i]);
     close(f);
end;

procedure init;
begin
     for i:=1 to n do begin
        b[i]:=a[i];
        p[i]:=i;
                      end;
end;

procedure qsort(li,ls:integer);
var i,j:integer;
begin
     i:=li;
     j:=ls;
     med:=b[(li+ls) shr 1];
     repeat
           while b[i]<med do i:=i+1;
           while b[j]>med do j:=j-1;
           if i<=j then begin
             aux:=b[i];
             b[i]:=b[j];
             b[j]:=aux;
             aux:=p[i];
             p[i]:=p[j];
             p[j]:=aux;
             i:=i+1;
             j:=j-1;
                        end;
     until i>j;
     if li<j then qsort(li,j);
     if i<ls then qsort(i,ls);
end;

procedure sort;
begin
     qsort(1,n);
     for i:=1 to n do
        pz[p[i]]:=i;
end;

function find(k:word):word;
begin
     for j:=1 to n do
        if pz[j]=k then find:=j;
end;

procedure rotate(k:word);
begin
     writeln(f,k);
     x:=1;
     y:=k-1;
     while x<y do begin
          aux:=a[x];
          a[x]:=a[y];
          a[y]:=aux;
          aux:=pz[x];
          pz[x]:=pz[y];
          pz[y]:=aux;
          x:=x+1;
          y:=y-1;
                  end;
     x:=k+1;
     y:=n;
     while x<y do begin
          aux:=a[x];
          a[x]:=a[y];
          a[y]:=aux;
          aux:=pz[x];
          pz[x]:=pz[y];
          pz[y]:=aux;
          x:=x+1;
          y:=y-1;
                  end;
end;

procedure work;
begin
     assign(f,no);rewrite(f);
     poz:=find(1);
     rotate(poz+1);
     for i:=2 to n do begin
        poz:=find(i);
        rotate(poz);
        rotate(poz+1);
                      end;
     rotate(n+1);
     writeln(f);
     close(f);
end;

begin {programul principal}
     load;
     init;
     sort;
     work;
end.

