/* Versiunea demo */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int _Inited=0, _NMoves=1, _Turn, _CRA, _LRA, _CDA, _LDA, _CRN, _LRN, _Check;

void _Error(char *S)
{ printf("%s[%d]: %s\n", _Turn?"Alb":"Negru", _NMoves, S);
  exit(1);
}

char *init(void)
{ char S[10]="RH8DG8RD4";
  if (_Inited) _Error("Functia init a fost deja chemata");
  _Inited=1;
  _Turn=1;
  _Check=0;
  _CRA=S[1]-64; _LRA=S[2]-48;
  _CDA=S[4]-64; _LDA=S[5]-48;
  _CRN=S[7]-64; _LRN=S[8]-48;
  return strdup(S);
}

void _VerifCross(int NewL, int NewC)
/* Verifica daca nu cumva dama alba sare peste regele alb */
{ int DL=NewL>_LDA ? -1: NewL<_LDA ? 1 : 0,
      DC=NewC>_CDA ? -1: NewC<_CDA ? 1 : 0;
  for (;(NewL!=_LDA) || (NewC!=_CDA); NewL+=DL, NewC+=DC)
    if ((NewL==_LRA) && (NewC==_CRA))
      _Error("Dama nu poate sari peste regele alb");
}

int _WhiteAttacks(int L, int C)
/* Verifica daca albul controleaza campul (C,L) */
{ if (abs(_LRA-L)<=1 && abs(_CRA-C)<=1)
    return 1;  /* RA controleaza campul */
    else if (_LDA!=L && _CDA!=C && abs(_LDA-L)!=abs(_CDA-C))
           return 0; /* DA nu e coliniara cu campul */
           else if ((_LRA-_LDA)*(C-_CDA)!=(L-_LDA)*(_CRA-_CDA))
                  return 1;  /* RA nu e coliniar cu DA si campul */
                  else return !(
                    (_LRA>=_LDA && _LRA<=L || _LRA>=L && _LRA<=_LDA) &&
                    (_CRA>=_CDA && _CRA<=C || _CRA>=C && _CRA<=_CDA) );
                    /* Este sah daca RA nu se interpune intre DA si camp */
}

void whitemove(char *S)
{ int NewL=S[2]-48, NewC=S[1]-64;

  if (!_Inited) _Error("Functia init nu a fost apelata");
  if (!_Turn) _Error("Functia whitemove a fost apelata cand negrul era la mutare");
  if (strlen(S)!=3) _Error(strcat(S, " - Parametrul nu are trei litere"));
  if (S[0]!='R' && S[0]!='D') _Error(strcat(S, " - Prima litera nu este R sau D"));
  if (S[1]<'A' || S[1]>'H') _Error(strcat(S, " - Coloana incorecta"));
  if (S[2]<'1' || S[2]>'8') _Error(strcat(S, " - Linie incorecta"));
  if (S[0]=='D')
    { if (_LDA!=NewL && _CDA!=NewC && abs(_LDA-NewL)!=abs(_CDA-NewC))
        _Error("Dama se muta pe linie sau pe diagonala");
      if (_LDA==NewL && _CDA==NewC) _Error("Dama nu poate sta pe loc");
      if (_LRA==NewL && _CRA==NewC) _Error("Dama nu poate captura propriul rege");
      _VerifCross(NewL, NewC);
      _LDA=NewL; _CDA=NewC;
    }
    else {
      if (abs(_LRA-NewL)>1 || abs(_CRA-NewC)>1)
        _Error("Regele se muta cu un patratel in orice directie");
      if (_LRA==NewL && _CRA==NewC) _Error("Regele nu poate sta pe loc");
      if (_LDA==NewL && _CDA==NewC) _Error("Regele nu poate captura propria dama");
      _LRA=NewL; _CRA=NewC;
    }
  _Check=_WhiteAttacks(_LRN, _CRN);
  _Turn=!_Turn;
}

void _SearchBest(int *BestL, int *BestC, int *AnyMoves)
/* Cauta cea mai buna mutare a negrului. Algoritmul este:
  1. Daca poate, ia dama alba
  2. Daca nu, gaseste acea mutare care sa il duca cat mai departe de
     marginea tablei (si bineinteles sa nu il lase in sah) */
{ int NewL, NewC;

  if (abs(_LRN-_LDA)<=1 && abs(_CRN-_CDA)<=1 &&  /* RN e langa DA */
     (abs(_LRA-_LDA)>1 || abs(_CRA-_CDA)>1))  /* RA nu apara DA */
    _Error("Ti-am lu-at da-ma! Ti-am lu-at da-ma! Remiza");
  for (NewL=_LRN-1; NewL<=_LRN+1; NewL++)
    for (NewC=_CRN-1; NewC<=_CRN+1; NewC++)
      if (NewL>=1 && NewL<=8 && NewC>=1 && NewC<=8 &&
         (NewL!=_LRN || NewC!=_CRN) && !_WhiteAttacks(NewL, NewC))
        { *BestL=NewL;
          *BestC=NewC;
          *AnyMoves=1;
          return;
        }
  *AnyMoves=0;
}

char *blackmove(void)
{ int BestL, BestC, AnyMoves;
  char *S=malloc(4);

  if (!_Inited) _Error("Functia init nu a fost apelata");
  if (_Turn) _Error("Functia blackmove a fost apelata cand albul era la mutare");
  _SearchBest(&BestL, &BestC, &AnyMoves);
  if (!AnyMoves)
    if (_Check) _Error("********* Mat! Ai reusit! *********");
      else _Error("Pat - remiza");
  if (_NMoves==5) _Error("Negrul a rezistat eroic timp de 5 mutari");
  _NMoves++;
  _Check=0;
  _Turn=!_Turn;
  _LRN=BestL; _CRN=BestC;
  S[0]='R'; S[1]=BestC+64; S[2]=BestL+48; S[3]=0;
  return strdup(S);
}
