unit Sah;
{ Versiune demo }

interface
  function init:String;
  procedure whitemove(S:String);
  function blackmove:String;

implementation
const Inited:Boolean=False; { True dupa init }
      NMoves:Integer=1;
var Turn:Boolean;    { White = True, Black = False }
    CRA, LRA, CDA, LDA, CRN, LRN:Integer;
    Check:Boolean;   { True daca negrul se afla in sah }

procedure Error(S:String);
begin
  if Turn then Write('Alb') else Write('Negru');
  WriteLn('[', NMoves, ']: ',S);
  Halt;
end;

function init:String;
const S:String='RH8DG8RD4';
begin
  if Inited then Error('Functia init a fost deja chemata');
  Inited:=True;
  Turn:=True;
  Check:=False;
  CRA:=Ord(S[2])-64; LRA:=Ord(S[3])-48;
  CDA:=Ord(S[5])-64; LDA:=Ord(S[6])-48;
  CRN:=Ord(S[8])-64; LRN:=Ord(S[9])-48;
  init:=S;
end;

procedure VerifCross(NewL, NewC:Integer);
{ Verifica daca nu cumva dama alba sare peste regele alb }
var DL, DC:Integer;
begin
  if NewL>LDA then DL:=-1
              else if NewL<LDA then DL:=1
                               else DL:=0;
  if NewC>CDA then DC:=-1
              else if NewC<CDA then DC:=1
                               else DC:=0;
  repeat
    NewL:=NewL+DL; NewC:=NewC+DC;
    if (NewL=LRA) and (NewC=CRA)
      then Error('Dama nu poate sari peste regele alb');
  until (NewL=LDA) and (NewC=CDA);
end;

function WhiteAttacks(L, C:Integer):Boolean;
{ Verifica daca albul controleaza campul (C,L) }
begin
  if (Abs(LRA-L)<=1) and (Abs(CRA-C)<=1)
    then WhiteAttacks:=True  { RA controleaza campul }
    else if (LDA<>L) and (CDA<>C) and (Abs(LDA-L)<>Abs(CDA-C))
           then WhiteAttacks:=False { DA nu e coliniara cu campul }
           else if (LRA-LDA)*(C-CDA)<>(L-LDA)*(CRA-CDA)
                  then WhiteAttacks:=True  { RA nu e coliniar cu DA si campul }
                  else WhiteAttacks:=not(
                  (((LRA>=LDA) and (LRA<=L)) or ((LRA>=L) and (LRA<=LDA))) and
                  (((CRA>=CDA) and (CRA<=C)) or ((CRA>=C) and (CRA<=CDA))));
                  { Este sah daca RA nu se interpune intre DA si camp }
end;

procedure whitemove(S:String);
var NewL, NewC:Integer;
begin
  if not Inited then Error('Functia init nu a fost apelata');
  if not Turn then Error('Functia whitemove a fost apelata cand negrul era la mutare');
  if Length(S)<>3 then Error(S+' - Parametrul nu are trei litere');
  if not (S[1] in ['R','D']) then Error(S+' - Prima litera nu este R sau D');
  if not (S[2] in ['A'..'H']) then Error(S+' - Coloana incorecta');
  NewC:=Ord(S[2])-64;
  if not (S[3] in ['1'..'8']) then Error(S+' - Linie incorecta');
  NewL:=Ord(S[3])-48;
  if S[1]='D'
    then begin
           if (LDA<>NewL) and (CDA<>NewC) and (Abs(LDA-NewL)<>Abs(CDA-NewC))
             then Error('Dama se muta pe linie sau pe diagonala');
           if (LDA=NewL) and (CDA=NewC) then Error('Dama nu poate sta pe loc');
           if (LRA=NewL) and (CRA=NewC) then Error('Dama nu poate captura propriul rege');
           VerifCross(NewL, NewC);
           LDA:=NewL; CDA:=NewC;
         end
    else begin
           if (Abs(LRA-NewL)>1) or (Abs(CRA-NewC)>1)
             then Error('Regele se muta cu un patratel in orice directie');
           if (LRA=NewL) and (CRA=NewC) then Error('Regele nu poate sta pe loc');
           if (LDA=NewL) and (CDA=NewC) then Error('Regele nu poate captura propria dama');
           LRA:=NewL; CRA:=NewC;
         end;
  Check:=WhiteAttacks(LRN, CRN);
  Turn:=not Turn;
end;

procedure SearchBest(var BestL, BestC:Integer; var AnyMoves:Boolean);
{ Cauta o mutare a negrului. Algoritmul este:
  1. Daca poate, ia dama alba
  2. Daca nu, gaseste o mutare care sa nu il lase in sah }
var NewL, NewC:Integer;
begin
  if (Abs(LRN-LDA)<=1) and (Abs(CRN-CDA)<=1) and { RN e langa DA }
     ((Abs(LRA-LDA)>1) or (Abs(CRA-CDA)>1))    { RA nu apara DA }
    then Error('Ti-am lu-at da-ma! Ti-am lu-at da-ma! Remiza');
  for NewL:=LRN-1 to LRN+1 do
    for NewC:=CRN-1 to CRN+1 do
      if (NewL>=1) and (NewL<=8) and (NewC>=1) and (NewC<=8)
        and ((NewL<>LRN) or (NewC<>CRN)) and not WhiteAttacks(NewL, NewC)
        then begin
               BestL:=NewL;
               BestC:=NewC;
               AnyMoves:=True;
               Exit;
             end;
  AnyMoves:=False;
end;

function blackmove:String;
var BestL, BestC:Integer;
    AnyMoves:Boolean;
begin
  if not Inited then Error('Functia init nu a fost apelata');
  if Turn then Error('Functia blackmove a fost apelata cand albul era la mutare');
  SearchBest(BestL, BestC, AnyMoves);
  if not AnyMoves
    then if Check then Error('********* Mat! Ai reusit! *********')
                  else Error('Pat - remiza');
  if NMoves=5 then Error('Negrul a rezistat eroic timp de 30 de mutari');
  Inc(NMoves);
  Check:=False;
  Turn:=not Turn;
  LRN:=BestL; CRN:=BestC;
  blackmove:='R'+Chr(BestC+64)+Chr(BestL+48);
end;

end.
