#include <stdio.h>
#include <stdlib.h>
#define NMax 180
#define Infinity 300000

typedef struct list {
          int K, D;
          struct list *Next;} List;

List *Vec[NMax+1];
  /* V[i] este lista cu vecinii lui i, fiecare cu distanta pana la i */
int Fort[NMax+1], Seen[NMax+1], N, M, K;
long Dist[NMax+1];

void Add(int Node1, int Node2, int Dist)
{ List *L=(List *)malloc(sizeof(List));
  L->K=Node2;
  L->D=Dist;
  L->Next=Vec[Node1];
  Vec[Node1]=L;
}

void ReadData(void)
/* Citeste datele. Pentru nodurile-fortareata, seteaza Seen=1, Dist=0.
   Pentru celelalte noduri, seteaza Seen=0, Dist=Infinity. */
{ FILE *F=fopen("asezari.in", "rt");
  int i, X, Y, D;

  fscanf(F, "%d %d %d", &N, &M, &K);
  for (i=1; i<=N; i++)
    { Dist[i]=Infinity;
      Fort[i]=0;
      Seen[i]=0;
      Vec[i]=NULL;
    }
  for (i=1; i<=K; i++)
    { fscanf(F, "%d", &X);
      Seen[X]=1;
      Dist[X]=0;
    }
  for (i=1; i<=M; i++)
    { fscanf(F, "%d %d %d", &X, &Y, &D);
      Add(X, Y, D); Add(Y, X, D);
    }
  fclose(F);
}

void InitDomains(void)
/* Pentru nodurile imediat vecine fortaretelor, seteaza Dist si Fort */
{ int i;
  List *L;

  for (i=1; i<=N; i++)
    if (Seen[i]) /* i este fortareata conform initializarii din ReadData */
      for (L=Vec[i]; L; L=L->Next)
        if (L->D<Dist[L->K] || L->D==Dist[L->K] && i<Fort[L->K])
          { Fort[L->K]=i;
            Dist[L->K]=L->D;
          }
}

void Dijkstra(void)
/* Aplica un Dijkstra generalizat (multisursa) */
{ long DMin;
  int Min, i, j;
  List *L;

  for (i=1; i<=N-K; i++)
    { /* Cautam nodul cu !Seen si Dist minim */
      DMin=Infinity+1;
      for (j=1; j<=N; j++)
        if (!Seen[j] && Dist[j]<DMin)
          { DMin=Dist[j]; Min=j; }
      Seen[Min]=1;
      for (L=Vec[Min]; L; L=L->Next)
        if (Dist[Min]+L->D<Dist[L->K] ||
            Dist[Min]+L->D==Dist[L->K] && Fort[Min]<Fort[L->K])
          { Fort[L->K]=Fort[Min];
            Dist[L->K]=Dist[Min]+L->D;
          }
    }
}

void Write(void)
{ int i;
  FILE *F=fopen("asezari.out", "wt");

  for (i=1; i<N; i++) fprintf(F, "%d ", Fort[i]);
  fprintf(F, "%d\n", Fort[N]);
  fclose(F);
}

void main(void)
{
  ReadData();
  InitDomains();
  Dijkstra();
  Write();
}
